
CODE                SEGMENT

                    ASSUME    CS:CODE,DS:CODE,SS:CODE
                    ORG       100h                          ; Programme .COM

COMMENT ! INSTALL.COM : Programme d'installation du programme TTO version 1.20.
          Utilisation : INSTALL [chemin complet du rpertoire de destination].
          Codes de sortie : 00h = Pas d'erreur,
                            01h = Aucun paramtre pass au programme,
                            02h = Erreur de dtection du rpertoire actuel,
                            03h = Erreur de cration du rpertoire destination,
                            04h = Erreur lors de la copie,
                            05h = Place disque insuffisante.
          Assembler   : 8086/8088.
          ASM --> OBJ : MASM 5.0.
          OBJ --> COM : TLINK 5.1 (TLINK install.obj /t). !


Start:              push      ds
                    pop       es
                    jmp       Debut

; *********************************************************************************************************************
;                                                       DONNEES
; *********************************************************************************************************************

NbFichiers          equ       06h

Intro               db        0Dh,0Ah,'Installation du programme TTO version 1.20 sur disque dur.'
                    db        0Dh,0Ah,'LPJJl Software, Belgium, 1996-97.'
PasserLigne         db        0Dh,0Ah,'$'
MsgCheminSource     db        0Dh,0Ah,'Rpertoire source      : ','$'
MsgCheminDest       db        0Dh,0Ah,'Rpertoire destination : ','$'
MsgErreurDtmChemin  db        0Dh,0Ah,'Erreur lors de la dtection du rpertoire courant.'
                    db        0Dh,0Ah,'$'
MsgErreurCapacite   db        0Dh,0Ah,'Capacit disque insuffisante.'
                    db        0Dh,0Ah,'$'
MsgErreurDtmCapa    db        0Dh,0Ah,'Erreur lors de la dtection de la capacit du disque.'
                    db        0Dh,0Ah,'$'
MsgCreationChemin   db        0Dh,0Ah,'Cration du rpertoire destination...   ','$'
MsgOk               db                'OK'
                    db        0Dh,0Ah,'$'
MsgErreur           db                'ERREUR'
                    db        0Dh,0Ah,'$'
MsgFinOk            db        0Dh,0Ah,'Le programme a t correctement install !'
                    db        0Ah
                    db        0Dh,0Ah,'LPJJl vous salue bien bas...'
                    db        0Dh,0Ah,'$'
MsgFinErreur        db        0Dh,0Ah,'Utilisation du programme : Tapez "INSTALL [chemin]" puis <Entre>'
                    db        0Dh,0Ah,'   [chemin] est le chemin d''accs COMPLET au rpertoire o vous dsirez'
                    db        0Dh,0Ah,'   installer le programme.'
                    db        0Dh,0Ah,'      Exemple : "INSTALL D:\PINGPONG\TTO".'
                    db        0Dh,0Ah,'   Attention : pour installer dans le rpertoire racine, ne pas oublier "\" !'
                    db        0Dh,0Ah,'      Exemple : "INSTALL C:\" (et non pas "INSTALL C:").'

                    db        0Dh,0Ah,'Pour plus d''explications, voyez le fichier INSTALL.TXT.'
                    db        0Dh,0Ah,'$'

NomsFichiers        db        '\TTO.EXE     ','$'
                    db        '\TTO.PIF     ','$'
                    db        '\TTO.HLP     ','$'
                    db        '\LISEZ.MOI   ','$'
                    db        '\TTO.INI     ','$'
                    db        '\TTO.ICO     ','$'

LongueurDest        db        ?
CheminDest          db        141 dup (00h)
LongueurSource      db        ?
CheminSource        db        ?,':\',141 dup (00h)
HandleSource        dw        ?
HandleDest          dw        ?
DateFichier         dw        0021h
HeureFichier        dw        0000h
Buffer              db        512 dup (?)

Lettres             db        'ABCDEFGHIJKLMNOPQRSTUVWXYZ'



; *********************************************************************************************************************
;                                                    INSTRUCTIONS
; *********************************************************************************************************************

; ---------------------------------------------------------------------------------------------------------------------
;                                        Affichage du message d'introduction
; ---------------------------------------------------------------------------------------------------------------------
Debut:              mov       dx,offset Intro
                    call      AFFICHE_MESSAGE

; ---------------------------------------------------------------------------------------------------------------------
;                          Transfert de la ligne de commande charge dans le PSP (en 80h)
; ---------------------------------------------------------------------------------------------------------------------
                    mov       si,0080h                      ; DS:SI = @ ligne de commande dans le PSP
                    mov       di,offset LongueurDest        ; ES:DI = @ ligne de commande dans le segment de donnes
                    cld
                    movsb                                   ; Transfert longueur paramtre - SI et DI sont positionns
                    cmp       byte ptr [si],' '             ; Le 1er caractre du paramtre est-il blanc ?
                    jne       TransfertParametre            ; Si non, lancer le transfert
                    inc       si                            ; Si oui, passer le caractre blanc...
                    dec       byte ptr LongueurDest         ; ... et dcrmenter la longueur du paramtre
TransfertParametre: xor       ch,ch
                    mov       cl,LongueurDest               ; CX = compteur de caractres  transfrer
                    mov       bx,cx                         ; Sauvetage de la longueur du paramtre dans BX
                    mov       bp,cx                         ; Sauvetage de la longueur du paramtre dans BP
                    jcxz      AucunParametre                ; Pas de paramtre dans la ligne de commande
                    rep       movsb                         ; Transfert de la ligne de commande

                    ; Chargement du caractre '$'  la suite de la ligne de commande
                    mov       CheminDest [bx],'$'           ; BX contient la longueur du paramtre
                    jmp       short DtmCheminActuel

                    ; Aucun paramtre pass au programme : sortie avec code d'erreur 01h
AucunParametre:     mov       al,01h                        ; AL = code de sortie du programme
                    jmp       Erreur                        ; Affichage du mode d'emploi puis sortie

; ---------------------------------------------------------------------------------------------------------------------
;                                          Dtermination du chemin actuel
; ---------------------------------------------------------------------------------------------------------------------
                    ; Dtermination du drive courant
DtmCheminActuel:    mov       ah,19h                        ; Dtermination du drive courant
                    int       21h                           ; Services DOS : AL = n du lecteur actuel
                    xor       bh,bh
                    mov       bl,al                         ; BX = code du drive
                    mov       al,Lettres [bx]
                    mov       CheminSource,al               ; La 1re lettre du chemin source est le drive

                    ; Dtermination du rpertoire courant (BL contient toujours le code du drive)
                    mov       ah,47h                        ; Dtermination du rpertoire actuel
                    mov       dl,bl                         ; DL = code du drive
                    mov       si,offset CheminSource + 03h  ; DS:SI = @ du buffer de rsultat
                    int       21h                           ; Services DOS : rpertoire charg en DS:SI (chane AZT)
                    jc        ErreurDtmChemin

                    ; Pas d'erreur : remplacement du caractre terminal 00h par '$' (DS:SI = @ chane)
                    ; La longueur de la chane source est calcule en mme temps
                    and       byte ptr LongueurSource,00h   ; Mise  0 de la longueur
Compare00h:         cmp       byte ptr [si],00h             ; Est-ce le caractre terminal ?
                    je        Trouve                        ; Si oui, fin de boucle
                    inc       si
                    inc       byte ptr LongueurSource
                    jmp       Compare00h                    ; Passer au caractre suivant
Trouve:             mov       byte ptr [si],'$'
                    jmp       short AffichageChemins

                    ; Erreur dans la dtermination du rpertoire actuel : message puis sortie
ErreurDtmChemin:    mov       dx,offset MsgErreurDtmChemin
                    call      AFFICHE_MESSAGE
                    mov       al,02h                        ; AL = code de sortie
                    jmp       Erreur

; ---------------------------------------------------------------------------------------------------------------------
;                                  Affichage des rpertoires source et destination
; ---------------------------------------------------------------------------------------------------------------------
                    ; Mise en majuscules du rpertoire destination
AffichageChemins:   mov       si,offset CheminDest          ; DS:SI = @ chemin destination
                    xor       ch,ch
                    mov       cl,LongueurDest               ; CX = Compteur de lettres du chemin
ComparaisonLettre:  cmp       byte ptr [si],'a'             ; Le caractre est-il infrieur  'a' ?
                    jb        CaractereSuivant              ; Si oui, passer au suivant
                    cmp       byte ptr [si],'z'             ; Si non, le caractre est-il suprieur  'z' ?
                    ja        CaractereSuivant              ; Si oui, passer au suivant
                    sub       byte ptr [si],20h             ; Si non, mettre en majuscule
CaractereSuivant:   inc       si
                    loop      ComparaisonLettre

                    ; Affichage des rpertoires
                    mov       dx,offset MsgCheminSource
                    call      AFFICHE_MESSAGE
                    mov       dx,offset CheminSource
                    call      AFFICHE_MESSAGE
                    mov       dx,offset MsgCheminDest
                    call      AFFICHE_MESSAGE
                    mov       dx,offset CheminDest
                    call      AFFICHE_MESSAGE
                    mov       dx,offset PasserLigne
                    call      AFFICHE_MESSAGE

; ---------------------------------------------------------------------------------------------------------------------
;                       Test de l'existence du rpertoire destination et cration ventuelle
; ---------------------------------------------------------------------------------------------------------------------
                    ; Remplacement du caractre terminal '$' par 00h (chane AZT)
                    ; BP contient toujours la longueur de chane
                    mov       si,offset CheminDest
                    mov       bx,bp                         ; BX = longueur de la chane
                    and       byte ptr [bx] [si],00h

                    ; Test de l'existence du rpertoire
                    mov       ah,3Bh                        ; Fixer le rpertoire courant
                    mov       dx,si                         ; DS:DX = @ chane du chemin du rpertoire
                    int       21h                           ; Services DOS : CF = 1 indique une erreur
                    jnc       CheminDestExiste              ; Si pas d'erreur, le chemin existe : on ne le cre pas

                    ; Le rpertoire n'existe pas : message puis cration
                    push      dx                            ; Sauvetage de l'adresse de la chane
                    mov       dx,offset MsgCreationChemin
                    call      AFFICHE_MESSAGE
                    mov       ah,39h                        ; Cration d'un sous-rpertoire
                    pop       dx                            ; DS:DX = @ chane du chemin du nouveau sous-rpertoire
                    int       21h                           ; Services DOS : CF = 1 indique une erreur
                    jnc       OkCreationChemin              ; Si pas d'erreur, message "OK" puis on passe  la suite

                    ; Si erreur, affichage du message "ERREUR" puis sortie du programme
                    mov       dx,offset MsgErreur
                    call      AFFICHE_MESSAGE
                    mov       al,03h                        ; AL = Code de sortie du programme
                    jmp       Erreur                        ; Affichage du mode d'emploi et sortie du programme

                    ;Si pas d'erreur, affichage du message "OK" puis passage  la suite
OkCreationChemin:   mov       dx,offset MsgOk
                    call      AFFICHE_MESSAGE

; ---------------------------------------------------------------------------------------------------------------------
;                       Test de la capacit disque disponible (au moins 600 secteurs libres)
; ---------------------------------------------------------------------------------------------------------------------
CheminDestExiste:   ; Dtermination du code du drive destination
                    mov       si,offset CheminDest          ; DS:SI = @ rpertoire de destination
                    mov       dl,[si]
                    sub       dl,'@'                        ; DL = Code du drive destination

                    ; Dtermination du nombre de secteurs libres
                    mov       ah,36h                        ; Dtermination capacit disque rsiduelle
                    int       21h                           ; Services DOS : AX = 0FFFFh indique une erreur
                                                            ;             ou AX = Nb secteurs par cluster
                                                            ;                BX = Nb clusters libres
                    cmp       ax,0FFFFh                     ; Y a-t-il eu erreur ?
                    je        ErreurDtmCapacite             ; Si oui, message puis sortie
                    mul       bx                            ; Si non, DX:AX = Nb de secteurs libres
                    jo        OKCapaciteDisque              ; Si OF = 1 alors DX est significatif et c'est forcment OK
                    cmp       ax,0258h                      ; Si DX non significatif alors AX <= 600 secteurs ?
                    jb        ErreurCapacite                ; Si oui alors message d'erreur et sortie
                    jmp       short OKCapaciteDisque        ; Si non alors on continue

                    ; Message d'erreur capacit disque insuffisante
ErreurCapacite:     mov       dx,offset MsgErreurCapacite
                    call      AFFICHE_MESSAGE
                    jmp       short SortieCapacite
                    ; Message d'erreur dtermination capacit disque rsiduelle
ErreurDtmCapacite:  mov       dx,offset MsgErreurDtmCapa
                    call      AFFICHE_MESSAGE
                    ; Code de sortie et fin de programme
SortieCapacite:     mov       al,05h                        ; AL = Code de sortie
                    jmp       Erreur

; ---------------------------------------------------------------------------------------------------------------------
;                                       Boucle gnrale de copie des fichiers
; ---------------------------------------------------------------------------------------------------------------------
                    ; Effacement ventuel du '\' terminal du chemin source et remplacement du '$' de fin par 00h
OKCapaciteDisque:   xor       bh,bh
                    mov       bl,LongueurSource             ; BX = Longueur du chemin source
                    dec       bx                            ; DS:BX = @ dernier caractre
                    cmp       byte ptr CheminSource [bx],'\'; Caractre '\' ?
                    je        DiminuerLgSource              ; Si oui, remplacer '\' par 00h (--> diminuer lg. chane)
                    inc       bx                            ; Si non, le caractre 00h remplacera rellement le '$'
                    jmp       short RemplacementSource
DiminuerLgSource:   dec       byte ptr LongueurSource
RemplacementSource: mov       byte ptr CheminSource [bx],00h; Placement du caractre 00h

                    ; Effacement ventuel du '\' terminal du chemin destination et remplacement du '$' de fin par 00h
                    mov       bl,LongueurDest               ; BX = Longueur du chemin destination
                    dec       bx                            ; DS:BX = @ dernier caractre
                    cmp       byte ptr CheminDest [bx],'\'  ; Caractre '\' ?
                    je        DiminuerLgDest                ; Si oui, remplacer '\' par 00h (--> diminuer lg. chane)
                    inc       bx                            ; Si non, le caractre 00h remplacera rellement le '$'
                    jmp       short RemplacementDest
DiminuerLgDest:     dec       byte ptr LongueurDest
RemplacementDest:   mov       byte ptr CheminDest [bx],00h  ; Placement du caractre 00h

                    ; Initialisation des variables de la boucle
                    mov       si,offset NomsFichiers        ; DS:SI = @ nom du fichier  copier
                    xor       bh,bh
                    mov       bl,LongueurSource             ; BX = Longueur du chemin source
                    xor       ah,ah
                    mov       al,LongueurDest
                    mov       bp,ax                         ; BP = Longueur du chemin Dest
                    mov       cx,NbFichiers                 ; CX = Nombre de fichiers  copier

                    ; Passer une ligne  l'cran
                    mov       dx,offset PasserLigne
                    call      AFFICHE_MESSAGE


BoucleCopie:        push      cx                            ; Sauvetage du compteur

                    ; Affichage du nom de fichier  copier
                    mov       dx,si
                    inc       dx                            ; Passer le caractre '\'
                    call      AFFICHE_MESSAGE

                    ; Remplacement du '$' du nom de fichier par 00h
                    mov       byte ptr [si + 0Dh],00h

                    ; Copie du nom de fichier dans les chemins source et destination
                    cld
                    mov       di,offset CheminSource        ; ES:DI = @ chemin source
                    add       di,bx                         ; ES:DI = @ caractre suivant le chemin source
                    mov       cx,0Eh                        ; CX = Longueur chane  transfrer
                    push      si                            ; Sauvetage de l'adresse du nom de fichier
                    rep       movsb                         ; Copie du nom de fichier
                    mov       di,offset CheminDest          ; ES:DI = @ chemin destination
                    add       di,bp                         ; ES:DI = @ caractre suivant le chemin destination
                    pop       si                            ; Restauration de l'adresse du nom de fichier
                    mov       cx,0Eh                        ; CX = longueur chane  transfrer
                    rep       movsb                         ; Copie : DS:SI pointe sur le nom de fichier suivant

                    ; Ouverture du fichier source
                    mov       dx,offset CheminSource
                    call      OUVERTURE_FICHIER
                    jc        ErreurCopie                   ; Erreur : fin de programme
                    mov       HandleSource,ax               ; Pas d'erreur : sauvetage du handle

                    ; Lecture de la date et de l'heure du fichier source
                    push      bx                            ; Sauvetage de la longueur du chemin source
                    mov       bx,ax
                    call      LECTURE_DH_FICHIER
                    pop       bx                            ; Restauration de la longueur du chemin source

                    ; Cration du fichier destination
                    mov       dx,offset CheminDest
                    call      CREATION_FICHIER
                    jc        ErreurCreation                ; Erreur : fermeture fichier source et sortie
                    mov       HandleDest,ax                 ; Pas d'erreur : sauvetage du handle

                    mov       dx,offset Buffer              ; DS:DX = @ buffer de lecture/criture

                    ; Lecture du fichier source
LectureFichier:     push      bx                            ; Sauvetage de la longueur du chemin source
                    mov       bx,HandleSource               ; BX = Handle du fichier
                    call      LECTURE_FICHIER
                    pop       bx                            ; Restauration de la longueur du chemin source
                    jc        ErreurLectEcriture            ; Erreur : fermeture des fichiers et sortie

                    ; Ecriture du fichier destination
EcritureFichier:    mov       cx,ax                         ; CX = Nombre de bytes  crire
                    jcxz      FermetureFichiers
                    push      bx                            ; Sauvetage de la longueur du chemin source
                    mov       bx,HandleDest                 ; BX = Handle du fichier
                    call      ECRITURE_FICHIER
                    pop       bx                            ; Restauration de la longueur du chemin source
                    jc        ErreurLectEcriture            ; Erreur : fermeture des fichiers et sortie

                    ; Test de la fin de copie
                    cmp       ax,0200h                      ; 512 bytes lus et crits ?
                    je        LectureFichier                ; Si oui, on recommence

                    ; Ecriture de la date et de l'heure du fichier source pour le fichier destination
FermetureFichiers:  push      bx                            ; Sauvetage de la longueur du chemin source
                    mov       bx,HandleDest
                    call      ECRITURE_DH_FICHIER

                    ; Fermeture du fichier source
                    mov       bx,HandleSource               ; BX = Handle du fichier
                    call      FERMETURE_FICHIER

                    ; Fermeture du fichier destination
                    mov       bx,HandleDest                 ; BX = Handle du fichier
                    call      FERMETURE_FICHIER
                    pop       bx                            ; Restauration de la longueur du chemin source
                    jc        ErreurCopie                   ; Message d'erreur et sortie

                    ; Affichage du message "OK"  la suite du nom de fichier copi
                    mov       dx,offset MsgOk
                    call      AFFICHE_MESSAGE

                    ; Bouclage
                    pop       cx                            ; Restauration du compteur de fichiers  copier
                    dec       cx                            ; Dcrmentation du compteur
                    jcxz      FinBoucle                     ; Si compteur = 0 alors fin de boucle...
                    jmp       BoucleCopie                   ; ... sinon bouclage

                    ; Si pas d'erreur, fin de programme
FinBoucle:          jmp       short PasErreur               ; Sortie du programme sans erreur

; ---------------------------------------------------------------------------------------------------------------------
;                            Gestion des erreurs survenues lors de la copie des fichiers
; ---------------------------------------------------------------------------------------------------------------------
ErreurLectEcriture: mov       bx,HandleDest
                    call      FERMETURE_FICHIER
ErreurCreation:     mov       bx,HandleSource
                    call      FERMETURE_FICHIER
ErreurCopie:        pop       cx                            ; Restauration de la hauteur de la pile (push cx)
                    mov       dx,offset MsgErreur
                    call      AFFICHE_MESSAGE
                    mov       al,04h                        ; AL = Code de sortie du programme
                    jmp       short Erreur                  ; Fin de programme

; ---------------------------------------------------------------------------------------------------------------------
;                        Tout s'est bien droul : affichage du message de sortie et sortie
; ---------------------------------------------------------------------------------------------------------------------
PasErreur:          xor      al,al                          ; AL = Code de sortie nul (pas d'erreur)
                    mov      dx,offset MsgFinOk
                    jmp      short AffichageFin

; ---------------------------------------------------------------------------------------------------------------------
;                       Il y a eu erreur : affichage du mode d'emploi du programme et sortie
; ---------------------------------------------------------------------------------------------------------------------
Erreur:             mov       dx,offset MsgFinErreur
AffichageFin:       call      AFFICHE_MESSAGE

; ---------------------------------------------------------------------------------------------------------------------
;                                Sortie du programme : AL contient le code de sortie
; ---------------------------------------------------------------------------------------------------------------------
                    mov       ah,4Ch                        ; Fin de programme
                    int       21h                           ; Services DOS


; *********************************************************************************************************************
;                                                     PROCEDURES
; *********************************************************************************************************************

; ---------------------------------------------------------------------------------------------------------------------
;                      Affichage d'un message  l'cran dont l'adresse est contebue dans DS:DX
; ---------------------------------------------------------------------------------------------------------------------
AFFICHE_MESSAGE     PROC      NEAR
                    push      ax
                    pushf
                    mov       ah,09h                        ; Affichage d'une chane de caractres
                    int       21h                           ; Services DOS
                    popf
                    pop       ax
                    ret
AFFICHE_MESSAGE     ENDP

; ---------------------------------------------------------------------------------------------------------------------
; Ouverture d'un fichier
;    Entre : DS:DX = @ nom du fichier
;    Sortie : CF indique si erreur. Si erreur, AX = Code d'erreur sinon AX = Handle du fichier
; ---------------------------------------------------------------------------------------------------------------------
OUVERTURE_FICHIER   PROC      NEAR
                    mov       ah,3Dh                        ; Ouverture d'un fichier
                    xor       al,al                         ; Ouverture en mode de lecture uniquement
                    int       21h                           ; Services DOS : CF = 1 indique une erreur
                    ret
OUVERTURE_FICHIER   ENDP

; ---------------------------------------------------------------------------------------------------------------------
; Cration d'un fichier
;    Entre : DS:DX = @ nom du fichier
;    Sortie : CF indique si erreur. Si erreur, AX = Code d'erreur sinon AX = Handle du fichier
; ---------------------------------------------------------------------------------------------------------------------
CREATION_FICHIER    PROC      NEAR
                    push      cx
                    mov       ah,3Ch                        ; Ouverture d'un fichier
                    xor       cx,cx                         ; Attribut du fichier : "archive"
                    int       21h                           ; Services DOS : CF = 1 indique une erreur
                    pop       cx
                    ret
CREATION_FICHIER    ENDP

; ---------------------------------------------------------------------------------------------------------------------
; Lecture d'un fichier
;    Entre : BX = Handle et DS:DX = @ buffer
;    Sortie : CF indique si erreur. Si erreur, AX = Code d'erreur sinon AX = Nb de bytes lus
; ---------------------------------------------------------------------------------------------------------------------
LECTURE_FICHIER     PROC      NEAR
                    push      cx
                    mov       ah,3Fh                        ; Lecture d'un fichier
                    mov       cx,0200h                      ; Taille du buffer = 512 bytes
                    int       21h                           ; Services DOS : CF = 1 indique une erreur
                    pop       cx
                    ret
LECTURE_FICHIER     ENDP

; ---------------------------------------------------------------------------------------------------------------------
; Ecriture d'un fichier
;    Entre : BX = Handle, CX = Nombre de bytes  crire et DS:DX = @ buffer
;    Sortie : CF indique si erreur. Si erreur, AX = Code d'erreur sinon AX = Nb de bytes crits
; ---------------------------------------------------------------------------------------------------------------------
ECRITURE_FICHIER    PROC      NEAR
                    push      cx
                    mov       ah,40h                        ; Ecriture dans un fichier
                    int       21h                           ; Services DOS : CF = 1 indique une erreur
                    pop       cx
                    ret
ECRITURE_FICHIER    ENDP

; ---------------------------------------------------------------------------------------------------------------------
; Fermeture d'un fichier
;    Entre : BX = Handle
;    Sortie : CF indique si erreur
; ---------------------------------------------------------------------------------------------------------------------
FERMETURE_FICHIER   PROC      NEAR
                    mov       ah,3Eh                        ; Fermeture d'un fichier
                    int       21h                           ; Services DOS : CF = 1 indique une erreur
                    ret
FERMETURE_FICHIER   ENDP

; ---------------------------------------------------------------------------------------------------------------------
; Lecture de la date et de l'heure d'un fichier
;    Entre : BX = Handle
;    Sortie : - Si pas d'erreur (CF = 0) : DateFichier et HeureFichier sont charges
;             - Si erreur (CF = 1) : DateFichier vaut 01/01/1980 et HeureFichier vaut 00:00,00
; ---------------------------------------------------------------------------------------------------------------------
LECTURE_DH_FICHIER  PROC      NEAR
                    push      cx
                    push      dx
                    xor       cx,cx                         ; Heure = 00:00,00
                    mov       dx,0021h                      ; Date = 01/01/1980
                    mov       ax,5700h                      ; Lecture de la date et de l'heure d'un fichier
                    int       21h                           ; Services DOS : CF = 1 indique une erreur
                    mov       HeureFichier,cx
                    mov       DateFichier,dx
                    pop       dx
                    pop       cx
                    ret
LECTURE_DH_FICHIER  ENDP

; ---------------------------------------------------------------------------------------------------------------------
; Ecriture de la date et de l'heure d'un fichier
;    Entre : BX = Handle, DateFichier = Date et HeureFichier = Heure
;    Sortie : aucune
; ---------------------------------------------------------------------------------------------------------------------
ECRITURE_DH_FICHIER PROC      NEAR
                    push      cx
                    push      dx
                    mov       ax,5701h                      ; Lecture de la date et de l'heure d'un fichier
                    mov       cx,HeureFichier               ; CX = Heure du fichier
                    mov       dx,DateFichier                ; DX = Date du fichier
                    int       21h                           ; Services DOS : CF = 1 indique une erreur
                    pop       dx
                    pop       cx
                    ret
ECRITURE_DH_FICHIER ENDP


CODE                ENDS

                    END       Start
