
PROGRAM TTO;

(* VERSION 1.20

   DATE DE CREATION : 02-03-1996.
   DERNIERE MISE A JOUR : 12-01-1997.

   ͻ
     GESTION DE TOURNOI DE TENNIS DE TABLE  
   ͼ

   MODULES COMPOSANT LE PROGRAMME :
   ==============================

   PROGRAMME PRINCIPAL (MENU PRINCIPAL)     : PROGRAM TTO;
   INTERFACE AVEC LE DOS                    : UNIT DOS;        ( TURBO.TPL )
   ECRAN BAS NIVEAU                         : UNIT TXT;        ( TXT 2.00 )
   SOURIS BAS NIVEAU                        : UNIT MOUSE;      ( TXT 3.00 (EXTRAITS) )
   RECONNAISSANCE DU HARDWARE BAS NIVEAU    : UNIT TESTADAP;   ( TXT 3.00 (EXTRAITS) )
   DECLARATIONS GLOBALES                    : UNIT TTO_DECL;
   GESTION DU HARDWARE ET DE LA SOURIS      : UNIT TTO_HARD;
   MODULES COMMUNS A TOUTES LES UNITES      : UNIT TTO_COMN;
   GESTION DES LISTES DE POINTEURS          : UNIT TTO_LIST;
   GESTION DES FICHIERS SUR DISQUE          : UNIT TTO_FILE;
   AIDE ET DEBOGAGE                         : UNIT TTO_HELP;
   MODULES GENERAUX DU PROGRAMME            : UNIT TTO_GENE;
   GESTION DES JOUEURS                      : UNIT TTO_PLYR;
   GESTION DES MATCHES                      : UNIT TTO_MTCH;
   DIVISION EN POULES                       : UNIT TTO_POUL;
   GESTION DES CLASSEMENTS                  : UNIT TTO_CLAS;
   MENU DE GESTION D'UNE CATEGORIE          : UNIT TTO_GEST;
   GESTION DES CATEGORIES                   : UNIT TTO_CATS;
   GESTION DES IMPRESSIONS                  : UNIT TTO_PRNT;
   OPTIONS DU PROGRAMME                     : UNIT TTO_OPTN.


   HIERARCHIE DES MODULES :
   ======================

             T  T  T  T  T  T  T  T  T  T  T  T  T  T  T    
      A      T  T  T  T  T  T  T  T  T  T  T  T  T  T  T    
      P      O  O  O  O  O  O  O  O  O  O  O  O  O  O  O    
      P P    -  -  -  -  -  -  -  -  -  -  -  -  -  -  -    
   > E A -> D  H  C  L  F  G  H  P  P  P  M  C  G  C  O    
     L R    E  A  O  I  I  E  E  R  O  L  T  L  E  A  P  T 
     E      C  R  M  S  L  N  L  N  U  Y  C  A  S  T  T  T 
     E      L  D  N  T  E  E  P  T  L  R  H  S  T  S  N  O 
   ͵
   MOUSE     -  X  -  -  -  -  -  -  -  -  -  -  -  -  -  - 
   TESTADAP  -  X  -  -  -  -  -  -  -  -  -  -  -  -  -  - 
   DOS       X  X  -  -  X  X  X  X  -  -  -  -  -  -  -  - 
   TXT       X  X  X  -  X  X  X  X  X  X  X  X  X  X  X  X 
   TTO_DECL     X  X  X  X  X  X  X  X  X  X  X  X  X  X  X 
   TTO_HARD  -     X  -  X  X  X  X  X  X  X  X  X  X  X  X 
   TTO_COMN  -  -     X  X  -  X  X  X  X  X  X  X  X  X  X 
   TTO_LIST  -  -  -     X  -  -  -  X  -  X  X  X  X  -  - 
   TTO_FILE  -  -  -  -     X  X  X  X  X  X  X  X  X  X  X 
   TTO_GENE  -  -  -  -  -     -  -  X  X  X  -  -  X  X  X 
   TTO_HELP  -  -  -  -  -  X     X  X  X  X  X  X  X  X  X 
   TTO_PRNT  -  -  -  -  -  -  -     -  -  -  -  X  X  -  X 
   TTO_POUL  -  -  -  -  -  -  -  -     -  -  -  X  -  -  - 
   TTO_PLYR  -  -  -  -  -  -  -  -  -     -  -  X  -  -  - 
   TTO_MTCH  -  -  -  -  -  -  -  -  -  -     -  X  -  -  - 
   TTO_CLAS  -  -  -  -  -  -  -  -  -  -  -     X  -  -  - 
   TTO_GEST  -  -  -  -  -  -  -  -  -  -  -  -     -  -  X 
   TTO_CATS  -  -  -  -  -  -  -  -  -  -  -  -  -     -  X 
   TTO_OPTN  -  -  -  -  -  -  -  -  -  -  -  -  -  -     X  *)


{$M 65520,0,655360}   (* TAILLE DE LA PILE ET LIMITES INFERIEURE ET SUPERIEURE DU TAS *)
{$B-}                 (* EVALUATION BOOLEENNE EN "COURT-CIRCUIT" (STOPPEE DES QUE LE RESULTAT EST CONNU) *)
{$D+}                 (* INFORMATIONS DE DEBOGAGE LORS DE LA COMPILATION *)
{$I-}                 (* GESTION DES PERSONNELLE DES ERREURS D'ENTREES/SORTIES *)
{$R-}                 (* CONTROLE DU DOMAINE DE VALIDITE DESACTIVE *)
{$S+}                 (* TEST DE DEBORDEMENT DE PILE LORS DE LA COMPILATION *)
{$T-}                 (* CREATION DU MAP FILE DESACTIVEE LORS DE L'EDITION DE LIENS *)
{$V+}                 (* VERIFICATION STRICTE DES TYPES DE STRINGS *)


Uses TXT,        (* GESTION DE L'ECRAN EN MODE TEXTE (VERSION 2.00) *)
     TTO_DECL,   (* DECLARATION DE CONSTANTES, TYPES ET VARIABLES GLOBALES *)
     TTO_HARD,   (* GESTION DE LA SOURIS, ECONOMISEUR D'ECRAN *)
     TTO_COMN,   (* EXPLICATIONS AU BAS DE L'ECRAN, MESSAGES D'AVERTISSEMENT ET D'ERREUR *)
     TTO_FILE,   (* SAUVETAGE SUR DISQUE ET RESTAURATION, SAUVETAGE AUTOMATIQUE *)
     TTO_GENE,   (* MODULES DE DEBUT ET DE FIN DE PROGRAMME *)
     TTO_CATS,   (* GESTION DES CATEGORIES (CREATION, MODIFICATION, SUPPRESSION) *)
     TTO_GEST,   (* MENU DE GESTION DES CATEGORIES (JOUEURS, MATCHES) *)
     TTO_PRNT,   (* IMPRESSION DES RESULTATS *)
     TTO_OPTN,   (* OPTIONS DU PROGRAMME *)
     TTO_HELP;   (* AIDE CONTEXTUELLE ET BOITE DE DIALOGUE DE DEBOGAGE *)


Function QUITTER_PROGRAMME : boolean;
(* CONFIRMATION DE LA SORTIE DU PROGRAMME ET DEMANDE SI SAUVETAGE *)
Var Quitter:boolean;
Begin
  if MESSAGE_AVERTISSEMENT(ip_Quitter + 1) then Void:=SAUVETAGE_SITUATION(ss_Normal);
  QUITTER_PROGRAMME:=MESSAGE_AVERTISSEMENT(ip_Quitter);
End;


Function SELECTION_CATEGORIE (Option : byte) : byte;
(* SELECTION D'UNE CATEGORIE (RETOURNE SON NUMERO - OU 0 SI ANNULER).
   Option : sc_Vierges = CATEGORIES VIERGES UNIQUEMENT,
            sc_Existantes = CATEGORIES EXISTANTES SEULEMENT,
            sc_Toutes = TOUTES LES CATEGORIES SONT BONNES. *)
Const c=47; lg=29;
Var x1,y1,x2,y2,x,y,Fond,Couleur:word;
    Image:videosave;
    Fond1,Normal1,Fond2,Brillant:word;
    Entree:char;
    Ligne:byte;
    Fin:boolean;
          Procedure LIGNE_ALLUMEE;
          (* MISE EN EVIDENCE DE LA LIGNE COURANTE *)
          Begin
            txtback(Fond2); txtcolour(Brillant); txtmove(c,Ligne); txtattrib(lg);
          End;
          Procedure LIGNE_ETEINTE;
          (* FIN DE LA MISE EN EVIDENCE DE LA LIGNE COURANTE *)
          Begin
            txtback(Fond1); txtcolour(Normal1); txtmove(c,Ligne); txtattrib(lg);
          End;
          Function OK_LIGNE : boolean;
          (* DETERMINE SI LA LIGNE COURANTE EST SELECTIONNABLE *)
          Begin
            case Option of
              sc_Vierges:OK_LIGNE:=Categories[Ligne-2].Situation = 0;
              sc_Existantes:OK_LIGNE:=Categories[Ligne-2].Situation <> 0;
              sc_Toutes:OK_LIGNE:=true;
            end;
          End;
Begin
  case ModeEcran of
    ModeMono:begin Fond1:=lightgrey; Normal1:=black; Fond2:=black; Brillant:=white; end;
    ModeCouleur:begin Fond1:=blue; Normal1:=yellow; Fond2:=brown; Brillant:=white; end;
  end;
  x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; x:=windx; y:=windy; Fond:=textbackgr; Couleur:=textcolour;
  txtunwind; txtsave(Image);
  MESSAGE_BAS_ECRAN(ip_SelectionCategorie + 1); TITRE_HAUT_ECRAN(0);
  Fin:=false; Ligne:=3; LIGNE_ALLUMEE;
  txtflush; mouseeventparams.me_modified:=false; if Souris then Void:=txtmousecurson;
  repeat
    if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
    if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   59:begin   (* F1 : AIDE *)
                        if Souris then Void:=txtmousecursoff;
                        AIDE(hlp_SelectionCategorie);
                        if Souris then Void:=txtmousecurson;
                      end;
                   71,73,119,132:begin   (* (CTRL-)HOME / (CTRL-)PgUp : CATEGORIE 1 *)
                                   if Ligne <> 3
                                      then
                                        begin
                                          if Souris then Void:=txtmousecursoff;
                                          LIGNE_ETEINTE; Ligne:=3; LIGNE_ALLUMEE;
                                          if Souris then Void:=txtmousecurson;
                                        end;
                                 end;
                   15,72:begin   (* TAB GAUCHE / FLECHE HAUT : CATEGORIE PRECEDENTE *)
                           if Souris then Void:=txtmousecursoff;
                           LIGNE_ETEINTE; if Ligne = 3 then Ligne:=22 else dec(Ligne); LIGNE_ALLUMEE;
                           if Souris then Void:=txtmousecurson;
                         end;
                   80:begin   (* FLECHE BAS : CATEGORIE SUIVANTE *)
                        if Souris then Void:=txtmousecursoff;
                        LIGNE_ETEINTE; if Ligne = 22 then Ligne:=3 else inc(Ligne); LIGNE_ALLUMEE;
                        if Souris then Void:=txtmousecurson;
                      end;
                   79,81,117,118:begin   (* (CTRL-)END / (CTRL-)PgDn : DERNIERE CATEGORIE *)
                                   if Ligne <> 22
                                      then
                                        begin
                                          if Souris then Void:=txtmousecursoff;
                                          LIGNE_ETEINTE; Ligne:=22; LIGNE_ALLUMEE;
                                          if Souris then Void:=txtmousecurson;
                                        end;
                                 end;
                   97:begin   (* CTRL-F4 : DEBOGAGE *)
                        if Souris then Void:=txtmousecursoff;
                        DEBOGAGE;
                        if Souris then Void:=txtmousecurson;
                      end;
                 end;
               end;
             9:begin   (* TAB DROITE : CATEGORIE SUIVANTE *)
                 if Souris then Void:=txtmousecursoff;
                 LIGNE_ETEINTE; if Ligne = 22 then Ligne:=3 else inc(Ligne); LIGNE_ALLUMEE;
                 if Souris then Void:=txtmousecurson;
               end;
             13:begin   (* ENTER : SELECTION *)
                  if OK_LIGNE
                     then
                       begin
                         Fin:=true; SELECTION_CATEGORIE:=Ligne - 2;
                       end;
                end;
             27:begin   (* ESCAPE : RETOUR AU MENU PRINCIPAL *)
                  Fin:=true; SELECTION_CATEGORIE:=0;
                end;
           end;
         end;
    if mouseeventparams.me_modified
       then
         begin
           with mouseeventparams do
             begin
               if (me_x in [46..76]) and (me_y in [3..22])
                  then
                    begin
                      Void:=txtmousecursoff;
                      LIGNE_ETEINTE; Ligne:=me_y; LIGNE_ALLUMEE;
                      Void:=txtmousecurson;
                      if OK_LIGNE
                         then
                           begin
                             Fin:=true; SELECTION_CATEGORIE:=Ligne - 2;
                           end;
                    end;
               me_modified:=false;
             end;
         end;
  until Fin;
  if Souris then Void:=txtmousecursoff;
  txtload(Image); txtwind(x1,y1,x2,y2); txtback(Fond); txtcolour(Couleur); txtmove(x,y);
End;


Procedure MENU_PRINCIPAL;
(* LE CORPS DU PROGRAMME *)
Const l1=6; c1=0; lg1=33; c2=44; lg2=29;
      LigneVierge='                                                                               ';
Var Fond1,Fond2,Fond3,Normal1,Normal3,Brillant:word;
    Ligne:byte;
    Entree:char;
    FinProgramme:boolean;
          Procedure RUBRIQUE_ALLUMEE;
          (* MISE EN EVIDENCE D'UNE RUBRIQUE DU MENU PRINCIPAL *)
          Begin
            txtback(Fond2); txtcolour(Brillant); txtmove(c1+3,Ligne); txtattrib(lg1);
          End;
          Procedure RUBRIQUE_ETEINTE;
          (* FIN DE LA MISE EN EVIDENCE D'UNE RUBRIQUE DU MENU PRINCIPAL *)
          Begin
            txtback(Fond1); txtcolour(Normal1); txtmove(c1+3,Ligne); txtattrib(lg1);
          End;
          Procedure RUBRIQUE_SELECTIONNEE;
          (* MISE EN CLIGNOTEMENT D'UNE RUBRIQUE EN COURS DE TRAITEMENT *)
          Begin
            txtback(Fond1); txtcolour(Normal1 + blink); txtmove(c1+3,Ligne); txtattrib(lg1); txtback(Fond1);
          End;
          Procedure ECRITURE_CATEGORIE (Numero:byte);
          (* ECRITURE DU NOM ET DE LA SITUATION DE LA CATEGORIE Numero *)
          Begin
            txtback(Fond3); txtcolour(Normal3);
            with Categories[Numero] do
              begin
                txtmove(c2+7,Numero+2);
                if Situation = 0
                   then
                     txtwrite('....................     ')
                   else
                     begin
                       txtwrite('                         '); txtmove(c2+7,Numero+2); txtwrite(NomCategorie);
                       txtmove(c2+28,Numero+2);
                       case Situation of
                         1:txtwrite(' 1/1');
                         2:txtwrite(' 1/2');
                         4:txtwrite(' 1/4');
                         8:txtwrite(' 1/8');
                         16:txtwrite('1/16');
                         32:txtwrite('1/32');
                         64:txtwrite('1/64');
                         254:txtwrite('Fini');
                         255:txtwrite('Elim');
                       end;
                     end;
              end;
          End;
          Procedure SELECTION_RUBRIQUE;
          (* LANCE LA PROCEDURE ASSOCIEE A LA RUBRIQUE SELECTIONNEE *)
          Var n:byte;
              Ok:boolean;
          Begin
            case Ligne of
              7:begin
                  n:=SELECTION_CATEGORIE(sc_Vierges);
                  if (n <> 0) and (CREATION_CATEGORIE(n)) then ECRITURE_CATEGORIE(n);
                end;
              8:begin
                  n:=SELECTION_CATEGORIE(sc_Existantes);
                  if (n <> 0) and (DESTRUCTION_CATEGORIE(n)) then ECRITURE_CATEGORIE(n);
                end;
              9:begin
                  n:=SELECTION_CATEGORIE(sc_Existantes);
                  if (n <> 0) and (MODIFICATION_CATEGORIE(n)) then ECRITURE_CATEGORIE(n);
                end;
              10:begin
                   n:=SELECTION_CATEGORIE(sc_Existantes);
                   if n <> 0
                      then
                        begin
                          GESTION_CATEGORIE(n); ECRITURE_CATEGORIE(n);
                        end;
                 end;
              11:begin   (* IMPRESSION DES RESULTATS *)
                   n:=SELECTION_CATEGORIE(sc_Existantes);
                   if n <> 0
                      then
                        begin
                          with Categories[n] do
                            if (Situation = 1) and (NbMatchesRestants = 0)
                               then Ok:=MESSAGE_AVERTISSEMENT(ip_Impressions + 1)   (* PAS DE STATUT "FINIE" ! *)
                               else Ok:=true;
                            if Ok and CREATION_FICHIER_INDEX(tf_Print,n) and CHARGEMENT_INDEX(tf_Print)
                               then
                                 begin
                                   AFFICHAGE_TEXTE_IMPRESSION(n);
                                   ContenuTexte:=ndx_Print;
                                 end;
                        end;
                 end;
              12:Void:=SAUVETAGE_SITUATION(ss_Normal);
              13:begin
                   if MESSAGE_AVERTISSEMENT(ip_RecuperationDisque + 1) then Void:=RECUPERATION_SITUATION;
                   for n:=1 to 20 do ECRITURE_CATEGORIE(n)
                 end;
              14:OPTIONS;
              15:FinProgramme:=QUITTER_PROGRAMME;
            end;
          End;
Begin
  case ModeEcran of
    ModeMono:begin Fond1:=lightgrey; Normal1:=black; Fond2:=black; Brillant:=white; Fond3:=lightgrey; Normal3:=black; end;
    ModeCouleur:begin Fond1:=cyan; Normal1:=yellow; Fond2:=red; Brillant:=white; Fond3:=blue; Normal3:=yellow; end;
  end;
  txtunwind; txtback(black); txtcolour(lightgrey); txtclear;
  (* TITRE DE L'ECRAN *)
  txtback(Fond1); txtcolour(Normal1);
  txtmove(0,0); txtwrite(LigneVierge);
  txtmove(1,0); txtwrite('TTO Version 1.20'); txtmove(64,0); txtwrite('LPJJl Software');
  txtcolour(Brillant);
  txtmove(33,0); txtwrite('MENU PRINCIPAL');
  (* DERNIERE LIGNE *)
  txtcolour(Normal1);
  txtmove(0,24); txtwrite(LigneVierge);
  (* MENU PRINCIPAL *)
  txtmove(c1,l1);    txtwrite(' ͻ ');
  txtmove(c1,l1+1);  txtwrite('   (C)ration d''une catgorie        ');
  txtmove(c1,l1+2);  txtwrite('   (D)estruction d''une catgorie     ');
  txtmove(c1,l1+3);  txtwrite('   (P)aramtres d''une catgorie      ');
  txtmove(c1,l1+4);  txtwrite('   (G)estion d''une catgorie         ');
  txtmove(c1,l1+5);  txtwrite('   (I)mpression des rsultats        ');
  txtmove(c1,l1+6);  txtwrite('   (S)auvetage sur disque            ');
  txtmove(c1,l1+7);  txtwrite('   (R)estauration depuis un disque   ');
  txtmove(c1,l1+8);  txtwrite('   (O)ptions du programme            ');
  txtmove(c1,l1+9);  txtwrite('   (Q)uitter le programme            ');
  txtmove(c1,l1+10); txtwrite(' ͼ ');
  (* TITRE DU MENU PRINCIPAL *)
  txtcolour(Brillant);
  txtmove(c1+12,l1); txtwrite(' Menu principal ');
  (* CATEGORIES *)
  txtback(Fond3); txtcolour(Normal3);
  txtmove(c2,1); txtwrite(' ͻ ');
  txtmove(c2,2); txtwrite('                                 ');
  for Ligne:=3 to 22 do
    begin
      txtmove(c2,Ligne); txtwrite('      ....................       ');
      txtmove(c2+4,Ligne); txtnumwrite(Ligne-2,2);
    end;
  txtmove(c2,23); txtwrite(' ͼ ');
  txtcolour(Brillant);
  txtmove(c2+11,1); txtwrite(' Catgories ');
  txtmove(c2+4,2); txtwrite('N                      Sit.');
  (* LECTURE DU CLAVIER ET DE LA SOURIS *)
  txtflush; mouseeventparams.me_modified:=false; if Souris then Void:=txtmousecurson;
  Ligne:=l1 + 1; RUBRIQUE_ALLUMEE; MESSAGE_BAS_ECRAN(1); FinProgramme:=false;
  repeat
    if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
    if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
    if txtkeypressed
       then   (* TOUCHE PRESSEE AU CLAVIER *)
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   59:begin   (* F1 : AIDE *)
                        if Souris then Void:=txtmousecursoff;
                        AIDE(hlp_MenuPrincipal);
                        if Souris then Void:=txtmousecurson;
                      end;
                   72,75:begin   (* FLECHE HAUT / FLECHE GAUCHE : RUBRIQUE PRECEDENTE *)
                           if Souris then Void:=txtmousecursoff;
                           RUBRIQUE_ETEINTE; if Ligne = (l1 + 1) then Ligne:=l1 + 9 else dec(Ligne); RUBRIQUE_ALLUMEE;
                           MESSAGE_BAS_ECRAN(Ligne - l1);
                           if Souris then Void:=txtmousecurson;
                         end;
                   71,73,132:begin   (* HOME / (CTRL-)PAGE HAUT : RUBRIQUE 1 *)
                               if Ligne <> (l1 + 1)
                                  then
                                    begin
                                      if Souris then Void:=txtmousecursoff;
                                      RUBRIQUE_ETEINTE; Ligne:=l1 + 1; RUBRIQUE_ALLUMEE;
                                      MESSAGE_BAS_ECRAN(Ligne - l1);
                                      if Souris then Void:=txtmousecurson;
                                    end;
                             end;
                   77,80:begin   (* FLECHE DROITE / FLECHE BAS : RUBRIQUE SUIVANTE *)
                           if Souris then Void:=txtmousecursoff;
                           RUBRIQUE_ETEINTE; if Ligne = (l1 + 9) then Ligne:=l1 + 1 else inc(Ligne); RUBRIQUE_ALLUMEE;
                           MESSAGE_BAS_ECRAN(Ligne - l1);
                           if Souris then Void:=txtmousecurson;
                         end;
                   79,81,118:begin   (* END / (CTRL-)PAGE BAS : DERNIERE RUBRIQUE *)
                               if Ligne <> (l1 + 9)
                                  then
                                    begin
                                      if Souris then Void:=txtmousecursoff;
                                      RUBRIQUE_ETEINTE; Ligne:=l1 + 9; RUBRIQUE_ALLUMEE;
                                      MESSAGE_BAS_ECRAN(Ligne - l1);
                                      if Souris then Void:=txtmousecurson;
                                    end;
                             end;
                   16,19,23,24,25,31,32,34,46:begin   (* ALT-LETTRE : SELECTION D'UNE RUBRIQUE *)
                                                if Souris then Void:=txtmousecursoff;
                                                RUBRIQUE_ETEINTE;
                                                case ord(Entree) of
                                                  16:Ligne:=l1 + 9;   (* ALT-Q *)
                                                  19:Ligne:=l1 + 7;   (* ALT-R *)
                                                  23:Ligne:=l1 + 5;   (* ALT-I *)
                                                  24:Ligne:=l1 + 8;   (* ALT-O *)
                                                  25:Ligne:=l1 + 3;   (* ALT-P *)
                                                  31:Ligne:=l1 + 6;   (* ALT-S *)
                                                  32:Ligne:=l1 + 2;   (* ALT-D *)
                                                  34:Ligne:=l1 + 4;   (* ALT-G *)
                                                  46:Ligne:=l1 + 1;   (* ALT-C *)
                                                end;
                                                MESSAGE_BAS_ECRAN(Ligne - l1);
                                                RUBRIQUE_SELECTIONNEE; SELECTION_RUBRIQUE; RUBRIQUE_ALLUMEE;
                                                if Souris then Void:=txtmousecurson;
                                              end;
                   97:begin   (* CTRL-F4 : DEBOGAGE *)
                        if Souris then Void:=txtmousecursoff;
                        DEBOGAGE;
                        if Souris then Void:=txtmousecurson;
                      end;
                 end;
               end;
             13:begin   (* ENTER : SELECTION D'UNE RUBRIQUE *)
                  if Souris then Void:=txtmousecursoff;
                  RUBRIQUE_SELECTIONNEE; SELECTION_RUBRIQUE; RUBRIQUE_ALLUMEE;
                  if Souris then Void:=txtmousecurson;
                end;
             27:begin   (* ESCAPE : QUITTER *)
                  if Ligne <> (l1 + 9)
                     then
                       begin
                         if Souris then Void:=txtmousecursoff;
                         RUBRIQUE_ETEINTE; Ligne:=l1 + 9; MESSAGE_BAS_ECRAN(Ligne - l1);
                         RUBRIQUE_SELECTIONNEE; SELECTION_RUBRIQUE; RUBRIQUE_ALLUMEE;
                         if Souris then Void:=txtmousecurson;
                       end;
                end;
             67,68,71,73,79..83,99,100,103,105,111..115:begin   (* LETTRE : SELECTION D'UNE RUBRIQUE *)
                                                          if Souris then Void:=txtmousecursoff;
                                                          RUBRIQUE_ETEINTE;
                                                          case ord(Entree) of
                                                            67,99:Ligne:=l1 + 1;    (* "C","c" *)
                                                            68,100:Ligne:=l1 + 2;   (* "D","d" *)
                                                            71,103:Ligne:=l1 + 4;   (* "G","g" *)
                                                            73,105:Ligne:=l1 + 5;   (* "I","i" *)
                                                            79,111:Ligne:=l1 + 8;   (* "O","o" *)
                                                            80,112:Ligne:=l1 + 3;   (* "P","p" *)
                                                            81,113:Ligne:=l1 + 9;   (* "Q","q" *)
                                                            82,114:Ligne:=l1 + 7;   (* "R","r" *)
                                                            83,115:Ligne:=l1 + 6;   (* "S","s" *)
                                                          end;
                                                          MESSAGE_BAS_ECRAN(Ligne - l1);
                                                          RUBRIQUE_SELECTIONNEE; SELECTION_RUBRIQUE; RUBRIQUE_ALLUMEE;
                                                          if Souris then Void:=txtmousecurson;
                                                        end;
           end;
         end;
    if mouseeventparams.me_modified
       then   (* ACTION SOURIS DETECTEE *)
         with mouseeventparams do
           begin
             if (me_x in [(c1+2)..(c1+36)]) and (me_y in [(l1+1)..(l1+9)])
                then
                  begin
                    Void:=txtmousecursoff;
                    RUBRIQUE_ETEINTE; Ligne:=me_y;
                    MESSAGE_BAS_ECRAN(Ligne - l1);
                    RUBRIQUE_SELECTIONNEE; SELECTION_RUBRIQUE; RUBRIQUE_ALLUMEE;
                    Void:=txtmousecurson;
                  end;
             me_modified:=false;
           end;
  until FinProgramme;
  if Souris then Void:=txtmousecursoff;
End;


BEGIN   (* PROGRAMME PRINCIPAL *)
  INITIALISATION_PROGRAMME;
  INTRODUCTION;
  MENU_PRINCIPAL;
  SORTIE_PROGRAMME;
END.
