
UNIT TTO_CATS;

(* CREATION, DESTRUCTION ET MODIFICATION CATEGORIES POUR LE PROGRAMME TTO.PAS 1.20 *)

INTERFACE

Uses TXT,        (* GESTION DE L'ECRAN EN MODE TEXTE *)
     TTO_DECL,   (* DECLARATION DE CONSTANTES, TYPES ET VARIABLES GLOBALES *)
     TTO_HARD,   (* GESTION BAS NIVEAU DE LA SOURIS, ECONOMISEUR D'ECRAN *)
     TTO_COMN,   (* EXPLICATIONS AU BAS DE L'ECRAN, MESSAGES D'AVERTISSEMENT *)
     TTO_LIST,   (* GESTION DES LISTES CHAINEES DE POINTEURS *)
     TTO_FILE,   (* SAUVETAGE AUTOMATIQUE SUR DISQUE *)
     TTO_GENE,   (* PROCEDURE TXTVALIDATE2 *)
     TTO_PRNT,   (* (RE)INITIALISATION DU FICHIER D'IMPRESSION *)
     TTO_HELP;   (* AIDE CONTEXTUELLE ET DEBOGAGE *)


Function CREATION_CATEGORIE (Numero : byte) : boolean;
   (* CREATION D'UNE NOUVELLE CATEGORIE *)
Function DESTRUCTION_CATEGORIE (Numero : byte) : boolean;
   (* DESTRUCTION D'UNE CATEGORIE EXISTANTE *)
Function MODIFICATION_CATEGORIE (Numero : byte) : boolean;
   (* GESTION D'UNE CATEGORIE EXISTANTE *)


IMPLEMENTATION

Function MENU_SITUATION (Numero : byte) : byte;
(* CHOIX DE LA SITUATION DE DEPART DE LA CATEGORIE N Numero DANS UN MENU DEROULANT.
   VALEURS RETOURNEES : 0 = ANNULER,
                        AUTRE = SITUATION CHOISIE. *)
Const c=15; l=8;
Var x,y,x1,y1,x2,y2,FondCourant,CouleurCourante:word;
    Image:videosave;
    Fond1,Normal1,Fond2,Brillant,FondOmbre,Ombre:byte;
    Ligne,Situation:byte;
    Entree:char;
    Ok:boolean;
          Procedure LIGNE_ALLUMEE;
          (* MISE EN EVIDENCE DE LA LIGNE COURANTE *)
          Begin
            txtback(Fond2); txtcolour(Brillant); txtmove(c+25,Ligne+l+4); txtattrib(15);
          End;
          Procedure LIGNE_ETEINTE;
          (* FIN DE LA MISE EN EVIDENCE DE LA LIGNE COURANTE *)
          Begin
            txtback(Fond1); txtcolour(Normal1); txtmove(c+25,Ligne+l+4); txtattrib(15);
          End;
Begin
  case ModeEcran of
    ModeMono:begin
               Fond1:=lightgrey; Normal1:=black; Fond2:=black; Brillant:=white; FondOmbre:=black; Ombre:=lightgrey;
             end;
    ModeCouleur:begin
                  Fond1:=lightgrey; Normal1:=yellow; Fond2:=black; Brillant:=white; FondOmbre:=black; Ombre:=lightgrey;
                end;
  end;
  x:=windx; y:=windy; x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image);
  txtback(Fond1); txtcolour(Normal1);
  txtmove(c+23,l+4);  txtwrite(' ͻ ');
  txtmove(c+23,l+5);  txtwrite('  ELIMINATOIRES  ');
  txtmove(c+23,l+6);  txtwrite('   1/64 FINALE   ');
  txtmove(c+23,l+7);  txtwrite('   1/32 FINALE   ');
  txtmove(c+23,l+8);  txtwrite('   1/16 FINALE   ');
  txtmove(c+23,l+9);  txtwrite('   1/8 FINALE    ');
  txtmove(c+23,l+10); txtwrite('   1/4 FINALE    ');
  txtmove(c+23,l+11); txtwrite('   1/2 FINALE    ');
  txtmove(c+23,l+12); txtwrite('     FINALE      ');
  txtmove(c+23,l+13); txtwrite(' ͼ ');
  txtback(FondOmbre); txtcolour(Ombre);
  for Ligne:=(l+5) to (l+13) do
    begin
      txtmove(c+42,Ligne); txtattrib(2);
    end;
  txtmove(c+25,l+14); txtattrib(19);
  Ok:=false; Ligne:=1; Situation:=255; LIGNE_ALLUMEE; MESSAGE_BAS_ECRAN(ip_ModificationCategorie + 5);
  txtflush; mouseeventparams.me_modified:=false; if Souris then Void:=txtmousecurson;
  repeat
    if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
    if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   59:begin   (* F1 : AIDE *)
                        if Souris then Void:=txtmousecursoff;
                        AIDE(hlp_CreationCategorie + 32);
                        if Souris then Void:=txtmousecursoff;
                      end;
                   71,73,119,132:begin   (* (CTRL-)HOME / (CTRL-)PgUp : LIGNE 1 *)
                                   if Ligne <> 1
                                      then
                                        begin
                                          if Souris then Void:=txtmousecursoff;
                                          LIGNE_ETEINTE; Ligne:=1; Situation:=255; LIGNE_ALLUMEE;
                                          if Souris then Void:=txtmousecurson;
                                        end;
                                 end;
                   15,72:begin   (* TAB GAUCHE / FLECHE HAUT : LIGNE PRECEDENTE *)
                           if Souris then Void:=txtmousecursoff;
                           LIGNE_ETEINTE;
                           case Ligne of
                             1:begin Ligne:=8; Situation:=1; end;
                             2:begin Ligne:=1; Situation:=255; end;
                           else
                             dec(Ligne); Situation:=Situation * 2;
                           end;
                           LIGNE_ALLUMEE;
                           if Souris then Void:=txtmousecurson;
                         end;
                   80:begin   (* FLECHE BAS : LIGNE SUIVANTE *)
                        if Souris then Void:=txtmousecursoff;
                        LIGNE_ETEINTE;
                        case Ligne of
                          1:begin Ligne:=2; Situation:=64; end;
                          8:begin Ligne:=1; Situation:=255; end;
                        else
                          inc(Ligne); Situation:=Situation div 2;
                        end;
                        LIGNE_ALLUMEE;
                        if Souris then Void:=txtmousecurson;
                      end;
                   79,81,117,118:begin   (* (CTRL-)END / (CTRL-)PgDn : DERNIERE LIGNE *)
                                   if Ligne <> 8
                                      then
                                        begin
                                          if Souris then Void:=txtmousecursoff;
                                          LIGNE_ETEINTE; Ligne:=8; Situation:=1; LIGNE_ALLUMEE;
                                          if Souris then Void:=txtmousecurson;
                                        end;
                                 end;
                   97:begin   (* CTRL-F4 : DEBOGAGE *)
                        if Souris then Void:=txtmousecursoff;
                        DEBOGAGE;
                        if Souris then Void:=txtmousecurson;
                      end;
                 end;
               end;
             9:begin   (* TAB DROITE : LIGNE SUIVANTE *)
                 if Souris then Void:=txtmousecursoff;
                 LIGNE_ETEINTE;
                 case Ligne of
                   1:begin Ligne:=2; Situation:=64; end;
                   8:begin Ligne:=1; Situation:=255; end;
                 else
                   inc(Ligne); Situation:=Situation div 2;
                 end;
                 LIGNE_ALLUMEE;
                 if Souris then Void:=txtmousecurson;
               end;
             13:begin   (* ENTER : SELECTIONNER UNE LIGNE *)
                  (* TEST SI COMPATIBILITE AVEC LE NOMBRE DE JOUEURS *)
                  case Ligne of
                    1:Ok:=true;
                    2:Ok:=Categories[Numero].NbJoueurs <= 128;
                    3:Ok:=Categories[Numero].NbJoueurs <= 64;
                    4:Ok:=Categories[Numero].NbJoueurs <= 32;
                    5:Ok:=Categories[Numero].NbJoueurs <= 16;
                    6:Ok:=Categories[Numero].NbJoueurs <= 8;
                    7:Ok:=Categories[Numero].NbJoueurs <= 4;
                    8:Ok:=Categories[Numero].NbJoueurs <= 2;
                  end;
                  if Ok then MENU_SITUATION:=Situation else Void:=MESSAGE_AVERTISSEMENT(ip_ModificationCategorie + 3);
                end;
             27:begin   (* ESCAPE : ABANDONNER *)
                  Ok:=true; MENU_SITUATION:=0;
                end;
           end;
         end;
    if mouseeventparams.me_modified
       then
         with mouseeventparams do
           begin
             if me_x in [(c+25)..(c+39)]
                then
                  begin
                    Ok:=true;
                    if me_y = (l+5) then MENU_SITUATION:=255 else
                    if me_y = (l+6) then MENU_SITUATION:=64 else
                    if me_y = (l+7) then MENU_SITUATION:=32 else
                    if me_y = (l+8) then MENU_SITUATION:=16 else
                    if me_y = (l+9) then MENU_SITUATION:=8 else
                    if me_y = (l+10) then MENU_SITUATION:=4 else
                    if me_y = (l+11) then MENU_SITUATION:=2 else
                    if me_y = (l+12) then MENU_SITUATION:=1 else Ok:=false;
                  end;
             me_modified:=false;
           end;
  until Ok;
  if Souris then Void:=txtmousecursoff;
  txtload(Image); txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


Function MODIFICATION_PARAMETRES_CATEGORIE (Option, Numero : byte) : byte;
(* MODIFICATION DU NOM ET DE LA SITUATION DE DEPART DE LA CATEGORIE N Numero.
   SI Option = mp_Modification, AFFICHAGE D'UN MESSAGE D'AVERTISSEMENT AVANT LA LECTURE DE LA SITUATION DE DEPART.
   SI Option = mp_Creation, AUCUN AVERTISSEMENT.
   VALEURS RETOURNEES : mp_Avorter = L'OPERATION A ETE ANNULEE,
                        mp_Ok = OK ET PAS DE MODIFICATION SITUATION DE DEPART,
                        mp_OkModifie = OK ET MODIFICATION SITUATION DE DEPART. *)
Const c=14; l=9; lg=51; nbl=5;
Var x1,y1,x2,y2,x,y,FondCourant,CouleurCourante:word;
    Image:videosave;
    Fond1,Normal1,Fond2,Brillant,Fond3,Normal3,FondOmbre,Ombre:word;
    Ligne,Rubrique:byte;
    Chaine:string;
    OptionLecture,Resultat,LigneAide:word;
    NomTemp:string[20];
    SituationDepart,SituationTemp,SituationSauve:byte;
    Entree:char;
    Ok,Avorter:boolean;
          Procedure ECRITURE_NOM;
          (* ECRITURE DU NOM DE LA CATEGORIE *)
          Begin
            txtback(Fond3); txtcolour(Normal3);
            txtmove(c+27,l+1); txtwrite('                    '); txtmove(c+27,l+1); txtwrite(NomTemp);
          End;
          Procedure ECRITURE_SITUATION;
          (* ECRITURE DE LA SITUATION *)
          Begin
            txtback(Fond3); txtcolour(Normal3);
            txtmove(c+27,l+2); txtwrite('             ');
            txtmove(c+27,l+2);
            case SituationTemp of
              1:txtwrite('FINALE');
              2..64:begin
                      txtwrite('1/'); txtnumwrite(SituationTemp,0); txtwrite(' FINALE');
                    end;
              255:txtwrite('ELIMINATOIRES');
            end;
          End;
          Procedure RUBRIQUE_ALLUMEE;
          (* MISE EN EVIDENCE DE LA RUBRIQUE COURANTE *)
          Begin
            txtback(Fond2); txtcolour(Brillant);
            case Rubrique of
              1:begin txtmove(c+27,l+1); txtattrib(20); end;
              2:begin txtmove(c+27,l+2); txtattrib(13); end;
              3:begin txtmove(c+10,l+3); txtattrib(10); end;
              4:begin txtmove(c+31,l+3); txtattrib(11); end;
            end;
          End;
          Procedure RUBRIQUE_ETEINTE;
          (* FIN DE LA MISE EN EVIDENCE DE LA RUBRIQUE COURANTE *)
          Begin
            txtback(Fond3); txtcolour(Normal3);
            case Rubrique of
              1:begin txtmove(c+27,l+1); txtattrib(20); end;
              2:begin txtmove(c+27,l+2); txtattrib(13); end;
              3:begin txtmove(c+10,l+3); txtattrib(10); end;
              4:begin txtmove(c+31,l+3); txtattrib(11); end;
            end;
          End;
          Function LECTURE_NOM : word;
          (* LECTURE DU NOM DE LA CATEGORIE.
             RENVOIE LA TOUCHE QUI A CAUSE LA FIN DE LA LECTURE. *)
          Var r:word;
              Ok,Avorter:boolean;
          Begin
            txtflush; txtcurssize(CurseurHaut,CurseurBas); txtback(Fond2); txtcolour(Brillant);
            Chaine:=NomTemp; Ok:=false; Avorter:=false;
            repeat
              txtmove(c+27,l+1); r:=txtvalidate2(Chaine,Chaine,20,OptionLecture,LigneAide,[0..255]);
              if (r and tv_Escape = 0) and (length(Chaine) > 0) and (Chaine[1] <> ' ')
                 then
                   begin
                     NomTemp:=Chaine; Ok:=true;
                   end
                 else
                   Avorter:=true;
            until (Ok) or (Avorter);
            txtcursoff;
            LECTURE_NOM:=r;
          End;
          Procedure ENCODAGE_RUBRIQUE;
          (* ENCODAGE DES RUBRIQUES DU NOM ET DE LA SITUATION DE DEPART *)
          Begin
            case Rubrique of
              1:begin   (* ENCODAGE DU NOM *)
                  Resultat:=LECTURE_NOM; ECRITURE_NOM;
                  if (Resultat = tv_Enter) or (Resultat = tv_ArDn) or (Resultat = tv_TabRi)
                     then
                       Rubrique:=2
                     else
                       if (Resultat = tv_PgDn) or (Resultat = tv_CtrlEnd) or (Resultat = tv_CtrlPgDn)
                          then
                            Rubrique:=3
                          else
                            if (Resultat = tv_ArUp) or (Resultat = tv_Escape) or (Resultat = tv_TabLe)
                               then
                                 Rubrique:=4;
                end;
              2:begin   (* ENCODAGE DE LA SITUATION DE DEPART *)
                  SituationSauve:=SituationTemp; SituationTemp:=MENU_SITUATION(Numero);
                  if SituationTemp <> 0
                     then
                       begin
                         ECRITURE_SITUATION; Rubrique:=3;
                       end
                     else
                       begin
                         SituationTemp:=SituationSauve; ECRITURE_SITUATION;
                       end;
                end;
            end;
          End;
Begin
  case ModeEcran of
    ModeMono:begin
               Fond1:=lightgrey; Normal1:=black; Fond2:=black; Brillant:=white;
               Fond3:=lightgrey; Normal3:=white; FondOmbre:=black; Ombre:=lightgrey;
             end;
    ModeCouleur:begin
                  Fond1:=blue; Normal1:=yellow; Fond2:=brown; Brillant:=white;
                  Fond3:=blue; Normal3:=white; FondOmbre:=black; Ombre:=lightgrey;
                end;
  end;
  x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; x:=windx; y:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image);
  txtback(Fond1); txtcolour(Normal1);
  txtmove(c,l);   txtwrite(' ͻ ');
  txtmove(c,l+1); txtwrite('   Nom de la catgorie : <                    >   ');
  txtmove(c,l+2); txtwrite('   Situation de dpart : <             >          ');
  if Option = mp_Modification then begin txtmove(c+14,l+2); txtwrite('actuelle '); end;
  txtmove(c,l+3); txtwrite('        <          >         <           >        ');
  txtmove(c,l+4); txtwrite(' ͼ ');
  txtback(FondOmbre); txtcolour(Ombre);
  for Ligne:=1 to (nbl-1) do
    begin
      txtmove(c+lg,l+Ligne); txtattrib(2);
    end;
  txtmove(c+2,l+nbl); txtattrib(lg);
  txtback(Fond1); txtcolour(Brillant);
  txtmove(32,l); txtwrite(' Catgorie n '); txtnumwrite(Numero,0); txtwrite(' ');
  txtback(Fond3); txtcolour(Normal3);
  txtmove(c+10,l+3); txtwrite('    OK    '); txtmove(c+31,l+3); txtwrite('  Annuler  ');
  with Categories[Numero] do
    begin
      NomTemp:=NomCategorie; SituationDepart:=Situation; SituationTemp:=Situation;
    end;
  ECRITURE_NOM; ECRITURE_SITUATION;
  OptionLecture:=tv_ArUp or tv_ArDn or tv_PgUp or tv_PgDn or tv_CtrlHome or tv_CtrlPgUp or tv_CtrlEnd or
                 tv_CtrlPgDn or tv_TabLe or tv_TabRi or tv_Upcase;
  if Option = mp_Creation then LigneAide:=hlp_CreationCategorie else LigneAide:=hlp_ParametresCategorie;
  txtflush; mouseeventparams.me_modified:=false; if Souris then Void:=txtmousecurson;
  Ok:=false; Avorter:=false; Rubrique:=1; RUBRIQUE_ALLUMEE; MESSAGE_BAS_ECRAN(ip_ModificationCategorie + 1);
  txtsimulatekey(13,28);
  repeat
    if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
    if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   59:begin   (* F1 : AIDE *)
                        if Souris then Void:=txtmousecursoff;
                        AIDE(LigneAide);
                        if Souris then Void:=txtmousecurson;
                      end;
                   15,72,75:begin   (* TAB GAUCHE / FLECHE HAUT / FLECHE GAUCHE : RUBRIQUE PRECEDENTE *)
                              if Souris then Void:=txtmousecursoff;
                              RUBRIQUE_ETEINTE;
                              case Rubrique of
                                1:Rubrique:=4;
                                2:begin Rubrique:=1; txtsimulatekey(13,28); end;
                              else
                                dec(Rubrique);
                              end;
                              RUBRIQUE_ALLUMEE; MESSAGE_BAS_ECRAN(ip_ModificationCategorie + Rubrique);
                              if Souris then Void:=txtmousecurson;
                            end;
                   71,73,119,132:begin   (* (CTRL-)HOME / (CTRL-)PgUp : RUBRIQUE 1 *)
                                   if Rubrique <> 1
                                      then
                                        begin
                                          if Souris then Void:=txtmousecursoff;
                                          RUBRIQUE_ETEINTE; Rubrique:=1; txtsimulatekey(13,28); RUBRIQUE_ALLUMEE;
                                          MESSAGE_BAS_ECRAN(ip_ModificationCategorie + Rubrique);
                                          if Souris then Void:=txtmousecurson;
                                        end;
                                 end;
                   77,80:begin   (* FLECHE DROITE / FLECHE BAS : RUBRIQUE SUIVANTE *)
                           if Souris then Void:=txtmousecursoff;
                           RUBRIQUE_ETEINTE;
                           case Rubrique of
                             4:begin Rubrique:=1; txtsimulatekey(13,28); end;
                           else
                             inc(Rubrique);
                           end;
                           RUBRIQUE_ALLUMEE; MESSAGE_BAS_ECRAN(ip_ModificationCategorie + Rubrique);
                           if Souris then Void:=txtmousecurson;
                         end;
                   79,81,117,118:begin   (* (CTRL-)END / (CTRL-)PgDn : BOUTON "OK" *)
                                   if Rubrique < 3
                                      then
                                        begin
                                          if Souris then Void:=txtmousecursoff;
                                          RUBRIQUE_ETEINTE; Rubrique:=3; RUBRIQUE_ALLUMEE;
                                          MESSAGE_BAS_ECRAN(ip_ModificationCategorie + Rubrique);
                                          if Souris then Void:=txtmousecurson;
                                        end;
                                 end;
                   97:begin   (* CTRL-F4 : DEBOGAGE *)
                        if Souris then Void:=txtmousecursoff;
                        DEBOGAGE;
                        if Souris then Void:=txtmousecurson;
                      end;
                 end;
               end;
             9:begin   (* TAB DROITE : RUBRIQUE SUIVANTE *)
                 if Souris then Void:=txtmousecursoff;
                 RUBRIQUE_ETEINTE;
                 case Rubrique of
                   4:begin Rubrique:=1; txtsimulatekey(13,28); end;
                 else
                   inc(Rubrique);
                 end;
                 RUBRIQUE_ALLUMEE; MESSAGE_BAS_ECRAN(ip_ModificationCategorie + Rubrique);
                 if Souris then Void:=txtmousecurson;
               end;
             13:begin   (* ENTER : ENCODAGE RUBRIQUE OU "OK" OU "ANNULER" *)
                  case Rubrique of
                    1:begin   (* ENCODAGE NOM *)
                        if Souris then Void:=txtmousecursoff;
                        RUBRIQUE_ETEINTE; ENCODAGE_RUBRIQUE; RUBRIQUE_ALLUMEE;
                        MESSAGE_BAS_ECRAN(ip_ModificationCategorie + Rubrique);
                        if Souris then Void:=txtmousecurson;
                      end;
                    2:begin   (* ENCODAGE SITUATION *)
                        if Souris then Void:=txtmousecursoff;
                        RUBRIQUE_ETEINTE;
                        if Option = mp_Modification then Void:=MESSAGE_AVERTISSEMENT(ip_ModificationCategorie + 1)
                                                     else Void:=true;
                        if Void then ENCODAGE_RUBRIQUE;
                        RUBRIQUE_ALLUMEE;
                        MESSAGE_BAS_ECRAN(ip_ModificationCategorie + Rubrique);
                        if Souris then Void:=txtmousecurson;
                      end;
                    3:begin   (* BOUTON "OK" *)
                        Ok:=(length(NomTemp) > 0) and (SituationTemp <> 0);
                      end;
                    4:Avorter:=true;   (* BOUTON "ANNULER" *)
                  end;
                end;
             27:begin   (* ESCAPE : BOUTON "ANNULER" *)
                  if Souris then Void:=txtmousecursoff;
                  RUBRIQUE_ETEINTE; Rubrique:=4; RUBRIQUE_ALLUMEE;
                  MESSAGE_BAS_ECRAN(ip_ModificationCategorie + 4);
                  if Souris then Void:=txtmousecurson;
                end;
           end;
         end;
    if mouseeventparams.me_modified
       then
         begin
           with mouseeventparams do
             begin
               if (me_y = (l+1)) and (me_x in [(c+27)..(c+46)])
                  then
                    begin   (* ENCODAGE DU NOM *)
                      Void:=txtmousecursoff;
                      RUBRIQUE_ETEINTE; ENCODAGE_RUBRIQUE; RUBRIQUE_ALLUMEE;
                      MESSAGE_BAS_ECRAN(ip_ModificationCategorie + Rubrique);
                      Void:=txtmousecurson;
                    end
                  else
                    if (me_y = (l+2)) and (me_x in [(c+27)..(c+39)])
                       then
                         begin   (* ENCODAGE DE LA SITUATION DE DEPART *)
                           Void:=txtmousecursoff;
                           RUBRIQUE_ETEINTE;
                           if Option = mp_Modification then Void:=MESSAGE_AVERTISSEMENT(ip_ModificationCategorie + 1)
                                                        else Void:=true;
                           if Void then ENCODAGE_RUBRIQUE;
                           RUBRIQUE_ALLUMEE;
                           MESSAGE_BAS_ECRAN(ip_ModificationCategorie + Rubrique);
                           Void:=txtmousecurson;
                         end
                       else
                         if (me_y = (l+3)) and (me_x in [(c+10)..(c+19)])
                            then   (* BOUTON "OK" *)
                              begin
                                Ok:=(length(NomTemp) > 0) and (SituationTemp <> 0);
                              end
                            else
                              if (me_y = (l+3)) and (me_x in [(c+31)..(c+41)])
                                 then   (* BOUTON "ANNULER" *)
                                   Avorter:=true;
               me_modified:=false;
             end;
         end;
  until (Ok) or (Avorter);
  if Souris then Void:=txtmousecursoff;
  if Avorter
     then
       MODIFICATION_PARAMETRES_CATEGORIE:=mp_Avorter
     else
       begin
         if SituationDepart = SituationTemp
            then MODIFICATION_PARAMETRES_CATEGORIE:=mp_Ok
            else MODIFICATION_PARAMETRES_CATEGORIE:=mp_OkModifie;
         with Categories[Numero] do
           begin
             NomCategorie:=NomTemp; Situation:=SituationTemp;
           end;
       end;
  txtload(Image); txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


Function CREATION_CATEGORIE (Numero : byte) : boolean;
(* CREATION D'UNE NOUVELLE CATEGORIE (N Numero).
   RETOURNE true SI L'OPERATION EST VALIDEE, false SINON. *)
Const c=16; l=9; lg=48; nbl=5;
Var x1,y1,x2,y2,x,y,FondCourant,CouleurCourante:word;
    Image:videosave;
    Resultat:byte;
Begin
  x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; x:=windx; y:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image); TITRE_HAUT_ECRAN(1);
  Resultat:=MODIFICATION_PARAMETRES_CATEGORIE(mp_Creation,Numero);
  if Resultat <> mp_Avorter then Void:=INITIALISATION_FICHIER_IMPRESSION(Numero);
  CREATION_CATEGORIE:=(Resultat <> mp_Avorter);
  txtload(Image); txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


Function DESTRUCTION_CATEGORIE (Numero : byte) : boolean;
(* DESTRUCTION DE LA CATEGORIE N Numero.
   RETOURNE true SI L'OPERATION EST VALIDEE, false SINON. *)
Var x1,y1,x2,y2,x,y,FondCourant,CouleurCourante:word;
    Image:videosave;
    Ok:boolean;
Begin
  x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; x:=windx; y:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image); TITRE_HAUT_ECRAN(2);
  Ok:=MESSAGE_AVERTISSEMENT(ip_DestructionCategorie + 1);
  if Ok
     then
       with Categories[Numero] do
         begin
           NomCategorie:=''; Situation:=0; NbJoueurs:=0;
           if pTeteJoueurs <> nil then SUPPRESSION_LISTE_JOUEURS_CATEGORIE(Numero);
           if pTeteMatches <> nil then SUPPRESSION_LISTE_MATCHES_CATEGORIE(Numero);
         end;
  txtload(Image); txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
  DESTRUCTION_CATEGORIE:=Ok;
End;


Function MODIFICATION_CATEGORIE (Numero : byte) : boolean;
(* MODIFICATION DU NOM OU DE LA SITUATION DE LA CATEGORIE N Numero.
   RETOURNE true SI L'OPERATION EST VALIDEE, false SINON. *)
Var x1,y1,x2,y2,x,y,FondCourant,CouleurCourante:word;
    Image:videosave;
    Resultat:byte;
Begin
  x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; x:=windx; y:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image); TITRE_HAUT_ECRAN(3);
  Resultat:=MODIFICATION_PARAMETRES_CATEGORIE(mp_Modification,Numero);
  txtload(Image); txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
  if Resultat = mp_OkModifie
     then
       with Categories[Numero] do
         begin
           if pTeteMatches <> nil then SUPPRESSION_LISTE_MATCHES_CATEGORIE(Numero);
           pTeteMatches:=nil; pQueueMatches:=nil; NbMatches:=0; NbMatchesRestants:=0;
           if pTeteJoueurs <> nil then ANNULATION_RESULTATS_JOUEURS(Numero);
         end;
  if Resultat <> mp_Avorter
     then   (* REMISE A ZERO EVENTUELLE DU FICHIER D'IMPRESSION *)
       if MESSAGE_AVERTISSEMENT(ip_ModificationCategorie + 4) then Void:=INITIALISATION_FICHIER_IMPRESSION(Numero);
  MODIFICATION_CATEGORIE:=(Resultat <> mp_Avorter);
End;


END.
