
UNIT TTO_CLAS;

(* AFFICHAGE DES CLASSEMENTS ET PASSAGE AU TOUR SUIVANT POUR LE PROGRAMME TTO VERSION 1.20 *)

INTERFACE

Uses TXT,        (* GESTION DE L'ECRAN EN MODE TEXTE *)
     TTO_DECL,   (* DECLARATION DES CONSTANTES, TYPES ET VARIABLES GLOBALES *)
     TTO_HARD,   (* GESTION DE LA SOURIS ET ECONOMISEUR D'ECRAN *)
     TTO_COMN,   (* EXPLICATIONS AU BAS DE L'ECRAN ET MESSAGES D'ERREUR OU D'AVERTISSEMENT *)
     TTO_LIST,   (* GESTION DES LISTES CHAINEES DE POINTEURS *)
     TTO_FILE,   (* SAUVETAGE AUTOMATIQUE SUR DISQUE *)
     TTO_HELP;   (* AIDE CONTEXTUELLE ET DEBOGAGE *)


Procedure CALCUL_POINTS (Numero : byte);
   (* CALCUL DES POINTS DE TOUS LES JOUEURS D'UNE CATEGORIE *)
Function CHOIX_SITUATION_TOUR_SUIVANT (Numero : byte) : byte;
   (* CHOIX DE LA SITUATION DU TOUR SUIVANT DANS UN MENU DEROULANT *)
Function CLASSEMENT_SELECTION (Numero : byte; NbJ, NbSelect : word; pTeteListe, pQueueListe : pListeJoueurs) : boolean;
   (* AFFICHAGE DU CLASSEMENT ET/OU SELECTION DE JOUEURS POUR LE TOUR SUIVANT *)


IMPLEMENTATION

Procedure CALCUL_POINTS (Numero : byte);
(* CALCUL DES POINTS DE TOUS LES JOUEURS DE LA CATEGORIE Numero AVANT AFFICHAGE DES RESULTATS.
   LE NOMBRE DE MATCHES JOUES EST EGALEMENT CALCULE.
   TOUS LES MATCHES SONT PASSES EN REVUE. *)
Var pM:pMatch;
    i,NbSets1,NbSets2:byte;
    Fin:boolean;
Begin
  ANNULATION_RESULTATS_JOUEURS(Numero);
  pM:=Categories[Numero].pTeteMatches;
  while pM <> nil do with pM^ do
    begin
      (* MISE A JOUR DU NOMBRE DE MATCHES JOUES PAR LES JOUEURS CONCERNES *)
      if Resultats[1,1] <> Resultats[1,2] then begin inc(pJoueur1^.MatchesJoues); inc(pJoueur2^.MatchesJoues); end;
      (* CALCUL DES POINTS, SETS ET SCORES *)
      i:=1; Fin:=false; NbSets1:=0; NbSets2:=0;
      while (i <= 5) and (not Fin) do
        begin
          if Resultats[i,1] = Resultats[i,2]
             then
               Fin:=true
             else
               if Resultats[i,1] > Resultats[i,2]
                  then   (* LE SET EST POUR LE JOUEUR 1 *)
                    begin
                      inc(NbSets1); inc(pJoueur1^.Sets); dec(pJoueur2^.Sets);
                      inc(pJoueur1^.Score,Resultats[i,1]-Resultats[i,2]); dec(pJoueur2^.Score,Resultats[i,1]-Resultats[i,2]);
                    end
                  else   (* LE SET EST POUR LE JOUEUR 2 *)
                    begin
                      inc(NbSets2); inc(pJoueur2^.Sets); dec(pJoueur1^.Sets);
                      inc(pJoueur2^.Score,Resultats[i,2]-Resultats[i,1]); dec(pJoueur1^.Score,Resultats[i,2]-Resultats[i,1]);
                    end;
          inc(i);
        end;
      if NbSets1 > NbSets2 then inc(pJoueur1^.Points) else if NbSets2 > NbSets1 then inc(pJoueur2^.Points);
      pM:=pM^.pSuiv;
    end;
End;


Function CHOIX_SITUATION_TOUR_SUIVANT (Numero : byte) : byte;
(* CHOIX DE LA SITUATION DU TOUR SUIVANT DANS UN MENU DEROULANT.
   RETOURNE LA SITUATION CHOISIE OU 0 SI ERREUR. *)
Const c=19; l=5; lg=41;
Var x,y,x1,y1,x2,y2,FondCourant,CouleurCourante:word;
    Image:videosave;
    Fond1,Normal1,Fond2,Brillant,FondOmbre,Ombre:word;
    Ligne,NouvelleSituation:byte;
    Entree:char;
    Fin:boolean;
          Procedure LIGNE_ALLUMEE;
          (* MISE EN SURBRILLANCE DE LA LIGNE COURANTE *)
          Begin
            txtback(Fond2); txtcolour(Brillant); txtmove(c+12,l+3+Ligne); txtattrib(17);
          End;
          Procedure LIGNE_ETEINTE;
          (* FIN DE LA MISE EN SURBRILLANCE DE LA LIGNE COURANTE *)
          Begin
            txtback(Fond1); txtcolour(Normal1); txtmove(c+12,l+3+Ligne); txtattrib(17);
          End;
Begin
  case ModeEcran of
    ModeMono:begin Fond1:=lightgrey; Normal1:=black; Fond2:=black; Brillant:=white; FondOmbre:=black; Ombre:=lightgrey; end;
    ModeCouleur:begin Fond1:=blue; Normal1:=yellow; Fond2:=brown; Brillant:=white; FondOmbre:=black; Ombre:=lightgrey; end;
  end;
  x:=windx; y:=windy; x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image);
  (* CADRE *)
  txtback(Fond1); txtcolour(Normal1);
  txtmove(c,l);    txtwrite(' ͻ ');
  txtmove(c,l+1);  txtwrite('  Situation actuelle :                 ');
  txtmove(c,l+2);  txtwrite('       Situation du tour suivant :     ');
  txtmove(c,l+3);  txtwrite('          Ŀ          ');
  txtmove(c,l+4);  txtwrite('            ELIMINATOIRES            ');
  txtmove(c,l+5);  txtwrite('             1/64 FINALE             ');
  txtmove(c,l+6);  txtwrite('             1/32 FINALE             ');
  txtmove(c,l+7);  txtwrite('             1/16 FINALE             ');
  txtmove(c,l+8);  txtwrite('             1/8 FINALE              ');
  txtmove(c,l+9);  txtwrite('             1/4 FINALE              ');
  txtmove(c,l+10); txtwrite('             1/2 FINALE              ');
  txtmove(c,l+11); txtwrite('               FINALE                ');
  txtmove(c,l+12); txtwrite('                FINIE                ');
  txtmove(c,l+13); txtwrite('                    ');
  txtmove(c,l+14); txtwrite(' ͼ ');
  txtcolour(Brillant); txtmove(26,l); txtwrite(' Situation du tour suivant ');
  txtmove(c+24,l+1);
  case Categories[Numero].Situation of
    1:txtwrite('FINALE');
    2..64:begin txtwrite('1/'); txtnumwrite(Categories[Numero].Situation,0); txtwrite(' FINALE'); end;
    254:txtwrite('FINIE');
    255:txtwrite('ELIMINATOIRES');
  end;
  txtback(FondOmbre); txtcolour(Ombre);
  for Ligne:=1 to 14 do begin txtmove(c+lg,l+Ligne); txtattrib(2); end;
  txtmove(c+2,l+15); txtattrib(lg);
  (* LECTURE DU CLAVIER ET DE LA SOURIS *)
  txtflush; mouseeventparams.me_modified:=false; MESSAGE_BAS_ECRAN(ip_PassageTourSuivant + 1);
  Fin:=false; Ligne:=1; LIGNE_ALLUMEE; if Souris then Void:=txtmousecurson;
  repeat
    if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
    if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   59:begin   (* F1 : AIDE *)
                        if Souris then Void:=txtmousecursoff;
                        AIDE(hlp_PassageTourSuivant + 27);
                        if Souris then Void:=txtmousecurson;
                      end;
                   15,72:begin   (* TAB GAUCHE / FLECHE HAUT : LIGNE PRECEDENTE *)
                           if Souris then Void:=txtmousecursoff;
                           LIGNE_ETEINTE; if Ligne = 1 then Ligne:=9 else dec(Ligne); LIGNE_ALLUMEE;
                           if Souris then Void:=txtmousecurson;
                         end;
                   71,73,119,132:if Ligne > 1   (* (CTRL-)HOME / (CTRL-)PgUp : 1ERE LIGNE *)
                                    then
                                      begin
                                        if Souris then Void:=txtmousecursoff;
                                        LIGNE_ETEINTE; Ligne:=1; LIGNE_ALLUMEE;
                                        if Souris then Void:=txtmousecurson;
                                      end;
                   80:begin   (* FLECHE BAS : LIGNE SUIVANTE *)
                        if Souris then Void:=txtmousecursoff;
                        LIGNE_ETEINTE; if Ligne = 9 then Ligne:=1 else inc(Ligne); LIGNE_ALLUMEE;
                        if Souris then Void:=txtmousecurson;
                      end;
                   79,81,117,118:if Ligne < 9   (* (CTRL-)END / (CTRL-)PgDn : DERNIERE LIGNE *)
                                    then
                                      begin
                                        if Souris then Void:=txtmousecursoff;
                                        LIGNE_ETEINTE; Ligne:=9; LIGNE_ALLUMEE;
                                        if Souris then Void:=txtmousecurson;
                                      end;
                   97:begin   (* CTRL-F4 : DEBOGAGE *)
                        if Souris then Void:=txtmousecursoff;
                        AIDE(hlp_PassageTourSuivant);
                        if Souris then Void:=txtmousecurson;
                      end;
                 end;
               end;
             9:begin   (* TAB DROITE : LIGNE SUIVANTE *)
                 if Souris then Void:=txtmousecursoff;
                 LIGNE_ETEINTE; if Ligne = 9 then Ligne:=1 else inc(Ligne); LIGNE_ALLUMEE;
                 if Souris then Void:=txtmousecurson;
               end;
             13:begin   (* ENTER : SELECTION D'UNE SITUATION *)
                  case Ligne of
                    1:NouvelleSituation:=255;
                    2:NouvelleSituation:=64;
                    3:NouvelleSituation:=32;
                    4:NouvelleSituation:=16;
                    5:NouvelleSituation:=8;
                    6:NouvelleSituation:=4;
                    7:NouvelleSituation:=2;
                    8:NouvelleSituation:=1;
                    9:NouvelleSituation:=254;
                  end;
                  if NouvelleSituation in [254,255]
                     then
                       Fin:=true
                     else
                       if NouvelleSituation <= (Categories[Numero].NbJoueursRestants div 2)
                          then   (* OK POUR LE NOMBRE DE JOUEURS EN LICE *)
                            Fin:=true
                          else   (* PAS ASSEZ DE JOUEURS EN LICE *)
                            Void:=MESSAGE_AVERTISSEMENT(ip_PassageTourSuivant + 3);
                end;
             27:begin   (* ESCAPE : ANNULER *)
                  Fin:=true; CHOIX_SITUATION_TOUR_SUIVANT:=0;
                end;
           end;
         end;
    if mouseeventparams.me_modified
       then
         with mouseeventparams do
           begin
             if (me_x in [(c+12)..(c+28)]) and (me_y in [(l+4)..(l+11)])
                then
                  begin
                    Void:=txtmousecursoff;
                    LIGNE_ETEINTE; Ligne:=me_y - l - 3;
                    case Ligne of
                      1:NouvelleSituation:=255;
                      2:NouvelleSituation:=64;
                      3:NouvelleSituation:=32;
                      4:NouvelleSituation:=16;
                      5:NouvelleSituation:=8;
                      6:NouvelleSituation:=4;
                      7:NouvelleSituation:=2;
                      8:NouvelleSituation:=1;
                      9:NouvelleSituation:=254;
                    end;
                    if NouvelleSituation in [254,255]
                       then
                         Fin:=true
                       else
                         if NouvelleSituation <= (Categories[Numero].NbJoueursRestants div 2)
                            then   (* OK POUR LE NOMBRE DE JOUEURS EN LICE *)
                              Fin:=true
                            else   (* PAS ASSEZ DE JOUEURS EN LICE *)
                              Void:=MESSAGE_AVERTISSEMENT(ip_PassageTourSuivant + 3);
                    LIGNE_ALLUMEE;
                    Void:=txtmousecurson;
                  end;
             me_modified:=false;
           end;
  until Fin;
  if Souris then Void:=txtmousecursoff;
  CHOIX_SITUATION_TOUR_SUIVANT:=NouvelleSituation;
  txtload(Image);
  txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


Function CLASSEMENT_SELECTION (Numero : byte; NbJ, NbSelect : word; pTeteListe, pQueueListe : pListeJoueurs) : boolean;
(* AFFICHAGE DE LA LISTE DES JOUEURS DE LA CATEGORIE Numero EXTRAITE PAR EXTRACTION_LISTE_JOUEURS.
   LA LISTE EST POINTEE PAR pTeteListe ET pQueueLISTE. LE NOMBRE DE JOUEURS DE LA LISTE EST NbJ.
   LA PROCEDURE SERT POUR L'AFFICHAGE SIMPLE DU CLASSEMENT ET POUR LA SELECTION POUR LE TOUR SUIVANT.
   NbSelect : 0 = AUCUN JOUEUR A SELECTIONNER (CATEGORIE AU STADE "FINIE"),
              1 = SELECTION D'AU MOINS 2 JOUEURS (SELECTION POUR ELIMINATOIRES),
              AUTRE = NOMBRE DE JOUEURS A SELECTIONNER POUR LE TOUR SUIVANT.
   RETOURNE true SI L'OPERATION DE SELECTION A ETE COMPLETEMENT ACHEVEE. *)
Const c=0; lg=79; NbL=20; yHaut=3;
      LigneVierge:string[76]='                                                                     ';
Var x,y,x1,y1,x2,y2,FondCourant,CouleurCourante:word;
    Fond1,Normal1,Fond2,Brillant:word;
    Image:videosave;
    TableauPointeurs:array[1..NbL] of pListeJoueurs;
    pLJ:pListeJoueurs;
    JoueurHaut,NbJoueursSelectionnes,LigneAide:word;
    Ligne:byte;
    Entree:char;
    Fin:boolean;
          Procedure LIGNE_ALLUMEE;
          (* MISE EN SURBRILLANCE DE LA LIGNE COURANTE *)
          Begin
            txtback(Fond2); txtcolour(Brillant); txtmove(c+2,Ligne); txtattrib(75);
          End;
          Procedure LIGNE_ETEINTE;
          (* FIN DE LA MISE EN SURBRILLANCE DE LA LIGNE COURANTE *)
          Begin
            txtback(Fond1); txtcolour(Normal1); txtmove(c+2,Ligne); txtattrib(75);
          End;
          Procedure AFFICHAGE_JOUEUR (l:byte);
          (* AFFICHAGE DU JOUEUR CORRESPONDANT A LA LIGNE l DE TableauPointeurs ET DE SES RESULTATS *)
          Var p:pJoueur;
              Chaine:string[5];
              a:byte;
          Begin
            txtback(Fond1); txtcolour(Normal1);
            txtmove(c+3,l+yHaut-1); if TableauPointeurs[l]^.Selection then txtwrite(#251) else txtwrite(' ');
            p:=TableauPointeurs[l]^.PointeurJoueur;
            with p^ do
              begin
                txtmove(c+8,l+yHaut-1); txtwrite(NomJoueur); txtmove(c+24,l+yHaut-1); txtwrite(PrenomJoueur);
                if (Categories[Numero].Situation = 255) and (Poule <> 0)
                   then
                     begin
                       str(Poule,Chaine); txtmove(c+42+(5-length(Chaine)) div 2 + 1,l+yHaut-1); txtwrite(Chaine);
                     end;
                str(MatchesJoues,Chaine); txtmove(c+49+(5-length(Chaine)) div 2 + 1,l+yHaut-1); txtwrite(Chaine);
                str(points,Chaine); txtmove(c+56+(5-length(Chaine)) div 2 + 1,l+yHaut-1); txtwrite(Chaine);
                str(Sets,Chaine); txtmove(c+63+(5-length(Chaine)) div 2 + 1,l+yHaut-1); txtwrite(Chaine);
                str(Score,Chaine); txtmove(c+70+(5-length(Chaine)) div 2 + 1,l+yHaut-1); txtwrite(Chaine);
              end;
          End;
          Procedure AFFICHAGE_PAGE;
          (* AFFICHAGE DU TABLEAU COMPLET DE JOUEURS (TableauPointeurs) *)
          Var i:byte;
          Begin
            txtback(Fond1); txtcolour(Normal1);
            for i:=1 to NbL do
              begin
                txtmove(c+3,i+yHaut-1); txtwrite(' '); txtmove(c+8,i+yHaut-1); txtwrite('                                ');
                txtmove(c+43,i+yHaut-1); txtwrite('      '); txtmove(c+50,i+yHaut-1); txtwrite('      ');
                txtmove(c+57,i+yHaut-1); txtwrite('      '); txtmove(c+64,i+yHaut-1); txtwrite('      ');
                txtmove(c+71,i+yHaut-1); txtwrite('      ');
                if TableauPointeurs[i] <> nil then AFFICHAGE_JOUEUR(i);
              end;
          End;
          Procedure AFFICHAGE_NOMBRE_SELECTIONNES;
          (* AFFICHAGE DU NOMBRE DE JOUEURS SELECTIONNES AU BAS DE L'ECRAN *)
          Begin
            txtback(Fond1); txtcolour(Brillant); txtmove(c+45,23); txtnumwrite(NbJoueursSelectionnes,5);
          End;
          Procedure PREMIER_JOUEUR;
          (* REMONTEE JUSQU'AU PREMIER JOUEUR *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pPrec <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if JoueurHaut > 1
                      then   (* SCROLLING *)
                        begin
                          i:=1; pLJ:=pTeteListe;
                          while (i <= NbL) and (pLJ <> nil) do
                            begin
                              TableauPointeurs[i]:=pLJ; inc(i); if pLJ <> nil then pLJ:=pLJ^.pSuiv;
                            end;
                          JoueurHaut:=1; AFFICHAGE_PAGE;
                        end;
                   Ligne:=yHaut; LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure DERNIER_JOUEUR;
          (* DESCENTE JUSQU'AU DERNIER JOUEUR *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pSuiv <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if NbJ > NbL
                      then   (* IL FAUDRA TESTER SI SCROLLING *)
                        begin
                          if JoueurHaut < (NbJ - NbL + 1)
                             then   (* LE DERNIER JOUEUR N'EST PAS A L'ECRAN : SCROLLING *)
                               begin
                                 i:=NbL; pLJ:=pQueueListe;
                                 while (i >= 1) and (pLJ <> nil) do
                                   begin
                                     TableauPointeurs[i]:=pLJ; dec(i); if pLJ <> nil then pLJ:=pLJ^.pPrec;
                                   end;
                                 Ligne:=yHaut + NbL - 1; JoueurHaut:=NbJ - NbL + 1; AFFICHAGE_PAGE;
                               end
                             else   (* LE DERNIER JOUEUR EST A L'ECRAN *)
                               Ligne:=NbJ - JoueurHaut + yHaut;
                        end
                      else   (* MOINS DE JOUEURS QUE DE LIGNES : DERNIER JOUEUR A L'ECRAN *)
                        Ligne:=NbJ + yHaut - 1;
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure JOUEUR_PRECEDENT;
          (* REMONTEE AU JOUEUR PRECEDENT *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pPrec <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if Ligne = yHaut
                      then   (* SCROLLING *)
                        begin
                          for i:=NbL downto 2 do TableauPointeurs[i]:=TableauPointeurs[i-1];
                          TableauPointeurs[1]:=TableauPointeurs[1]^.pPrec; dec(JoueurHaut);
                          txtwind(c+2,3,c+76,22); txtinsdn(0); txtunwind; txtmove(c+2,3); txtwrite(LigneVierge);
                          AFFICHAGE_JOUEUR(1);
                        end
                      else   (* PAS DE SCROLLING *)
                        dec(Ligne);
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure JOUEUR_SUIVANT;
          (* DESCENTE AU JOUEUR SUIVANT *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pSuiv <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if Ligne = (yHaut + NbL - 1)
                      then   (* SCROLLING *)
                        begin
                          for i:=1 to (NbL - 1) do TableauPointeurs[i]:=TableauPointeurs[i+1];
                          TableauPointeurs[NbL]:=TableauPointeurs[NbL]^.pSuiv; inc(JoueurHaut);
                          txtwind(c+2,3,c+76,22); txtdeldn(0); txtunwind; txtmove(c+2,22); txtwrite(LigneVierge);
                          AFFICHAGE_JOUEUR(NbL);
                        end
                      else   (* PAS DE SCROLLING *)
                        inc(Ligne);
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure PAGE_PRECEDENTE;
          (* AFFICHAGE DE LA PAGE DE JOUEURS PRECEDENTE *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pPrec <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if JoueurHaut > (NbL - 1)
                      then   (* SCROLLING D'UNE PAGE ENTIERE *)
                        begin
                          pLJ:=TableauPointeurs[1]; TableauPointeurs[NbL]:=pLJ; pLJ:=pLJ^.pPrec;
                          for i:=(NbL - 1) downto 1 do
                            begin
                              TableauPointeurs[i]:=pLJ; pLJ:=pLJ^.pPrec;
                            end;
                          dec(JoueurHaut,NbL - 1); AFFICHAGE_PAGE;
                        end
                      else
                        if JoueurHaut > 1
                           then   (* PREMIERE PAGE *)
                             begin
                               i:=1; pLJ:=pTeteListe;
                               while (i <= NbL) and (pLJ <> nil) do
                                 begin
                                   TableauPointeurs[i]:=pLJ; inc(i); if pLJ <> nil then pLJ:=pLJ^.pSuiv;
                                 end;
                               JoueurHaut:=1; AFFICHAGE_PAGE;
                             end
                           else   (* PAS DE SCROLLING *)
                             Ligne:=yHaut;
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure PAGE_SUIVANTE;
          (* AFFICHAGE DE LA PAGE DE JOUEURS SUIVANTE *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pSuiv <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if NbJ > (2 * (NbL - 1))
                      then   (* IL FAUDRA TESTER SI SCROLLING PAGE ENTIERE *)
                        begin
                          if JoueurHaut <= (NbJ - 2 * (NbL - 1))
                             then   (* SCROLLING D'UNE PAGE ENTIERE *)
                               begin
                                 pLJ:=TableauPointeurs[NbL]; TableauPointeurs[1]:=pLJ; pLJ:=pLJ^.pSuiv;
                                 for i:=2 to NbL do
                                   begin
                                     TableauPointeurs[i]:=pLJ; pLJ:=pLJ^.pSuiv;
                                   end;
                                 inc(JoueurHaut,NbL - 1); AFFICHAGE_PAGE;
                               end
                             else
                               if JoueurHaut < (NbJ - NbL + 1)
                                  then   (* AFFICHAGE DE LA DERNIERE PAGE *)
                                    begin
                                      i:=NbL; pLJ:=pQueueListe;
                                      while (i >= 1) and (pLJ <> nil) do
                                        begin
                                          TableauPointeurs[i]:=pLJ; dec(i); if pLJ <> nil then pLJ:=pLJ^.pPrec;
                                        end;
                                      JoueurHaut:=NbJ - NbL + 1; AFFICHAGE_PAGE;
                                    end
                                  else   (* DERNIERE PAGE DEJA AFFICHEE *)
                                    Ligne:=NbJ - JoueurHaut + yHaut;
                        end
                      else
                        if NbJ > NbL
                           then   (* IL FAUDRA TESTER SI SCROLLING *)
                             begin
                               if JoueurHaut < (NbJ - NbL + 1)
                                  then   (* AFFICHAGE DE LA DERNIERE PAGE *)
                                    begin
                                      i:=NbL; pLJ:=pQueueListe;
                                      while (i >= 1) and (pLJ <> nil) do
                                        begin
                                          TableauPointeurs[i]:=pLJ; dec(i); if pLJ <> nil then pLJ:=pLJ^.pPrec;
                                        end;
                                      JoueurHaut:=NbJ - NbL + 1; AFFICHAGE_PAGE;
                                    end
                                  else   (* DERNIERE PAGE DEJA AFFICHEE *)
                                    Ligne:=NbJ - JoueurHaut + yHaut;
                             end
                           else   (* MOINS DE JOUEURS QUE DE LIGNES : L'UNIQUE ET DERNIERE PAGE EST DEJA AFFICHEE *)
                             Ligne:=NbJ + yHaut - 1;
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure SELECTION_DESELECTION;
          (* SELECTION/DESELECTION DU JOUEUR SURBRILLE *)
          Var Ok:boolean;
          Begin
            Ok:=true;
            with TableauPointeurs[Ligne-yHaut+1]^ do
              begin
                if Selection
                   then   (* DESELECTION *)
                     begin
                       Selection:=false; dec(NbJoueursSelectionnes);
                     end
                   else
                     if NbSelect = 1
                        then   (* PAS DE NOMBRE LIMITE A SELECTIONNER *)
                          begin
                            Selection:=true; inc(NbJoueursSelectionnes);
                          end
                        else   (* NOMBRE LIMITE A SELECTIONNER *)
                          if NbJoueursSelectionnes < NbSelect
                             then   (* SELECTION *)
                               begin
                                 Selection:=true; inc(NbJoueursSelectionnes);
                               end
                             else   (* LE NOMBRE DE SELECTIONNES EST DEJA ATTEINT *)
                               begin
                                 Void:=MESSAGE_AVERTISSEMENT(ip_PassageTourSuivant + 1); Ok:=false;
                               end;
              end;
            if Ok
               then
                 begin
                   AFFICHAGE_JOUEUR(Ligne-yHaut+1); AFFICHAGE_NOMBRE_SELECTIONNES;
                 end;
          End;
Begin
  case ModeEcran of
    ModeMono:begin Fond1:=lightgrey; Normal1:=black; Fond2:=black; Brillant:=white; end;
    ModeCouleur:begin Fond1:=blue; Normal1:=yellow; Fond2:=brown; Brillant:=white; end;
  end;
  x:=windx; y:=windy; x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image);
  (* CADRE *)
  txtback(Fond1); txtcolour(Normal1);
  txtmove(c,1); txtwrite(' ͻ ');
  txtmove(c,2); txtwrite('                                                                       ');
  for Ligne:=3 to 22 do
    begin
      txtmove(c,Ligne); txtwrite('                                                                       ');
    end;
  txtmove(c,23); txtwrite(' ͼ ');
  (* TITRES *)
  if NbSelect = 0 then TITRE_HAUT_ECRAN(ip_AffichageClassement) else TITRE_HAUT_ECRAN(ip_PassageTourSuivant);
  txtcolour(Brillant); txtmove(28,1); txtwrite(' Classement des joueurs ');
  txtmove(c+2,2); txtwrite('Sl'); txtmove(c+22,2); txtwrite('Joueur');
  txtmove(c+43,2); txtwrite('Poule'); txtmove(c+51,2); txtwrite('Jou'); txtmove(c+57,2); txtwrite('Points');
  txtmove(c+65,2); txtwrite('Sets'); txtmove(c+71,2); txtwrite('Score');
  if NbSelect <> 0
     then
       begin
         txtmove(c+21,23); txtwrite(' Joueurs slectionns :     0 / ');
         if NbSelect = 1 then txtwrite('?') else txtnumwrite(NbSelect,0); txtwrite(' ');
       end;
  (* BOUTONS DE LA SOURIS *)
  txtmove(c+77,3); txtwrite(''); txtmove(c+77,4); txtwrite(#30); txtmove(c+77,5); txtwrite(#24);
  txtmove(c+77,22); txtwrite(''); txtmove(c+77,21); txtwrite(#31); txtmove(c+77,20); txtwrite(#25);
  (* INITIALISATION DU TABLEAU DE POINTEURS *)
  for Ligne:=1 to NbL do TableauPointeurs[Ligne]:=nil;
  Ligne:=1; pLJ:=pTeteListe;
  while (pLJ <> nil) and (Ligne <= NbL) do
    begin
      TableauPointeurs[Ligne]:=pLJ; pLJ:=pLJ^.pSuiv; inc(Ligne);
    end;
  AFFICHAGE_PAGE;
  if NbSelect = 0 then LigneAide:=hlp_AffichageClassement else LigneAide:=hlp_PassageTourSuivant + 87;
  (* LECTURE DU CLAVIER ET DE LA SOURIS *)
  NbJoueursSelectionnes:=0; JoueurHaut:=1;
  txtflush; mouseeventparams.me_modified:=false; Ligne:=yHaut; LIGNE_ALLUMEE; Fin:=false;
  if NbSelect = 0 then MESSAGE_BAS_ECRAN(ip_AffichageClassement) else MESSAGE_BAS_ECRAN(ip_PassageTourSuivant);
  if Souris then Void:=txtmousecurson;
  repeat
    if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
    if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   59:begin   (* F1 : AIDE *)
                        if Souris then Void:=txtmousecursoff;
                        AIDE(LigneAide);
                        if Souris then Void:=txtmousecurson;
                      end;
                   71,119,132:PREMIER_JOUEUR;   (* (CTRL-)HOME / CTRL-PgUp : JOUEUR 1 *)
                   15,72:JOUEUR_PRECEDENT;      (* TAB GAUCHE / FLECHE HAUT : JOUEUR PRECEDENT *)
                   73:PAGE_PRECEDENTE;          (* PgUp : PAGE PRECEDENTE *)
                   80:JOUEUR_SUIVANT;           (* FLECHE BAS : JOUEUR SUIVANT *)
                   81:PAGE_SUIVANTE;            (* PgDn : PAGE SUIVANTE *)
                   79,117,118:DERNIER_JOUEUR;   (* (CTRL-)END / CTRL-PgDn : DERNIER JOUEUR *)
                   97:begin   (* CTRL-F4 : DEBOGAGE *)
                        if Souris then Void:=txtmousecursoff;
                        DEBOGAGE;
                        if Souris then Void:=txtmousecurson;
                      end;
                 end;
               end;
             9:JOUEUR_SUIVANT;   (* TAB DROITE : JOUEUR SUIVANT *)
             13,32:if NbSelect <> 0   (* ENTER / ESPACE : SELECTION/DESELECTION D'UN JOUEUR *)
                      then
                        begin
                          if Souris then Void:=txtmousecursoff;
                          LIGNE_ETEINTE; SELECTION_DESELECTION; LIGNE_ALLUMEE;
                          if Souris then Void:=txtmousecurson;
                        end;
             27:if NbSelect = 0   (* ESCAPE : SORTIE *)
                   then   (* AUCUN JOUEUR A SELECTIONNER *)
                     begin
                       Fin:=true; CLASSEMENT_SELECTION:=true;
                     end
                   else   (* PASSAGE AU TOUR SUIVANT *)
                     if NbJoueursSelectionnes = NbSelect
                        then
                          begin
                            Fin:=true; CLASSEMENT_SELECTION:=true;
                          end
                        else
                          if MESSAGE_AVERTISSEMENT(ip_PassageTourSuivant)
                             then
                               begin
                                 Fin:=true; CLASSEMENT_SELECTION:=false;
                               end;
           end;
         end;
    if mouseeventparams.me_modified
       then
         with mouseeventparams do
           begin
             if me_x = (c+77)
                then   (* BOUTON *)
                  begin
                    case me_y of
                      3:PREMIER_JOUEUR;
                      4:PAGE_PRECEDENTE;
                      5:JOUEUR_PRECEDENT;
                      20:JOUEUR_SUIVANT;
                      21:PAGE_SUIVANTE;
                      22:DERNIER_JOUEUR;
                    end;
                  end
                else
                  if (me_x in [(c+2)..(c+76)]) and (me_y in [3..22]) and (NbSelect <> 0) and
                     (TableauPointeurs[me_y-yHaut+1] <> nil)
                     then   (* SELECTION/DESELECTION DU JOUEUR COURANT *)
                       begin
                         Void:=txtmousecursoff;
                         LIGNE_ETEINTE; Ligne:=me_y; SELECTION_DESELECTION; LIGNE_ALLUMEE;
                         Void:=txtmousecurson;
                       end;
             me_modified:=false;
           end;
  until Fin;
  if Souris then Void:=txtmousecursoff;
  txtload(Image);
  txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


END.
