
UNIT TTO_COMN;

(* MODULES COMMUNS A TOUTES LES UNITES DU PROGRAMME TTO VERSION 1.20 :
   - AFFICHAGE DE LA LIGNE D'EXPLICATION AU BAS DE L'ECRAN;
   - AFFICHAGE DU TITRE A LA 1ERE LIGNE DE L'ECRAN;
   - AFFICHAGE D'UN MESSAGE D'AVERTISSEMENT OU DE CONFIRMATION;
   - AFFICHAGE D'UN MESSAGE D'ERREUR;
   - CONVERSIONS DE CHAINES (SUITE DE CODES ASCII <--> CHAINE DE CARACTERES). *)


INTERFACE

Uses TXT,        (* GESTION DE L'ECRAN EN MODE TEXTE (VERSION 2.00) *)
     TTO_DECL,   (* DECLARATIONS DE TYPES, CONSTANTES ET VARIABLES GLOBALES *)
     TTO_HARD;   (* GESTION BAS NIVEAU SOURIS ET ECONOMISEUR D'ECRAN *)


Procedure MESSAGE_BAS_ECRAN (n : word);
   (* AFFICHAGE D'UN MESSAGE SUR LA DERNIERE LIGNE DE L'ECRAN *)
Procedure TITRE_HAUT_ECRAN (n : word);
   (* AFFICHAGE D'UN TITRE SUR LA 1ERE LIGNE DE L'ECRAN *)
Function MESSAGE_AVERTISSEMENT (n : word) : boolean;
   (* AFFICHE UN MESSAGE D'AVERTISSEMENT (BOITE DE DIALOGUE) *)
Function MESSAGE_ERREUR (n : word) : boolean;
   (* AFFICHE UN MESSAGE D'ERREUR (BOITE DE DIALOGUE) *)

Function CHAR_TO_ASCII (ChaineChar : string) : string;
   (* TRADUIT UNE CHAINE DE CARACTERES EN UNE SUITE DE CODES ASCII (EXEMPLE : '!]M' --> '33 93 77') *)
Function ASCII_TO_CHAR (ChaineAscii : string) : string;
   (* TRADUIT UNE SUITE DE CODES ASCII EN UNE CHAINE DE CARACTERES (EXEMPLE : '33 93 77' --> '!]M') *)


IMPLEMENTATION

Procedure MESSAGE_BAS_ECRAN (n : word);
(* AFFICHAGE D'UN MESSAGE SUR LA DERNIERE LIGNE DE L'ECRAN *)
Var x,y,x1,y1,x2,y2,FondCourant,CouleurCourante:word;
    Fond,Couleur:word;
Begin
  case ModeEcran of
    ModeMono:begin Fond:=lightgrey; Couleur:=black; end;
    ModeCouleur:begin Fond:=cyan; Couleur:=yellow; end;
  end;
  x:=windx; y:=windy; x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtback(Fond); txtcolour(Couleur); txtmove(0,24);
  case n of
    (* RUBRIQUES DU MENU PRINCIPAL *)
    1:   txtwrite(' Cration d''une nouvelle catgorie                                     F1-Aide ');
    2:   txtwrite(' Destruction d''une catgorie existante et de tout ce qui y a trait     F1-Aide ');
    3:   txtwrite(' Modification du nom de la catgorie ou de sa situation de dpart      F1-Aide ');
    4:   txtwrite(' Inscriptions de joueurs, rsultats des matches, classements...        F1-Aide ');
    5:   txtwrite(' Impression des rsultats partiels ou finaux des catgories choisies   F1-Aide ');
    6:   txtwrite(' Sauvetage de la situation sur disque dur ou disquette                 F1-Aide ');
    7:   txtwrite(' Rcupration de la situation sauve sur disque dur ou disquette       F1-Aide ');
    8:   txtwrite(' Options du programme (sauvetage automatique, options d''impression...) F1-Aide ');
    9:   txtwrite(' Quitter dfinitivement le programme                                   F1-Aide ');
    (* MESSAGES BOITE DE DIALOGUE "MODIFIER UNE CATEGORIE" *)
    301: txtwrite(' Nom de la catgorie : 20 caractres maximum (mise en majuscules automatique)  ');
    302: txtwrite(' Pressez ENTER pour choisir la situation de dpart (ESCAPE = Annuler)  F1-Aide ');
    303: txtwrite(' Enregistrer les changements et retourner au menu principal            F1-Aide ');
    304: txtwrite(' Retourner au menu principal sans enregistrer les changements          F1-Aide ');
    305: txtwrite(' Pressez ENTER pour choisir une situation ou ESCAPE pour annuler       F1-Aide ');
    (* MESSAGE DE SELECTION D'UN JOUEUR *)
    400: txtwrite(' Slectionnez avec ENTER ou avec la souris (ESCAPE = Annuler)          F1-Aide ');
    (* MESSAGES MENU "GESTION CATEGORIE" *)
    401: txtwrite(' Inscription d''un joueur dans la catgorie                             F1-Aide ');
    402: txtwrite(' Suppression d''un joueur et donc des matches le concernant             F1-Aide ');
    403: txtwrite(' Modifier les donnes d''un joueur (nom, prnom, ge, club)             F1-Aide ');
    404: txtwrite(' Affichage du classement actuel (par poules ou par catgorie entire)  F1-Aide ');
    405: txtwrite(' Division ou redivision de la catgorie en poules (si liminatoires)   F1-Aide ');
    406: txtwrite(' Cration automatique (si liminatoires) ou manuelle des matches       F1-Aide ');
    407: txtwrite(' Encodage ou modification du rsultat COMPLET d''un match               F1-Aide ');
    408: txtwrite(' A la fin d''un tour, passage au tour suivant (Ex. 1/8 --> 1/4 finale)  F1-Aide ');
    409: txtwrite(' Retour au menu principal                                              F1-Aide ');
    (* MESSAGES BOITE DE DIALOGUE "MODIFIER UN JOUEUR" *)
    431: txtwrite(' Nom : 15 caractres maximum (mise en majuscules automatique)          F1-Aide ');
    432: txtwrite(' Prnom : 15 caractres maximum (mise en majuscules automatique)       F1-Aide ');
    433: txtwrite(' Age (facultatif)                                                      F1-Aide ');
    434: txtwrite(' Club (facultatif)                                                     F1-Aide ');
    435: txtwrite(' Enregistrer les changements et retourner au menu de gestion           F1-Aide ');
    436: txtwrite(' Retourner au menu de gestion sans enregistrer les changements         F1-Aide ');
    (* MESSAGE AFFICHAGE DU CLASSEMENT *)
    440: txtwrite(' Pressez ESCAPE pour quitter                                           F1-Aide ');
    (* MESSAGE REPARTITION DES JOUEURS DANS LES POULES *)
    450: txtwrite(' Pressez ENTER pour choisir un joueur ou ESCAPE pour quitter           F1-Aide ');
    (* MESSAGES BOITE DE DIALOGUE LECTURE DU NOMBRE DE POULES *)
    451: txtwrite(' Entrez un nombre suprieur  1                                        F1-Aide ');
    452: txtwrite(' Enregistrer les changements et retourner au menu de gestion           F1-Aide ');
    453: txtwrite(' Retourner au menu de gestion sans enregistrer les changements         F1-Aide ');
    (* MESSAGES BOITE DE DIALOGUE ATTRIBUTION N DE POULE A UN JOUEUR *)
    454: txtwrite(' Entrez un nombre compris entre 1 et le nombre de poules               F1-Aide ');
    455: txtwrite(' Voir la liste des joueurs de la poule courante (fentre de droite)    F1-Aide ');
    456: txtwrite(' Enregistrer le nouveau n de poule                                    F1-Aide ');
    457: txtwrite(' Quitter sans enregistrer le nouveau n de poule                       F1-Aide ');
    (* MESSAGES CREATION MANUELLE LISTE DES MATCHES *)
    460: txtwrite(' Pressez ENTER pour choisir un joueur ou ESCAPE pour quitter           F1-Aide ');
    (* MESSAGES ENCODAGE DU RESULTAT D'UN MATCH *)
    470: txtwrite(' Pressez ENTER pour choisir un match ou ESCAPE pour quitter            F1-Aide ');
    471: txtwrite(' Rsultat du joueur 1 - Les sets non jous doivent rester  0 - 0      F1-Aide ');
    472: txtwrite(' Rsultat du joueur 2 - Les sets non jous doivent rester  0 - 0      F1-Aide ');
    473: txtwrite(' Enregistrer le rsultat du match (si les scores sont corrects)        F1-Aide ');
    474: txtwrite(' Quitter sans enregistrer le rsultat du match                         F1-Aide ');
    (* MESSAGES PASSAGE AU TOUR SUIVANT *)
    480: txtwrite(' Pressez ENTER/ESPACE pour (d)slectionner un joueur (ESCAPE = Fin)   F1-Aide ');
    481: txtwrite(' Pressez ENTER pour choisir situation tour suivant (ESCAPE = Annuler)  F1-Aide ');
    (* MESSAGES SAUVETAGE DE LA SITUATION SUR DISQUE *)
    500: txtwrite(' Pressez ENTER ou cliquez sur "OK" avec la souris                              ');
    501: txtwrite(' Sauvetage des catgories en cours...                                          ');
    502: txtwrite(' Sauvetage des joueurs en cours...                                             ');
    503: txtwrite(' Sauvetage des matches en cours...                                             ');
    (* MESSAGES BOITE DE DIALOGUE OPTIONS DU PROGRAMME *)
    701: txtwrite(' Pressez ENTER ou BARRE D''ESPACEMENT pour (d)slectionner l''option    F1-Aide ');
    702: txtwrite(' Entrez un nombre entre 1 et 99                                        F1-Aide ');
    703: txtwrite(' Codes DECIMAUX spars par des espaces (exemple : 27 95 0)            F1-Aide ');
    704: txtwrite(' Enregistrer les options et retourner au menu principal                F1-Aide ');
    705: txtwrite(' Retourner au menu principal sans enregistrer les changements          F1-Aide ');
    (* MESSAGES DE LA GESTION DE L'AIDE *)
    801: txtwrite(' Pressez "T" pour accder  la table des matires ou ESCAPE pour quitter       ');
    802: txtwrite(' Pressez ENTER ou cliquez avec la souris pour choisir (ESCAPE = Quitter)       ');
    (* MESSAGES ACCOMPAGNANT UN AVERTISSEMENT *)
    901: txtwrite(' Pressez "O" ou "N" ou cliquez sur un bouton avec la souris                    ');
    902: txtwrite(' Pressez ENTER ou cliquez sur "OK" avec la souris                              ');
    (* MESSAGES ACCOMPAGNANT UN MESSAGE D'ERREUR *)
    1101:txtwrite(' Pressez "R" ou "A" ou cliquez sur un bouton avec la souris                    ');
    1102:txtwrite(' Pressez ENTER ou cliquez sur "OK" avec la souris                              ');
    (* MESSAGE DE SELECTION D'UNE CATEGORIE *)
    1201:txtwrite(' Slectionnez avec ENTER ou avec la souris (ESCAPE = Annuler)          F1-Aide ');
    (* MESSAGE DE LA BOITE DE DIALOGUE DE DEBUGGING *)
    1301:txtwrite(' Pressez ENTER ou "O" pour quitter                                     F1-Aide ');
    (* MESSAGES BOITES DE DIALOGUE FICHIERS D'IMPRESSION *)
    1401:txtwrite(' Pressez ENTER ou cliquez sur "OK" avec la souris                      F1-Aide ');
    1402:txtwrite(' Pressez "I" pour imprimer ou ESCAPE pour quitter                      F1-Aide ');
    1403:txtwrite(' Pressez ESCAPE pour interrompre l''opration en cours                          ');
    (* MESSAGE AVERTISSEMENT CREATION D'UN FICHIER INDEX *)
    1501:txtwrite(' Pressez ESCAPE pour interrompre l''opration en cours                          ');
  else
    txtwrite('                                                                               ');
  end;
  txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


Procedure TITRE_HAUT_ECRAN (n : word);
(* AFFICHAGE D'UN TITRE SUR LA 1ERE LIGNE DE L'ECRAN *)
Var x1,y1,x2,y2,x,y,FondCourant,CouleurCourante:word;
    Fond,Couleur:word;
Begin
  case ModeEcran of
    ModeMono:begin Fond:=lightgrey; Couleur:=white; end;
    ModeCouleur:begin Fond:=cyan; Couleur:=white; end;
  end;
  x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; x:=windx; y:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtback(Fond); txtcolour(Couleur); txtmove(26,0);
  case n of
    0:   txtwrite(' SELECTION D''UNE CATEGORIE  ');
    1:   txtwrite('  CREATION D''UNE CATEGORIE  ');
    2:   txtwrite('DESTRUCTION D''UNE CATEGORIE ');
    3:   txtwrite('MODIFICATION D''UNE CATEGORIE');
    4:   txtwrite('  GESTION D''UNE CATEGORIE   ');
    5:   txtwrite(' SAUVETAGE DE LA SITUATION  ');
    6:   txtwrite('RECUPERATION DE LA SITUATION');
    7:   txtwrite('   OPTIONS DU PROGRAMME     ');
    8:   txtwrite('   QUITTER LE PROGRAMME     ');
    9:   txtwrite('         IMPRESSION         ');
    400: txtwrite('   SELECTION D''UN JOUEUR    ');
    410: txtwrite('  INSCRIPTION D''UN JOUEUR   ');
    420: txtwrite('  SUPPRESSION D''UN JOUEUR   ');
    430: txtwrite('  MODIFICATION D''UN JOUEUR  ');
    440: txtwrite('AFFICHAGE CLASSEMENT ACTUEL ');
    450: txtwrite('     DIVISION EN POULES     ');
    451: txtwrite('REPARTITION DANS LES POULES ');
    460: txtwrite(' CREATION LISTE DES MATCHES ');
    470: txtwrite('   RESULTATS DES MATCHES    ');
    480: txtwrite('  PASSAGE AU TOUR SUIVANT   ');
    800: txtwrite('            AIDE            ');
  else
    txtwrite('                            ');
  end;
  txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


Function MESSAGE_AVERTISSEMENT (n : word) : boolean;
(* AFFICHE UN MESSAGE D'AVERTISSEMENT OU DE CONFIRMATION (BOITE DE DIALOGUE).
   CERTAINS MESSAGES DEMANDENT UNIQUEMENT DE VALIDER "OK", D'AUTRES "OUI/NON".
   PAS D'AIDE NI DE SAUVETAGE AUTOMATIQUE DISPONIBLES; PAR CONTRE, ECONOMISEUR D'ECRAN DISPONIBLE.
   LA FONCTION RETOURNE true SI "OK" OU "OUI", false SI "NON". *)
Const c=13; l=9; lg=54; nbl=5;
Var Fond1,Normal1,Fond2,Brillant,Fond3,Normal3,FondOmbre,Ombre:word;
    x1,y1,x2,y2,x,y,FondCourant,CouleurCourante:word;
    Image:videosave;
    Ligne,Bouton:byte;
    Fin:boolean;
    Entree:char;
          Procedure BOUTON_ALLUME;
          (* MISE EN EVIDENCE DU BOUTON COURANT *)
          Begin
            txtback(Fond2); txtcolour(Brillant);
            case Bouton of
              1:begin txtmove(29,l+3); txtattrib(7); end;
              2:begin txtmove(44,l+3); txtattrib(7); end;
              3:begin txtmove(35,l+3); txtattrib(10); end;
            end;
          End;
          Procedure BOUTON_ETEINT;
          (* FIN DE LA MISE EN EVIDENCE DU BOUTON COURANT *)
          Begin
            txtback(Fond3); txtcolour(Normal3);
            case Bouton of
              1:begin txtmove(29,l+3); txtattrib(7); end;
              2:begin txtmove(44,l+3); txtattrib(7); end;
              3:begin txtmove(35,l+3); txtattrib(10); end;
            end;
          End;
Begin
  case ModeEcran of
    ModeMono:begin
               Fond1:=lightgrey; Normal1:=black; Fond2:=black; Brillant:=white;
               Fond3:=lightgrey; Normal3:=white; FondOmbre:=black; Ombre:=lightgrey;
             end;
    ModeCouleur:begin
                  Fond1:=magenta; Normal1:=yellow; Fond2:=green; Brillant:=white;
                  Fond3:=magenta; Normal3:=white; FondOmbre:=black; Ombre:=lightgrey;
                end;
  end;
  x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; x:=windx; y:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image);
  txtback(Fond1); txtcolour(Normal1);
  txtmove(c,l);   txtwrite(' ͻ ');
  for Ligne:=1 to (nbl-2) do
    begin
      txtmove(c,l+Ligne); txtwrite('                                                    ');
    end;
  txtmove(c,l+nbl-1); txtwrite(' ͼ ');
  txtback(FondOmbre); txtcolour(Ombre);
  for Ligne:=1 to (nbl-1) do
    begin
      txtmove(c+lg,l+Ligne); txtattrib(2);
    end;
  txtmove(c+2,l+nbl); txtattrib(lg);
  (* TITRE *)
  txtback(Fond1); txtcolour(Brillant);
  case n of
    201:begin txtmove(25,l); txtwrite(' Suppression de la catgorie '); end;
    301..303:begin txtmove(26,l); txtwrite(' Paramtres de la catgorie '); end;
    304:begin txtmove(20,l); txtwrite(' Modification de la situation actuelle '); end;
    411..417:begin txtmove(27,l); txtwrite(' Inscription d''un joueur '); end;
    420:begin txtmove(27,l); txtwrite(' Suppression d''un joueur '); end;
    440:begin txtmove(27,l); txtwrite(' Affichage du classement '); end;
    450,451:begin txtmove(30,l); txtwrite(' Division en poules '); end;
    452:begin txtmove(25,l); txtwrite(' Rpartition dans les poules '); end;
    460..469:begin txtmove(29,l); txtwrite(' Cration des matches '); end;
    471..476:begin txtmove(28,l); txtwrite(' Encodage d''un rsultat '); end;
    480,481:begin txtmove(24,l); txtwrite(' Slection pour le tour suivant '); end;
    482,483:begin txtmove(27,l); txtwrite(' Passage au tour suivant '); end;
    601:begin txtmove(27,l); txtwrite(' Restauration des donnes '); end;
    1000:begin txtmove(33,l); txtwrite(' Confirmation '); end;
    1001:begin txtmove(29,l); txtwrite(' Quitter le programme '); end;
    1400..1402:begin txtmove(34,l); txtwrite(' Impression '); end;
  else
    txtmove(32,l); txtwrite(' Avertissement ');
  end;
  (* MESSAGE (OU LIGNE 1 DU MESSAGE) *)
  txtcolour(Normal1); txtmove(c+3,l+1);
  case n of
    201: txtwrite('  Tous les joueurs et matches seront effacs !');
    301: txtwrite('    Tous les matches encods seront effacs !');
    302: txtwrite('   Vous devez encoder le nom ET la situation');
    303: txtwrite('  Votre choix est incompatible avec le nombre');
    304: txtwrite(' Il est possible de remettre l''historique de la');
    411: txtwrite('La catgorie tant au stade des 1/64 de finale,');
    412: txtwrite('La catgorie tant au stade des 1/32 de finale,');
    413: txtwrite('La catgorie tant au stade des 1/16 de finale,');
    414: txtwrite(' La catgorie tant au stade des 1/8 de finale,');
    415: txtwrite(' La catgorie tant au stade des 1/4 de finale,');
    416: txtwrite('  La catgorie tant au stade des 1/2 finales,');
    417: txtwrite('   La catgorie tant au stade de la finale,');
    420: txtwrite('Tout ce qui se rapporte  ce joueur sera perdu !');
    440: txtwrite('       La catgorie est divise en poules.');
    450: txtwrite('    La catgorie est dj divise en poules.');
    451: txtwrite('Des matches ont t crs : ils seront effacs !');
    452: txtwrite('          Vous venez de presser ESCAPE.');
    460: txtwrite('          Vous venez de presser ESCAPE.');
    461: txtwrite('  Tous les rsultats actuels seront effacs !');
    462: txtwrite('La catgorie tant au stade des 1/64 de finale,');
    463: txtwrite('La catgorie tant au stade des 1/32 de finale,');
    464: txtwrite('La catgorie tant au stade des 1/16 de finale,');
    465: txtwrite(' La catgorie tant au stade des 1/8 de finale,');
    466: txtwrite(' La catgorie tant au stade des 1/4 de finale,');
    467: txtwrite('  La catgorie tant au stade des 1/2 finales,');
    468: txtwrite('   La catgorie tant au stade de la finale,');
    469: txtwrite('  Certains numros de poules sont incorrects.');
    471: txtwrite('    Le rsultat du 1er set est impossible.');
    472: txtwrite('    Le rsultat du 2me set est impossible.');
    473: txtwrite('    Le rsultat du 3me set est impossible.');
    474: txtwrite('    Le rsultat du 4me set est impossible.');
    475: txtwrite('    Le rsultat du 5me set est impossible.');
    476: txtwrite('   Le nombre de sets encods est impossible.');
    480: txtwrite('          Vous venez de presser ESCAPE.');
    481: txtwrite('      Le nombre de joueurs  slectionner');
    482: txtwrite('  Tous les matches du tour actuel ne sont pas');
    483: txtwrite('     La situation choisie est incompatible');
    601: txtwrite(' Vous venez de demander la restauration depuis');
    1000:txtwrite('               Vous partez dj ?');
    1001:txtwrite('       Afin de ne pas perdre vos donnes,');
    1400:txtwrite('   Aucun type d''imprimante n''est slectionn.');
    1401:txtwrite('Pas de statut "Finie"  la catgorie : la finale');
    1402:txtwrite('            Vous venez de presser "I"');
  end;
  (* QUESTION (OU LIGNE 2 DU MESSAGE) *)
  txtmove(c+3,l+2);
  case n of
    201: txtwrite('Voulez-vous dtruire la catgorie slectionne ?');
    301: txtwrite('  Voulez-vous changer la situation de dpart ?');
    302: txtwrite('     pour que les donnes soient acceptes.');
    303: txtwrite('          de joueurs de la catgorie !');
    304: txtwrite('   catgorie  zro. Dsirez-vous le faire ?');
    411: txtwrite('    les 128 joueurs maximum sont atteints !');
    412: txtwrite('     les 64 joueurs maximum sont atteints !');
    413: txtwrite('     les 32 joueurs maximum sont atteints !');
    414: txtwrite('     les 16 joueurs maximum sont atteints !');
    415: txtwrite('     les 8 joueurs maximum sont atteints !');
    416: txtwrite('     les 4 joueurs maximum sont atteints !');
    417: txtwrite('     les 2 joueurs maximum sont atteints !');
    420: txtwrite('           Dsirez-vous le supprimer ?');
    440: txtwrite('Dsirez-vous un classement par poules spares ?');
    450: txtwrite('      Voulez-vous recommencer la division ?');
    451: txtwrite(' Voulez-vous rediviser la catgorie en poules ?');
    452: txtwrite('     Voulez-vous abandonner la rpartition ?');
    460: txtwrite('Voulez-vous abandonner la cration des matches ?');
    461: txtwrite('   Voulez-vous recrer la liste des matches ?');
    462: txtwrite('     il doit y avoir 128 joueurs inscrits !');
    463: txtwrite('     il doit y avoir 64 joueurs inscrits !');
    464: txtwrite('     il doit y avoir 32 joueurs inscrits !');
    465: txtwrite('     il doit y avoir 16 joueurs inscrits !');
    466: txtwrite('      il doit y avoir 8 joueurs inscrits !');
    467: txtwrite('      il doit y avoir 4 joueurs inscrits !');
    468: txtwrite('      il doit y avoir 2 joueurs inscrits !');
    469: txtwrite('   Utilisez la rubrique "Division en poules".');
    471: txtwrite('        Veuillez corriger cette erreur.');
    472: txtwrite('        Veuillez corriger cette erreur.');
    473: txtwrite('        Veuillez corriger cette erreur.');
    474: txtwrite('        Veuillez corriger cette erreur.');
    475: txtwrite('        Veuillez corriger cette erreur.');
    476: txtwrite('    Veillez  encoder un rsultat COMPLET !');
    480: txtwrite('     Voulez-vous abandonner la slection ?');
    481: txtwrite('               est dj atteint !');
    482: txtwrite(' jous : impossible de passer au tour suivant !');
    483: txtwrite('   avec le nombre de joueurs encore en lice !');
    601: txtwrite('   le disque. Confirmez-vous cette commande ?');
    1000:txtwrite(' Dsirez-vous quitter ce magnifique programme ?');
    1001:txtwrite('  voulez-vous sauver la situation sur disque ?');
    1400:txtwrite(' Voyez la rubrique "Options" du menu principal.');
    1401:txtwrite(' ne sera pas imprime ! Voulez-vous continuer ?');
    1402:txtwrite('       Dsirez-vous lancer l''impression ?');
  end;
  if (n=201) or (n=301) or (n=304) or (n=420) or (n=440) or (n=450) or (n=451) or (n=452) or (n=460) or
     (n=461) or (n=470) or (n=480) or (n=601) or (n=1000) or (n=1001) or (n=1401) or (n=1402)
     then   (* BOUTONS "OUI" ET "NON *)
       begin
         txtback(Fond1); txtcolour(Normal1); txtmove(28,l+3); txtwrite('<       >'); txtmove(43,l+3); txtwrite('<       >');
         txtback(Fond3); txtcolour(Normal3); txtmove(29,l+3); txtwrite(' (O)ui '); txtmove(44,l+3); txtwrite(' (N)on ');
         Bouton:=1; BOUTON_ALLUME; MESSAGE_BAS_ECRAN(ip_Avertissement + 1);
         txtflush; mouseeventparams.me_modified:=false; if Souris then Void:=txtmousecurson; Fin:=false;
         repeat
           if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
           if txtkeypressed
              then
                begin
                  txtinput(Entree);
                  case ord(Entree) of
                    0:begin
                        txtinput(Entree);
                        case ord(Entree) of
                          15,72,75,77,80:begin   (* TAB GAUCHE / FLECHES : AUTRE BOUTON *)
                                           if Souris then Void:=txtmousecursoff;
                                           BOUTON_ETEINT; if Bouton = 1 then Bouton:=2 else Bouton:=1; BOUTON_ALLUME;
                                           if Souris then Void:=txtmousecurson;
                                         end;
                          24:begin   (* ALT-O : OUI *)
                               MESSAGE_AVERTISSEMENT:=true; Fin:=true;
                             end;
                          49:begin   (* ALT-N : NON *)
                               MESSAGE_AVERTISSEMENT:=false; Fin:=true;
                             end;
                        end;
                      end;
                    9:begin   (* TAB DROITE : AUTRE BOUTON *)
                        if Souris then Void:=txtmousecursoff;
                        BOUTON_ETEINT; if Bouton = 1 then Bouton:=2 else Bouton:=1; BOUTON_ETEINT;
                        if Souris then Void:=txtmousecurson;
                      end;
                    13:begin   (* ENTER : CHOIX DU BOUTON COURANT *)
                         MESSAGE_AVERTISSEMENT:=(Bouton = 1); Fin:=true;
                       end;
                    78,110:begin   (* "N","n" : NON *)
                             MESSAGE_AVERTISSEMENT:=false; Fin:=true;
                           end;
                    79,111:begin   (* "O","o" : OUI *)
                             MESSAGE_AVERTISSEMENT:=true; Fin:=true;
                           end;
                  end;
                end;
           if mouseeventparams.me_modified
              then
                begin
                  with mouseeventparams do
                    begin
                      if me_y = (l + 3)
                         then
                           begin
                             case me_x of
                               29..35:begin   (* OUI *)
                                        MESSAGE_AVERTISSEMENT:=true; Fin:=true;
                                      end;
                               44..50:begin   (* NON *)
                                        MESSAGE_AVERTISSEMENT:=false; Fin:=true;
                                      end;
                             end;
                           end;
                      me_modified:=false;
                    end;
                end;
         until Fin;
       end
     else   (* UN SEUL BOUTON "OK" *)
       begin
         txtback(Fond1); txtcolour(Normal1); txtmove(34,l+3); txtwrite('<          >');
         txtback(Fond3); txtcolour(Normal3); txtmove(35,l+3); txtwrite('   (O)K   ');
         Bouton:=3; BOUTON_ALLUME; MESSAGE_BAS_ECRAN(ip_Avertissement + 2);
         txtflush; mouseeventparams.me_modified:=false; if Souris then Void:=txtmousecurson; Fin:=false;
         repeat
           if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
           if txtkeypressed
              then
                begin
                  txtinput(Entree);
                  case ord(Entree) of
                    0:begin
                        txtinput(Entree); if ord(Entree) = 24 then Fin:=true;   (* ALT-O *)
                      end;
                    13,79,111:Fin:=true;   (* ENTER / "O" / "o" : OK *)
                  end;
                end;
           if mouseeventparams.me_modified
              then
                begin
                  with mouseeventparams do
                    begin
                      if (me_y = (l+3)) and (me_x in [35..44]) then Fin:=true;
                      me_modified:=false;
                    end;
                end;
         until Fin;
         MESSAGE_AVERTISSEMENT:=true;
       end;
  if Souris then Void:=txtmousecursoff;
  txtload(Image); txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


Function MESSAGE_ERREUR (n : word) : boolean;
(* AFFICHE UN MESSAGE D'ERREUR (BOITE DE DIALOGUE).
   CERTAINS MESSAGES DEMANDENT UNIQUEMENT DE VALIDER "OK", D'AUTRES "RECOMMENCER OU ABANDONNER".
   PAS D'AIDE NI DE SAUVETAGE AUTOMATIQUE DISPONIBLES; PAR CONTRE, ECONOMISEUR D'ECRAN DISPONIBLE.
   LA FONCTION RETOURNE true SI "OK" OU "RECOMMENCER", false SI "ABANDONNER". *)
Const c=13; l=9; lg=54; nbl=5;
Var Fond1,Normal1,Fond2,Brillant,Fond3,Normal3,FondOmbre,Ombre:word;
    x1,y1,x2,y2,x,y,FondCourant,CouleurCourante:word;
    Image:videosave;
    Ligne,Bouton:byte;
    Fin:boolean;
    Entree:char;
          Procedure BOUTON_ALLUME;
          (* MISE EN EVIDENCE DU BOUTON COURANT *)
          Begin
            txtback(Fond2); txtcolour(Brillant);
            case Bouton of
              1:begin txtmove(23,l+3); txtattrib(15); end;
              2:begin txtmove(42,l+3); txtattrib(14); end;
              3:begin txtmove(35,l+3); txtattrib(10); end;
            end;
          End;
          Procedure BOUTON_ETEINT;
          (* FIN DE LA MISE EN EVIDENCE DU BOUTON COURANT *)
          Begin
            txtback(Fond3); txtcolour(Normal3);
            case Bouton of
              1:begin txtmove(23,l+3); txtattrib(15); end;
              2:begin txtmove(42,l+3); txtattrib(14); end;
              3:begin txtmove(35,l+3); txtattrib(10); end;
            end;
          End;
Begin
  case ModeEcran of
    ModeMono:begin
               Fond1:=lightgrey; Normal1:=black; Fond2:=black; Brillant:=white;
               Fond3:=lightgrey; Normal3:=white; FondOmbre:=black; Ombre:=lightgrey;
             end;
    ModeCouleur:begin
                  Fond1:=red; Normal1:=yellow; Fond2:=cyan; Brillant:=white;
                  Fond3:=red; Normal3:=white; FondOmbre:=black; Ombre:=lightgrey;
                end;
  end;
  x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; x:=windx; y:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image);
  txtback(Fond1); txtcolour(Normal1);
  txtmove(c,l); txtwrite(' ͻ ');
  for Ligne:=1 to (nbl-2) do
    begin
      txtmove(c,l+Ligne); txtwrite('                                                    ');
    end;
  txtmove(c,l+nbl-1); txtwrite(' ͼ ');
  txtback(FondOmbre); txtcolour(Ombre);
  for Ligne:=1 to (nbl-1) do
    begin
      txtmove(c+lg,l+Ligne); txtattrib(2);
    end;
  txtmove(c+2,l+nbl); txtattrib(lg);
  (* TITRE *)
  txtback(Fond1); txtcolour(Brillant);
  if n < 1000
     then
       begin
         txtmove((61 - length(NomFichierTraite)) div 2,l); txtwrite(' Fichier ' + NomFichierTraite + ' : Erreur ');
       end
     else
       if n >= 2000
          then
            begin
              txtmove(29,l); txtwrite(' Erreur d''imprimante ');
            end
          else
            begin
              txtmove(36,l); txtwrite(' Erreur ');
            end;
  (* MESSAGE (OU LIGNE 1 DU MESSAGE) - LONGUEUR LIGNE : VOIR ERREUR N 156 *)
  txtcolour(Normal1); txtmove(c+3,l+1);
  case n of
    1:   txtwrite('        1 : Numro de fonction invalide.');
    2:   txtwrite('            2 : Fichier introuvable.');
    3:   txtwrite('    3 : Chemin d''accs au fichier incorrect.');
    4:   txtwrite('   4 : Trop de fichiers ouverts simultanment.');
    5:   txtwrite('         5 : Accs au fichier interdit.');
    6:   txtwrite('    6 : Identificateur de fichier incorrect.');
    7:   txtwrite('          7 : Bloc de mmoire dtruit.');
    8:   txtwrite('           8 : Mmoire insuffisante.');
    9:   txtwrite('     9 : Adresse de zone mmoire incorrecte.');
    10:  txtwrite('          10 : Environnement incorrect.');
    19:  txtwrite('        19 : Disque protg en criture.');
    21:  txtwrite('              21 : Disque non prt.');
    23:  txtwrite('          23 : Erreur de donnes (CRC).');
    24:  txtwrite('       24 : Taille de structure erronne.');
    25:  txtwrite(' 25 : Erreur positionnement des ttes du disque.');
    26:  txtwrite('       26 : Descripteur de mdia inconnu.');
    27:  txtwrite('            27 : Secteur non trouv.');
    29:  txtwrite('    29 : Erreur d''criture sur priphrique.');
    30:  txtwrite('    30 : Erreur de lecture sur priphrique.');
    31:  txtwrite('          31 : Panne lie au hardware.');
    100: txtwrite('       100 : Erreur de lecture du disque.');
    101: txtwrite('       101 : Erreur d''criture du disque.');
    103: txtwrite('            103 : Fichier non ouvert.');
    150: txtwrite('       150 : Disque protg en criture.');
    152: txtwrite('             152 : Disque non prt.');
    154: txtwrite('         154 : Erreur de donnes (CRC).');
    155: txtwrite('      155 : Taille de structure erronne.');
    156: txtwrite('156 : Erreur positionnement des ttes du disque.');
    157: txtwrite('       157 : Descripteur de mdia inconnu.');
    158: txtwrite('            158 : Secteur non trouv.');
    160: txtwrite('    160 : Erreur d''criture sur priphrique.');
    161: txtwrite('    161 : Erreur de lecture sur priphrique.');
    162: txtwrite('          162 : Panne lie au hardware.');
    1001:txtwrite('       1001 : Place mmoire insuffisante.');
    1002:txtwrite(' 1002 : Erreur liaison entre joueurs et matches.');
    2001:txtwrite('          2001 : Imprimante non prte.');
    2008:txtwrite('         2008 : Erreur de transmission.');
    2016:txtwrite('          2016 : Imprimante non prte.');
    2032:txtwrite('             2032 : Plus de papier.');
    2064:txtwrite('    2064 : Dernier caractre non reu (ACK).');
    2128:txtwrite('          2128 : Imprimante non prte.');
  else
    txtwrite('    '); txtnumwrite(n,0); txtwrite(' : Erreur non prvue par le programme.');
  end;
  (* QUESTION (OU LIGNE 2 DU MESSAGE) *)
  txtmove(c+3,l+2);
  case n of
    1:   txtwrite(' Erreur de communication entre programme et DOS.');
    2:   txtwrite('  Le fichier est absent du rpertoire courant.');
    3:   txtwrite('    Le DOS ne trouve pas le bon rpertoire.');
    4:   txtwrite('      (voir "FILES=" dans le CONFIG.SYS)');
    5:   txtwrite(' Le DOS ne peut ouvrir le fichier correctement.');
    6:   txtwrite(' Les donnes du DOS sont peut-tre endommages.');
    7:   txtwrite('       L''opration courante est stoppe.');
    8:   txtwrite('       L''opration courante est stoppe.');
    9:   txtwrite('       L''opration courante est stoppe.');
    10:  txtwrite('       L''opration courante est stoppe.');
    19:  txtwrite(' Faites glisser le petit clapet de la disquette.');
    21:  txtwrite(' Le contrleur de disque a mal t rinitialis.');
    23:  txtwrite('      Le disque est probablement endommag.');
    24:  txtwrite(' Le format des donnes du disque est incorrect.');
    25:  txtwrite(' Le contrleur de disque a mal t rinitialis.');
    26:  txtwrite(' Le DOS ne peut reconnatre le format du disque.');
    27:  txtwrite('       Le format du disque est incorrect.');
    29:  txtwrite('   Disque non format ou panne du contrleur.');
    30:  txtwrite('   Disque non format ou panne du contrleur.');
    31:  txtwrite('   Disque non format ou panne plus gnrale.');
    100: txtwrite('  Tentative de lecture aprs la fin du fichier.');
    101: txtwrite('              Le disque est plein !');
    103: txtwrite('   Le fichier n''a pas t ouvert correctement.');
    150: txtwrite(' Faites glisser le petit clapet de la disquette.');
    152: txtwrite(' Le contrleur de disque a mal t rinitialis.');
    154: txtwrite('      Le disque est probablement endommag.');
    155: txtwrite(' Le format des donnes du disque est incorrect.');
    156: txtwrite(' Le contrleur de disque a mal t rinitialis.');
    157: txtwrite(' Le DOS ne peut reconnatre le format du disque.');
    158: txtwrite('       Le format du disque est incorrect.');
    160: txtwrite('   Disque non format ou panne du contrleur.');
    161: txtwrite('   Disque non format ou panne du contrleur.');
    162: txtwrite('   Disque non format ou panne plus gnrale.');
    1001:txtwrite('       L''opration courante est stoppe.');
    1002:txtwrite('          La rcupration est stoppe.');
    2001:txtwrite('   Pas de rponse de l''imprimante (Time Out).');
    2008:txtwrite('    Erreur d''intgrit des donnes dtecte.');
    2016:txtwrite('        Imprimante hors ligne (Off Line).');
    2032:txtwrite('  Veuillez insrer du papier dans l''imprimante.');
    2064:txtwrite('  L''imprimante n''est pas ou est mal connecte.');
    2128:txtwrite('           Imprimante occupe (Busy).');
  else
    txtwrite('    Voir manuel technique du DOS ou du BIOS.');
  end;
  (* BOUTONS *)
  if (n in [1..6]) or ((n >= 11) and (n <= 1000)) or (n > 2000)
     then
       begin   (* BOUTONS "RECOMMENCER" ET "ABANDONNER" *)
         txtback(Fond1); txtcolour(Normal1);
         txtmove(22,l+3); txtwrite('<               >'); txtmove(41,l+3); txtwrite('<              >');
         txtback(Fond3); txtcolour(Normal3);
         txtmove(23,l+3); txtwrite(' (R)ecommencer '); txtmove(42,l+3); txtwrite(' (A)bandonner ');
         Bouton:=1; BOUTON_ALLUME; MESSAGE_BAS_ECRAN(ip_Erreur + 1);
         txtflush; mouseeventparams.me_modified:=false; if Souris then Void:=txtmousecurson; Fin:=false;
         repeat
           if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
           if txtkeypressed
              then
                begin
                  txtinput(Entree);
                  case ord(Entree) of
                    0:begin
                        txtinput(Entree);
                        case ord(Entree) of
                          15,72,75,77,80:begin   (* TAB GAUCHE / FLECHES : AUTRE BOUTON *)
                                           if Souris then Void:=txtmousecursoff;
                                           BOUTON_ETEINT; if Bouton = 1 then Bouton:=2 else Bouton:=1; BOUTON_ALLUME;
                                           if Souris then Void:=txtmousecurson;
                                         end;
                          19:begin   (* ALT-R : RECOMMENCER *)
                               MESSAGE_ERREUR:=true; Fin:=true;
                             end;
                          30:begin   (* ALT-A : ABANDONNER *)
                               MESSAGE_ERREUR:=false; Fin:=true;
                             end;
                        end;
                      end;
                    9:begin   (* TAB DROITE : AUTRE BOUTON *)
                        if Souris then Void:=txtmousecursoff;
                        BOUTON_ETEINT; if Bouton = 1 then Bouton:=2 else Bouton:=1; BOUTON_ETEINT;
                        if Souris then Void:=txtmousecurson;
                      end;
                    13:begin   (* ENTER : CHOIX DU BOUTON COURANT *)
                         MESSAGE_ERREUR:=(Bouton = 1); Fin:=true;
                       end;
                    65,97:begin   (* "A","a" : ABANDONNER *)
                            MESSAGE_ERREUR:=false; Fin:=true;
                          end;
                    82,114:begin   (* "R","r" : RECOMMENCER *)
                             MESSAGE_ERREUR:=true; Fin:=true;
                           end;
                  end;
                end;
           if mouseeventparams.me_modified
              then
                begin
                  with mouseeventparams do
                    begin
                      if me_y = (l + 3)
                         then
                           begin
                             case me_x of
                               23..37:begin   (* RECOMMENCER *)
                                        MESSAGE_ERREUR:=true; Fin:=true;
                                      end;
                               42..55:begin   (* ABANDONNER *)
                                        MESSAGE_ERREUR:=false; Fin:=true;
                                      end;
                             end;
                           end;
                      me_modified:=false;
                    end;
                end;
         until Fin;
       end
     else   (* UN SEUL BOUTON "OK" *)
       begin
         txtback(Fond1); txtcolour(Normal1); txtmove(34,l+3); txtwrite('<          >');
         txtback(Fond3); txtcolour(Normal3); txtmove(35,l+3); txtwrite('   (O)K   ');
         Bouton:=3; BOUTON_ALLUME; MESSAGE_BAS_ECRAN(ip_Erreur + 2);
         txtflush; mouseeventparams.me_modified:=false; if Souris then Void:=txtmousecurson; Fin:=false;
         repeat
           if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
           if txtkeypressed
              then
                begin
                  txtinput(Entree);
                  case ord(Entree) of
                    0:begin
                        txtinput(Entree); if ord(Entree) = 24 then Fin:=true;   (* ALT-O *)
                      end;
                    13,79,111:Fin:=true;   (* ENTER / "O" / "o" : OK *)
                  end;
                end;
           if mouseeventparams.me_modified
              then
                begin
                  with mouseeventparams do
                    begin
                      if (me_y = (l+3)) and (me_x in [35..44]) then Fin:=true;
                      me_modified:=false;
                    end;
                end;
         until Fin;
         MESSAGE_ERREUR:=false;
       end;
  if Souris then Void:=txtmousecursoff;
  txtload(Image); txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


Function CHAR_TO_ASCII (ChaineChar : string) : string;
(* TRADUIT UNE CHAINE DE CARACTERES EN UNE SUITE DE CODES ASCII (EXEMPLE : '!]M' --> '33 93 77') *)
Var ChaineAscii,Chaine:string;
    i:byte;
Begin
  ChaineAscii:='';
  if length(ChaineChar) > 0
     then
       for i:=1 to length(ChaineChar) do
         begin
           str(ord(ChaineChar[i]),Chaine); ChaineAscii:=ChaineAscii + Chaine + ' ';
         end;
  CHAR_TO_ASCII:=ChaineAscii;
End;


Function ASCII_TO_CHAR (ChaineAscii : string) : string;
(* TRADUIT UNE SUITE DE CODES ASCII EN CHAINE DE CARACTERES (EXEMPLE : '33 93 77' --> '!]M') *)
Var ChaineChar,Chaine:string;
    Caractere:char;
    i,n:byte;
    Erreur:integer;
Begin
  ChaineChar:='';
  if length(ChaineAscii) > 0
     then
       begin
         Chaine:='';
         for i:=1 to length(ChaineAscii) do
           begin
             Caractere:=ChaineAscii[i];
             if Caractere = ' '
                then   (* SEPARATEUR : TRAITEMENT DE Chaine *)
                  begin
                    val(Chaine,n,Erreur); ChaineChar:=ChaineChar + chr(n);
                    Chaine:='';
                  end
                else   (* CARACTERE NORMAL *)
                  Chaine:=Chaine + Caractere;
           end;
         (* TRAITEMENT DE LA DERNIERE Chaine *)
         val(Chaine,n,Erreur); ChaineChar:=ChaineChar + chr(n);
       end;
  ASCII_TO_CHAR:=ChaineChar;
End;


END.
