
UNIT TTO_DECL;

(* DECLARATIONS GLOBALES POUR LE PROGRAMME TTO.PAS VERSION 1.20 *)


INTERFACE

(* ******************************************************************************************************************** *)
(*                                                     UNITES UTILISEES                                                 *)
(* ******************************************************************************************************************** *)

Uses DOS,   (* INTERFACE AVEC LE DOS - TURBO.TPL *)
     TXT;   (* GESTION DE L'ECRAN EN MODE TEXTE (VERSION 2.00) *)


(* ******************************************************************************************************************** *)
(*             CONSTANTES NON TYPEES (NON RESERVEES EN MEMOIRE CAR UNIQUEMENT UTILISEES PAR LE COMPILATEUR)             *)
(* ******************************************************************************************************************** *)

Const (* ============================================================================================================== *)
      (*                                         GESTION BAS NIVEAU DE LA SOURIS                                        *)
      (* ============================================================================================================== *)
      (* EVENEMENTS SOURIS *)
      me_MouseMove = $0001;     (* DEPLACEMENT DU CURSEUR *)
      me_LButtonDown = $0002;   (* BOUTON GAUCHE ENFONCE *)
      me_LButtonUp = $0004;     (* BOUTON GAUCHE RELACHE *)
      me_RButtonDown = $0008;   (* BOUTON DROIT ENFONCE *)
      me_RButtonUp = $0010;     (* BOUTON DROIT RELACHE *)
      me_MButtonDown = $0020;   (* BOUTON DU MILIEU ENFONCE *)
      me_MButtonUp = $0040;     (* BOUTON DU MILIEU RELACHE *)
      me_Shift = $0020;         (* TOUCHE "SHIFT" ENFONCEE EN MEME TEMPS *)
      me_Ctrl = $0040;          (* TOUCHE "CTRL" ENFONCEE EN MEME TEMPS *)
      me_Alt = $0080;           (* TOUCHE "ALT" ENFONCEE EN MEME TEMPS *)
      (* TYPES DE GESTIONNAIRE D'EVENEMENTS SOURIS *)
      me_Normal = 0;      (* TYPE NORMAL, SANS CONTROLE DES TOUCHES DU CLAVIER *)
      me_Alternate = 1;   (* TYPE "ALTERNATE" (AVEC CONTROLE DES TOUCHES DU CLAVIER ("SHIFT", "CTRL", "ALT")) *)
      (* TYPES DE SOURIS *)
      mp_Bus = 1;      (* TYPE "BUS" *)
      mp_Serial = 2;   (* TYPE "SERIAL" *)
      mp_InPort = 3;   (* TYPE "IN PORT" *)
      mp_Ps2 = 4;      (* TYPE "PS/2" *)
      mp_Hp = 5;       (* TYPE "HP" *)
      (* BOUTONS DE LA SOURIS *)
      mp_LButton = 0;   (* BOUTON GAUCHE *)
      mp_RButton = 1;   (* BOUTON DROIT *)
      mp_MButton = 2;   (* BOUTON DU MILIEU *)
      (* BOUTONS DE LA SOURIS ENFONCES *)
      mp_LButtonDown = $0001;   (* BOUTON GAUCHE ENFONCE *)
      mp_RButtonDown = $0002;   (* BOUTON DROIT ENFONCE *)
      mp_MButtonDown = $0004;   (* BOUTON DU MILIEU ENFONCE *)
      (* TYPES DE DRIVERS SOURIS *)
      mp_Com = $0000;   (* FICHIER .COM *)
      mp_Sys = $8000;   (* FICHIER .SYS *)
      (* TYPES DE CURSEURS SOURIS *)
      mc_Log = $0000;          (* TYPE TEXTE "LOGIQUE" *)
      mc_Electronic = $1000;   (* TYPE TEXTE "HARDWARE" *)
      mc_Graphic = $2000;      (* TYPE GRAPHIQUE *)
      (* OPTIONS DES MASQUES DU CURSEUR SOURIS *)
      mc_Keep = 0;      (* CONSERVE LES COULEURS D'ECRAN *)
      mc_Replace = 1;   (* REMPLACE LES COULEURS D'ECRAN PAR DES COULEURS DEFINIES *)
      mc_Invert = 2;    (* INVERSION DES COULEURS D'ECRAN *)
      (* FREQUENCES D'INTERRUPTION DE LA SOURIS (IPS = INTERRUPT PER SECOND) *)
      mp_0ips = $0001;     (* 0 IPS *)
      mp_30ips = $0002;    (* 30 IPS *)
      mp_50ips = $0004;    (* 50 IPS *)
      mp_100ips = $0008;   (* 100 IPS *)
      mp_200ips = $0010;   (* 200 IPS *)

      (* ============================================================================================================== *)
      (*                                              GESTION DU HARDWARE                                               *)
      (* ============================================================================================================== *)
      (* TYPES DE CARTES VIDEO *)
      vc_None = $00;       (* AUCUNE CARTE DETECTEE *)
      vc_Unknown = $00;    (* CARTE INCONNUE *)
      vc_MDA = $01;        (* CARTE MDA *)
      vc_CGA = $02;        (* CARTE CGA *)
      vc_Hercules = $04;   (* CARTE HERCULES *)
      vc_EGA = $08;        (* CARTE EGA *)
      vc_MCGA = $10;       (* CARTE MCGA *)
      vc_VGA = $20;        (* CARTE VGA *)
      vc_SVGAVesa = $40;   (* CARTE SVGA COMPATIBLE VESA *)
      vc_Error = $80;      (* ERREUR LORS DE LA DETECTION DE LA CARTE *)
      (* TYPES DE MONITEURS *)
      vm_None = $00;           (* AUCUN MONITEUR DETECTE *)
      vm_Unknown = $00;        (* TYPE DE MONITEUR INCONNU *)
      vm_Mono = $01;           (* MONITEUR MONOCHROME *)
      vm_Colour = $02;         (* MONITEUR COULEUR *)
      vm_MonoAnalog = $04;     (* MONITEUR MONOCHROME ANALOGIQUE *)
      vm_ColourAnalog = $08;   (* MONITEUR COULEUR ANALOGIQUE *)
      vm_EGAHiRes = $10;       (* MONITEUR EGA HAUTE RESOLUTION *)
      vm_Error = $80;          (* ERREUR LORS DE LA DETECTION DU MONITEUR *)
      (* TYPES D'ORDINATEURS *)
      ct_Unknown = 0;          (* TYPE D'ORDINATEUR INCONNU *)
      ct_PC = 1;               (* PC *)
      ct_PCBiosXT = 2;         (* PC AVEC BIOS PC/XT *)
      ct_PCConv = 3;           (* PC CONVERTIBLE *)
      ct_PCJr = 4;             (* PC JUNIOR *)
      ct_XT = 5;               (* PC/XT *)
      ct_XT286 = 6;            (* PC/XT AVEC PROCESSEUR 80286 *)
      ct_AT = 7;               (* PC/AT *)
      ct_Ps2Mod25 = 8;         (* PS/2 MODELE 25 *)
      ct_Ps2Mod30 = 9;         (* PS/2 MODELE 30 *)
      ct_Ps2Mod50 = 10;        (* PS/2 MODELE 50 *)
      ct_Ps2Mod60 = 11;        (* PS/2 MODELE 60 *)
      ct_Ps2Mod80 = 12;        (* PS/2 MODELE 80 *)
      ct_AT_Ps2_XT286 = 101;   (* PC/AT OU PS/2 OU PC/XT AVEC PROCESSEUR 80286 *)
      ct_Ps2 = 102;            (* PS/2 (MODELE INDETERMINE) *)
      ct_Error = 255;          (* ERREUR LORS DE LA DETECTION DU TYPE D'ORDINATEUR *)

      (* ============================================================================================================== *)
      (*               TOUCHES SPECIALES DU CLAVIER ET MODE DE FONCTIONNEMENT DE LA FONCTION TXTVALIDATE2               *)
      (* ============================================================================================================== *)
      tv_ArUp = $8000;        (* FLECHE HAUT *)
      tv_ArDn = $4000;        (* FLECHE BAS *)
      tv_PgUp = $2000;        (* PAGE HAUT *)
      tv_PgDn = $1000;        (* PAGE BAS *)
      tv_TabRi = $0800;       (* TAB DROITE *)
      tv_TabLe = $0400;       (* TAB GAUCHE *)
      tv_CtrlEnter = $0200;   (* CTRL-ENTER *)
      tv_CtrlArUp = $0100;    (* CTRL-FLECHE HAUT *)
      tv_CtrlArDn = $0080;    (* CTRL-FLECHE BAS *)
      tv_CtrlPgUp = $0040;    (* CTRL-PAGE HAUT *)
      tv_CtrlPgDn = $0020;    (* CTRL-PAGE BAS *)
      tv_CtrlHome = $0010;    (* CTRL-HOME  *)
      tv_CtrlEnd = $0008;     (* CTRL-END *)
      tv_Escape = $0004;      (* ESCAPE *)
      tv_Insert = $0002;      (* MODE INSERTION AU DEMARRAGE *)
      tv_UpCase = $0001;      (* CONVERSION EN MAJUSCULES *)
      tv_Enter = $0000;       (* ENTER *)

      (* ============================================================================================================== *)
      (*                                      FONCTIONNEMENT GENERAL DU PROGRAMME                                       *)
      (* ============================================================================================================== *)
      (* MODES DE GESTION DES COULEURS A L'ECRAN *)
      ModeMono = 0;      (* MODE MONOCHROME *)
      ModeGris = 1;      (* MODE NIVEAUX DE GRIS *)
      ModeCouleur = 2;   (* MODE COULEUR *)
      (* PARAMETRES DE LA LIGNE DE COMMANDE DU PROGRAMME *)
      pp_Mono = $0001;      (* FORCER LE MODE MONOCHROME *)
      pp_Gris = $0002;      (* FORCER LE MODE NIVEAUX DE GRIS *)
      pp_Couleur = $0004;   (* FORCER LE MODE COULEUR *)
      (* TYPES D'IMPRIMANTES *)
      ti_Aucune = 0;       (* AUCUNE IMPRIMANTE SELECTIONNEE *)
      ti_HPDeskJet = 1;    (* HP DESKJET 5xx OU EMULATION *)
      ti_ProPrinter = 2;   (* IBM PROPRINTER OU EMULATION *)
      ti_EpsonLX = 3;      (* EPSON LX/FX OU EMULATION *)
      ti_Autre = 255;      (* AUTRE IMPRIMANTE *)
      (* VALEURS DE TEST DU STATUT DE L'IMPRIMANTE *)
      si_TimeOut = $01;        (* BIT "TIME OUT" (ERREUR SI = 1) *)
      si_Transmission = $08;   (* BIT "TRANSMISSION" (ERREUR SI = 1) *)
      si_OnLine = $10;         (* BIT "ON LINE" (ERREUR SI = 0) *)
      si_Paper = $20;          (* BIT "PAPER" (ERREUR SI = 1) *)
      si_ACK = $40;            (* BIT "ACK" (ERREUR SI = 1) *)
      si_Busy = $80;           (* BIT "BUSY" (ERREUR SI = 0) *)
      (* GESTION DES LISTES DE POINTEURS *)
      list_Ajout = 0;   (* AJOUTER LE NOUVEAU POINTEUR EN FIN DE LISTE *)
      list_Alpha = 1;   (* INSERER LE NOUVEAU POINTEUR DANS LA LISTE TRIEE PAR ORDRE ALPHABETIQUE *)
      list_Poule = 2;   (* INSERER LE NOUVEAU POINTEUR DANS LA LISTE TRIEE PAR N DE POULE *)
      list_Clas = 3;    (* INSERER LE NOUVEAU POINTEUR DANS LA LISTE TRIEE SELON LE CLASSEMENT DES JOUEURS *)
      list_PouleNormal = 1;     (* EXTRAIRE LES JOUEURS CORRESPONDANT AU N DE POULE *)
      list_PouleAlpha = 2;      (* EXTRAIRE LES JOUEURS CORRESPONDANT AU N DE POULE ET LES TRIER PAR ORDRE ALPHABETIQUE *)
      list_PouleClas = 3;       (* EXTRAIRE LES JOUEURS CORRESPONDANT AU N DE POULE ET LES CLASSER *)
      list_LiceNormal = 4;      (* EXTRAIRE LES JOUEURS ENCORE EN LICE *)
      list_LiceAlpha = 5;       (* EXTRAIRE LES JOUEURS ENCORE EN LICE ET LES TRIER PAR ORDRE ALPHABETIQUE *)
      list_LiceClas = 6;        (* EXTRAIRE LES JOUEURS ENCORE EN LICE ET LES CLASSER, TOUTES POULES CONFONDUES *)
      list_LiceClasPoule = 7;   (* EXTRAIRE LES JOUEURS ENCORE EN LICE ET LES CLASSER, POULE PAR POULE *)
      (* TYPES DE FICHIERS *)
      tf_Categories = 1;   (* FICHIER DE SAUVETAGE DES CATEGORIES (CATEGORI.TTO) *)
      tf_Joueurs = 2;      (* FICHIER DE SAUVETAGE DES JOUEURS (JOUEURS.TTO) *)
      tf_Matches = 3;      (* FICHIER DE SAUVETAGE DES MATCHES (MATCHES.TTO) *)
      tf_Ini = 4;          (* FICHIER DE DEMARRAGE (TTO.INI ET TTO.I~I) *)
      tf_Aide = 5;         (* FICHIER D'AIDE (TTO.HLP) *)
      tf_Print = 6;        (* FICHIER D'IMPRESSION (CAT??.PRN) *)
      tf_Index = 7;        (* FICHIER D'INDEX DE FICHIER TEXTE (TTOPRN.NDX ET TTOHLP.NDX) *)
      (* TYPE DE SAUVETAGE DE LA SITUATION SUR DISQUE *)
      ss_Normal = 0;        (* SAUVETAGE DECLENCHE PAR L'UTILISATEUR *)
      ss_Automatique = 1;   (* SAUVETAGE AUTOMATIQUE *)
      (* TEST D'EGALITE DE DATE ET HEURE DE FICHIERS *)
      tdh_Ok = 0;           (* EGALITE DES DATES ET HEURES *)
      tdh_Difference = 1;   (* DATES OU HEURES DIFFERENTES *)
      tdh_Erreur = 2;       (* ERREUR LORS DU TEST *)
      (* INDICATEURS DE POSITION DANS LE PROGRAMME (POUR MESSAGES AU BAS DE L'ECRAN...) *)
      ip_MenuPrincipal = 0;             (* MENU PRINCIPAL *)
      ip_CreationCategorie = 100;       (* CREATION D'UNE CATEGORIE *)
      ip_DestructionCategorie = 200;    (* DESTRUCTION D'UNE CATEGORIE *)
      ip_ModificationCategorie = 300;   (* MODIFICATION DES PARAMETRES D'UNE CATEGORIE *)
      ip_GestionCategorie = 400;        (* GESTION D'UNE CATEGORIE *)
      ip_InscriptionJoueur = 410;       (* INSCRIPTION D'UN JOUEUR *)
      ip_SuppressionJoueur = 420;       (* SUPPRESSION D'UN JOUEUR *)
      ip_ModificationJoueur = 430;      (* MODIFICATION DES DONNEES D'UN JOUEUR *)
      ip_AffichageClassement = 440;     (* AFFICHAGE DU CLASSEMENT DES JOUEURS *)
      ip_DivisionPoules = 450;          (* DIVISION DE LA CATEGORIE EN POULES *)
      ip_CreationMatches = 460;         (* CREATION DE LA LISTE DES MATCHES *)
      ip_EncodageResultat = 470;        (* ENCODAGE DU RESULTAT D'UN MATCH *)
      ip_PassageTourSuivant = 480;      (* PASSAGE AU TOUR SUIVANT *)
      ip_RetourMenu = 490;              (* RETOUR AU MENU PRINCIPAL *)
      ip_Impressions = 1400;            (* GESTION DES IMPRESSIONS *)
      ip_SauvetageDisque = 500;         (* SAUVETAGE SUR DISQUE *)
      ip_RecuperationDisque = 600;      (* RESTAURATION DEPUIS LE DISQUE *)
      ip_OptionsProgramme = 700;        (* OPTIONS DU PROGRAMME *)
      ip_Quitter = 1000;                (* QUITTER LE PROGRAMME *)
      ip_Aide = 800;                    (* GESTION DE L'AIDE *)
      ip_Avertissement = 900;           (* MESSAGES D'AVERTISSEMENT *)
      ip_Erreur  = 1100;                (* MESSAGES D'ERREUR *)
      ip_SelectionCategorie = 1200;     (* SELECTION D'UNE CATEGORIE *)
      ip_Debogage = 1300;               (* BOITE DE DIALOGUE DE DEBOGAGE *)
      ip_Indexation = 1500;             (* GESTION DES FICHIERS D'INDEX *)
      (* OPTIONS DE SELECTION D'UNE CATEGORIE *)
      sc_Existantes = 1;   (* N'ACCEPTER QUE LES N DE CATEGORIES EXISTANTES *)
      sc_Vierges = 2;      (* N'ACCEPTER QUE LES N DE CATEGORIES INUTILISEES *)
      sc_Toutes = 3;       (* ACCEPTER TOUS LES N DE CATEGORIES *)
      (* OPTIONS D'AFFICHAGE (REAFFICHAGE) DES PARAMETRES D'UNE CATEGORIE *)
      apc_Nom = $01;    (* NOM DE LA CATEGORIE *)
      apc_Sit = $02;    (* SITUATION ACTUELLE *)
      apc_NbJ = $04;    (* NOMBRE DE JOUEURS INSCRITS *)
      apc_NbJR = $08;   (* NOMBRE DE JOUEURS RESTANTS *)
      apc_NbM = $10;    (* NOMBRE DE MATCHES *)
      apc_NbMR = $20;   (* NOMBRE DE MATCHES RESTANTS *)
      apc_NbP = $40;    (* NOMBRE DE POULES *)
      (* OPTIONS DE MODIFICATION DES PARAMETRES D'UNE CATEGORIE ET D'UN JOUEUR *)
      mp_Creation = 0;       (* ENCODAGE DE NOUVEAUX PARAMETRES (CREATION D'UNE CATEGORIE OU D'UN JOUEUR) *)
      mp_Modification = 1;   (* MODIFICATION DE PARAMETRES EXISTANTS *)
      mp_Avorter = 0;        (* CODE DE SORTIE : OPERATION AVORTEE *)
      mp_Ok = 1;             (* CODE DE SORTIE : OK ET PAS DE MODIFICATION DE LA SITUATION DE LA CATEGORIE *)
      mp_OkModifie = 2;      (* CODE DE SORTIE : OK MAIS MODIFICATION DE LA SITUATION DE LA CATEGORIE *)
      (* ANALYSE DU RESULTAT D'UN MATCH *)
      arm_Ok = 0;             (* RESULTAT CORRECT *)
      arm_ErreurSet1 = 1;     (* ERREUR AU SET 1 *)
      arm_ErreurSet2 = 2;     (* ERREUR AU SET 2 *)
      arm_ErreurSet3 = 3;     (* ERREUR AU SET 3 *)
      arm_ErreurSet4 = 4;     (* ERREUR AU SET 4 *)
      arm_ErreurSet5 = 5;     (* ERREUR AU SET 5 *)
      arm_ErreurNbSets = 6;   (* NOMBRE DE SETS INCORRECT *)
      (* INDICATION DU CONTENU DU TABLEAU Texte (filepos DE CHAQUE LIGNE DU FICHIER TEXTE A AFFICHER) *)
      ndx_Aucun = 0;   (* AUCUN INDEX CHARGE DANS LE TABLEAU *)
      ndx_Print = 1;   (* CONTENU DU FICHIER TTOPRN.NDX *)
      ndx_Aide = 2;    (* CONTENU DU FICHIER TTOHLP.NDX *)

      (* ============================================================================================================== *)
      (*                                      DEPLACEMENTS DANS LE FICHIER D'AIDE                                       *)
      (* ============================================================================================================== *)
      hlp_Debut = 0;
      hlp_UtilisationAide = 5;
      hlp_PresentationPrgm = 23;
      hlp_GestionTournoi = 54;
         hlp_GestionTournoiGeneralites = 78;
         hlp_LancementPrgm = 153;
         hlp_ParametreLancement = 179;
         hlp_DemarragePrgm = 197;
      hlp_FichierIni = 218;
      hlp_OptionsDefaut = 337;
      hlp_UtilisationPrgm = 349;
         hlp_UtilisationMenus = 367;
         hlp_ChampsAEncoder = 388;
         hlp_BoitesDialogue = 405;
         hlp_Listes = 432;
         hlp_MessagesAvertissement = 467;
      hlp_MenuPrincipal = 503;
         hlp_MenuPrincipalGeneralites = 531;
         hlp_SelectionCategorie = 615;
         hlp_CreationCategorie = 649;
         hlp_ParametresCategorie = 700;
         hlp_DestructionCategorie = 715;
         hlp_GestionCategorie = 728;
         hlp_ImpressionResultats = 734;
         hlp_SauvetageDisque = 791;
         hlp_RestaurationDisque = 805;
         hlp_OptionsPrgm = 826;
            hlp_OptionSouris = 859;
            hlp_OptionAutoSave = 868;
            hlp_OptionScreenSaver = 879;
            hlp_OptionImprimante = 888;
            hlp_OptionCommandesImprimante = 898;
            hlp_OptionsEnregistrer = 932;
         hlp_QuitterPrgm = 947;
      hlp_MenuGestionCategorie = 958;
         hlp_MenuGestionGeneralites = 998;
         hlp_SelectionJoueur = 1091;
         hlp_InscriptionJoueur = 1117;
         hlp_SuppressionJoueur = 1151;
         hlp_ModificationJoueur = 1161;
         hlp_AffichageClassement = 1185;
            hlp_PrincipesClassement = 1235;
         hlp_DivisionPoules = 1262;
         hlp_CreationMatches = 1323;
            hlp_CreationAutomatique = 1333;
            hlp_CreationManuelle = 1341;
         hlp_EncodageResultat = 1360;
         hlp_PassageTourSuivant = 1415;
      hlp_Problemes = 1530;
         hlp_ProblemesDemarrage = 1534;
         hlp_ProblemeFichiers = 1578;
         hlp_ProblemeImprimante = 1604;
         hlp_ProblemeMemoire = 1617;
         hlp_ProblemeAbsenceDernierTour = 1642;
         hlp_ProblemeCurseurSouris = 1655;
         hlp_ProblemeRestitutionEnvironnement = 1680;
      hlp_MessagesErreur = 1710;
      hlp_InformationsTechniques = 2025;
         hlp_Debogage = 2074;
         hlp_ContactsAuteur = 2100;


(* ******************************************************************************************************************** *)
(*                                                          TYPES                                                       *)
(* ******************************************************************************************************************** *)

Type (* =============================================================================================================== *)
     (*                                         GESTION BAS NIVEAU DE LA SOURIS                                         *)
     (* =============================================================================================================== *)
     tMouseEventParams = record   (* PARAMETRES D'UN EVENEMENT SOURIS (UNITE TXT 3.00) *)
                           me_Modified : boolean;          (* INDIQUE QUE PARAMETRES MODIFIES PAR UN EVENEMENT *)
                           me_Event : word;                (* MASQUE DES EVENEMENTS APPELANTS *)
                           me_Buttons : word;              (* MASQUE DES BOUTONS DE LA SOURIS *)
                           me_X, me_Y : word;              (* COORDONNEES (TEXTE) DU CURSEUR *)
                           me_XMove, me_YMove : integer;   (* DEPLACEMENT DU CURSEUR (EN MICKEYS) *)
                           me_Valid : boolean;             (* INDIQUE SI LES PARAMETRES SONT SIGNIFICATIFS *)
                         end;
     tMouseParams = record   (* PARAMETRES GENERAUX DE LA SOURIS (UNITE TXT 3.00) *)
                      mp_MouseType : byte;                 (* TYPE DE SOURIS *)
                      mp_NbButtons : byte;                 (* NOMBRE DE BOUTONS *)
                      mp_VersionHi, mp_VersionLo : byte;   (* VERSION DU DRIVER *)
                      mp_DriverSeg, mp_DriverOfs : word;   (* ADRESSE DU DRIVER *)
                      mp_DriverType : word;                (* DRIVER .SYS OU DRIVER .COM *)
                      mp_SaveBufferSize : word;            (* TAILLE DU BUFFER DE SAUVEGARDE *)
                      mp_X, mp_Y : word;                   (* COORDONNEES DU CURSEUR *)
                      mp_Page : word;                      (* PAGE ACTUELLE DU CURSEUR *)
                      mp_XSpeed, mp_YSpeed : word;         (* VITESSES HORIZONTALE ET VERTICALE (MICKEYS/CARACTERE) *)
                      mp_DoubleSpeed : word;               (* SEUIL DE DOUBLEMENT DE LA VITESSE *)
                      mp_Mask1, mp_Mask2 : word;           (* MASQUES DU CURSEUR / DEBUT-FIN BALAYAGE *)
                      mp_ButtonsDown : word;               (* MASQUE DES BOUTONS ENFONCES *)
                      mp_CursorType : word;                (* TYPE DE CURSEUR *)
                      mp_CursorCounter : word;             (* COMPTEUR DE CURSEUR INTERNE *)
                      mp_IntFreq : word;                   (* FREQUENCE D'INTERRUPTION DU DRIVER *)
                      mp_Valid : boolean;                  (* INDIQUE SI LES PARAMETRES SONT SIGNIFICATIFS *)
                    end;

     (* =============================================================================================================== *)
     (*                                               GESTION DE L'ECRAN                                                *)
     (* =============================================================================================================== *)
     tTextParams = record   (* PARAMETRES DU MODE VIDEO COURANT (UNITE TXT 3.00) *)
                     tp_ModeType:byte;   (* MODE COULEUR OU MONOCHROME *)
                   end;

     (* =============================================================================================================== *)
     (*                                              GESTION DU HARDWARE                                                *)
     (* =============================================================================================================== *)
     tDriveTab = array [0..25] of boolean;   (* DRIVES INSTALLES (A..Z) *)

     (* =============================================================================================================== *)
     (*                                           TYPES CHAINES DE CARACTERES                                           *)
     (* =============================================================================================================== *)
     Str4 = string[4];
     Str16 = string[16];

     (* =============================================================================================================== *)
     (*                                               LISTES DE POINTEURS                                               *)
     (* =============================================================================================================== *)
     pJoueur = ^EnregJ;   (* POINTEUR SUR UN JOUEUR DANS LE HEAP *)
     EnregJ = record   (* ENREGISTREMENT D'UN JOUEUR DANS LE HEAP : 75 BYTES *)
                NumeroSauvetage : word;                 (* N ATTRIBUE LORS DU SAUVETAGE (POUR RECONSTITUER MATCHES) *)
                NomJoueur, PrenomJoueur : string[15];   (* NOM ET PRENOM *)
                Age : string[2];                        (* AGE (FACULTATIF) *)
                Club : string[20];                      (* CLUB (FACULTATIF) *)
                EnLice : boolean;                       (* INDIQUE SI LE JOUEUR EST ENCORE EN LICE *)
                Poule : word;                           (* N DE POULE *)
                MatchesJoues : word;                    (* NOMBRE DE MATCHES JOUES DANS LE TOUR COURANT *)
                Points, Sets, Score : integer;          (* POINTS, BALANCE DES SETS, BALANCES DES SCORES *)
                pPrec, pSuiv : pJoueur;                 (* POINTEURS SUR LES ENREGISTREMENTS PRECEDENT ET SUIVANT *)
              end;

     pListeJoueurs = ^EnregListeJ;   (* POINTEUR SUR UN ELEMENT DE LISTE DE JOUEURS TRIES *)
     EnregListeJ = record   (* ELEMENT DE LISTE DE JOUEURS TRIEE : 13 BYTES *)
                     PointeurJoueur : pJoueur;       (* POINTEUR SUR L'ENREGISTREMENT COMPLET DU JOUEUR *)
                     Selection : boolean;            (* INDIQUE SI L'ELEMENT DE LISTE EST SELECTIONNE OU PAS *)
                     pPrec, pSuiv : pListeJoueurs;   (* POINTEURS SUR LES ENREGISTREMENTS PRECEDENT ET SUIVANT *)
                   end;

     TabR = array [1..5,1..2] of integer;   (* RESULTATS (5 SETS) D'UN MATCH *)
     pMatch = ^EnregM;   (* POINTEUR SUR UN MATCH DANS LE HEAP *)
     EnregM = record   (* ENREGISTREMENT D'UN MATCH DANS LE HEAP : 38 BYTES *)
                Poule : word;                   (* N DE POULE *)
                pJoueur1, pJoueur2 : pJoueur;   (* POINTEURS SUR LES ENREGISTREMENTS COMPLETS DES 2 JOUEURS *)
                Resultats : TabR;               (* RESULTATS DES 5 SETS *)
                pPrec, pSuiv : pMatch;          (* POINTEURS SUR LES ENREGISTREMENTS PRECEDENT ET SUIVANT *)
              end;

     (* =============================================================================================================== *)
     (*                                                    TABLEAUX                                                     *)
     (* =============================================================================================================== *)
     EnregC = record   (* ENREGISTREMENT D'UNE CATEGORIE DANS LE DATA SEGMENT : 48 BYTES *)
                NomCategorie : string[20];               (* NOM DE LA CATEGORIE *)
                Situation : byte;                        (* SITUATION COURANTE (ELIMINATOIRES, Xme DE FINALE, FINIE) *)
                NbPoules : word;                         (* NOMBRE DE POULES CREES *)
                NbJoueurs, NbJoueursRestants : word;     (* NOMBRES DE JOUEURS INSCRITS ET DE JOUEURS ENCORE EN LICE *)
                NbMatches, NbMatchesRestants : word;     (* NOMBRES DE MATCHES CREES ET DE MATCHES RESTANT A JOUER *)
                pTeteJoueurs, pQueueJoueurs : pJoueur;   (* POINTEURS SUR LA TETE ET LA QUEUE DE LISTE DES JOUEURS *)
                pTeteMatches, pQueueMatches : pMatch;    (* POINTEURS SUR LA TETE ET LA QUEUE DE LISTE DES MATCHES *)
              end;
     TabC = array [1..20] of EnregC;        (* TABLEAU DES 20 CATEGORIES *)

     TabP = array [1..3,1..2] of integer;   (* POINTS / SETS / SCORE (POUR LE TRAITEMENT D'UN RESULTAT DE MATCH) *)

     TabT = array [1..2500] of longint;     (* filepos DE CHAQUE LIGNE D'UN FICHIER TEXTE A AFFICHER *)

     EnregTdM = record   (* ELEMENT DE LA TABLE DES MATIERES DE L'AIDE *)
                  Rubrique : string[34];   (* NOM DE LA RUBRIQUE *)
                  NumeroLigne : word;      (* N DE LA LIGNE CORRESPONDANTE DANS LE FICHIER TTO.HLP *)
                end;
     TabTdM = array [1..52] of EnregTdM;   (* TABLE DES MATIERES (52 RUBRIQUES) *)

     (* =============================================================================================================== *)
     (*                                              FICHIERS SUR DISQUE                                                *)
     (* =============================================================================================================== *)
     EnregFichierC = record   (* ENREGISTREMENT DU FICHIER DE SAUVETAGE DES CATEGORIES : 32 BYTES *)
                       NomCategorie : string[20];             (* NOM DE LA CATEGORIE *)
                       Situation : byte;                      (* SITUATION COURANTE (ELIMINATOIRES, Xme DE FINALE, FINIE) *)
                       NbPoules : word;                       (* NOMBRE DE POULES CREEES *)
                       NbJoueurs, NbJoueursRestants : word;   (* NOMBRES DE JOUEURS INSCRITS ET DE JOUEURS RESTANT EN LICE *)
                       NbMatches, NbMatchesRestants : word;   (* NOMBRES DE MATCHES CREES ET DE MATCHES RESTANT A JOUEUR *)
                     end;
     FichierC = file of EnregFichierC;   (* FICHIER DE SAUVETAGE DES CATEGORIES (CATEGORI.TTO) *)

     EnregFichierJ = record   (* ENREGISTREMENT DU FICHIER DE SAUVETAGE DES JOUEURS : 70 BYTES *)
                       Categorie : byte;                       (* N DE CATEGORIE *)
                       NumeroSauvetage : word;                 (* N ATTRIBUE POUR RECONSTITUER LES MATCHES *)
                       NomJoueur, PrenomJoueur : string[15];   (* NOM ET PRENOM DU JOUEUR *)
                       Age : string[2];                        (* AGE *)
                       Club : string[20];                      (* CLUB *)
                       EnLice : boolean;                       (* INDIQUE SI LE JOUEUR EST ENCORE EN LICE *)
                       Poule : word;                           (* N DE POULE *)
                       MatchesJoues : word;                    (* NOMBRE DE MATCHES JOUES DANS LE TOUR COURANT *)
                       Points, Sets, Score : integer;          (* POINTS, BALANCE DES SETS, BALANCE DES SCORES *)
                     end;
     FichierJ = file of EnregFichierJ;   (* FICHIER DE SAUVETAGE DES JOUEURS (JOUEURS.TTO) *)

     EnregFichierM = record   (* ENREGISTREMENT DU FICHIER DE SAUVETAGE DES MATCHES : 27 BYTES *)
                       Categorie : byte;                      (* N DE CATEGORIE *)
                       Poule : word;                          (* N DE POULE *)
                       NumeroJoueur1, NumeroJoueur2 : word;   (* N DES 2 JOUEURS ATTRIBUES LORS DU SAUVETAGE *)
                       Resultats : TabR;                      (* RESULTATS DES 5 SETS DU MATCH *)
                     end;
     FichierM = file of EnregFichierM;   (* FICHIER DE SAUVETAGE DES MATCHES (MATCHES.TTO) *)

     FichierNDX = file of longint;   (* FICHIER D'INDEX CONTENANT LES filepos DE CHAQUE LIGNE D'UN FICHIER TEXTE *)


(* ******************************************************************************************************************** *)
(*               CONSTANTES TYPEES (VARIABLES GLOBALES AVEC VALEUR INITIALE STOCKEES DANS LE DATA SEGMENT)              *)
(* ******************************************************************************************************************** *)

Const (* ============================================================================================================== *)
      (*                      GESTION DE LA SOURIS, DU HARDWARE ET DES MORCEAUX DE L'UNITE TXT 3.00                     *)
      (* ============================================================================================================== *)
      (* PARAMETRES D'EVENEMENT SOURIS (VALEURS NON SIGNIFICATIVES !) *)
      MouseEventParams : tMouseEventParams = (me_Modified : false;
                                              me_Event : $0000;
                                              me_Buttons : $0000;
                                              me_X : 0; me_Y : 0;
                                              me_XMove : 0; me_YMove : 0;
                                              me_Valid : false);
      (* PARAMETRES GENERAUX DE LA SOURIS (VALEURS NON SIGNIFICATIVES !) *)
      MouseParams : tMouseParams = (mp_MouseType : 0;
                                    mp_NbButtons : 0;
                                    mp_VersionHi : 0; mp_VersionLo : 0;
                                    mp_DriverSeg : $0000; mp_DriverOfs : $0000;
                                    mp_DriverType : $FFFF;
                                    mp_SaveBufferSize : 0;
                                    mp_X : 0; mp_Y : 0;
                                    mp_Page : 0;
                                    mp_XSpeed : 0; mp_YSpeed : 0;
                                    mp_DoubleSpeed : 0;
                                    mp_Mask1 : $0000; mp_Mask2 : $0000;
                                    mp_ButtonsDown : $0000;
                                    mp_CursorType : $FFFF;
                                    mp_CursorCounter : $0000;
                                    mp_IntFreq : $0000;
                                    mp_Valid : false);
      (* PARAMETRES VIDEO COURANTS *)
      TextParams : tTextParams = (tp_ModeType : 1);   (* MODE COULEUR *)
      (* INDICATEUR DE TEST DE COMPATIBILITE AVEC LE HARDWARE POUR CHAQUE MODULE TXT 3.00 *)
      Test_Systems : boolean = true;   (* TEST DE COMPATIBILITE HARDWARE *)
      (* DETOURNEMENT D'INTERRUPTIONS (CTRL-C, CTRL-BREAK, CTRL-ALT-DEL) - PROCEDURE TXTAVOIDBREAK2 *)
      OldInt09 : pointer = nil;   (* ADRESSE DE L'INT 09H DETOURNEE *)
      OldInt1B : pointer = nil;   (* ADRESSE DE L'INT 1BH DETOURNEE *)
      Int09 : byte = 0;           (* NOUVEAU N DE L'ANCIENNE INT 09H *)

      (* ============================================================================================================== *)
      (*                                            GESTION DE L'IMPRIMANTE                                             *)
      (* ============================================================================================================== *)
      Imprimante : byte = ti_Aucune;   (* TYPE D'IMPRIMANTE *)
      (* CODES DE COMMANDE D'IMPRIMANTE A UTILISER PAR LE PROGRAMME *)
      ci_CompresseOUI : string = '';   (* VALEUR DU CODE "DEBUT DE CARACTERES COMPRESSES" *)
      ci_CompresseNON : string = '';   (* VALEUR DU CODE "FIN DE CARACTERES COMPRESSES" *)
      ci_GrasOUI : string = '';        (* VALEUR DU CODE "DEBUT D'IMPRESSION EN GRAS" *)
      ci_GrasNON : string = '';        (* VALEUR DU CODE "FIN D'IMPRESSION EN GRAS" *)
      ci_SouligneOUI : string = '';    (* VALEUR DU CODE "DEBUT DU SOULIGNEMENT" *)
      ci_SouligneNON : string = '';    (* VALEUR DU CODE "FIN DU SOULIGNEMENT" *)
      (* CODES DE COMMANDE FOURNIS PAR LE PROGRAMME *)
      (* (1) HP DESKJET 5xx *)
      ci_HP_CompressedON : string = #27#40#115#50#48#72;
      ci_HP_CompressedOFF : string = #27#40#115#49#48#72;
      ci_HP_BoldON : string = #27#40#115#51#66;
      ci_HP_BoldOFF : string = #27#40#115#48#66;
      ci_HP_UnderlineON : string = #27#38#100#51#68;
      ci_HP_UnderlineOFF : string = #27#38#100#64;
      (* (2) IBM PROPRINTER *)
      ci_IBM_CompressedON : string = #15;
      ci_IBM_CompressedOFF : string = #18;
      ci_IBM_BoldON : string = #27#69;
      ci_IBM_BoldOFF : string = #27#70;
      ci_IBM_UnderlineON : string = #27#45#1;
      ci_IBM_UnderlineOFF : string = #27#45#0;
      (* (3) EPSON LX/FX *)
      ci_Epson_CompressedON : string = #27#15;
      ci_Epson_CompressedOFF : string = #18;
      ci_Epson_BoldON : string = #27#69;
      ci_Epson_BoldOFF : string = #27#70;
      ci_Epson_UnderlineON : string = #27#45#1;
      ci_Epson_UnderlineOFF : string = #27#45#0;
      (* (4) CODES DE COMMANDE COMMUNS *)
      ci_CR : string = #13;   (* RETOUR CHARRIOT *)
      ci_LF : string = #10;   (* SAUT DE LIGNE *)
      ci_FF : string = #12;   (* SAUT DE PAGE *)
      (* CODES DE COMMANDE D'IMPRIMANTE DEFINIS PAR L'UTILISATEUR *)
      ci_CompressedON : string = '';    (* DEBUT DES CARACTERES COMPRESSES *)
      ci_CompressedOFF : string = '';   (* FIN DES CARACTERES COMPRESSES *)
      ci_BoldON : string = '';          (* DEBUT DU GRAS *)
      ci_BoldOFF : string = '';         (* FIN DU GRAS *)
      ci_UnderlineON : string = '';     (* DEBUT DU SOULIGNEMENT *)
      ci_UnderlineOFF : string = '';    (* FIN DU SOULIGNEMENT *)

      (* ============================================================================================================== *)
      (*                                               GESTION DU TIMER                                                 *)
      (* ============================================================================================================== *)
      SauverSituation : boolean = false;     (* INDIQUE QUE LE DELAI DE SAUVETAGE AUTOMATIQUE EST ECOULE *)
      EconomiserEcran : boolean = false;     (* INDIQUE QUE LE DELAI DE L'ECONOMISEUR D'ECRAN EST ECOULE *)
      VitesseTimer : byte = 0;               (* VITESSE DU TIMER (0 = ENCORE AUCUN TEST EFFECTUE OU ERREUR) *)
      DelaiSauvetage : byte = 15;            (* FREQUENCE DU SAUVETAGE AUTOMATIQUE (EN MINUTES) *)
      DelaiEcran : byte = 3;                 (* DELAI DE L'ECONOMISEUR D'ECRAN (EN MINUTES) *)
      CompteurTicsSauvetage : longint = 0;   (* COMPTEUR DE TICS D'HORLOGE DU SAUVETAGE AUTOMATIQUE *)
      CompteurTicsEcran : longint = 0;       (* COMPTEUR DE TICS D'HORLOGE DE L'ECONOMISEUR D'ECRAN *)
      TicsDelaiSauvetage : longint = 0;      (* DELAI DU SAUVETAGE AUTOMATIQUE EXPRIME EN TICS *)
      TicsDelaiEcran : longint = 0;          (* DELAI DE L'ECONOMISEUR D'ECRAN EXPRIME EN TICS *)

      (* ============================================================================================================== *)
      (*                                         TABLE DES MATIERES DE L'AIDE                                           *)
      (* ============================================================================================================== *)
      TableDesMatieres : TabTdM = (
         (Rubrique : 'UTILISATION DE L''AIDE             '; NumeroLigne : hlp_UtilisationAide),
         (Rubrique : 'PRESENTATION DU PROGRAMME         '; NumeroLigne : hlp_PresentationPrgm),
         (Rubrique : 'LA GESTION DU TOURNOI             '; NumeroLigne : hlp_GestionTournoi),
         (Rubrique : ' Gnralits                   '; NumeroLigne : hlp_GestionTournoiGeneralites),
         (Rubrique : 'LANCEMENT DU PROGRAMME            '; NumeroLigne : hlp_LancementPrgm),
         (Rubrique : ' Paramtre de lancement        '; NumeroLigne : hlp_ParametreLancement),
         (Rubrique : ' Dmarrage du programme        '; NumeroLigne : hlp_DemarragePrgm),
         (Rubrique : ' Le fichier TTO.INI            '; NumeroLigne : hlp_FichierIni),
         (Rubrique : ' Options par dfaut            '; NumeroLigne : hlp_OptionsDefaut),
         (Rubrique : 'UTILISATION DU PROGRAMME          '; NumeroLigne : hlp_UtilisationPrgm),
         (Rubrique : ' Utilisation des menus         '; NumeroLigne : hlp_UtilisationMenus),
         (Rubrique : ' Champs  encoder              '; NumeroLigne : hlp_ChampsAEncoder),
         (Rubrique : ' Botes de dialogue            '; NumeroLigne : hlp_BoitesDialogue),
         (Rubrique : ' Listes                        '; NumeroLigne : hlp_Listes),
         (Rubrique : ' Messages d''avertissement      '; NumeroLigne : hlp_MessagesAvertissement),
         (Rubrique : 'LE MENU PRINCIPAL                 '; NumeroLigne : hlp_MenuPrincipal),
         (Rubrique : ' Gnralits                   '; NumeroLigne : hlp_MenuPrincipalGeneralites),
         (Rubrique : ' Slection d''une catgorie     '; NumeroLigne : hlp_SelectionCategorie),
         (Rubrique : ' Cration d''une catgorie      '; NumeroLigne : hlp_CreationCategorie),
         (Rubrique : ' Paramtres d''une catgorie    '; NumeroLigne : hlp_ParametresCategorie),
         (Rubrique : ' Destruction d''une catgorie   '; NumeroLigne : hlp_DestructionCategorie),
         (Rubrique : ' Gestion d''une catgorie       '; NumeroLigne : hlp_GestionCategorie),
         (Rubrique : ' Impression des rsultats      '; NumeroLigne : hlp_ImpressionResultats),
         (Rubrique : ' Sauvetage sur disque          '; NumeroLigne : hlp_SauvetageDisque),
         (Rubrique : ' Restauration depuis un disque '; NumeroLigne : hlp_RestaurationDisque),
         (Rubrique : ' Options du programme          '; NumeroLigne : hlp_OptionsPrgm),
         (Rubrique : '    Dsactiver la souris      '; NumeroLigne : hlp_OptionSouris),
         (Rubrique : '    Sauvetage automatique     '; NumeroLigne : hlp_OptionAutoSave),
         (Rubrique : '    Ecran en veilleuse        '; NumeroLigne : hlp_OptionScreenSaver),
         (Rubrique : '    Imprimante                '; NumeroLigne : hlp_OptionImprimante),
         (Rubrique : '    Commandes d''imprimante    '; NumeroLigne : hlp_OptionCommandesImprimante),
         (Rubrique : '    Enregistrer les options   '; NumeroLigne : hlp_OptionsEnregistrer),
         (Rubrique : ' Quitter le programme          '; NumeroLigne : hlp_QuitterPrgm),
         (Rubrique : 'LE MENU DE GESTION D''UNE CATEGORIE'; NumeroLigne : hlp_MenuGestionCategorie),
         (Rubrique : ' Gnralits                   '; NumeroLigne : hlp_Menugestiongeneralites),
         (Rubrique : ' Slection d''un joueur         '; NumeroLigne : hlp_SelectionJoueur),
         (Rubrique : ' Inscription d''un joueur       '; NumeroLigne : hlp_InscriptionJoueur),
         (Rubrique : ' Suppression d''un joueur       '; NumeroLigne : hlp_SuppressionJoueur),
         (Rubrique : ' Modification d''un joueur      '; NumeroLigne : hlp_ModificationJoueur),
         (Rubrique : ' Affichage du classement       '; NumeroLigne : hlp_AffichageClassement),
         (Rubrique : '    Principes du classement   '; NumeroLigne : hlp_PrincipesClassement),
         (Rubrique : ' Division en poules            '; NumeroLigne : hlp_DivisionPoules),
         (Rubrique : ' Cration des matches          '; NumeroLigne : hlp_CreationMatches),
         (Rubrique : '    Cration automatique      '; NumeroLigne : hlp_CreationAutomatique),
         (Rubrique : '    Cration manuelle         '; NumeroLigne : hlp_CreationManuelle),
         (Rubrique : ' Encodage d''un rsultat        '; NumeroLigne : hlp_EncodageResultat),
         (Rubrique : ' Passage au tour suivant       '; NumeroLigne : hlp_PassageTourSuivant),
         (Rubrique : 'PROBLEMES RENCONTRES              '; NumeroLigne : hlp_Problemes),
         (Rubrique : 'MESSAGES D''ERREUR                 '; NumeroLigne : hlp_MessagesErreur),
         (Rubrique : 'INFORMATIONS TECHNIQUES           '; NumeroLigne : hlp_InformationsTechniques),
         (Rubrique : ' Bote de dialogue de dbogage '; NumeroLigne : hlp_Debogage),
         (Rubrique : ' Contacts avec l''auteur        '; NumeroLigne : hlp_ContactsAuteur));

      (* ============================================================================================================== *)
      (*                                      FONCTIONNEMENT GENERAL DU PROGRAMME                                       *)
      (* ============================================================================================================== *)
      SauverOptions : boolean = true;         (* INDIQUE S'IL FAUT SAUVER LES OPTIONS EN FIN DE PROGRAMME *)
      ParametresProgramme : word = 0;         (* COMBINAISON or DES PARAMETRES DE LA LIGNE DE COMMANDE *)
      NbLignesTexte : word = 0;               (* NOMBRE DE LIGNES DU FICHIER TEXTE A AFFICHER *)
      ContenuTexte : byte = ndx_Aucun;        (* INDICATION CONTENU DU TABLEAU Texte (filepos LIGNES TEXTE A AFFICHER) *)
      TabHexa : Str16 = '0123456789ABCDEF';   (* TABLE DE CONVERSION DE CHAINES DECIMAL/HEXA *)


(* ******************************************************************************************************************** *)
(*                        VARIABLES GLOBALES (SANS VALEUR INITIALE, STOCKEES DANS LE DATA SEGMENT)                      *)
(* ******************************************************************************************************************** *)

Var (* ================================================================================================================ *)
    (*                                  GESTION DE LA SOURIS, DU HARDWARE ET DE LA VIDEO                                *)
    (* ================================================================================================================ *)
    Registres : registers;   (* REGISTRES DU PROCESSEUR A PASSER AUX FONCTIONS DOS ET BIOS *)
    (* TIMER *)
    Int08 : byte;             (* NOUVEAU N DE L'INT 08H DETOURNEE *)
    AdresseInt08 : pointer;   (* ANCIENNE ADRESSE DE L'INT 08H DETOURNEE *)
    (* HARDWARE *)
    TypeOrdinateur : byte;    (* TYPE D'ORDINATEUR DETECTE *)
    Carte, Moniteur : byte;   (* CARTE VIDEO ET MONITEUR INSTALLES *)
    (* SOURIS *)
    Souris : boolean;            (* INDIQUE SI GESTION DE LA SOURIS *)
    BufferSouris : pointer;      (* ADRESSE DE SAUVETAGE DES PARAMETRES INITIAUX DE LA SOURIS *)
    TailleBufferSouris : word;   (* TAILLE DU BUFFER DE SAUVEGARDE DES PARAMETRES DE LA SOURIS *)
    (* VIDEO *)
    ModeEcran : byte;                 (* MODE DE GESTION DES COULEURS A L'ECRAN *)
    CurseurHaut, CurseurBas : word;   (* LIMITES DU CURSEUR *)

    (* ================================================================================================================ *)
    (*                                        FONCTIONNEMENT GENERAL DU PROGRAMME                                       *)
    (* ================================================================================================================ *)
    Void : boolean;      (* RESULTATS IGNORES DE FONCTIONS TXT 3.00 *)
    Categories : TabC;   (* TABLEAU GENERAL DES CATEGORIES *)
    Texte : TabT;        (* TABLEAU DES filepos DU FICHIER TEXTE A AFFICHER *)

    (* ================================================================================================================ *)
    (*                                          GESTION DES FICHIERS SUR DISQUE                                         *)
    (* ================================================================================================================ *)
    BufferCategories : EnregFichierC;   (* BUFFER DE SAUVETAGE DES CATEGORIES *)
    FichierCategories : FichierC;       (* FICHIER DE SAUVETAGE DES CATEGORIES *)
    BufferJoueurs : EnregFichierJ;      (* BUFFER DE SAUVETAGE DES JOUEURS *)
    FichierJoueurs : FichierJ;          (* FICHIER DE SAUVETAGE DES JOUEURS *)
    BufferMatches : EnregFichierM;      (* BUFFER DE SAUVETAGE DES MATCHES *)
    FichierMatches : FichierM;          (* FICHIER DE SAUVETAGE DES MATCHES *)
    BufferIni : string;                 (* BUFFER DE LECTURE/ECRITURE DU FICHIER DE DEMARRAGE *)
    FichierIni : text;                  (* FICHIER DE DEMARRAGE (TTO.INI) *)
    BufferAide : string;                (* BUFFER DE LECTURE/ECRITURE DU FICHIER D'AIDE *)
    FichierAide : text;                 (* FICHIER D'AIDE (TTO.HLP) *)
    BufferPrint : string;               (* BUFFER DE LECTURE/ECRITURE DU FICHIER D'IMPRESSION *)
    FichierPrint : text;                (* FICHIER D'IMPRESSION (CAT??.PRN) *)
    BufferIndex : longint;              (* BUFFER LECTURE/ECRITURE FICHIER INDEX *)
    FichierIndex : FichierNDX;          (* FICHIER INDEX (*.NDX) *)
    NomFichierTraite : string[12];      (* NOM DU FICHIER EN COURS *)

    (* ================================================================================================================ *)
    (*     VARIABLES DE LA PROCEDURE DEBOGAGE (STOCKEES DANS LE DATA SEGMENT POUR NE PAS ENCOMBRER LE STACK SEGMENT)    *)
    (* ================================================================================================================ *)
    dbg_x, dbg_y : word;                                    (* COORDONNEES DU CURSEUR *)
    dbg_x1, dbg_y1, dbg_x2, dbg_y2 : word;                  (* COORDONNEES DE LA FENETRE ACTIVE *)
    dbg_FondCourant, dbg_CouleurCourante : word;            (* FOND ET COULEUR COURANTS *)
    dbg_Image : videosave;                                  (* SAUVETAGE DE L'ECRAN *)
    dbg_Fond1, dbg_Normal1, dbg_Fond2, dbg_Brillant, dbg_Fond3, dbg_Normal3, dbg_FondOmbre, dbg_Ombre : word;   (* COULEURS *)
    dbg_Ligne : byte;                                       (* LIGNE DE CONSTRUCTION DU CADRE D'AFFICHAGE *)
    dbg_MemoireDisponible : longint;                        (* MEMOIRE DISPONIBLE *)
    dbg_TypeOrdinateur, dbg_Carte, dbg_Moniteur : string;   (* HARDWARE DETECTE *)
    dbg_TypeSouris, dbg_VersionSouris : string;             (* SOURIS DETECTEE *)
    dbg_CompteurSouris : word;                              (* COMPTEUR DE CURSEUR SOURIS *)
    dbg_EspaceDisque : longint;                             (* ESPACE DISPONIBLE SUR LE DISQUE *)
    dbg_Erreur : integer;                                   (* RECOIT LE RESULTAT DE doserror *)
    dbg_Chaine : Str4;                                      (* VARIABLE DE CONVERSION DECIMAL/HEXA *)
    dbg_n : word;                                           (* VARIABLE DE TRAVAIL CONVERSION DECIMAL/HEXA *)
    dbg_Entree : char;                                      (* BUFFER CLAVIER *)
    dbg_Fin : boolean;                                      (* FIN DE BOUCLE DE LECTURE DU CLAVIER *)


IMPLEMENTATION


END.
