
UNIT TTO_GEST;

(* GESTION D'UNE CATEGORIE POUR LE PROGRAMME TTO.PAS VERSION 1.10 *)

INTERFACE

Uses TXT,        (* GESTION DE L'ECRAN EN MODE TEXTE *)
     TTO_DECL,   (* DECLARATION DE CONSTANTES, TYPES ET VARIABLES GLOBALES *)
     TTO_HARD,   (* GESTION DE LA SOURIS, ECONOMISEUR D'ECRAN *)
     TTO_COMN,   (* EXPLICATIONS AU BAS DE L'ECRAN, MESSAGES D'ERREUR OU D'AVERTISSEMENT *)
     TTO_FILE,   (* SAUVETAGE AUTOMATIQUE SUR DISQUE *)
     TTO_LIST,   (* GESTION DES LISTES CHAINEES DE POINTEURS, CREATION AUTOMATIQUE DES MATCHES *)
     TTO_PRNT,   (* MISE A JOUR DU FICHIER D'IMPRESSION *)
     TTO_POUL,   (* DIVISION D'UNE CATEGORIE EN POULES *)
     TTO_PLYR,   (* MODIFICATION DES PARAMETRES D'UN JOUEUR *)
     TTO_MTCH,   (* CREATION MANUELLE DES MATCHES ET ENCODAGE DES RESULTATS *)
     TTO_CLAS,   (* AFFICHAGE DU CLASSEMENT ET PASSAGE AU TOUR SUIVANT *)
     TTO_HELP;   (* AIDE CONTECTUELLE ET DEBOGAGE *)


Procedure GESTION_CATEGORIE (Numero : byte);
   (* MENU DE GESTION D'UNE CATEGORIE *)


IMPLEMENTATION

Function INSCRIPTION_JOUEUR (Numero : byte) : boolean;
(* LECTURE DES DONNEES D'UN JOUEUR ET INSERTION DANS LA LISTE CHAINEE DE LA CATEGORIE Numero.
   RETOURNE true SI JOUEUR INSCRIT, false SI PAS DE NOUVEAU JOUEUR. *)
Var x1,y1,x2,y2:word;
    Image:videosave;
    Resultat:byte;
    Joueur:EnregJ;
    p:pJoueur;
    Ok:boolean;
Begin
  with Categories[Numero] do
    begin
      Ok:=true; if Situation in [1..64] then  Ok:=(NbJoueurs < (Situation * 2));
    end;
  if Ok
     then
       begin
         INSCRIPTION_JOUEUR:=false;
         x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; txtwind(0,0,79,0); txtsave(Image);
         TITRE_HAUT_ECRAN(ip_InscriptionJoueur);
         with Joueur do
           begin
             NomJoueur:=''; PrenomJoueur:=''; Age:=''; Club:='';
             if MODIFICATION_PARAMETRES_JOUEUR(Joueur) <> mp_Avorter
                then   (* INSCRIPTION ACTEE *)
                  begin
                    Poule:=0; EnLice:=true; MatchesJoues:=0; Points:=0; Sets:=0; Score:=0;
                    new(p);
                    if p <> nil
                       then
                         begin
                           p^:=Joueur;
                           with Categories[Numero] do
                             begin
                               (* INSERTION DANS LA LISTE CHAINEE DES JOUEURS *)
                               AJOUT_JOUEUR_LISTE_CATEGORIE(Numero,list_Alpha,p);
                               (* MISE A JOUR DES PARAMETRES DE LA CATEGORIE *)
                               inc(NbJoueurs); inc(NbJoueursRestants);
                             end;
                           INSCRIPTION_JOUEUR:=true;
                         end
                       else
                         Void:=MESSAGE_ERREUR(1001);
                  end;
           end;
         txtload(Image); txtwind(x1,y1,x2,y2);
       end
     else   (* LE NOMBRE DE JOUEURS MAXIMUM EST ATTEINT *)
       case Categories[Numero].Situation of
         64:Void:=MESSAGE_AVERTISSEMENT(ip_InscriptionJoueur + 1);
         32:Void:=MESSAGE_AVERTISSEMENT(ip_InscriptionJoueur + 2);
         16:Void:=MESSAGE_AVERTISSEMENT(ip_InscriptionJoueur + 3);
         8:Void:=MESSAGE_AVERTISSEMENT(ip_InscriptionJoueur + 4);
         4:Void:=MESSAGE_AVERTISSEMENT(ip_InscriptionJoueur + 5);
         2:Void:=MESSAGE_AVERTISSEMENT(ip_InscriptionJoueur + 6);
         1:Void:=MESSAGE_AVERTISSEMENT(ip_InscriptionJoueur + 7);
       end;
End;


Function SUPPRESSION_JOUEUR (Numero : byte; Pointeur : pJoueur) : boolean;
(* SUPPRESSION DU JOUEUR POINTE PAR Pointeur ET DE TOUT CE QUI S'Y RAPPORTE.
   Numero EST LE N DE LA CATEGORIE.
   RETOURNE true SI JOUEUR SUPPRIME OU false SI OPERATION ANNULEE. *)
Var pM,pDetruire:pMatch;
Begin
  if MESSAGE_AVERTISSEMENT(ip_SuppressionJoueur)
     then
       begin
         dec(Categories[Numero].NbJoueurs);
         if Pointeur^.EnLice
            then
              begin
                dec(Categories[Numero].NbJoueursRestants);
                if Categories[Numero].NbMatches <> 0
                   then
                     begin
                       (* SUPPRESSION DES MATCHES OU LE JOUEUR INTERVIENT *)
                       pM:=Categories[Numero].pTeteMatches;
                       while pM <> nil do
                         begin
                           if (pM^.pJoueur1 = Pointeur) or (pM^.pJoueur2 = Pointeur)
                              then
                                begin
                                  with Categories[Numero] do
                                    begin
                                      dec(NbMatches);
                                      with pM^ do if Resultats[1,1] = Resultats[1,2] then dec(NbMatchesRestants);
                                    end;
                                  pDetruire:=pM; pM:=pM^.pSuiv; SUPPRESSION_MATCH_LISTE_CATEGORIE(Numero,pDetruire);
                                end
                              else
                                pM:=pM^.pSuiv;
                         end;
                     end;
              end;
         (* SUPPRESSION DU JOUEUR DANS LA LISTE *)
         SUPPRESSION_JOUEUR_LISTE_CATEGORIE(Numero,Pointeur);
         SUPPRESSION_JOUEUR:=true;
       end
     else
       SUPPRESSION_JOUEUR:=false;
End;


Function MODIFICATION_JOUEUR (Numero : byte; Pointeur : pJoueur) : boolean;
(* MODIFICATION DES DONNEES PERSONNELLES D'UN JOUEUR DE LA CATEGORIE Numero.
   RETOURNE true SI NOM OU PRENOM MODIFIE, false SINON. *)
Begin
  MODIFICATION_JOUEUR:=(MODIFICATION_PARAMETRES_JOUEUR(Pointeur^) = mp_OkModifie);
End;


Procedure AFFICHAGE_CLASSEMENT (Numero : byte);
(* CLASSEMENT DES JOUEURS (PLUSIEURS CLASSEMENTS POSSIBLES) *)
Var pTeteListe,pQueueListe:pListeJoueurs;
    NbJoueurs:word;
    Option:byte;
Begin
  with Categories[Numero] do
    if NbJoueursRestants > 0
       then
         begin
           CALCUL_POINTS(Numero);
           if (Situation = 255) and (NbPoules > 0)
              then   (* DEMANDE SI AFFICHAGE CATEGORIE ENTIERE OU POULE PAR POULE *)
                begin
                  if MESSAGE_AVERTISSEMENT(ip_AffichageClassement) then Option:=list_LiceClasPoule else Option:=list_LiceClas;
                  NbJoueurs:=EXTRACTION_LISTE_JOUEURS(Option,0,Numero,pTeteListe,pQueueListe);
                end
              else   (* AFFICHAGE DU CLASSEMENT DE LA CATEGORIE ENTIERE *)
                NbJoueurs:=EXTRACTION_LISTE_JOUEURS(list_LiceClas,0,Numero,pTeteListe,pQueueListe);
           if NbJoueurs > 0
              then
                begin
                  Void:=CLASSEMENT_SELECTION(Numero,NbJoueurs,0,pTeteliste,pQueueListe);
                  SUPPRESSION_LISTE_JOUEURS(pTeteListe);
                end;
         end;
End;


Function DIVISION_EN_POULES (Numero : byte) : boolean;
(* SI ELIMINATOIRES, REPARTITION DES JOUEURS DANS DES POULES.
   RETOURNE true SI L'OPERATION S'EST BIEN DEROULEE, false SINON. *)
Var Nombre,NbJoueurs:word;
    p:pJoueur;
    pTeteLJ,pQueueLJ:pListeJoueurs;
    Ok:boolean;
Begin
  Ok:=(Categories[Numero].Situation = 255) and (Categories[Numero].NbJoueurs > 0);
  if Ok then if Categories[Numero].NbPoules > 0 then Ok:=MESSAGE_AVERTISSEMENT(ip_DivisionPoules);
  if Ok then if Categories[Numero].NbMatches > 0 then Ok:=MESSAGE_AVERTISSEMENT(ip_DivisionPoules + 1);
  if Ok
     then
       begin
         Nombre:=LECTURE_NOMBRE_POULES(Numero);
         if Nombre > 0
            then
              with Categories[Numero] do
                begin
                  p:=pTeteJoueurs; while p <> nil do begin p^.Poule:=0; p:=p^.pSuiv; end;
                  if pTeteMatches <> nil then SUPPRESSION_LISTE_MATCHES_CATEGORIE(Numero);
                  NbPoules:=Nombre; pTeteMatches:=nil; pQueueMatches:=nil; NbMatches:=0; NbMatchesRestants:=0;
                  ANNULATION_RESULTATS_JOUEURS(Numero);
                  NbJoueurs:=EXTRACTION_LISTE_JOUEURS(list_LiceNormal,0,Numero,pTeteLJ,pQueueLJ); Ok:=NbJoueurs <> 0;
                  if Ok then Ok:=REPARTITION_JOUEURS_DANS_POULES(Numero,NbJoueurs,pTeteLJ,pQueueLJ);
                end;
       end;
  DIVISION_EN_POULES:=Ok;
End;


Function CREATION_LISTE_MATCHES (Numero : byte) : boolean;
(* CREATION DE LA LISTE DES MATCHES DE LA CATEGORIE Numero.
   SI ELIMINATOIRES : SI PAS DE POULES ALORS DEMANDER S'IL FAUT LES CREER.
                      SI POULES, ALORS VERIFIER QUE CHAQUE JOUEUR CORRESPOND A UN NUMERO DE POULE VALIDE.
                      SI NON, REDIVISER LA CATEGORIE EN POULES.
                      CREER AUTOMATIQUEMENT LA LISTE DES MATCHES.
   SI Xme DE FINALE : VERIFIER QUE LE NOMBRE DE JOUEURS EST ATTEINT.
                       SI OUI, CREER MANUELLEMENT LA LISTE DES MATCHES.
   RETOURNE true SI L'OPERATION S'EST BIEN DEROULEE ET false SINON. *)
Var Ok:boolean;
    p:pJoueur;
Begin
  with Categories[Numero] do
    begin
      Ok:=true;
      if NbMatches <> 0
         then   (* DES MATCHES EXISTENT DEJA ! *)
           if MESSAGE_AVERTISSEMENT(ip_CreationMatches + 1)
              then
                begin
                  SUPPRESSION_LISTE_MATCHES_CATEGORIE(Numero); ANNULATION_RESULTATS_JOUEURS(Numero);
                end
              else
                Ok:=false;
      if Ok
         then
           case Situation of
             64:if NbJoueursRestants <> 128 then begin Ok:=false; Void:=MESSAGE_AVERTISSEMENT(ip_CreationMatches + 2); end;
             32:if NbJoueursRestants <> 64 then begin Ok:=false; Void:=MESSAGE_AVERTISSEMENT(ip_CreationMatches + 3); end;
             16:if NbJoueursRestants <> 32 then begin Ok:=false; Void:=MESSAGE_AVERTISSEMENT(ip_CreationMatches + 4); end;
             8:if NbJoueursRestants <> 16 then begin Ok:=false; Void:=MESSAGE_AVERTISSEMENT(ip_CreationMatches + 5); end;
             4:if NbJoueursRestants <> 8 then begin Ok:=false; Void:=MESSAGE_AVERTISSEMENT(ip_CreationMatches + 6); end;
             2:if NbJoueursRestants <> 4 then begin Ok:=false; Void:=MESSAGE_AVERTISSEMENT(ip_CreationMatches + 7); end;
             1:if NbJoueursRestants <> 2 then begin Ok:=false; Void:=MESSAGE_AVERTISSEMENT(ip_CreationMatches + 8); end;
           else
             if NbJoueursRestants > 0
                then
                  if NbPoules <> 0
                     then   (* VERIFICATION QUE CHAQUE JOUEUR CORRESPOND A UNE POULE CORRECTE *)
                       begin
                         p:=pTeteJoueurs;
                         while (p <> nil) and (Ok) do if p^.Poule in [1..NbPoules] then p:=p^.pSuiv else Ok:=false;
                         if not Ok then Void:=MESSAGE_AVERTISSEMENT(ip_CreationMatches + 9);
                       end;
           end;
      if Ok
         then   (* CREATION DES MATCHES *)
           begin
             case Situation of
               1..64:NbMatches:=CREATION_MANUELLE_MATCHES(Numero);
             else
               NbMatches:=CREATION_AUTOMATIQUE_MATCHES(Numero);
             end;
             NbMatchesRestants:=NbMatches; Ok:=(NbMatches > 0);
           end;
    end;
  CREATION_LISTE_MATCHES:=Ok;
End;


Procedure PASSAGE_TOUR_SUIVANT (Numero : byte);
(* PASSAGE AU TOUR SUIVANT : 1. CHOIX DE LA SITUATION DU TOUR SUIVANT;
                             2. SELECTION DES JOUEURS POUR CE TOUR SUIVANT;
                             3. MISE A JOUR DU FICHIER D'IMPRESSION (DONNEES DU TOUR ECOULE);
                             4. MISE A JOUR DES JOUEURS ENCORE EN LICE;
                             5. MISE A JOUR DE LA SITUATION DE LA CATEGORIE;
                             6. SUPPRESSION DE LA LISTE DES MATCHES;
                             7. SUPPRESSION DE LA LISTE DE JOUEURS EXTRAITE POUR LA SELECTION DES JOUEURS. *)
Const pTeteListe:pListeJoueurs=nil;
      pQueueListe:pListeJoueurs=nil;
Var pLJ:pListeJoueurs;
    p:pJoueur;
    NbJ,NbSelect:word;
    Option,NouvelleSituation:byte;
    Ok:boolean;
Begin
  with Categories[Numero] do
    if NbMatchesRestants = 0
       then   (* TOUS LES MATCHES ONT ETE JOUES *)
         begin
           (* ----- 1. CHOIX DE LA SITUATION DU TOUR SUIVANT *)
           NouvelleSituation:=CHOIX_SITUATION_TOUR_SUIVANT(Numero);
           if NouvelleSituation <> 0
              then
                begin
                  if NouvelleSituation <> 254
                     then   (* PAS DE STATUT "FINIE" : SELECTION DES JOUEURS *)
                       begin
                         (* ----- 2. SELECTION DES JOUEURS *)
                         case NouvelleSituation of
                           1..64:NbSelect:=NouvelleSituation * 2;
                           255:NbSelect:=1;
                         end;
                         CALCUL_POINTS(Numero);
                         Option:=list_LiceClas;   (* PAR DEFAUT, CLASSEMENT SUR LA CATEGORIE ENTIERE *)
                         if (Situation = 255) and (NbPoules > 0)
                            then   (* DEMANDE SI AFFICHAGE CATEGORIE ENTIERE OU POULE PAR POULE *)
                              if MESSAGE_AVERTISSEMENT(ip_AffichageClassement) then Option:=list_LiceClasPoule;
                         NbJ:=EXTRACTION_LISTE_JOUEURS(Option,0,Numero,pTeteListe,pQueueListe);
                         if NbJ > 0
                            then
                              Ok:=CLASSEMENT_SELECTION(Numero,NbJ,NbSelect,pTeteliste,pQueueListe)
                            else
                              Ok:=false;
                       end
                     else   (* STATUT "FINIE" : PAS DE SELECTION DE JOUEURS *)
                       Ok:=true;
                end
              else   (* OPERATION AVORTEE AU NIVEAU DE LA DEMANDE DE LA NOUVELLE SITUATION *)
                Ok:=false;
           (* ----- 3. MISE A JOUR DU FICHIER D'IMPRESSION *)
           if Ok then Ok:=MISE_A_JOUR_FICHIER_IMPRESSION(Numero,pTeteListe);
           if Ok
              then
                begin
                  (* ----- 4. MISE A JOUR DES JOUEURS ENCORE EN LICE *)
                  if NouvelleSituation <> 254
                     then   (* DESELECTION DES JOUEURS NON SELECTIONNES *)
                       begin
                         pLJ:=pTeteListe;
                         while pLJ <> nil do with pLJ^ do
                           begin
                             PointeurJoueur^.EnLice:=Selection; pLJ:=pLJ^.pSuiv;
                           end;
                         (* COMPTAGE DU NOMBRE DE SELECTIONNES *)
                         p:=pTeteJoueurs; NbJoueursRestants:=0;
                         while p <> nil do
                           begin
                             if p^.EnLice then inc(NbJoueursRestants); p:=p^.pSuiv;
                           end;
                       end
                     else   (* DESELECTION DE TOUS LES JOUEURS *)
                       begin
                         p:=pTeteJoueurs;
                         while p <> nil do
                           begin
                             p^.EnLice:=false; p:=p^.pSuiv;
                           end;
                         NbJoueursRestants:=0;
                       end;
                  (* ----- 5. MISE A JOUR DE LA SITUATION DE LA CATEGORIE *)
                  Situation:=NouvelleSituation;
                  (* ----- 6. SUPPRESSION DE LA LISTE DES MATCHES *)
                  SUPPRESSION_LISTE_MATCHES_CATEGORIE(Numero); NbMatches:=0; NbMatchesRestants:=0;
                end;
           (* ----- 7. SUPPRESSION DE LA LISTE DES JOUEURS CREE POUR LA SELECTION *)
           if (NouvelleSituation <> 254) and (pTeteListe <> nil) then SUPPRESSION_LISTE_JOUEURS(pTeteListe);
         end
       else   (* TOUS LES MATCHES N'ONT PAS ETE JOUES *)
         Void:=MESSAGE_AVERTISSEMENT(ip_PassageTourSuivant + 2);
End;


Function SELECTION_JOUEUR (Numero : byte) : pJoueur;
(* SELECTION D'UN JOUEUR DANS LA COLONNE DE DROITE DE L'ECRAN.
   RETOURNE L'ADRESSE DU JOUEUR SELECTIONNE OU nil SI AVORTER. *)
Const c=40; lg=33; NbL=21; yHaut=2;
Type TabPointeurs = array[1..NbL] of pJoueur;
Var x,y,x1,y1,x2,y2,FondCourant,CouleurCourante:word;
    Image:videosave;
    Fond1,Normal1,Fond2,Brillant:word;
    TableauPointeurs:TabPointeurs;
    p:pJoueur;
    Ligne,JoueurHaut:byte;
    Entree:char;
    Ok:boolean;
          Procedure LIGNE_ALLUMEE;
          (* MISE EN EVIDENCE DE LA LIGNE COURANTE *)
          Begin
            txtback(Fond2); txtcolour(Brillant); txtmove(c+3,Ligne); txtattrib(lg);
          End;
          Procedure LIGNE_ETEINTE;
          (* FIN DE LA MISE EN EVIDENCE DE LA LIGNE COURANTE *)
          Begin
            txtback(Fond1); txtcolour(Normal1); txtmove(c+3,Ligne); txtattrib(lg);
          End;
          Procedure AFFICHAGE_JOUEUR (n:byte);
          (* AFFICHAGE DU JOUEUR CORRESPONDANT A TableauPointeurs[n] *)
          Begin
            txtback(Fond1); txtcolour(Normal1);
            if TableauPointeurs[n] = nil
               then
                 begin
                   txtmove(c+4,n+1); txtwrite('............... ...............');
                 end
               else
                 begin
                   txtmove(c+4,n+1); txtwrite('                               ');
                   txtmove(c+4,n+1); txtwrite(TableauPointeurs[n]^.NomJoueur);
                   txtmove(c+20,n+1); txtwrite(TableauPointeurs[n]^.PrenomJoueur);
                 end;
          End;
          Procedure AFFICHAGE_PAGE;
          (* AFFICHAGE DES JOUEURS CORRESPONDANT A TableauPointeurs *)
          Var n:byte;
          Begin
            for n:=1 to NbL do AFFICHAGE_JOUEUR(n);
          End;
          Procedure PREMIER_JOUEUR;
          (* REMONTEE JUSQU'AU PREMIER JOUEUR *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pPrec <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if JoueurHaut > 1
                      then   (* SCROLLING *)
                        begin
                          i:=1; p:=Categories[Numero].pTeteJoueurs;
                          while (i <= NbL) and (p <> nil) do
                            begin
                              TableauPointeurs[i]:=p; inc(i); if p <> nil then p:=p^.pSuiv;
                            end;
                          JoueurHaut:=1; AFFICHAGE_PAGE;
                        end;
                   Ligne:=yHaut; LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure DERNIER_JOUEUR;
          (* DESCENTE JUSQU'AU DERNIER JOUEUR *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pSuiv <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if Categories[Numero].NbJoueurs > NbL
                      then   (* IL FAUDRA TESTER SI SCROLLING *)
                        begin
                          if JoueurHaut < (Categories[Numero].NbJoueurs - NbL + 1)
                             then   (* LE DERNIER JOUEUR N'EST PAS A L'ECRAN : SCROLLING *)
                               begin
                                 i:=NbL; p:=Categories[Numero].pQueueJoueurs;
                                 while (i >= 1) and (p <> nil) do
                                   begin
                                     TableauPointeurs[i]:=p; dec(i); if p <> nil then p:=p^.pPrec;
                                   end;
                                 Ligne:=yHaut + NbL - 1; JoueurHaut:=Categories[Numero].NbJoueurs - NbL + 1; AFFICHAGE_PAGE;
                               end
                             else   (* LE DERNIER JOUEUR EST A L'ECRAN *)
                               Ligne:=Categories[Numero].NbJoueurs - JoueurHaut + yHaut;
                        end
                      else   (* MOINS DE JOUEURS QUE DE LIGNES : DERNIER JOUEUR A L'ECRAN *)
                        Ligne:=Categories[Numero].NbJoueurs + yHaut - 1;
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure JOUEUR_PRECEDENT;
          (* REMONTEE AU JOUEUR PRECEDENT *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pPrec <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if Ligne = yHaut
                      then   (* SCROLLING *)
                        begin
                          for i:=NbL downto 2 do TableauPointeurs[i]:=TableauPointeurs[i-1];
                          TableauPointeurs[1]:=TableauPointeurs[1]^.pPrec; dec(JoueurHaut);
                          txtback(Fond1); txtcolour(Normal1);
                          txtwind(c+2,yHaut,c+36,yHaut + NbL - 1); txtinsdn(0); txtunwind;
                          AFFICHAGE_JOUEUR(1);
                        end
                      else   (* PAS DE SCROLLING *)
                        dec(Ligne);
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure JOUEUR_SUIVANT;
          (* DESCENTE AU JOUEUR SUIVANT *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pSuiv <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if Ligne = (yHaut + NbL - 1)
                      then   (* SCROLLING *)
                        begin
                          for i:=1 to (NbL - 1) do TableauPointeurs[i]:=TableauPointeurs[i+1];
                          TableauPointeurs[NbL]:=TableauPointeurs[NbL]^.pSuiv; inc(JoueurHaut);
                          txtback(Fond1); txtcolour(Normal1);
                          txtwind(c+2,yHaut,c+36,yHaut + NbL - 1); txtdeldn(0); txtunwind;
                          AFFICHAGE_JOUEUR(NbL);
                        end
                      else   (* PAS DE SCROLLING *)
                        inc(Ligne);
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure PAGE_PRECEDENTE;
          (* AFFICHAGE DE LA PAGE DE JOUEURS PRECEDENTE *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pPrec <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if JoueurHaut > (NbL - 1)
                      then   (* SCROLLING D'UNE PAGE ENTIERE *)
                        begin
                          p:=TableauPointeurs[1]; TableauPointeurs[NbL]:=p; p:=p^.pPrec;
                          for i:=(NbL - 1) downto 1 do
                            begin
                              TableauPointeurs[i]:=p; p:=p^.pPrec;
                            end;
                          dec(JoueurHaut,NbL - 1); AFFICHAGE_PAGE;
                        end
                      else
                        if JoueurHaut > 1
                           then   (* PREMIERE PAGE *)
                             begin
                               i:=1; p:=Categories[Numero].pTeteJoueurs;
                               while (i <= NbL) and (p <> nil) do
                                 begin
                                   TableauPointeurs[i]:=p; inc(i); if p <> nil then p:=p^.pSuiv;
                                 end;
                               JoueurHaut:=1; AFFICHAGE_PAGE;
                             end
                           else   (* PAS DE SCROLLING *)
                             Ligne:=yHaut;
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure PAGE_SUIVANTE;
          (* AFFICHAGE DE LA PAGE DE JOUEURS SUIVANTE *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pSuiv <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if Categories[Numero].NbJoueurs > (2 * (NbL - 1))
                      then   (* IL FAUDRA TESTER SI SCROLLING PAGE ENTIERE *)
                        begin
                          if JoueurHaut <= (Categories[Numero].NbJoueurs - 2 * (NbL - 1))
                             then   (* SCROLLING D'UNE PAGE ENTIERE *)
                               begin
                                 p:=TableauPointeurs[NbL]; TableauPointeurs[1]:=p; p:=p^.pSuiv;
                                 for i:=2 to NbL do
                                   begin
                                     TableauPointeurs[i]:=p; p:=p^.pSuiv;
                                   end;
                                 inc(JoueurHaut,NbL - 1); AFFICHAGE_PAGE;
                               end
                             else
                               if JoueurHaut < (Categories[Numero].NbJoueurs - NbL + 1)
                                  then   (* AFFICHAGE DE LA DERNIERE PAGE *)
                                    begin
                                      i:=NbL; p:=Categories[Numero].pQueueJoueurs;
                                      while (i >= 1) and (p <> nil) do
                                        begin
                                          TableauPointeurs[i]:=p; dec(i); if p <> nil then p:=p^.pPrec;
                                        end;
                                      JoueurHaut:=Categories[Numero].NbJoueurs - NbL + 1; AFFICHAGE_PAGE;
                                    end
                                  else   (* DERNIERE PAGE DEJA AFFICHEE *)
                                    Ligne:=Categories[Numero].NbJoueurs - JoueurHaut + yHaut;
                        end
                      else
                        if Categories[Numero].NbJoueurs > NbL
                           then   (* IL FAUDRA TESTER SI SCROLLING *)
                             begin
                               if JoueurHaut < (Categories[Numero].NbJoueurs - NbL + 1)
                                  then   (* AFFICHAGE DE LA DERNIERE PAGE *)
                                    begin
                                      i:=NbL; p:=Categories[Numero].pQueueJoueurs;
                                      while (i >= 1) and (p <> nil) do
                                        begin
                                          TableauPointeurs[i]:=p; dec(i); if p <> nil then p:=p^.pPrec;
                                        end;
                                      JoueurHaut:=Categories[Numero].NbJoueurs - NbL + 1; AFFICHAGE_PAGE;
                                    end
                                  else   (* DERNIERE PAGE DEJA AFFICHEE *)
                                    Ligne:=Categories[Numero].NbJoueurs - JoueurHaut + yHaut;
                             end
                           else   (* MOINS DE JOUEURS QUE DE LIGNES : L'UNIQUE ET DERNIERE PAGE EST DEJA AFFICHEE *)
                             Ligne:=Categories[Numero].NbJoueurs + yHaut - 1;
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
Begin
  case ModeEcran of
    ModeMono:begin Fond1:=lightgrey; Normal1:=black; Fond2:=black; Brillant:=white; end;
    ModeCouleur:begin Fond1:=blue; Normal1:=yellow; Fond2:=brown; Brillant:=white end;
  end;
  x:=windx; y:=windy; x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image);
  MESSAGE_BAS_ECRAN(ip_GestionCategorie); TITRE_HAUT_ECRAN(ip_GestionCategorie);
  (* INITIALISATION DU TABLEAU DE POINTEURS *)
  for Ligne:=1 to NbL do TableauPointeurs[Ligne]:=nil;
  Ligne:=1; p:=Categories[Numero].pTeteJoueurs;
  while (p <> nil) and (Ligne <= NbL) do
    begin
      TableauPointeurs[Ligne]:=p; p:=p^.pSuiv; inc(Ligne);
    end;
  (* SOURIS ET CLAVIER *)
  Ligne:=yHaut; JoueurHaut:=1; LIGNE_ALLUMEE;
  txtflush; mouseeventparams.me_modified:=false; if Souris then Void:=txtmousecurson;
  Ok:=false;
  repeat
    if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
    if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   59:begin   (* F1 : AIDE *)
                        if Souris then Void:=txtmousecursoff;
                        AIDE(hlp_SelectionJoueur);
                        if Souris then Void:=txtmousecurson;
                      end;
                   71,119,132:PREMIER_JOUEUR;   (* (CTRL-)HOME / (CTRL-)PgUp : 1ER JOUEUR *)
                   15,72:JOUEUR_PRECEDENT;      (* TAB GAUCHE / FLECHE HAUT : JOUEUR PRECEDENT *)
                   73:PAGE_PRECEDENTE;          (* PgUp : PAGE PRECEDENTE *)
                   80:JOUEUR_SUIVANT;           (* FLECHE BAS : JOUEUR SUIVANT *)
                   81:PAGE_SUIVANTE;            (* PgDn : PAGE SUIVANTE *)
                   79,117,118:DERNIER_JOUEUR;   (* (CTRL-)END / (CTRL-)PgDn : DERNIER JOUEUR *)
                   97:begin   (* CTRL-F4 : DEBOGAGE *)
                        if Souris then Void:=txtmousecursoff;
                        DEBOGAGE;
                        if Souris then Void:=txtmousecurson;
                      end;
                 end;
               end;
             9:JOUEUR_SUIVANT;   (* TAB DROITE : JOUEUR SUIVANT *)
             13:begin   (* ENTER : SELECTION *)
                  Ok:=true; SELECTION_JOUEUR:=TableauPointeurs[Ligne - 1];
                end;
             27:begin   (* ESCAPE : ANNULER *)
                  Ok:=true; SELECTION_JOUEUR:=nil;
                end;
           end;
         end;
    if mouseeventparams.me_modified
       then
         with mouseeventparams do
           begin
             case me_x of
               42..76:begin   (* SELECTION D'UN JOUEUR *)
                        if me_y in [2..22]
                           then
                             begin
                               if TableauPointeurs[me_y - 1] <> nil
                                  then
                                    begin
                                      Ok:=true; SELECTION_JOUEUR:=TableauPointeurs[me_y - 1];
                                    end;
                             end;
                        end;
               77:begin   (* BOUTON DE SCROLLING *)
                    case me_y of
                      2:PREMIER_JOUEUR;
                      3:PAGE_PRECEDENTE;
                      4:JOUEUR_PRECEDENT;
                      20:JOUEUR_SUIVANT;
                      21:PAGE_SUIVANTE;
                      22:DERNIER_JOUEUR;
                    end;
               end;
             end;
             me_modified:=false;
           end;
  until Ok;
  if Souris then Void:=txtmousecursoff;
  txtload(Image); txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


Procedure GESTION_CATEGORIE (Numero : byte);
(* MENU DE GESTION DE LA CATEGORIE N Numero *)
Const l1=10; c1=0; lg1=28; c2=45; lg2=23; c3=0; l3=2; c4=40;
Var x1,y1,x2,y2,x,y,FondCourant,CouleurCourante:word;
    Image:videosave;
    Fond1,Normal1,Fond2,Brillant2,Fond3,Normal3,Brillant3,Fond4,Normal4,Fond5,Brillant5:word;
    Pointeur:pJoueur;
    Ligne:byte;
    Entree:char;
    Ok:boolean;
          Procedure AFFICHAGE_PARAMETRES_CATEGORIE (Option:byte);
          (* AFFICHAGE DE CERTAINS PARAMETRES DE LA CATEGORIE.
             Option EST LA COMBINAISON LOGIQUE (OR) DES apc_????  *)
          Begin
            with Categories[Numero] do
              begin
                if (Option and apc_Nom) <> 0
                   then
                     begin
                       txtback(Fond3); txtcolour(Brillant2 + blink);
                       txtmove(c3+12,l3); txtwrite('                    ');
                       txtmove(c3+12,l3); txtwrite(NomCategorie);
                     end;
                if (Option and apc_Sit) <> 0
                   then
                     begin
                       txtback(Fond3); txtcolour(Brillant3);
                       txtmove(c3+21,l3+1); txtwrite('             '); txtmove(c3+21,l3+1);
                       case Situation of
                         1:txtwrite('FINALE');
                         2..64:begin
                                 txtwrite('1/'); txtnumwrite(Situation,0); txtwrite(' FINALE');
                               end;
                         254:txtwrite('FINIE');
                         255:txtwrite('ELIMINATOIRES');
                       end;
                     end;
                if (Option and apc_NbP) <> 0
                   then
                     begin
                       txtback(Fond3); txtcolour(Brillant3);
                       txtmove(c3+21,l3+2); txtwrite('     '); txtmove(c3+21,l3+2);
                       if Situation = 255 then txtnumwrite(NbPoules,0) else txtwrite('-');
                     end;
                if (Option and apc_NbJ) <> 0
                   then
                     begin
                       txtback(Fond3); txtcolour(Brillant3);
                       txtmove(c3+29,l3+3); txtwrite('     '); txtmove(c3+29,l3+3); txtnumwrite(NbJoueurs,0);
                     end;
                if (Option and apc_NbJR) <> 0
                   then
                     begin
                       txtback(Fond3); txtcolour(Brillant3);
                       txtmove(c3+29,l3+4); txtwrite('     '); txtmove(c3+29,l3+4); txtnumwrite(NbJoueursRestants,0);
                     end;
                if (Option and apc_NbM) <> 0
                   then
                     begin
                       txtback(Fond3); txtcolour(Brillant3);
                       txtmove(c3+29,l3+5); txtwrite('     '); txtmove(c3+29,l3+5); txtnumwrite(NbMatches,0);
                     end;
                if (Option and apc_NbMR) <> 0
                   then
                     begin
                       txtback(Fond3); txtcolour(Brillant3);
                       txtmove(c3+29,l3+6); txtwrite('     '); txtmove(c3+29,l3+6); txtnumwrite(NbMatchesRestants,0);
                     end;
              end;
          End;
          Procedure AFFICHAGE_LISTE_JOUEURS;
          (* AFFICHAGE DES NOMS ET PRENOMS DES 21 PREMIERS JOUEURS DE LA CATEGORIE *)
          Var l:byte;
              p:pJoueur;
          Begin
            txtback(Fond4); txtcolour(Normal4);
            for l:=2 to 22 do
              begin
                txtmove(c4+4,l); txtwrite('............... ...............');
              end;
            with Categories[Numero] do
              begin
                l:=2; p:=pTeteJoueurs;
                while (l <= 22) and (p <> nil) do
                  begin
                    txtmove(c4+4,l); txtwrite('                               ');
                    txtmove(c4+4,l); txtwrite(p^.NomJoueur); txtmove(c4+20,l); txtwrite(p^.PrenomJoueur);
                    inc(l); p:=p^.pSuiv;
                  end;
              end;
          End;
          Procedure RUBRIQUE_ALLUMEE;
          (* MISE EN EVIDENCE DE LA RUBRIQUE COURANTE *)
          Begin
            txtback(Fond2); txtcolour(Brillant2); txtmove(c1+3,Ligne+l1); txtattrib(lg1);
          End;
          Procedure RUBRIQUE_ETEINTE;
          (* FIN DE LA MISE EN EVIDENCE DE LA RUBRIQUE COURANTE *)
          Begin
            txtback(Fond1); txtcolour(Normal1); txtmove(c1+3,Ligne+l1); txtattrib(lg1);
          End;
          Procedure RUBRIQUE_SELECTIONNEE;
          (* MISE EN CLIGNOTEMENT DE LA RUBRIQUE EN TRAIN D'ETRE EXECUTEE *)
          Begin
            txtback(Fond1); txtcolour(Normal1 + blink); txtmove(c1+3,Ligne+l1); txtattrib(lg1); txtback(Fond1);
          End;
          Procedure SELECTION_RUBRIQUE;
          (* LANCE LA PROCEDURE ASSOCIEE A LA RUBRIQUE COURANTE *)
          Begin
            case Ligne of
              1:if INSCRIPTION_JOUEUR(Numero)
                   then
                     begin
                       AFFICHAGE_LISTE_JOUEURS; AFFICHAGE_PARAMETRES_CATEGORIE(apc_NbJ or apc_NbJR);
                     end;
              2:if Categories[Numero].NbJoueurs > 0
                   then
                     begin
                       Pointeur:=SELECTION_JOUEUR(Numero);
                       if (Pointeur <> nil) and (SUPPRESSION_JOUEUR(Numero,Pointeur))
                          then
                            begin
                              AFFICHAGE_LISTE_JOUEURS;
                              AFFICHAGE_PARAMETRES_CATEGORIE(apc_NbJ or apc_NbJR or apc_NbM or apc_NbMR);
                            end;
                     end;
              3:if Categories[Numero].NbJoueurs > 0
                   then
                     begin
                       Pointeur:=SELECTION_JOUEUR(Numero);
                       if (Pointeur <> nil) and (MODIFICATION_JOUEUR(Numero,Pointeur))
                          then
                            begin
                              TRI_ALPHABETIQUE_JOUEURS(Numero); AFFICHAGE_LISTE_JOUEURS;
                            end;
                     end;
              4:if Categories[Numero].NbJoueurs > 0 then AFFICHAGE_CLASSEMENT(Numero);
              5:if (Categories[Numero].NbJoueurs > 0) and (Categories[Numero].Situation <> 254)
                   then
                     begin
                       Void:=DIVISION_EN_POULES(Numero); AFFICHAGE_PARAMETRES_CATEGORIE(apc_NbP or apc_NbM or apc_NbMR);
                     end;
              6:if (Categories[Numero].NbJoueurs > 0) and (Categories[Numero].Situation <> 254) and
                   (CREATION_LISTE_MATCHES(Numero))
                   then AFFICHAGE_PARAMETRES_CATEGORIE(apc_NbM or apc_NbMR);
              7:if Categories[Numero].NbMatches > 0
                   then
                     begin
                       ENCODAGE_RESULTATS(Numero); AFFICHAGE_PARAMETRES_CATEGORIE(apc_NbMR);
                     end;
              8:if (Categories[Numero].NbMatches > 0) and (Categories[Numero].Situation <> 254)
                   then
                     begin
                       PASSAGE_TOUR_SUIVANT(Numero);
                       AFFICHAGE_PARAMETRES_CATEGORIE(apc_Sit or apc_NbP or apc_NbJR or apc_NbM or apc_NbMR);
                     end;
              9:Ok:=true;
            end;
          End;
Begin
  x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; x:=windx; y:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image); TITRE_HAUT_ECRAN(4);
  txtback(black); txtcolour(lightgrey); txtwind(0,1,79,23); txtclear; txtunwind;
  case ModeEcran of
    ModeMono:begin
               Fond1:=lightgrey; Normal1:=black; Fond2:=black; Brillant2:=white; Fond3:=black;
               Normal3:=lightgrey; Brillant3:=white; Fond4:=lightgrey; Normal4:=black; Fond5:=black; Brillant5:=white;
             end;
    ModeCouleur:begin
                  Fond1:=cyan; Normal1:=yellow; Fond2:=red; Brillant2:=white; Fond3:=black;
                  Normal3:=lightgrey; Brillant3:=lightcyan; Fond4:=blue; Normal4:=yellow; Fond5:=brown; Brillant5:=white;
                end;
  end;
  (* MENU DE GESTION *)
  txtback(Fond1); txtcolour(Normal1);
  txtmove(c1,l1);    txtwrite(' ͻ ');
  txtmove(c1,l1+1);  txtwrite('   (I)nscription d''un joueur    ');
  txtmove(c1,l1+2);  txtwrite('   (S)uppression d''un joueur    ');
  txtmove(c1,l1+3);  txtwrite('   (M)odification d''un joueur   ');
  txtmove(c1,l1+4);  txtwrite('   (A)ffichage du classement    ');
  txtmove(c1,l1+5);  txtwrite('   (D)ivision en poules         ');
  txtmove(c1,l1+6);  txtwrite('   (C)ration des matches       ');
  txtmove(c1,l1+7);  txtwrite('   (E)ncodage d''un rsultat     ');
  txtmove(c1,l1+8);  txtwrite('   (P)assage au tour suivant    ');
  txtmove(c1,l1+9);  txtwrite('   (R)etour au menu principal   ');
  txtmove(c1,l1+10); txtwrite(' ͼ ');
  txtcolour(Brillant2); txtmove(c1+9,l1); txtwrite(' Menu de gestion ');
  (* PARAMETRES DE LA CATEGORIE *)
  txtback(Fond3); txtcolour(Normal3);
  txtmove(c3,l3); txtwrite('Catgorie : '); txtmove(c3,l3+1); txtwrite('Situation actuelle : ');
  txtmove(c3,l3+2); txtwrite('Nombre de poules   : ');
  txtmove(c3,l3+3); txtwrite('Nombre de joueurs inscrits : '); txtmove(c3,l3+4); txtwrite('Joueurs encore en course   : ');
  txtmove(c3,l3+5); txtwrite('Nombre total de matches    : '); txtmove(c3,l3+6); txtwrite('Matches encore  jouer     : ');
  AFFICHAGE_PARAMETRES_CATEGORIE(apc_Nom or apc_Sit or apc_NbP or apc_NbJ or apc_NbJR or apc_NbM or apc_NbMR);
  (* MENU DE SELECTION DES JOUEURS *)
  txtback(Fond4); txtcolour(Normal4);
  txtmove(c4,1); txtwrite(' ͻ ');
  for Ligne:=2 to 22 do
    begin
      txtmove(c4,Ligne); txtwrite('                                     ');
    end;
  txtmove(c4,23); txtwrite(' ͼ ');
  txtcolour(Brillant5);
  txtmove(c4+15,1); txtwrite(' Joueurs ');
  txtmove(c4+37,2); txtwrite(''); txtmove(c4+37,3); txtwrite(#30); txtmove(c4+37,4); txtwrite(#24);
  txtmove(c4+37,22); txtwrite(''); txtmove(c4+37,21); txtwrite(#31); txtmove(c4+37,20); txtwrite(#25);
  AFFICHAGE_LISTE_JOUEURS;
  (* CLAVIER ET SOURIS *)
  Ok:=false; Ligne:=1; RUBRIQUE_ALLUMEE; MESSAGE_BAS_ECRAN(ip_GestionCategorie + 1);
  txtflush; mouseeventparams.me_modified:=false; if Souris then Void:=txtmousecurson;
  repeat
    if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
    if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   59:begin   (* F1 : AIDE *)
                        if Souris then Void:=txtmousecursoff;
                        AIDE(hlp_MenuGestionCategorie);
                        if Souris then Void:=txtmousecurson;
                      end;
                   72:begin   (* FLECHE HAUT : LIGNE PRECEDENTE *)
                        if Souris then Void:=txtmousecursoff;
                        RUBRIQUE_ETEINTE; if Ligne = 1 then Ligne:=9 else dec(Ligne); RUBRIQUE_ALLUMEE;
                        MESSAGE_BAS_ECRAN(ip_GestionCategorie + Ligne);
                        if Souris then Void:=txtmousecurson;
                      end;
                   71,73,119,132:begin   (* (CTRL-)HOME / (CTRL-)PgUp : LIGNE 1 *)
                                   if Ligne <> 1
                                      then
                                        begin
                                          if Souris then Void:=txtmousecursoff;
                                          RUBRIQUE_ETEINTE; Ligne:=1; RUBRIQUE_ALLUMEE;
                                          MESSAGE_BAS_ECRAN(ip_GestionCategorie + Ligne);
                                          if Souris then Void:=txtmousecurson;
                                        end;
                                 end;
                   80:begin   (* FLECHE BAS : LIGNE SUIVANTE *)
                        if Souris then Void:=txtmousecursoff;
                        RUBRIQUE_ETEINTE; if Ligne = 9 then Ligne:=1 else inc(Ligne); RUBRIQUE_ALLUMEE;
                        MESSAGE_BAS_ECRAN(ip_GestionCategorie + Ligne);
                        if Souris then Void:=txtmousecurson;
                      end;
                   79,81,117,118:begin   (* (CTRL-)END / (CTRL-)PgDn : DERNIERE LIGNE *)
                                   if Ligne <> 9
                                      then
                                        begin
                                          if Souris then Void:=txtmousecursoff;
                                          RUBRIQUE_ETEINTE; Ligne:=9; RUBRIQUE_ALLUMEE;
                                          MESSAGE_BAS_ECRAN(ip_GestionCategorie + Ligne);
                                          if Souris then Void:=txtmousecurson;
                                        end;
                                 end;
                   18,19,23,25,30..32,46,50:begin    (* ALT-LETTRE : SELECTION D'UNE RUBRIQUE *)
                                              if Souris then Void:=txtmousecursoff;
                                              RUBRIQUE_ETEINTE;
                                              case ord(Entree) of
                                                18:Ligne:=7;   (* ALT-E *)
                                                19:Ligne:=9;   (* ALT-R *)
                                                23:Ligne:=1;   (* ALT-I *)
                                                25:Ligne:=8;   (* ALT-P *)
                                                30:Ligne:=4;   (* ALT-A *)
                                                31:Ligne:=2;   (* ALT-S *)
                                                32:Ligne:=5;   (* ALT-D *)
                                                46:Ligne:=6;   (* ALT-C *)
                                                50:Ligne:=3;   (* ALT-M *)
                                              end;
                                              MESSAGE_BAS_ECRAN(ip_GestionCategorie + Ligne);
                                              RUBRIQUE_SELECTIONNEE; SELECTION_RUBRIQUE; RUBRIQUE_ALLUMEE;
                                              if Souris then Void:=txtmousecurson;
                                            end;
                   97:begin   (* CTRL-F4 : DEBOGAGE *)
                        if Souris then Void:=txtmousecursoff;
                        DEBOGAGE;
                        if Souris then Void:=txtmousecurson;
                      end;
                 end;
               end;
             13:begin   (* ENTER : SELECTION D'UNE RUBRIQUE *)
                  if Souris then Void:=txtmousecursoff;
                  RUBRIQUE_SELECTIONNEE; SELECTION_RUBRIQUE; RUBRIQUE_ALLUMEE;
                  if Souris then Void:=txtmousecurson;
                end;
             27:begin   (* ESCAPE : RETOUR AU MENU PRINCIPAL *)
                  if Souris then Void:=txtmousecursoff;
                  RUBRIQUE_ETEINTE; Ligne:=9; MESSAGE_BAS_ECRAN(ip_GestionCategorie + Ligne);
                  RUBRIQUE_SELECTIONNEE; SELECTION_RUBRIQUE;
                  if Souris then Void:=txtmousecurson;
                end;
             65,67..69,73,77,80,82,83,97,99..101,105,109,112,114,115:begin    (* LETTRE : SELECTION D'UNE RUBRIQUE *)
                  if Souris then Void:=txtmousecursoff;
                  RUBRIQUE_ETEINTE;
                  case ord(Entree) of
                    65,97:Ligne:=4;    (* "A","a" *)
                    67,99:Ligne:=6;    (* "C","c" *)
                    68,100:Ligne:=5;   (* "D","d" *)
                    69,101:Ligne:=7;   (* "E","e" *)
                    73,105:Ligne:=1;   (* "I","i" *)
                    77,109:Ligne:=3;   (* "M","m" *)
                    80,112:Ligne:=8;   (* "P","p" *)
                    82,114:Ligne:=9;   (* "R","r" *)
                    83,115:Ligne:=2;   (* "S","s" *)
                  end;
                  MESSAGE_BAS_ECRAN(ip_GestionCategorie + Ligne);
                  RUBRIQUE_SELECTIONNEE; SELECTION_RUBRIQUE; RUBRIQUE_ALLUMEE;
                  if Souris then Void:=txtmousecurson;
                end;
           end;
         end;
    if mouseeventparams.me_modified
       then
         with mouseeventparams do
           begin
             if (me_x in [(c1+2)..(c1+lg1+2)]) and (me_y in [(l1+1)..(l1+9)])
                then
                  begin
                    Void:=txtmousecursoff;
                    RUBRIQUE_ETEINTE; Ligne:=me_y - l1; RUBRIQUE_SELECTIONNEE;
                    MESSAGE_BAS_ECRAN(ip_GestionCategorie + Ligne);
                    SELECTION_RUBRIQUE; RUBRIQUE_ALLUMEE;
                    Void:=txtmousecurson;
                  end;
             me_modified:=false;
           end;
  until Ok;
  if Souris then Void:=txtmousecursoff;
  txtload(Image); txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


END.
