
UNIT TTO_HELP;

(* GESTION DE L'AIDE ET DEBOGAGE POUR LE PROGRAMME TTO VERSION 1.20 :

   - AIDE : LE TEXTE COMPLET DE L'AIDE SE TROUVE DANS LE FICHIER TEXTE "TTO.HLP".
            LE FAIT DE PRESSER SUR F1 ENCLENCHE LA VISUALISATION DU TEXTE; PRESSER
            "T" PROVOQUE L'APPARITION DE LA TABLE DES MATIERES.
            L'AIDE EST ACCOMPAGNEE DU FICHIER "TTOHLP.NDX", QUI CONTIENT LES POSITIONS
            (filepos) DE CHAQUE LIGNE DU TEXTE.
   - DEBOGAGE : CTRL-F4 ENTRAINE L'AFFICHAGE DE LA BOITE DE DIALOGUE DE DEBOGAGE. *)


INTERFACE

{$I-}

Uses DOS,        (* DETERMINATION DE L'ESPACE LIBRE SUR DISQUE *)
     TXT,        (* GESTION D'ECRAN EN MODE TEXTE (VERSION 2.00) *)
     TTO_DECL,   (* DECLARATION DE TYPES, CONSTANTES ET VARIABLES GLOBALES *)
     TTO_HARD,   (* GESTION BAS NIVEAU (SOURIS, ECONOMISEUR D'ECRAN...) *)
     TTO_COMN,   (* EXPLICATIONS AU BAS DE L'ECRAN, MESSAGES D'AVERTISSEMENT OU D'ERREUR *)
     TTO_FILE;   (* GESTION DES FICHIERS SUR DISQUE *)


Procedure AIDE (LigneAffichage : word);
   (* AFFICHAGE DE L'AIDE CONTEXTUELLE *)
Procedure DEBOGAGE;
   (* BOITE DE DIALOGUE DE DEBOGAGE *)


IMPLEMENTATION

Function TABLE_DES_MATIERES : word;
(* AFFICHAGE DE LA TABLE DES MATIERES DE L'AIDE.
   RETOURNE LE N DE LIGNE DE L'AIDE A AFFICHER OU 0 SI ANNULER. *)
Const c=19; l=2; lg=42;
Var x,y,x1,y1,x2,y2,FondCourant,CouleurCourante:word;
    Image:videosave;
    Fond1,Normal1,Fond2,Brillant,FondOmbre,Ombre:word;
    Ligne,RubriqueHaut:byte;
    Entree:char;
    Fin:boolean;
          Procedure LIGNE_ALLUMEE;
          (* MISE EN SURBRILLANCE DE LA LIGNE COURANTE *)
          Begin
            txtback(Fond2); txtcolour(Brillant); txtmove(c+2,Ligne); txtattrib(38);
          End;
          Procedure LIGNE_ETEINTE;
          (* FIN DE LA MISE EN SURBRILLANCE DE LA LIGNE COURANTE *)
          Begin
            txtback(Fond1); txtcolour(Normal1); txtmove(c+2,Ligne); txtattrib(38);
          End;
          Procedure AFFICHAGE_LIGNE (n:byte);
          (* AFFICHAGE DU CONTENU DE LA LIGNE n A LA LIGNE COURANTE *)
          Begin
            txtback(Fond1); txtcolour(Normal1);
            txtmove(c+4,Ligne); txtwrite(TableDesMatieres[n].Rubrique);
          End;
          Procedure AFFICHAGE_PAGE;
          (* AFFICHAGE D'UNE PAGE EN COMMENCANT A LA RUBRIQUE RubriqueHaut *)
          Var i:byte;
          Begin
            txtback(Fond1); txtcolour(Normal1);
            for i:=0 to 18 do
              begin
                txtmove(c+4,l+i+1); txtwrite(TableDesMatieres[RubriqueHaut+i].Rubrique);
              end;
          End;
          Procedure PREMIERE_LIGNE;
          (* DEPLACEMENT DE LA SURBRILLANCE VERS LA PREMIERE LIGNE *)
          Begin
            if (Ligne <> (l+1)) or (RubriqueHaut <> 1)
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if RubriqueHaut <> 1
                      then   (* SCROLLING *)
                        begin
                          RubriqueHaut:=1; AFFICHAGE_PAGE;
                        end;
                   Ligne:=l + 1; LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure PAGE_PRECEDENTE;
          (* REMONTEE D'UNE PAGE *)
          Begin
            if (Ligne <> (l+1)) or (RubriqueHaut <> 1)
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if RubriqueHaut > 18
                      then   (* SCROLLING D'UNE PAGE ENTIERE *)
                        begin
                          dec(RubriqueHaut,18); AFFICHAGE_PAGE;
                        end
                      else
                        if RubriqueHaut > 1
                           then   (* AFFICHAGE DE LA PREMIERE PAGE *)
                             begin
                               RubriqueHaut:=1; AFFICHAGE_PAGE;
                             end
                           else   (* LA PREMIERE LIGNE EST DEJA A L'ECRAN *)
                             Ligne:=l + 1;
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure LIGNE_PRECEDENTE;
          (* REMONTEE D'UNE LIGNE *)
          Begin
            if (Ligne > (l+1)) or (RubriqueHaut > 1)
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if Ligne = (l+1)
                      then   (* SCROLLING *)
                        begin
                          txtback(Fond1); txtcolour(Normal1);
                          txtwind(c+2,l+1,c+39,l+19); txtinsdn(0); txtunwind;
                          dec(RubriqueHaut); AFFICHAGE_LIGNE(RubriqueHaut);
                        end
                      else   (* LA LIGNE PRECEDENTE EST DEJA A L'ECRAN *)
                        dec(Ligne);
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure LIGNE_SUIVANTE;
          (* DESCENTE D'UNE LIGNE *)
          Begin
            if (Ligne < (l+19)) or (RubriqueHaut < 34)
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if Ligne = (l+19)
                      then   (* SCROLLING *)
                        begin
                          txtback(Fond1); txtcolour(Normal1);
                          txtwind(c+2,l+1,c+39,l+19); txtdeldn(0); txtunwind;
                          inc(RubriqueHaut); AFFICHAGE_LIGNE(RubriqueHaut + 18);
                        end
                      else
                        inc(Ligne);
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure PAGE_SUIVANTE;
          (* DESCENTE D'UNE PAGE *)
          Begin
            if (Ligne <> (l+19)) or (RubriqueHaut <> 34)
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if RubriqueHaut <= 16
                      then   (* SCROLLING D'UNE PAGE ENTIERE *)
                        begin
                          inc(RubriqueHaut,18); AFFICHAGE_PAGE;
                        end
                      else
                        if RubriqueHaut < 34
                           then   (* AFFICHAGE DE LA DERNIERE PAGE *)
                             begin
                               RubriqueHaut:=34; AFFICHAGE_PAGE;
                             end
                           else   (* LA DERNIERE LIGNE EST DEJA A L'ECRAN *)
                             Ligne:=l + 19;
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure DERNIERE_LIGNE;
          (* DEPLACEMENT DE LA SURBRILLANCE VERS LA DERNIERE LIGNE *)
          Begin
            if (Ligne <> (l+19)) or (RubriqueHaut <> 34)
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if RubriqueHaut < 34
                      then   (* SCROLLING *)
                        begin
                          RubriqueHaut:=34; AFFICHAGE_PAGE;
                        end;
                   Ligne:=l + 19; LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
Begin
  x:=windx; y:=windy; x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image);
  case ModeEcran of
    ModeMono:begin Fond1:=lightgrey; Normal1:=black; Fond2:=black; Brillant:=white; FondOmbre:=black; Ombre:=lightgrey; end;
    ModeCouleur:begin Fond1:=magenta; Normal1:=yellow; Fond2:=green; Brillant:=white; FondOmbre:=black; Ombre:=lightgrey; end;
  end;
  (* CADRE ET TITRE *)
  txtback(Fond1); txtcolour(Normal1);
  txtmove(c,l); txtwrite(' ͻ ');
  for Ligne:=1 to 19 do
    begin
      txtmove(c,l+Ligne); txtwrite('                                        ');
    end;
  txtmove(c,l+20); txtwrite(' ͼ ');
  txtcolour(Brillant); txtmove(30,l); txtwrite(' Table des matires ');
  (* BOUTONS DE LA SOURIS *)
  txtmove(c+40,l+1); txtwrite(''); txtmove(c+40,l+2); txtwrite(#30); txtmove(c+40,l+3); txtwrite(#24);
  txtmove(c+40,l+19); txtwrite(''); txtmove(c+40,l+18); txtwrite(#31); txtmove(c+40,l+17); txtwrite(#25);
  (* OMBRE *)
  txtback(FondOmbre); txtcolour(Ombre);
  for Ligne:=1 to 20 do
    begin
      txtmove(c+lg,l+Ligne); txtattrib(2);
    end;
  txtmove(c+2,l+21); txtattrib(lg);
  (* INITIALISATIONS ET LECTURE DU CLAVIER OU DE LA SOURIS *)
  MESSAGE_BAS_ECRAN(ip_Aide + 2);
  txtflush; mouseeventparams.me_modified:=false;
  RubriqueHaut:=1; AFFICHAGE_PAGE;
  Fin:=false; Ligne:=l+1; LIGNE_ALLUMEE; if Souris then Void:=txtmousecurson;
  repeat
    if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
    if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   71,119,132:PREMIERE_LIGNE;  (* (CTRL-)HOME / CTRL-PgUp : PREMIERE PAGE *)
                   15,72:LIGNE_PRECEDENTE;     (* TAB GAUCHE / FLECHE HAUT : LIGNE PRECEDENTE *)
                   73:PAGE_PRECEDENTE;         (* PgUp : PAGE PRECEDENTE *)
                   79,117,118:DERNIERE_LIGNE;  (* (CTRL-)END / CTRL-PgDn : DERNIERE PAGE *)
                   80:LIGNE_SUIVANTE;          (* FLECHE BAS : LIGNE SUIVANTE *)
                   81:PAGE_SUIVANTE;           (* PgDn : PAGE SUIVANTE *)
                 end;
               end;
             9:LIGNE_SUIVANTE;   (* TAB DROITE : LIGNE SUIVANTE *)
             13:begin   (* ENTER : SELECTIONNER UNE RUBRIQUE ET QUITTER *)
                  Fin:=true; TABLE_DES_MATIERES:=TableDesMatieres[RubriqueHaut+Ligne-l-1].NumeroLigne;
                end;
             27:begin   (* ESCAPE : QUITTER *)
                  Fin:=true; TABLE_DES_MATIERES:=0;
                end;
           end;
         end;
    if mouseeventparams.me_modified
       then
         with mouseeventparams do
           begin
             if me_x = (c+40)
                then
                  begin
                    if me_y = (l+1) then PREMIERE_LIGNE else
                    if me_y = (l+2) then PAGE_PRECEDENTE else
                    if me_y = (l+3) then LIGNE_PRECEDENTE else
                    if me_y = (l+17) then LIGNE_SUIVANTE else
                    if me_y = (l+18) then PAGE_SUIVANTE else
                    if me_y = (l+19) then DERNIERE_LIGNE;
                  end
                else
                  if (me_x in [(c+2)..(c+39)]) and (me_y in [(l+1)..(l+19)])
                     then
                       begin
                         Fin:=true; TABLE_DES_MATIERES:=TableDesMatieres[RubriqueHaut+me_y-l-1].NumeroLigne;
                       end;
             me_modified:=false;
           end;
  until Fin;
  if Souris then Void:=txtmousecursoff;
  (* RESTAURATION DE L'ENVIRONNEMENT *)
  txtload(Image); txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


Procedure AFFICHAGE_TEXTE_AIDE (LigneAffichage : word);
(* AFFICHAGE DU CONTENU DU FICHIER D'AIDE.
   SI LigneAffichage VAUT 0 ALORS AFFICHAGE DES LE DEBUT SINON AFFICHAGE
   A PARTIR DE LA LIGNE LigneAffichage.
   LES filepos DE CHAQUE LIGNE SE TROUVENT DANS LE FICHIER TTOHLP.NDX.
   LE TABLEAU Texte DOIT DEJA ETRE INITIALISE.
   NbLignesTexte EST UNE VARIABLE GLOBALE QUI DOIT AUSSI ETRE INITIALISEE. *)
Var x,y,x1,y1,x2,y2,FondCourant,CouleurCourante:word;
    Image:videosave;
    Fond1,Normal1,Brillant:word;
    Ligne:byte;
    LigneHaut:word;
    Entree:char;
    Fin:boolean;
          Function AFFICHAGE_LIGNE (nEcran:byte;nTexte:word) : boolean;
          (* AFFICHAGE DE LA LIGNE nTexte A LA LIGNE nEcran. RETOURNE false SI ERREUR. *)
          Begin
            if Souris then Void:=txtmousecursoff;
            if DEPLACEMENT_FICHIER(tf_Aide,Texte[nTexte]) and LECTURE_FICHIER(tf_Aide)
               then
                 begin
                   txtmove(3,nEcran); txtwrite('                                                                         ');
                   txtmove(3,nEcran); txtwrite(BufferAide); AFFICHAGE_LIGNE:=true;
                 end
               else
                 AFFICHAGE_LIGNE:=false;
            if Souris then Void:=txtmousecurson;
          End;
          Function AFFICHAGE_PAGE : boolean;
          (* AFFICHAGE D'UNE PAGE. RETOURNE false SI ERREUR. *)
          Var i:byte;
              j:word;
              Ok:boolean;
          Begin
            i:=2; j:=LigneHaut; Ok:=true;
            while (i <= 22) and (j <= NbLignesTexte) and (Ok) do
              begin
                Ok:=AFFICHAGE_LIGNE(i,j); inc(i); inc(j);
              end;
            AFFICHAGE_PAGE:=Ok;
          End;
          Function PREMIERE_PAGE : boolean;
          (* REMONTEE JUSQU'A LA PREMIERE PAGE. RETOURNE false SI ERREUR. *)
          Begin
            PREMIERE_PAGE:=true;
            if LigneHaut > 1
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LigneHaut:=1; PREMIERE_PAGE:=AFFICHAGE_PAGE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Function DERNIERE_PAGE : boolean;
          (* DESCENTE JUSQU'A LA DERNIERE PAGE. RETOURNE false SI ERREUR. *)
          Begin
            DERNIERE_PAGE:=true;
            if (NbLignesTexte > 21) and (LigneHaut < (NbLignesTexte - 20))
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LigneHaut:=NbLignesTexte - 20; DERNIERE_PAGE:=AFFICHAGE_PAGE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Function LIGNE_PRECEDENTE : boolean;
          (* REMONTEE JUSQU'A LA LIGNE PRECEDENTE. RETOURNE false SI ERREUR. *)
          Begin
            LIGNE_PRECEDENTE:=true;
            if LigneHaut > 1
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   txtwind(2,2,76,22); txtinsdn(0); txtunwind;
                   dec(LigneHaut); LIGNE_PRECEDENTE:=AFFICHAGE_LIGNE(2,LigneHaut);
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Function LIGNE_SUIVANTE : boolean;
          (* DESCENTE JUSQU'A LA LIGNE SUIVANTE. RETOURNE false SI ERREUR. *)
          Begin
            LIGNE_SUIVANTE:=true;
            if (NbLignesTexte > 21) and (LigneHaut < (NbLignesTexte - 20))
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   txtwind(2,2,76,22); txtdeldn(0); txtunwind;
                   inc(LigneHaut); LIGNE_SUIVANTE:=AFFICHAGE_LIGNE(22,LigneHaut + 20);
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Function PAGE_PRECEDENTE : boolean;
          (* REMONTEE A LA PAGE PRECEDENTE. RETOURNE false SI ERREUR. *)
          Begin
            PAGE_PRECEDENTE:=true;
            if LigneHaut > 1
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   if LigneHaut > 21
                      then dec(LigneHaut,20)  (* REMONTEE D'UNE PAGE ENTIERE *)
                      else LigneHaut:=1;  (* AFFICHAGE DE LA PREMIERE PAGE *)
                   PAGE_PRECEDENTE:=AFFICHAGE_PAGE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Function PAGE_SUIVANTE : boolean;
          (* DESCENTE A LA PAGE SUIVANTE. RETOURNE false SI ERREUR. *)
          Begin
            PAGE_SUIVANTE:=true;
            if NbLignesTexte > 40
               then   (* POSSIBILITE DE SCROLLING D'UNE PAGE ENTIERE *)
                 begin
                   if LigneHaut < (NbLignesTexte - 40)
                      then   (* SCROLLING D'UNE PAGE ENTIERE *)
                        begin
                          if Souris then Void:=txtmousecursoff;
                          inc(LigneHaut,20);
                          PAGE_SUIVANTE:=AFFICHAGE_PAGE;
                          if Souris then Void:=txtmousecurson;
                        end
                      else
                        if LigneHaut < (NbLignesTexte - 20)
                           then   (* AFFICHAGE DE LA DERNIERE PAGE *)
                             begin
                               if Souris then Void:=txtmousecursoff;
                               LigneHaut:=NbLignesTexte - 20;
                               PAGE_SUIVANTE:=AFFICHAGE_PAGE;
                               if Souris then Void:=txtmousecurson;
                             end;
                 end
               else   (* PAS DE SCROLLING D'UNE PAGE ENTIERE *)
                 if (NblignesTexte > 21) and (LigneHaut < (NbLignesTexte - 20))
                    then   (* AFFICHAGE DE LA DERNIERE PAGE *)
                      begin
                        if Souris then Void:=txtmousecursoff;
                        LigneHaut:=NbLignesTexte - 20;
                        PAGE_SUIVANTE:=AFFICHAGE_PAGE;
                        if Souris then Void:=txtmousecurson;
                      end;
          End;
Begin
  case ModeEcran of
    ModeMono:begin Fond1:=lightgrey; Normal1:=black; Brillant:=white; end;
    ModeCouleur:begin Fond1:=lightgrey; Normal1:=black; Brillant:=white; end;
  end;
  x:=windx; y:=windy; x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image);
  TITRE_HAUT_ECRAN(800);
  (* CADRE *)
  txtback(Fond1); txtcolour(Normal1);
  txtmove(0,1); txtwrite(' ͻ ');
  for Ligne:=2 to 22 do
    begin
      txtmove(0,Ligne); txtwrite('                                                                             ');
    end;
  txtmove(0,23); txtwrite(' ͼ ');
  txtcolour(Brillant); txtmove(37,1); txtwrite(' Aide ');
  (* BOUTONS DE LA SOURIS *)
  txtmove(77,2); txtwrite(''); txtmove(77,3); txtwrite(#30); txtmove(77,4); txtwrite(#24);
  txtmove(77,22); txtwrite(''); txtmove(77,21); txtwrite(#31); txtmove(77,20); txtwrite(#25);
  txtcolour(Normal1);
  (* OUVERTURE DU FICHIER D'AIDE ET BRANCHEMENT A LA LIGNE LigneAffichage *)
  NomFichierTraite:='TTO.HLP'; assign(FichierAide,NomFichierTraite);
  txtflush; mouseeventparams.me_modified:=false; MESSAGE_BAS_ECRAN(ip_Aide + 1);
  if LigneAffichage = 0 then LigneHaut:=1 else LigneHaut:=LigneAffichage;
  if OUVERTURE_FICHIER(tf_Aide) and AFFICHAGE_PAGE
     then
       begin
         Fin:=false; Ligne:=2; if Souris then Void:=txtmousecurson;
         (* LECTURE DU CLAVIER ET DE LA SOURIS *)
         repeat
           if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
           if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
           if txtkeypressed
              then   (* ACTION CLAVIER DETECTEE *)
                begin
                  txtinput(Entree);
                  case ord(Entree) of
                    0:begin
                        txtinput(Entree);
                        case ord(Entree) of
                          20:begin   (* ALT-T : TABLE DES MATIERES *)
                               if Souris then Void:=txtmousecursoff;
                               LigneAffichage:=TABLE_DES_MATIERES;
                               if LigneAffichage <> 0 then begin LigneHaut:=LigneAffichage; Fin:=not AFFICHAGE_PAGE; end;
                               if Souris then Void:=txtmousecurson;
                             end;
                          71,119,132:Fin:=not PREMIERE_PAGE;   (* (CTRL-)HOME / CTRL-PgUp : PREMIERE PAGE *)
                          72:Fin:=not LIGNE_PRECEDENTE;        (* FLECHE HAUT : LIGNE PRECEDENTE *)
                          73:Fin:=not PAGE_PRECEDENTE;         (* PgUp : PAGE PRECEDENTE *)
                          79,117,118:Fin:=not DERNIERE_PAGE;   (* (CTRL-)END / CTRL-PgDn : DERNIERE PAGE *)
                          80:Fin:=not LIGNE_SUIVANTE;          (* FLECHE BAS : LIGNE SUIVANTE *)
                          81:Fin:=not PAGE_SUIVANTE;           (* PgDn : PAGE SUIVANTE *)
                        end;
                      end;
                    27:Fin:=true;   (* ESCAPE : QUITTER *)
                    84,116:begin   (* "T","t" : TABLE DES MATIERES *)
                             if Souris then Void:=txtmousecursoff;
                             LigneAffichage:=TABLE_DES_MATIERES;
                             if LigneAffichage <> 0 then begin LigneHaut:=LigneAffichage; Fin:=not AFFICHAGE_PAGE; end;
                             if Souris then Void:=txtmousecurson;
                           end;
                  end;
                end;
           if mouseeventparams.me_modified
              then   (* ACTION SOURIS DETECTEE *)
                with mouseeventparams do
                  begin
                    if me_x = 77
                       then
                         case me_y of
                           2:Fin:=not PREMIERE_PAGE;
                           3:Fin:=not PAGE_PRECEDENTE;
                           4:Fin:=not LIGNE_PRECEDENTE;
                           20:Fin:=not LIGNE_SUIVANTE;
                           21:Fin:=not PAGE_SUIVANTE;
                           22:Fin:=not DERNIERE_PAGE;
                         end;
                    me_modified:=false;
                  end;
         until Fin;
         if Souris then Void:=txtmousecursoff;
         (* FERMETURE DU FICHIER *)
         Void:=FERMETURE_FICHIER(tf_Aide);
       end;
  (* RESTAURATION DE L'ECRAN ORIGINAL *)
  txtload(Image);
  txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


Procedure AIDE (LigneAffichage : word);
(* AFFICHAGE DE L'AIDE CONTEXTUELLE.
   1. TESTE SI LA DATE ET L'HEURE DES FICHIERS TTO.HLP ET TTOHLP.NDX CORRESPONDENT.
      SI NON, LE FICHIER TTOHLP.NDX EST RECREE ET LA DATE ET L'HEURE ALIGNEES;
   2. CHARGEMENT DES INDEX;
   3. AFFICHAGE DU TEXTE A PARTIR DE LA LIGNE LigneAffichage. *)
Var Ok:boolean;
Begin
  if ContenuTexte = ndx_Aide
     then
       Ok:=true
     else
       begin
         if TEST_DATE_HEURE_FICHIERS <> tdh_Ok
            then
              begin
                Ok:=CREATION_FICHIER_INDEX(tf_Aide,0); if Ok then Void:=ALIGNER_DATE_HEURE_FICHIERS;
              end
            else
              Ok:=true;
         if Ok then Ok:=CHARGEMENT_INDEX(tf_Aide);
       end;
  if Ok
     then
       begin
         AFFICHAGE_TEXTE_AIDE(LigneAffichage);
         ContenuTexte:=ndx_Aide;
       end;
End;


Procedure DEBOGAGE;
(* AFFICHAGE DE DIVERS PARAMETRES DU PROGRAMME OU DE LA MEMOIRE.
   LA SOURIS EST INDISPONIBLE.
   F1 PERMET D'AFFICHER L'AIDE CONTEXTUELLE.
   AFIN DE MODIFIER AU MINIMUM LA PILE, TOUTES LES VARIABLES UTILISEES DANS CETTE
   PROCEDURE ONT ETE DECLAREES GLOBALES (SE TROUVENT DONC DANS LE DATA SEGMENT). *)
          Function HEXA (Valeur:word) : Str4;
          (* RETOURNE UNE CHAINE DONNANT LA VALEUR HEXADECIMALE DE Valeur *)
          Begin
            dbg_Chaine:='0000';
            dbg_n:=hi(Valeur) div 16; dbg_Chaine[1]:=TabHexa[dbg_n+1];
            dbg_n:=hi(Valeur) mod 16; dbg_Chaine[2]:=TabHexa[dbg_n+1];
            dbg_n:=lo(Valeur) div 16; dbg_Chaine[3]:=TabHexa[dbg_n+1];
            dbg_n:=lo(Valeur) mod 16; dbg_Chaine[4]:=TabHexa[dbg_n+1];
            HEXA:=dbg_Chaine;
          End;
Begin
  dbg_x:=windx; dbg_y:=windy; dbg_x1:=windx1; dbg_y1:=windy1; dbg_x2:=windx2; dbg_y2:=windy2;
  dbg_FondCourant:=textbackgr; dbg_CouleurCourante:=textcolour;
  txtunwind; txtsave(dbg_Image);
  case ModeEcran of
    ModeMono:begin
               dbg_Fond1:=lightgrey; dbg_Normal1:=black; dbg_Fond2:=black; dbg_Brillant:=white;
               dbg_Fond3:=lightgrey; dbg_Normal3:=white; dbg_FondOmbre:=black; dbg_Ombre:=lightgrey;
             end;
    ModeCouleur:begin
                  dbg_Fond1:=lightgrey; dbg_Normal1:=yellow; dbg_Fond2:=black; dbg_Brillant:=white;
                  dbg_Fond3:=lightgrey; dbg_Normal3:=white; dbg_FondOmbre:=black; dbg_Ombre:=lightgrey;
                end;
  end;
  (* CADRE *)
  txtback(dbg_Fond1); txtcolour(dbg_Normal1);
  txtmove(6,1);  txtwrite(' ͻ ');
  txtmove(6,2);  txtwrite('                                                                  ');
  txtmove(6,3);  txtwrite('   HARDWARE                                                       ');
  txtmove(6,4);  txtwrite('      Type d''ordinateur :                                         ');
  txtmove(6,5);  txtwrite('      Carte vido :                                               ');
  txtmove(6,6);  txtwrite('      Moniteur    :                                               ');
  txtmove(6,7);  txtwrite('   SOURIS                                                         ');
  txtmove(6,8);  txtwrite('      Type :                                                      ');
  txtmove(6,9);  txtwrite('      Version :                                                   ');
  txtmove(6,10); txtwrite('      Compteur de curseur :                                       ');
  txtmove(6,11); txtwrite('   MEMOIRE                                                        ');
  txtmove(6,12); txtwrite('      Mmoire disponible (bytes)             :                    ');
  txtmove(6,13); txtwrite('      Plus grand bloc allouable (bytes)      :                    ');
  txtmove(6,14); txtwrite('      Nombre de joueurs allouables           :                    ');
  txtmove(6,15); txtwrite('      Nombre de matches allouables           :                    ');
  txtmove(6,16); txtwrite('      Nombre de joueurs extraits allouables  :                    ');
  txtmove(6,17); txtwrite('      CS :           DS :           SS :           SP :           ');
  txtmove(6,18); txtwrite('   DISQUE                                                         ');
  txtmove(6,19); txtwrite('      Espace libre sur le disque (Kb) :                           ');
  txtmove(6,20); txtwrite('      Nom de fichier courant :                                    ');
  txtmove(6,21); txtwrite('                                                                  ');
  txtmove(6,22); txtwrite('                          <            >                          ');
  txtmove(6,23); txtwrite(' ͼ ');
  txtcolour(dbg_Brillant); txtmove(35,1); txtwrite(' Dbogage ');
  txtback(dbg_Fond2); txtcolour(dbg_Brillant); txtmove(34,22); txtwrite('    (O)k    ');
  txtback(dbg_FondOmbre); txtcolour(dbg_Ombre);
  for dbg_Ligne:=2 to 23 do begin txtmove(74,dbg_Ligne); txtattrib(2); end;
  MESSAGE_BAS_ECRAN(ip_Debogage + 1);
  (* AFFICHAGE DES VALEURS *)
  txtback(dbg_Fond3); txtcolour(dbg_Normal3);
  (* HARDWARE *)
  txtmove(33,4); txtwrite(dbg_TypeOrdinateur);
  txtmove(27,5); txtwrite(dbg_Carte);
  txtmove(27,6); txtwrite(dbg_Moniteur);
  (* SOURIS *)
  txtmove(20,8); if Souris then txtwrite(dbg_TypeSouris) else txtwrite('(Driver dsactiv ou Erreur de dtection)');
  with mouseparams do
    begin
      txtmove(23,9); if Souris then txtwrite(dbg_VersionSouris) else txtwrite('?');
      txtmove(35,10);
      if (Souris) and (txtgetmousecursorcounter(dbg_CompteurSouris))
         then txtnumwrite(dbg_CompteurSouris,0) else txtwrite('?');
    end;
  (* MEMOIRE *)
  dbg_MemoireDisponible:=memavail;
  txtmove(54,12); txtnumwrite(dbg_MemoireDisponible,0);
  txtmove(54,13); txtnumwrite(maxavail,0);
  txtmove(54,14); txtnumwrite(dbg_MemoireDisponible div 75,0);
  txtmove(54,15); txtnumwrite(dbg_MemoireDisponible div 38,0);
  txtmove(54,16); txtnumwrite(dbg_MemoireDisponible div 13,0);
  txtmove(18,17); txtwrite(HEXA(cseg)); txtmove(33,17); txtwrite(HEXA(dseg));
  txtmove(48,17); txtwrite(HEXA(sseg)); txtmove(63,17); txtwrite(HEXA(sptr));
  (* DISQUE *)
  dbg_EspaceDisque:=diskfree(0); dbg_Erreur:=doserror;
  txtmove(47,19); if dbg_Erreur = 0 then txtnumwrite(dbg_EspaceDisque div 1024,0) else txtwrite('(Erreur)');
  txtmove(38,20); txtwrite(NomFichierTraite);
  (* LECTURE DU CLAVIER *)
  txtflush; dbg_Fin:=false;
  repeat
    if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
    if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
    if txtkeypressed
       then
         begin
           txtinput(dbg_Entree);
           case ord(dbg_Entree) of
             0:begin
                 txtinput(dbg_Entree);
                 case ord(dbg_Entree) of
                   24:dbg_Fin:=true;   (* ALT-O : OK *)
                   59:AIDE(2049);   (* F1 : AIDE *)
                 end;
               end;
             13,79,111:dbg_Fin:=true;   (* ENTER / "O", "o" : OK *)
           end;
         end;
  until dbg_Fin;
  txtload(dbg_Image); txtwind(dbg_x1,dbg_y1,dbg_x2,dbg_y2);
  txtback(dbg_FondCourant); txtcolour(dbg_CouleurCourante); txtmove(dbg_x,dbg_y);
End;


END.
