
UNIT TTO_MTCH;

(* GESTION DES MATCHES POUR LE PROGRAMME TTO.PAS VERSION 1.20.
   MODULES UTILISES PAR L'UNITE TTO_GEST (GESTION D'UNE CATEGORIE). *)

INTERFACE

Uses TXT,        (* GESTION DE L'ECRAN EN MODE TEXTE *)
     TTO_DECL,   (* DECLARATION DES CONSTANTES, TYPES ET VARIABLES GLOBALES *)
     TTO_HARD,   (* GESTION DE LA SOURIS, ECONOMISEUR D'ECRAN *)
     TTO_COMN,   (* EXPLICATIONS AU BAS DE L'ECRAN ET MESSAGES D'ERREUR OU D'AVERTISSEMENT *)
     TTO_LIST,   (* GESTION DES LISTES CHAINEES DE POINTEURS *)
     TTO_FILE,   (* SAUVETAGE AUTOMATIQUE SUR DISQUE *)
     TTO_GENE,   (* PROCEDURE TXTVALIDATE2 *)
     TTO_HELP;   (* AIDE CONTEXTUELLE ET DEBOGAGE *)


Function CREATION_MANUELLE_MATCHES (Numero : byte) : word;
   (* CREATION MANUELLE DE LA LISTE DES MATCHES D'UNE CATEGORIE *)
Procedure ENCODAGE_RESULTATS (Numero : byte);
   (* AFFICHAGE DE LA LISTE DES MATCHES ET ENCODAGE/MODIFICATION DE RESULTATS *)


IMPLEMENTATION

Function CREATION_MANUELLE_MATCHES (Numero : byte) : word;
(* CREATION MANUELLE DE LA LISTE DES MATCHES DE LA CATEGORIE Numero.
   UNIQUEMENT SI PAS AU STADE DES ELIMINATOIRES.
   RETOURNE LE NOMBRE DE MATCHES CREES (0 SI ERREUR OU AVORTER) *)
Const c1=0; lg1=33; c2=40; lg2=39; NbL=21; yHaut=2;
      Gauche=1; Droite=2;
Var x1,y1,x2,y2,x,y,FondCourant,CouleurCourante:word;
    Image:videosave;
    Fond1,Normal1,Fond2,Brillant2,Fond3,Normal3,Brillant4:word;
    pTeteLJ,pQueueLJ,pLJ:pListeJoueurs;
    pM:pMatch;
    TableauPointeurs:array[1..NbL] of pListeJoueurs;
    JoueurHaut,NbMatches,NbJoueurs:word;
    LigneJ,LigneM,ColonneM:byte;
    Entree:char;
    Ok:boolean;
          Procedure LIGNE_ALLUMEE;
          (* MISE EN EVIDENCE DE LA LIGNE COURANTE DU CADRE DES JOUEURS *)
          Begin
            txtback(Fond2); txtcolour(Brillant2); txtmove(c1+3,LigneJ); txtattrib(lg1);
          End;
          Procedure LIGNE_ETEINTE;
          (* FIN DE LA MISE EN EVIDENCE DE LA LIGNE COURANTE DU CADRE DES JOUEURS *)
          Begin
            txtback(Fond1); txtcolour(Normal1); txtmove(c1+3,LigneJ); txtattrib(lg1);
          End;
          Procedure AFFICHAGE_JOUEUR (n:byte);
          (* AFFICHAGE DU JOUEUR CORRESPONDANT A TableauPointeurs[n] *)
          Begin
            txtback(Fond1); txtcolour(Normal1);
            txtmove(c1+4,n+1); txtwrite('                               ');
            with TableauPointeurs[n]^ do
              begin
                txtmove(c1+4,n+1); txtwrite(PointeurJoueur^.NomJoueur);
                txtmove(c1+20,n+1); txtwrite(PointeurJoueur^.PrenomJoueur);
              end;
          End;
          Procedure AFFICHAGE_PAGE;
          (* AFFICHAGE DES JOUEURS CORRESPONDANT A TableauPointeurs *)
          Var n:byte;
          Begin
            txtback(Fond1); txtcolour(Normal1);
            for n:=1 to 21 do
              if TableauPointeurs[n] = nil
                 then
                   begin
                     txtmove(c1+4,n+1); txtwrite('............... ...............');
                   end
                 else
                   AFFICHAGE_JOUEUR(n);
          End;
          Procedure PREMIER_JOUEUR;
          (* REMONTEE JUSQU'AU PREMIER JOUEUR *)
          Var i:byte;
          Begin
            if TableauPointeurs[LigneJ - yHaut + 1]^.pPrec <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if JoueurHaut > 1
                      then   (* SCROLLING *)
                        begin
                          i:=1; pLJ:=pTeteLJ;
                          while (i <= NbL) and (pLJ <> nil) do
                            begin
                              TableauPointeurs[i]:=pLJ; inc(i); if pLJ <> nil then pLJ:=pLJ^.pSuiv;
                            end;
                          JoueurHaut:=1; AFFICHAGE_PAGE;
                        end;
                   LigneJ:=yHaut; LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure DERNIER_JOUEUR;
          (* DESCENTE JUSQU'AU DERNIER JOUEUR *)
          Var i:byte;
          Begin
            if TableauPointeurs[LigneJ - yHaut + 1]^.pSuiv <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if NbJoueurs > NbL
                      then   (* IL FAUDRA TESTER SI SCROLLING *)
                        begin
                          if JoueurHaut < (NbJoueurs - NbL + 1)
                             then   (* LE DERNIER JOUEUR N'EST PAS A L'ECRAN : SCROLLING *)
                               begin
                                 i:=NbL; pLJ:=pQueueLJ;
                                 while (i >= 1) and (pLJ <> nil) do
                                   begin
                                     TableauPointeurs[i]:=pLJ; dec(i); if pLJ <> nil then pLJ:=pLJ^.pPrec;
                                   end;
                                 LigneJ:=yHaut + NbL - 1; JoueurHaut:=NbJoueurs - NbL + 1; AFFICHAGE_PAGE;
                               end
                             else   (* LE DERNIER JOUEUR EST A L'ECRAN *)
                               LigneJ:=NbJoueurs - JoueurHaut + yHaut;
                        end
                      else   (* MOINS DE JOUEURS QUE DE LIGNES : DERNIER JOUEUR A L'ECRAN *)
                        LigneJ:=NbJoueurs + yHaut - 1;
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure JOUEUR_PRECEDENT;
          (* REMONTEE AU JOUEUR PRECEDENT *)
          Var i:byte;
          Begin
            if TableauPointeurs[LigneJ - yHaut + 1]^.pPrec <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if LigneJ = yHaut
                      then   (* SCROLLING *)
                        begin
                          for i:=NbL downto 2 do TableauPointeurs[i]:=TableauPointeurs[i-1];
                          TableauPointeurs[1]:=TableauPointeurs[1]^.pPrec; dec(JoueurHaut);
                          txtwind(c1+2,yHaut,c1+36,yHaut+NbL-1); txtinsdn(0); txtunwind; AFFICHAGE_JOUEUR(1);
                        end
                      else   (* PAS DE SCROLLING *)
                        dec(LigneJ);
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure JOUEUR_SUIVANT;
          (* DESCENTE AU JOUEUR SUIVANT *)
          Var i:byte;
          Begin
            if TableauPointeurs[LigneJ - yHaut + 1]^.pSuiv <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if LigneJ = (yHaut + NbL - 1)
                      then   (* SCROLLING *)
                        begin
                          for i:=1 to (NbL - 1) do TableauPointeurs[i]:=TableauPointeurs[i+1];
                          TableauPointeurs[NbL]:=TableauPointeurs[NbL]^.pSuiv; inc(JoueurHaut);
                          txtwind(c1+2,yHaut,c1+36,yHaut+NbL-1); txtdeldn(0); txtunwind; AFFICHAGE_JOUEUR(NbL);
                        end
                      else   (* PAS DE SCROLLING *)
                        inc(LigneJ);
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure PAGE_PRECEDENTE;
          (* AFFICHAGE DE LA PAGE DE JOUEURS PRECEDENTE *)
          Var i:byte;
          Begin
            if TableauPointeurs[LigneJ - yHaut + 1]^.pPrec <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if JoueurHaut > (NbL - 1)
                      then   (* SCROLLING D'UNE PAGE ENTIERE *)
                        begin
                          pLJ:=TableauPointeurs[1]; TableauPointeurs[NbL]:=pLJ; pLJ:=pLJ^.pPrec;
                          for i:=(NbL - 1) downto 1 do
                            begin
                              TableauPointeurs[i]:=pLJ; pLJ:=pLJ^.pPrec;
                            end;
                          dec(JoueurHaut,NbL - 1); AFFICHAGE_PAGE;
                        end
                      else
                        if JoueurHaut > 1
                           then   (* PREMIERE PAGE *)
                             begin
                               i:=1; pLJ:=pTeteLJ;
                               while (i <= NbL) and (pLJ <> nil) do
                                 begin
                                   TableauPointeurs[i]:=pLJ; inc(i); if pLJ <> nil then pLJ:=pLJ^.pSuiv;
                                 end;
                               JoueurHaut:=1; AFFICHAGE_PAGE;
                             end
                           else   (* PAS DE SCROLLING *)
                             LigneJ:=yHaut;
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure PAGE_SUIVANTE;
          (* AFFICHAGE DE LA PAGE DE JOUEURS SUIVANTE *)
          Var i:byte;
          Begin
            if TableauPointeurs[LigneJ - yHaut + 1]^.pSuiv <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if NbJoueurs > (2 * (NbL - 1))
                      then   (* IL FAUDRA TESTER SI SCROLLING PAGE ENTIERE *)
                        begin
                          if JoueurHaut <= (NbJoueurs - 2 * (NbL - 1))
                             then   (* SCROLLING D'UNE PAGE ENTIERE *)
                               begin
                                 pLJ:=TableauPointeurs[NbL]; TableauPointeurs[1]:=pLJ; pLJ:=pLJ^.pSuiv;
                                 for i:=2 to NbL do
                                   begin
                                     TableauPointeurs[i]:=pLJ; pLJ:=pLJ^.pSuiv;
                                   end;
                                 inc(JoueurHaut,NbL - 1); AFFICHAGE_PAGE;
                               end
                             else
                               if JoueurHaut < (NbJoueurs - NbL + 1)
                                  then   (* AFFICHAGE DE LA DERNIERE PAGE *)
                                    begin
                                      i:=NbL; pLJ:=pQueueLJ;
                                      while (i >= 1) and (pLJ <> nil) do
                                        begin
                                          TableauPointeurs[i]:=pLJ; dec(i); if pLJ <> nil then pLJ:=pLJ^.pPrec;
                                        end;
                                      JoueurHaut:=NbJoueurs - NbL + 1; AFFICHAGE_PAGE;
                                    end
                                  else   (* DERNIERE PAGE DEJA AFFICHEE *)
                                    LigneJ:=NbJoueurs - JoueurHaut + yHaut;
                        end
                      else
                        if NbJoueurs > NbL
                           then   (* IL FAUDRA TESTER SI SCROLLING *)
                             begin
                               if JoueurHaut < (NbJoueurs - NbL + 1)
                                  then   (* AFFICHAGE DE LA DERNIERE PAGE *)
                                    begin
                                      i:=NbL; pLJ:=pQueueLJ;
                                      while (i >= 1) and (pLJ <> nil) do
                                        begin
                                          TableauPointeurs[i]:=pLJ; dec(i); if pLJ <> nil then pLJ:=pLJ^.pPrec;
                                        end;
                                      JoueurHaut:=NbJoueurs - NbL + 1; AFFICHAGE_PAGE;
                                    end
                                  else   (* DERNIERE PAGE DEJA AFFICHEE *)
                                    LigneJ:=NbJoueurs - JoueurHaut + yHaut;
                             end
                           else   (* MOINS DE JOUEURS QUE DE LIGNES : L'UNIQUE ET DERNIERE PAGE EST DEJA AFFICHEE *)
                             LigneJ:=NbJoueurs + yHaut - 1;
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure SCROLLING_MATCHES;
          (* SCROLLING ET AFFICHAGE LIGNE VIERGE AU BAS DE LA FENETRE MATCHES *)
          Begin
            txtback(Fond3); txtcolour(Normal3);
            txtwind(c2+2,2,c2+lg2-3,22); txtinsup(20); txtunwind;
            txtmove(c2+3,22); txtwrite('                -                ');
          End;
          Procedure AFFICHAGE_MATCH;
          (* AFFICHAGE DU MATCH POINTE PAR pM A LA LIGNE LigneM *)
          Begin
            txtback(Fond3); txtcolour(Normal3);
            with pM^ do
              begin
                txtmove(c2+3,LigneM); txtwrite(pJoueur1^.NomJoueur);
                if (length(pJoueur1^.NomJoueur) <= 12) and (length(pJoueur1^.PrenomJoueur) > 0)
                   then txtwrite (' ' + pJoueur1^.PrenomJoueur[1] + '.');
                if pJoueur2 <> nil
                   then
                     begin
                       txtmove(c2+21,LigneM); txtwrite(pJoueur2^.NomJoueur);
                       if (length(pJoueur2^.NomJoueur) <= 12) and (length(pjoueur2^.PrenomJoueur) > 0)
                          then txtwrite (' ' + pJoueur2^.PrenomJoueur[1] + '.');
                     end;
              end;
          End;
          Procedure SELECTION_JOUEUR;
          (* REACTION AU CHOIX D'UN JOUEUR *)
          Var n:byte;
              p:pListeJoueurs;
          Begin
            case ColonneM of
              Gauche:begin   (* CREATION D'UN MATCH *)
                       new(pM);
                       if pM <> nil
                          then
                            begin
                              with pM^ do
                                begin
                                  Poule:=0;
                                  pJoueur1:=TableauPointeurs[LigneJ-1]^.PointeurJoueur; pJoueur2:=nil;
                                  for n:=1 to 5 do
                                    begin
                                      Resultats[n,1]:=0; Resultats[n,2]:=0;
                                    end;
                                  pPrec:=nil; pSuiv:=nil;
                                end;
                              ColonneM:=Droite;
                              if Souris then Void:=txtmousecursoff;
                              if LigneM = 22 then SCROLLING_MATCHES else inc(LigneM); AFFICHAGE_MATCH;
                              if Souris then Void:=txtmousecurson;
                            end
                          else
                            begin
                              if Souris then Void:=txtmousecursoff;
                              Void:=MESSAGE_ERREUR(1001); Ok:=true; NbMatches:=0;
                              if Souris then Void:=txtmousecurson;
                              SUPPRESSION_LISTE_MATCHES_CATEGORIE(Numero);
                            end;
                     end;
              Droite:begin   (* INSERTION DU MATCH DANS LA LISTE DES MATCHES *)
                       pM^.pJoueur2:=TableauPointeurs[LigneJ-1]^.PointeurJoueur;
                       AJOUT_MATCH_LISTE_CATEGORIE(Numero,pM); inc(NbMatches);
                       ColonneM:=Gauche;
                       if Souris then Void:=txtmousecursoff;
                       AFFICHAGE_MATCH;
                       if Souris then Void:=txtmousecurson;
                     end;
            end;
            if not Ok
               then   (* SI PAS TERMINE ALORS SUPPRESSION DU JOUEUR DANS LA LISTE *)
                 begin
                   SUPPRESSION_JOUEUR_LISTE(TableauPointeurs[LigneJ-1],pTeteLJ,pQueueLJ); dec(NbJoueurs);
                   if NbJoueurs = 0
                      then   (* FIN DE LA CREATION DES MATCHES *)
                        Ok:=true
                      else   (* AFFICHAGE DES JOUEURS *)
                        begin
                          for n:=1 to 21 do TableauPointeurs[n]:=nil;
                          n:=1; p:=pTeteLJ;
                          while (n <= 21) and (p <> nil) do
                            begin
                              TableauPointeurs[n]:=p; inc(n); if p <> nil then p:=p^.pSuiv;
                            end;
                          JoueurHaut:=1;
                          if Souris then Void:=txtmousecursoff;
                          LIGNE_ETEINTE; AFFICHAGE_PAGE; LigneJ:=2; LIGNE_ALLUMEE;
                          if Souris then Void:=txtmousecurson;
                        end;
                 end;
          End;
Begin
  case ModeEcran of
    ModeMono:begin
               Fond1:=lightgrey; Normal1:=black; Fond2:=black; Brillant2:=white;
               Fond3:=lightgrey; Normal3:=black; Brillant4:=white;
             end;
    ModeCouleur:begin
                  Fond1:=blue; Normal1:=yellow; Fond2:=brown; Brillant2:=white;
                  Fond3:=magenta; Normal3:=yellow; Brillant4:=white;
                end;
  end;
  x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; x:=windx; y:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image); TITRE_HAUT_ECRAN(ip_CreationMatches);
  NbJoueurs:=EXTRACTION_LISTE_JOUEURS(list_LiceNormal,0,Numero,pTeteLJ,pQueueLJ);
  (* INITIALISATION DU TABLEAU DE POINTEURS DES JOUEURS *)
  for LigneJ:=1 to NbL do TableauPointeurs[LigneJ]:=nil;
  LigneJ:=1; pLJ:=pTeteLJ;
  while (LigneJ <= NbL) and (pLJ <> nil) do
    begin
      TableauPointeurs[LigneJ]:=pLJ; inc(LigneJ); if pLJ <> nil then pLJ:=pLJ^.pSuiv;
    end;
  JoueurHaut:=1;
  (* CADRE JOUEURS *)
  txtback(Fond1); txtcolour(Normal1);
  txtmove(c1,1); txtwrite(' ͻ ');
  for LigneJ:=2 to 22 do
    begin
      txtmove(c1,LigneJ); txtwrite('                                     ');
    end;
  txtmove(c1,23); txtwrite(' ͼ ');
  txtcolour(Brillant2);
  txtmove(c1+37,2); txtwrite(''); txtmove(c1+37,3); txtwrite(#30); txtmove(c1+37,4); txtwrite(#24);
  txtmove(c1+37,22); txtwrite(''); txtmove(c1+37,21); txtwrite(#31); txtmove(c1+37,20); txtwrite(#25);
  txtmove(c1+10,1); txtwrite(' Joueurs  rpartir ');
  (* CADRE MATCHES *)
  txtback(Fond3); txtcolour(Normal3);
  txtmove(c2,1); txtwrite(' ͻ ');
  for LigneM:=2 to 22 do
    begin
      txtmove(c2,LigneM); txtwrite('                  -                  ');
    end;
  txtmove(c2,23); txtwrite(' ͼ ');
  txtcolour(Brillant4);
  txtmove(c2+10,1); txtwrite(' Liste des matches ');
  (* CREATION DES MATCHES *)
  MESSAGE_BAS_ECRAN(ip_CreationMatches); AFFICHAGE_PAGE;
  txtflush; mouseeventparams.me_modified:=false;
  Ok:=false; NbMatches:=0; LigneJ:=yHaut; LigneM:=1; ColonneM:=Gauche; LIGNE_ALLUMEE;
  if Souris then Void:=txtmousecurson;
  repeat
    if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
    if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   59:begin   (* F1 : AIDE *)
                        if Souris then Void:=txtmousecursoff;
                        AIDE(hlp_CreationAutomatique + 6);
                        if Souris then Void:=txtmousecurson;
                      end;
                   71,119,132:PREMIER_JOUEUR;   (* CTRL-PgUp / (CTRL-)HOME : JOUEUR 1 *)
                   72:JOUEUR_PRECEDENT;         (* FLECHE HAUT : JOUEUR PRECEDENT *)
                   73:PAGE_PRECEDENTE;          (* PgUp : PAGE PRECEDENTE *)
                   80:JOUEUR_SUIVANT;           (* FLECHE BAS : JOUEUR SUIVANT *)
                   81:PAGE_SUIVANTE;            (* PgDn : PAGE SUIVANTE *)
                   79,117,118:DERNIER_JOUEUR;   (* CTRL-PgDn / (CTRL-)END : DERNIER JOUEUR *)
                   97:begin   (* CTRL-F4 : DEBOGAGE *)
                        if Souris then Void:=txtmousecursoff;
                        DEBOGAGE;
                        if Souris then Void:=txtmousecurson;
                      end;
                 end;
               end;
             13:SELECTION_JOUEUR;   (* ENTER : SELECTION D'UN JOUEUR *)
             27:begin   (* ESCAPE : ANNULER *)
                  if MESSAGE_AVERTISSEMENT(ip_CreationMatches)
                     then
                       begin
                         Ok:=true; NbMatches:=0;
                         if Categories[Numero].pTeteMatches <> nil then SUPPRESSION_LISTE_MATCHES_CATEGORIE(Numero);
                       end;
                end;
           end;
         end;
    if mouseeventparams.me_modified
       then
         with mouseeventparams do
           begin
             if (me_x in [(c1+2)..(c1+36)]) and (me_y in [2..22])
                then   (* SELECTION D'UN JOUEUR *)
                  begin
                    if TableauPointeurs[me_y - 1] <> nil
                       then
                         begin
                           LigneJ:=me_y; SELECTION_JOUEUR;
                         end;
                  end
                else
                  if me_x = (c1+37)
                     then
                       case me_y of
                         2:PREMIER_JOUEUR;
                         3:PAGE_PRECEDENTE;
                         4:JOUEUR_PRECEDENT;
                         20:JOUEUR_SUIVANT;
                         21:PAGE_SUIVANTE;
                         22:DERNIER_JOUEUR;
                       end;
             me_modified:=false;
           end;
  until Ok;
  if Souris then Void:=txtmousecursoff;
  CREATION_MANUELLE_MATCHES:=NbMatches;
  txtload(Image); txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


Function ANALYSE_RESULTAT_MATCH (Res : TabR) : byte;
(* ANALYSE DU RESULTAT D'UN MATCH CONTENU DANS Res.
   RETOURNE UN BYTE DE CODE : arm_Ok = PAS D'ERREUR,
                              arm_ErreurSet1..arm_ErreurSet5 = RESULTAT IMPOSSIBLE AU 1..5me SET,
                              arm_ErreurNbSets = NOMBRE DE SETS IMPOSSIBLE. *)
Var i,NbSets1,NbSets2:byte;
    Fin,Erreur:boolean;
Begin
  ANALYSE_RESULTAT_MATCH:=arm_Ok;
  (* VERIFICATION DE LA VALIDITE DES SCORES ET COMPTAGE DU NOMBRE DE SETS *)
  i:=1; Fin:=false; Erreur:=false; NbSets1:=0; NbSets2:=0;
  while (i <= 5) and (not Fin) and (not Erreur) do
    begin
      if (Res[i,1] = 0) and (Res[i,2] = 0)
         then
           Fin:=true   (* SET A ZERO : FIN DU RESULTAT *)
         else
           if (Res[i,1] = 11) and (Res[i,2] = 0)
              then   (* SCORE A 11 POUR LE JOUEUR 1 *)
                begin
                  inc(NbSets1); inc(i);
                end
              else
                if (Res[i,1] = 0) and (Res[i,2] = 11)
                   then   (* SCORE A 11 POUR LE JOUEUR 2 *)
                     begin
                       inc(NbSets2); inc(i);
                     end
                   else
                     if (Res[i,1] > 21) and ((Res[i,1] - Res[i,2]) = 2)
                        then   (* SCORE AU-DELA DE 21 POUR LE JOUEUR 1 *)
                          begin
                            inc(NbSets1); inc(i);
                          end
                        else
                          if (Res[i,2] > 21) and ((Res[i,2] - Res[i,1]) = 2)
                             then   (* SCORE AU-DELA DE 21 POUR LE JOUEUR 2 *)
                               begin
                                 inc(NbSets2); inc(i);
                               end
                             else
                               if (Res[i,1] = 21) and ((Res[i,1] - Res[i,2]) >= 2)
                                  then   (* SCORE A 21 POUR LE JOUEUR 1 *)
                                    begin
                                      inc(NbSets1); inc(i);
                                    end
                                  else
                                    if (Res[i,2] = 21) and ((Res[i,2] - Res[i,1]) >= 2)
                                       then   (* SCORE A 21 POUR LE JOUEUR 2 *)
                                         begin
                                           inc(NbSets2); inc(i);
                                         end
                                       else
                                         begin   (* ERREUR DANS LE SCORE *)
                                           Erreur:=true; ANALYSE_RESULTAT_MATCH:=i;
                                         end;
    end;
  if not Erreur
     then   (* ANALYSE DU NOMBRE DE SETS *)
       if not(((NbSets1 > NbSets2) and (NbSets1 in [2,3])) or ((NbSets2 > NbSets1) and (NbSets2 in [2,3])))
          then ANALYSE_RESULTAT_MATCH:=arm_ErreurNbSets;
End;


Function ENCODAGE_RESULTAT_MATCH (Numero : byte; pM : pMatch) : boolean;
(* ENCODAGE DU RESULTAT D'UN MATCH DE LA CATEGORIE Numero POINTE PAR pM.
   RETOURNE true SI OK OU false SI AVORTER.
   SI OPERATION AVORTEE, PAS DE MODIFICATION DU RESULTAT DU MATCH. *)
Const c=20; l=6; lg=39;
Var x1,y1,x2,y2,x,y,FondCourant,CouleurCourante:word;
    Image:videosave;
    Fond1,Normal1,Fond2,Brillant,Fond3,Normal3,FondOmbre,Ombre:word;
    OptionLecture:word;
    Rubrique:byte;
    Entree:char;
    Fin:boolean;
    ResTemp:TabR;
          Procedure RUBRIQUE_ALLUMEE;
          (* MISE EN SURBRILLANCE DE LA RUBRIQUE COURANTE *)
          Begin
            txtback(Fond2); txtcolour(Brillant);
            case Rubrique of
              4:begin txtmove(c+19,l+6); txtattrib(2); end;
              5:begin txtmove(c+26,l+6); txtattrib(2); end;
              6:begin txtmove(c+19,l+7); txtattrib(2); end;
              7:begin txtmove(c+26,l+7); txtattrib(2); end;
              8:begin txtmove(c+19,l+8); txtattrib(2); end;
              9:begin txtmove(c+26,l+8); txtattrib(2); end;
              10:begin txtmove(c+19,l+9); txtattrib(2); end;
              11:begin txtmove(c+26,l+9); txtattrib(2); end;
              12:begin txtmove(c+19,l+10); txtattrib(2); end;
              13:begin txtmove(c+26,l+10); txtattrib(2); end;
              14:begin txtmove(c+7,l+11); txtattrib(10); end;
              15:begin txtmove(c+23,l+11); txtattrib(9); end;
            end;
          End;
          Procedure RUBRIQUE_ETEINTE;
          (* FIN DE LA MISE EN SURBRILLANCE DE LA RUBRIQUE COURANTE *)
          Begin
            txtback(Fond3); txtcolour(Normal3);
            case Rubrique of
              4:begin txtmove(c+19,l+6); txtattrib(2); end;
              5:begin txtmove(c+26,l+6); txtattrib(2); end;
              6:begin txtmove(c+19,l+7); txtattrib(2); end;
              7:begin txtmove(c+26,l+7); txtattrib(2); end;
              8:begin txtmove(c+19,l+8); txtattrib(2); end;
              9:begin txtmove(c+26,l+8); txtattrib(2); end;
              10:begin txtmove(c+19,l+9); txtattrib(2); end;
              11:begin txtmove(c+26,l+9); txtattrib(2); end;
              12:begin txtmove(c+19,l+10); txtattrib(2); end;
              13:begin txtmove(c+26,l+10); txtattrib(2); end;
              14:begin txtmove(c+7,l+11); txtattrib(10); end;
              15:begin txtmove(c+23,l+11); txtattrib(9); end;
            end;
          End;
          Procedure AFFICHAGE_MESSAGE_RUBRIQUE;
          (* AFFICHAGE MESSAGE BAS DE L'ECRAN CORRESPONDANT RUBRIQUE COURANTE *)
          Begin
            case Rubrique of
              4,6,8,10,12:MESSAGE_BAS_ECRAN(ip_EncodageResultat + 1);
              5,7,9,11,13:MESSAGE_BAS_ECRAN(ip_EncodageResultat + 2);
              14:MESSAGE_BAS_ECRAN(ip_EncodageResultat + 3);
              15:MESSAGE_BAS_ECRAN(ip_EncodageResultat + 4);
            end;
          End;
          Procedure RUBRIQUE_PRECEDENTE;
          (* SAUT VERS LA RUBRIQUE PRECEDENTE *)
          Begin
            if Souris then Void:=txtmousecursoff;
            RUBRIQUE_ETEINTE;
            case Rubrique of
              4:Rubrique:=15;
              5..14:begin dec(Rubrique); txtsimulatekey(13,28); end;
              15:Rubrique:=14;
            end;
            RUBRIQUE_ALLUMEE; AFFICHAGE_MESSAGE_RUBRIQUE;
            if Souris then Void:=txtmousecurson;
          End;
          Procedure RUBRIQUE_SUIVANTE;
          (* SAUT VERS LA RUBRIQUE SUIVANTE *)
          Begin
            if Souris then Void:=txtmousecursoff;
            RUBRIQUE_ETEINTE;
            case Rubrique of
              4..12:begin inc(Rubrique); txtsimulatekey(13,28); end;
              13,14:inc(Rubrique);
              15:Rubrique:=4;
            end;
            RUBRIQUE_ALLUMEE; AFFICHAGE_MESSAGE_RUBRIQUE;
            if Souris then Void:=txtmousecurson;
          End;
          Procedure PREMIERE_RUBRIQUE;
          (* SAUT VERS LA RUBRIQUE 4 *)
          Begin
            if Souris then Void:=txtmousecursoff;
            RUBRIQUE_ETEINTE; Rubrique:=4; txtsimulatekey(13,28); RUBRIQUE_ALLUMEE; AFFICHAGE_MESSAGE_RUBRIQUE;
            if Souris then Void:=txtmousecurson;
          End;
          Procedure BOUTON_OK;
          (* SAUT VERS LE BOUTON "OK" *)
          Begin
            if Rubrique < 14
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   RUBRIQUE_ETEINTE; Rubrique:=14; RUBRIQUE_ALLUMEE; AFFICHAGE_MESSAGE_RUBRIQUE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure BOUTON_ANNULER;
          (* SAUT VERS LE BOUTON "ANNULER" *)
          Begin
            if Souris then Void:=txtmousecursoff;
            RUBRIQUE_ETEINTE; Rubrique:=15; RUBRIQUE_ALLUMEE; AFFICHAGE_MESSAGE_RUBRIQUE;
            if Souris then Void:=txtmousecurson;
          End;
          Procedure ECRITURE_RUBRIQUE;
          (* ECRITURE DU CONTENU DE LA RUBRIQUE COURANTE *)
          Var Chaine:string[31];
          Begin
            txtback(Fond3); txtcolour(Normal3);
            case Rubrique of
              1:if (Categories[Numero].Situation = 255) and (Categories[Numero].NbPoules <> 0)
                   then
                     begin
                       str(pM^.Poule,Chaine); txtmove(c+21+(5-length(Chaine)) div 2,l+1); txtwrite(Chaine);
                     end;
              2:with pM^ do with pJoueur1^ do
                  begin
                    Chaine:=NomJoueur; if length(PrenomJoueur) <> 0 then Chaine:=Chaine + ' ' + PrenomJoueur;
                    txtmove(c+4+(31-length(Chaine)) div 2,l+2); txtwrite(Chaine);
                  end;
              3:with pM^ do with pJoueur2^ do
                  begin
                    Chaine:=NomJoueur; if length(PrenomJoueur) <> 0 then Chaine:=Chaine + ' ' + PrenomJoueur;
                    txtmove(c+4+(31-length(Chaine)) div 2,l+4); txtwrite(Chaine);
                  end;
              4:begin txtmove(c+19,l+6); txtnumwrite(ResTemp[1,1],0); end;
              5:begin txtmove(c+26,l+6); txtnumwrite(ResTemp[1,2],0); end;
              6:begin txtmove(c+19,l+7); txtnumwrite(ResTemp[2,1],0); end;
              7:begin txtmove(c+26,l+7); txtnumwrite(ResTemp[2,2],0); end;
              8:begin txtmove(c+19,l+8); txtnumwrite(ResTemp[3,1],0); end;
              9:begin txtmove(c+26,l+8); txtnumwrite(ResTemp[3,2],0); end;
              10:begin txtmove(c+19,l+9); txtnumwrite(ResTemp[4,1],0); end;
              11:begin txtmove(c+26,l+9); txtnumwrite(ResTemp[4,2],0); end;
              12:begin txtmove(c+19,l+10); txtnumwrite(ResTemp[5,1],0); end;
              13:begin txtmove(c+26,l+10); txtnumwrite(ResTemp[5,2],0); end;
            end;
          End;
          Function LECTURE_RUBRIQUE : word;
          (* LECTURE DE LA RUBRIQUE COURANTE.
             RETOURNE LE CODE DE LA TOUCHE AYANT DECLENCHE LA FIN DE LA LECTURE. *)
          Var r,xx,yy:word;
              Chaine:string;
              Erreur:integer;
              Ok,Avorter:boolean;
          Begin
            case Rubrique of
              4:begin xx:=c+19; yy:=l+6; str(ResTemp[1,1],Chaine); end;
              5:begin xx:=c+26; yy:=l+6; str(ResTemp[1,2],Chaine); end;
              6:begin xx:=c+19; yy:=l+7; str(ResTemp[2,1],Chaine); end;
              7:begin xx:=c+26; yy:=l+7; str(ResTemp[2,2],Chaine); end;
              8:begin xx:=c+19; yy:=l+8; str(ResTemp[3,1],Chaine); end;
              9:begin xx:=c+26; yy:=l+8; str(ResTemp[3,2],Chaine); end;
              10:begin xx:=c+19; yy:=l+9; str(ResTemp[4,1],Chaine); end;
              11:begin xx:=c+26; yy:=l+9; str(ResTemp[4,2],Chaine); end;
              12:begin xx:=c+19; yy:=l+10; str(ResTemp[5,1],Chaine); end;
              13:begin xx:=c+26; yy:=l+10; str(ResTemp[5,2],Chaine); end;
            end;
            txtflush; txtcurssize(CurseurHaut,CurseurBas); txtback(Fond2); txtcolour(Brillant);
            Ok:=false; Avorter:=false;
            repeat
              txtmove(xx,yy); r:=txtvalidate2(Chaine,Chaine,2,OptionLecture,hlp_EncodageResultat+33,[48..57]);
              if (r and tv_Escape = 0) and (length(Chaine) > 0)
                 then
                   begin
                     Ok:=true;
                     case Rubrique of
                       4:val(Chaine,ResTemp[1,1],Erreur);
                       5:val(Chaine,ResTemp[1,2],Erreur);
                       6:val(Chaine,ResTemp[2,1],Erreur);
                       7:val(Chaine,ResTemp[2,2],Erreur);
                       8:val(Chaine,ResTemp[3,1],Erreur);
                       9:val(Chaine,ResTemp[3,2],Erreur);
                       10:val(Chaine,ResTemp[4,1],Erreur);
                       11:val(Chaine,ResTemp[4,2],Erreur);
                       12:val(Chaine,ResTemp[5,1],Erreur);
                       13:val(Chaine,ResTemp[5,2],Erreur);
                     end;
                   end
                 else
                   Avorter:=true;
            until (Ok) or (Avorter);
            txtcursoff; ECRITURE_RUBRIQUE; LECTURE_RUBRIQUE:=r;
          End;
          Procedure SELECTION_RUBRIQUE;
          (* REACTION A LA SELECTION DE LA RUBRIQUE COURANTE *)
          Var r:word;
              Analyse:byte;
          Begin
            case Rubrique of
              4..13:begin
                      r:=LECTURE_RUBRIQUE; ECRITURE_RUBRIQUE;
                      if (r = tv_Enter) or (r = tv_ArDn) or (r = tv_TabRi)
                         then
                           RUBRIQUE_SUIVANTE
                         else
                           if (r = tv_ArUp) or (r = tv_TabLe)
                              then
                                RUBRIQUE_PRECEDENTE
                              else
                                if (r = tv_PgUp) or (r = tv_CtrlPgUp) or (r = tv_CtrlHome)
                                   then
                                     PREMIERE_RUBRIQUE
                                   else
                                     if (r = tv_PgDn) or (r = tv_CtrlPgDn) or (r = tv_CtrlEnd)
                                        then
                                          BOUTON_OK
                                        else
                                          if r = tv_Escape
                                             then
                                               BOUTON_ANNULER;
                    end;
              14:begin
                   Analyse:=ANALYSE_RESULTAT_MATCH(ResTemp);
                   if Analyse = 0
                      then
                        begin
                          pM^.Resultats:=ResTemp; Fin:=true; ENCODAGE_RESULTAT_MATCH:=true;
                        end
                      else
                        Void:=MESSAGE_AVERTISSEMENT(ip_EncodageResultat + Analyse);
                 end;
              15:begin
                   Fin:=true; ENCODAGE_RESULTAT_MATCH:=false;
                 end;
            end;
          End;
Begin
  case ModeEcran of
    ModeMono:begin
               Fond1:=lightgrey; Normal1:=black; Fond2:=black; Brillant:=white;
               Fond3:=lightgrey; Normal3:=white; FondOmbre:=black; Ombre:=lightgrey;
             end;
    ModeCouleur:begin
                  Fond1:=magenta; Normal1:=yellow; Fond2:=green; Brillant:=white;
                  Fond3:=magenta; Normal3:=white; FondOmbre:=black; Ombre:=lightgrey;
                end;
  end;
  x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; x:=windx; y:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image);
  txtback(Fond1); txtcolour(Normal1);
  txtmove(c,l);    txtwrite(' ͻ ');
  txtmove(c,l+1);  txtwrite('           Poule : <     >           ');
  txtmove(c,l+2);  txtwrite('  <                               >  ');
  txtmove(c,l+3);  txtwrite('                contre               ');
  txtmove(c,l+4);  txtwrite('  <                               >  ');
  txtmove(c,l+5);  txtwrite(' Ķ ');
  txtmove(c,l+6);  txtwrite('         Set 1 : <  > - <  >         ');
  txtmove(c,l+7);  txtwrite('         Set 2 : <  > - <  >         ');
  txtmove(c,l+8);  txtwrite('         Set 3 : <  > - <  >         ');
  txtmove(c,l+9);  txtwrite('         Set 4 : <  > - <  >         ');
  txtmove(c,l+10); txtwrite('         Set 5 : <  > - <  >         ');
  txtmove(c,l+11); txtwrite('     <          >    <         >     ');
  txtmove(c,l+12); txtwrite(' ͼ ');
  txtback(FondOmbre); txtcolour(Ombre);
  for Rubrique:=1 to 12 do
    begin
      txtmove(c+lg,l+Rubrique); txtattrib(2);
    end;
  txtmove(c+2,l+13); txtattrib(lg);
  txtback(Fond1); txtcolour(Brillant);
  txtmove(c+9,l); txtwrite(' Rsultat d''un match ');
  txtback(Fond3); txtcolour(Normal3);
  txtmove(c+7,l+11); txtwrite('    Ok   '); txtmove(c+23,l+11); txtwrite(' Annuler ');
  (* INITIALISATION DU TABLEAU DE RESULTATS TEMPORAIRE *)
  ResTemp:=pM^.Resultats;
  OptionLecture:=tv_ArUp or tv_ArDn or tv_PgUp or tv_PgDn or tv_CtrlHome or tv_CtrlPgUp or tv_CtrlEnd or
                 tv_CtrlPgDn or tv_TabLe or tv_TabRi;
  (* AFFICHAGE DES RUBRIQUES *)
  for Rubrique:=1 to 13 do ECRITURE_RUBRIQUE;
  (* LECTURE DU CLAVIER ET DE LA SOURIS *)
  txtflush; mouseeventparams.me_modified:=false;
  Fin:=false; Rubrique:=4; RUBRIQUE_ALLUMEE; MESSAGE_BAS_ECRAN(ip_EncodageResultat + 1);
  txtsimulatekey(13,28); if Souris then Void:=txtmousecurson;
  repeat
    if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
    if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   59:begin   (* F1 : AIDE *)
                        if Souris then Void:=txtmousecursoff;
                        AIDE(hlp_EncodageResultat + 33);
                        if Souris then Void:=txtmousecurson;
                      end;
                   15,72,75:RUBRIQUE_PRECEDENTE;      (* TAB GAUCHE / FLECHE HAUT / FLECHE GAUCHE *)
                   71,73,119,132:PREMIERE_RUBRIQUE;   (* (CTRL-)HOME / (CTRL-)PgUp *)
                   77,80:RUBRIQUE_SUIVANTE;           (* FLECHE DROITE / FLECHE BAS *)
                   79,81,117,118:BOUTON_OK;           (* (CTRL-)END / (CTRL-)PgDn *)
                   97:begin   (* CTRL-F4 : DEBOGAGE *)
                        if Souris then Void:=txtmousecursoff;
                        DEBOGAGE;
                        if Souris then Void:=txtmousecurson;
                      end;
                 end;
               end;
             9:RUBRIQUE_SUIVANTE;   (* TAB DROITE *)
             13:begin   (* ENTER *)
                  if Souris then Void:=txtmousecursoff;
                  RUBRIQUE_ETEINTE; SELECTION_RUBRIQUE; RUBRIQUE_ALLUMEE; AFFICHAGE_MESSAGE_RUBRIQUE;
                  if Souris then Void:=txtmousecurson;
                end;
             27:BOUTON_ANNULER;   (* ESCAPE *)
           end;
         end;
    if mouseeventparams.me_modified
       then
         with mouseeventparams do
           begin
             if (me_y in [(l+6)..(l+10)]) and ((me_x in [(c+19),(c+20)]) or (me_x in [(c+26),(c+27)]))
                  then   (* ENCODAGE D'UN SCORE *)
                    begin
                      Void:=txtmousecursoff;
                      RUBRIQUE_ETEINTE;
                      if me_y = (l+6)
                         then begin if me_x in [(c+19),(c+20)] then Rubrique:=4 else Rubrique:=5; end
                         else
                           if me_y = (l+7)
                              then begin if me_x in [(c+19),(c+20)] then Rubrique:=6 else Rubrique:=7; end
                              else
                                if me_y = (l+8)
                                   then begin if me_x in [(c+19),(c+20)] then Rubrique:=8 else Rubrique:=9; end
                                   else
                                     if me_y = (l+9)
                                        then begin if me_x in [(c+19),(c+20)] then Rubrique:=10 else Rubrique:=11; end
                                        else
                                          if me_y = (l+10)
                                             then begin if me_x in [(c+19),(c+20)] then Rubrique:=12 else Rubrique:=13; end;
                      AFFICHAGE_MESSAGE_RUBRIQUE; SELECTION_RUBRIQUE; RUBRIQUE_ALLUMEE; AFFICHAGE_MESSAGE_RUBRIQUE;
                      Void:=txtmousecurson;
                    end
                  else
                    if (me_x in [(c+7)..(c+15)]) and (me_y = (l+11))
                       then   (* BOUTON "OK" *)
                         begin
                           Void:=txtmousecursoff;
                           RUBRIQUE_ETEINTE;
                           Rubrique:=14; AFFICHAGE_MESSAGE_RUBRIQUE; SELECTION_RUBRIQUE;
                           RUBRIQUE_ALLUMEE; AFFICHAGE_MESSAGE_RUBRIQUE;
                           Void:=txtmousecurson;
                         end
                       else
                         if (me_x in [(c+23)..(c+31)]) and (me_y = (l+11))
                            then   (* BOUTON "ANNULER" *)
                              begin
                                Void:=txtmousecursoff;
                                RUBRIQUE_ETEINTE;
                                Rubrique:=15; AFFICHAGE_MESSAGE_RUBRIQUE; SELECTION_RUBRIQUE;
                                RUBRIQUE_ALLUMEE; AFFICHAGE_MESSAGE_RUBRIQUE;
                                Void:=txtmousecurson;
                              end;
               me_modified:=false;
           end;
  until Fin;
  if Souris then Void:=txtmousecursoff;
  txtload(Image); txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


Procedure ENCODAGE_RESULTATS (Numero : byte);
(* AFFICHAGE DE LA LISTE DES MATCHES ET ENCODAGE/MODIFICATION DE RESULTATS *)
Const c=0; lg=75; NbL=20; yHaut=3;
      LigneVierge:string[78]='                 -                           -     -     -     -     -   ';
Var x,y,x1,y1,x2,y2,FondCourant,CouleurCourante:word;
    Image:videosave;
    Fond1,Normal1,Fond2,Brillant:word;
    Ligne:byte;
    Ok:boolean;
    TableauPointeurs:array[1..20] of pMatch;
    MatchHaut:word;
    p:pMatch;
    Entree:char;
          Procedure LIGNE_ALLUMEE;
          (* MISE EN EVIDENCE D'UNE LIGNE *)
          Begin
            txtback(Fond2); txtcolour(Brillant); txtmove(c+2,Ligne); txtattrib(lg);
          End;
          Procedure LIGNE_ETEINTE;
          (* FIN DE LA MISE EN EVIDENCE D'UNE LIGNE *)
          Begin
            txtback(Fond1); txtcolour(Normal1); txtmove(c+2,Ligne); txtattrib(lg);
          End;
          Procedure AFFICHAGE_MATCH (n:byte);
          (* AFFICHAGE JOUEURS ET RESULTATS CORRESPONDANT A TableauPointeurs[n] *)
          Var pJ:pJoueur;
              i,j:byte;
              Chaine:string[5];
          Begin
            txtback(Fond1); txtcolour(Normal1);
            txtmove(c+2,yHaut+n-1); txtwrite(LigneVierge);
            with TableauPointeurs[n]^ do
              begin
                pJ:=pJoueur1; txtmove(c+3,yHaut+n-1); txtwrite(pJ^.NomJoueur);
                if (length(pJ^.NomJoueur) <= 12) and (length(pJ^.PrenomJoueur) > 0)
                   then txtwrite(' ' + pJ^.PrenomJoueur[1] + '.');
                pJ:=pJoueur2; txtmove(c+21,yHaut+n-1); txtwrite(pJ^.NomJoueur);
                if (length(pJ^.NomJoueur) <= 12) and (length(pJ^.PrenomJoueur) > 0)
                   then txtwrite(' ' + pJ^.PrenomJoueur[1] + '.');
                if Poule <> 0
                   then
                     begin
                       str(Poule,Chaine); txtmove(c+39+(5-length(Chaine)) div 2,yHaut+n-1); txtwrite(Chaine);
                     end;
                i:=47;
                for j:=1 to 5 do
                  begin
                    if (Resultats[j,1] <> 0) or (Resultats[j,2] <> 0)
                       then
                         begin
                           txtmove(i,yHaut+n-1); txtnumwrite(Resultats[j,1],2);
                           txtmove(i+3,yHaut+n-1); txtnumwrite(Resultats[j,2],0);
                         end;
                    inc(i,6);
                  end;
              end;
          End;
          Procedure AFFICHAGE_PAGE;
          (* AFFICHAGE DES MATCHES CORRESPONDANT A TableauPointeurs *)
          Var Fin:boolean;
              n:byte;
          Begin
            txtback(Fond1); txtcolour(Normal1);
            for n:=1 to NbL do
              begin
                txtmove(c+3,yHaut+n-1); txtwrite('               '); txtmove(c+21,yHaut+n-1); txtwrite('               ');
                txtmove(c+39,yHaut+n-1); txtwrite('     ');
                txtmove(c+46,yHaut+n-1); txtwrite('   -     -     -     -     -   ');
              end;
            n:=1; Fin:=false;
            while (n <= NbL) and (not Fin) do
              if TableauPointeurs[n] = nil then Fin:=true else begin AFFICHAGE_MATCH(n); inc(n); end;
          End;
          Procedure PREMIER_MATCH;
          (* REMONTEE JUSQU'AU PREMIER MATCH *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pPrec <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if MatchHaut > 1
                      then   (* SCROLLING *)
                        begin
                          i:=1; p:=Categories[Numero].pTeteMatches;
                          while (i <= NbL) and (p <> nil) do
                            begin
                              TableauPointeurs[i]:=p; inc(i); if p <> nil then p:=p^.pSuiv;
                            end;
                          MatchHaut:=1; AFFICHAGE_PAGE;
                        end;
                   Ligne:=yHaut; LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure DERNIER_MATCH;
          (* DESCENTE JUSQU'AU DERNIER MATCH *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pSuiv <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if Categories[Numero].NbMatches > NbL
                      then   (* IL FAUDRA TESTER SI SCROLLING *)
                        begin
                          if MatchHaut < (Categories[Numero].NbMatches - NbL + 1)
                             then   (* LE DERNIER MATCH N'EST PAS A L'ECRAN : SCROLLING *)
                               begin
                                 i:=NbL; p:=Categories[Numero].pQueueMatches;
                                 while (i >= 1) and (p <> nil) do
                                   begin
                                     TableauPointeurs[i]:=p; dec(i); if p <> nil then p:=p^.pPrec;
                                   end;
                                 Ligne:=yHaut + NbL - 1; MatchHaut:=Categories[Numero].NbMatches - NbL + 1; AFFICHAGE_PAGE;
                               end
                             else   (* LE DERNIER MATCH EST A L'ECRAN *)
                               Ligne:=Categories[Numero].NbMatches - MatchHaut + yHaut;
                        end
                      else   (* MOINS DE MATCHES QUE DE LIGNES : DERNIER MATCH A L'ECRAN *)
                        Ligne:=Categories[Numero].NbMatches + yHaut - 1;
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure MATCH_PRECEDENT;
          (* REMONTEE AU MATCH PRECEDENT *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pPrec <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if Ligne = yHaut
                      then   (* SCROLLING *)
                        begin
                          for i:=NbL downto 2 do TableauPointeurs[i]:=TableauPointeurs[i-1];
                          TableauPointeurs[1]:=TableauPointeurs[1]^.pPrec; dec(MatchHaut);
                          txtwind(c+2,yHaut,c+76,yHaut+NbL-1); txtinsdn(0); txtunwind;
                          txtback(Fond1); txtcolour(Normal1);
                          txtmove(c+2,yHaut); txtwrite(LigneVierge); AFFICHAGE_MATCH(1);
                        end
                      else   (* PAS DE SCROLLING *)
                        dec(Ligne);
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure MATCH_SUIVANT;
          (* DESCENTE AU MATCH SUIVANT *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pSuiv <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if Ligne = (yHaut + NbL - 1)
                      then   (* SCROLLING *)
                        begin
                          for i:=1 to (NbL - 1) do TableauPointeurs[i]:=TableauPointeurs[i+1];
                          TableauPointeurs[NbL]:=TableauPointeurs[NbL]^.pSuiv; inc(MatchHaut);
                          txtwind(c+2,yHaut,c+76,yHaut+NbL-1); txtdeldn(0); txtunwind;
                          txtback(Fond1); txtcolour(Normal1);
                          txtmove(c+2,yHaut+NbL-1); txtwrite(LigneVierge); AFFICHAGE_MATCH(NbL);
                        end
                      else   (* PAS DE SCROLLING *)
                        inc(Ligne);
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure PAGE_PRECEDENTE;
          (* AFFICHAGE DE LA PAGE DE MATCHES PRECEDENTE *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pPrec <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if MatchHaut > (NbL - 1)
                      then   (* SCROLLING D'UNE PAGE ENTIERE *)
                        begin
                          p:=TableauPointeurs[1]; TableauPointeurs[NbL]:=p; p:=p^.pPrec;
                          for i:=(NbL - 1) downto 1 do
                            begin
                              TableauPointeurs[i]:=p; p:=p^.pPrec;
                            end;
                          dec(MatchHaut,NbL - 1); AFFICHAGE_PAGE;
                        end
                      else
                        if MatchHaut > 1
                           then   (* PREMIERE PAGE *)
                             begin
                               i:=1; p:=Categories[Numero].pTeteMatches;
                               while (i <= NbL) and (p <> nil) do
                                 begin
                                   TableauPointeurs[i]:=p; inc(i); if p <> nil then p:=p^.pSuiv;
                                 end;
                               MatchHaut:=1; AFFICHAGE_PAGE;
                             end
                           else   (* PAS DE SCROLLING *)
                             Ligne:=yHaut;
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure PAGE_SUIVANTE;
          (* AFFICHAGE DE LA PAGE DE MATCHES SUIVANTE *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pSuiv <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if Categories[Numero].NbMatches > (2 * (NbL - 1))
                      then   (* IL FAUDRA TESTER SI SCROLLING PAGE ENTIERE *)
                        begin
                          if MatchHaut <= (Categories[Numero].NbMatches - 2 * (NbL - 1))
                             then   (* SCROLLING D'UNE PAGE ENTIERE *)
                               begin
                                 p:=TableauPointeurs[NbL]; TableauPointeurs[1]:=p; p:=p^.pSuiv;
                                 for i:=2 to NbL do
                                   begin
                                     TableauPointeurs[i]:=p; p:=p^.pSuiv;
                                   end;
                                 inc(MatchHaut,NbL - 1); AFFICHAGE_PAGE;
                               end
                             else
                               if MatchHaut < (Categories[Numero].NbMatches - NbL + 1)
                                  then   (* AFFICHAGE DE LA DERNIERE PAGE *)
                                    begin
                                      i:=NbL; p:=Categories[Numero].pQueueMatches;
                                      while (i >= 1) and (p <> nil) do
                                        begin
                                          TableauPointeurs[i]:=p; dec(i); if p <> nil then p:=p^.pPrec;
                                        end;
                                      MatchHaut:=Categories[Numero].NbMatches - NbL + 1; AFFICHAGE_PAGE;
                                    end
                                  else   (* DERNIERE PAGE DEJA AFFICHEE *)
                                    Ligne:=Categories[Numero].NbMatches - MatchHaut + yHaut;
                        end
                      else
                        if Categories[Numero].NbMatches > NbL
                           then   (* IL FAUDRA TESTER SI SCROLLING *)
                             begin
                               if MatchHaut < (Categories[Numero].NbMatches - NbL + 1)
                                  then   (* AFFICHAGE DE LA DERNIERE PAGE *)
                                    begin
                                      i:=NbL; p:=Categories[Numero].pQueueMatches;
                                      while (i >= 1) and (p <> nil) do
                                        begin
                                          TableauPointeurs[i]:=p; dec(i); if p <> nil then p:=p^.pPrec;
                                        end;
                                      MatchHaut:=Categories[Numero].NbMatches - NbL + 1; AFFICHAGE_PAGE;
                                    end
                                  else   (* DERNIERE PAGE DEJA AFFICHEE *)
                                    Ligne:=Categories[Numero].NbMatches - MatchHaut + yHaut;
                             end
                           else   (* MOINS DE MATCHES QUE DE LIGNES : L'UNIQUE ET DERNIERE PAGE EST DEJA AFFICHEE *)
                             Ligne:=Categories[Numero].NbMatches + yHaut - 1;
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure SELECTION_MATCH;
          (* REACTION A LA SELECTION D'UN MATCH (ENCODAGE) *)
          Var NouveauMatch:boolean;
          Begin
            (* TEST SI NOUVEAU MATCH OU SI MODIFICATION MATCH DEJA ENCODE *)
            with TableauPointeurs[Ligne-yHaut+1]^ do NouveauMatch:=((Resultats[1,1] = 0) and (Resultats[1,2] = 0));
            (* ENCODAGE DU RESULTAT DU MATCH *)
            if ENCODAGE_RESULTAT_MATCH(Numero,TableauPointeurs[Ligne-yHaut+1])
               then
                 begin
                   AFFICHAGE_MATCH(Ligne-yHaut+1);
                   if NouveauMatch then dec(Categories[Numero].NbMatchesRestants);
                 end;
          End;
Begin
  case ModeEcran of
    ModeMono:begin Fond1:=lightgrey; Normal1:=black; Fond2:=black; Brillant:=white; end;
    ModeCouleur:begin Fond1:=blue; Normal1:=yellow; Fond2:=brown; Brillant:=white; end;
  end;
  x:=windx; y:=windy; x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image);
  TITRE_HAUT_ECRAN(ip_EncodageResultat); MESSAGE_BAS_ECRAN(ip_EncodageResultat);
  (* CADRE *)
  txtback(Fond1); txtcolour(Normal1);
  txtmove(c,1); txtwrite(' ͻ ');
  txtmove(c,2); txtwrite('                                                                           ');
  for Ligne:=3 to 22 do
    begin
      txtmove(c,Ligne); txtwrite('                  -                           -     -     -     -     -    ');
    end;
  txtmove(c,23); txtwrite(' ͼ ');
  (* TITRES *)
  txtcolour(Brillant); txtmove(28,1); txtwrite(' Encodage des rsultats ');
  txtmove(c+17,2); txtwrite('Match'); txtmove(c+39,2); txtwrite('Poule'); txtmove(49,2); txtwrite('1');
  txtmove(55,2); txtwrite('2'); txtmove(61,2); txtwrite('3'); txtmove(67,2); txtwrite('4'); txtmove(73,2); txtwrite('5');
  (* BOUTONS DE LA SOURIS *)
  txtmove(c+77,3); txtwrite(''); txtmove(c+77,4); txtwrite(#30); txtmove(c+77,5); txtwrite(#24);
  txtmove(c+77,22); txtwrite(''); txtmove(c+77,21); txtwrite(#31); txtmove(c+77,20); txtwrite(#25);
  (* INITIALISATION DU TABLEAU DE POINTEURS *)
  for Ligne:=1 to 20 do TableauPointeurs[Ligne]:=nil;
  Ligne:=1; p:=Categories[Numero].pTeteMatches;
  while (p <> nil) and (Ligne <= NbL) do
    begin
      TableauPointeurs[Ligne]:=p; p:=p^.pSuiv; inc(Ligne);
    end;
  AFFICHAGE_PAGE;
  (* LECTURE DU CLAVIER OU DE LA SOURIS *)
  txtflush; mouseeventparams.me_modified:=false;
  Ok:=false; Ligne:=yHaut; MatchHaut:=1; LIGNE_ALLUMEE; if Souris then Void:=txtmousecurson;
  repeat
    if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
    if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   59:begin   (* F1 : AIDE *)
                        if Souris then Void:=txtmousecursoff;
                        AIDE(hlp_EncodageResultat);
                        if Souris then Void:=txtmousecurson;
                      end;
                   71,119,132:PREMIER_MATCH;   (* (CTRL-)HOME / CTRL-PgUp : PREMIER MATCH *)
                   15,72:MATCH_PRECEDENT;      (* TAB GAUCHE / FLECHE HAUT : MATCH PRECEDENT *)
                   73:PAGE_PRECEDENTE;         (* PgUp : PAGE PRECEDENTE *)
                   80:MATCH_SUIVANT;           (* FLECHE BAS : MATCH SUIVANT *)
                   81:PAGE_SUIVANTE;           (* PgDn : PAGE SUIVANTE *)
                   79,117,118:DERNIER_MATCH;   (* (CTRL-)END / CTRL-PgDn : DERNIER MATCH *)
                   97:begin   (* CTRL-F4 : DEBOGAGE *)
                        if Souris then Void:=txtmousecursoff;
                        DEBOGAGE;
                        if Souris then Void:=txtmousecurson;
                      end;
                 end;
               end;
             9:MATCH_SUIVANT;   (* TAB DROITE : MATCH SUIVANT *)
             13:begin   (* ENTER : ENCODAGE/MODIFICATION *)
                  if Souris then Void:=txtmousecursoff;
                  LIGNE_ETEINTE; SELECTION_MATCH; LIGNE_ALLUMEE;
                  if Souris then Void:=txtmousecurson;
                end;
             27:Ok:=true;   (* ESCAPE : FIN *)
           end;
         end;
    if mouseeventparams.me_modified
       then
         with mouseeventparams do
           begin
             if me_x = (c+77)
                then
                  case me_y of
                    3:PREMIER_MATCH;
                    4:PAGE_PRECEDENTE;
                    5:MATCH_PRECEDENT;
                    20:MATCH_SUIVANT;
                    21:PAGE_SUIVANTE;
                    22:DERNIER_MATCH;
                  end
                else
                  if (me_x in [(c+2)..(c+76)]) and (me_y in [3..22])
                     then
                       begin   (* SELECTION D'UN MATCH *)
                         Void:=txtmousecursoff;
                         LIGNE_ETEINTE;
                         if TableauPointeurs[me_y-yHaut+1] <> nil then begin Ligne:=me_y; SELECTION_MATCH; end;
                         LIGNE_ALLUMEE;
                         Void:=txtmousecurson;
                       end;
             me_modified:=false;
           end;
  until Ok;
  if Souris then Void:=txtmousecursoff;
  txtload(Image); txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


END.
