
UNIT TTO_OPTN;

(* BOITE DE DIALOGUE DES OPTIONS DU PROGRAMME TTO VERSION 1.20 *)


INTERFACE

Uses TXT,        (* GESTION DE L'ECRAN EN MODE TEXTE (VERSION 2.00) *)
     TTO_DECL,   (* DECLARATION DE CONSTANTES, TYPES ET VARIABLES GLOBALES *)
     TTO_HARD,   (* GESTION BAS NIVEAU DE LA SOURIS ET DU TIMER, ECONOMISEUR D'ECRAN *)
     TTO_COMN,   (* EXPLICATIONS AU BAS DE L'ECRAN *)
     TTO_GENE,   (* INITIALISATION DE LA SOURIS ET DU TIMER *)
     TTO_FILE,   (* SAUVETAGE AUTOMATIQUE SUR DISQUE *)
     TTO_HELP;   (* AIDE CONTEXTUELLE ET DEBOGAGE *)


Procedure OPTIONS;
   (* ENCODAGE DES OPTIONS DU PROGRAMME *)


IMPLEMENTATION

Procedure OPTIONS;
(* ENCODAGE DES OPTIONS DU PROGRAMME.
   LA SOURIS N'EST PAS ACTIVEE DANS LA BOITE DE DIALOGUE.
   L'AIDE (F1) ET LA BOITE DE DIALOGUE DE DEBOGAGE (CTRL-F4) SONT DISPONIBLES.
   L'ECONOMISEUR D'ECRAN ET LE SAUVETAGE AUTOMATIQUE SONT ACTIVES. *)
Type Tableau=array[1..19,1..3] of byte;
Const c=2; l=1;
Var x,y,x1,y1,x2,y2,FondCourant,CouleurCourante:word;
    Image:videosave;
    Fond1,Normal1,Fond2,Brillant,Fond3,Normal3,FondOmbre,Ombre,Rubrique:byte;
    Tab:Tableau;   (* COORDONNEES ET LONGUEUR DES RUBRIQUES *)
    OptionLecture,Resultat:word;
    Entree:char;
    Ok,Annuler:boolean;
    (* VARIABLES DE SAUVETAGE DES OPTIONS AU CAS OU "ANNULER" *)
    DelaiSauvetage2,DelaiEcran2,Imprimante2,VitesseTimer2:byte;
    Souris2,SauverOptions2:boolean;
    Code1,Code2,Code3,Code4,Code5,Code6:string[35];
          Procedure RUBRIQUE_ALLUMEE;
          (* MISE EN SURBRILLANCE D'UNE RUBRIQUE + MESSAGE AU BAS DE L'ECRAN *)
          Begin
            txtback(Fond2); txtcolour(Brillant);
            txtmove(Tab[Rubrique,1],Tab[Rubrique,2]); txtattrib(Tab[Rubrique,3]);
            case Rubrique of
              1,2,4,6..10,17:MESSAGE_BAS_ECRAN(ip_OptionsProgramme + 1);
              3,5:MESSAGE_BAS_ECRAN(ip_OptionsProgramme + 2);
              11..16:MESSAGE_BAS_ECRAN(ip_OptionsProgramme + 3);
              18:MESSAGE_BAS_ECRAN(ip_OptionsProgramme + 4);
              19:MESSAGE_BAS_ECRAN(ip_OptionsProgramme + 5);
            end;
          End;
          Procedure RUBRIQUE_ETEINTE;
          (* FIN DE LA MISE EN SURBRILLANCE D'UNE RUBRIQUE *)
          Begin
            txtback(Fond1); txtcolour(Brillant); txtmove(Tab[Rubrique,1],Tab[Rubrique,2]); txtattrib(Tab[Rubrique,3]);
          End;
          Procedure RUBRIQUE_PRECEDENTE;
          (* RUBRIQUE PRECEDENTE. SIMULE EVENTUELLEMENT "ENTER" *)
          Begin
            case Rubrique of
              1:Rubrique:=19;
              4:begin if DelaiSauvetage2 <> 0 then Rubrique:=3 else Rubrique:=2; txtsimulatekey(13,28); end;
              6:begin if DelaiEcran2 <> 0 then Rubrique:=5 else Rubrique:=4; txtsimulatekey(13,28); end;
              17:begin if Imprimante2 = ti_Autre then Rubrique:=16 else Rubrique:=10; txtsimulatekey(13,28); end;
              19:dec(Rubrique);
            else
              dec(Rubrique); txtsimulatekey(13,28);
            end;
          End;
          Procedure RUBRIQUE_SUIVANTE;
          (* RUBRIQUE SUIVANTE. SIMULE EVENTUELLEMENT "ENTER" *)
          Begin
            case Rubrique of
              2:begin if DelaiSauvetage2 <> 0 then Rubrique:=3 else Rubrique:=4; txtsimulatekey(13,28); end;
              4:begin if DelaiEcran2 <> 0 then Rubrique:=5 else Rubrique:=6; txtsimulatekey(13,28); end;
              10:begin if Imprimante2 = ti_Autre then Rubrique:=11 else Rubrique:=17; txtsimulatekey(13,28); end;
              17,18:inc(Rubrique);
              19:begin Rubrique:=1; txtsimulatekey(13,28); end;
            else
              inc(Rubrique); txtsimulatekey(13,28);
            end;
          End;
          Procedure AFFICHAGE_RUBRIQUE (n:byte);
          (* AFFICHAGE DU CONTENU D'UNE RUBRIQUE *)
          Begin
            txtback(Fond1); txtcolour(Brillant);
            txtmove(Tab[n,1],Tab[n,2]);
            case n of
              1:if Souris2 then txtwrite('.') else txtwrite('');
              2:if DelaiSauvetage2 <> 0 then txtwrite('') else txtwrite('.');
              3:if DelaiSauvetage2 <> 0 then txtnumwrite(DelaiSauvetage2,2) else txtwrite('..');
              4:if DelaiEcran2 <> 0 then txtwrite('') else txtwrite('.');
              5:if DelaiEcran2 <> 0 then txtnumwrite(DelaiEcran2,2) else txtwrite('..');
              6:if Imprimante2 = ti_HPDeskJet then txtwrite('') else txtwrite('.');
              7:if Imprimante2 = ti_ProPrinter then txtwrite('') else txtwrite('.');
              8:if Imprimante2 = ti_EpsonLX then txtwrite('') else txtwrite('.');
              9:if Imprimante2 = ti_Aucune then txtwrite('') else txtwrite('.');
              10:if Imprimante2 = ti_Autre then txtwrite('') else txtwrite('.');
              11..16:begin
                       txtwrite('...................................'); txtmove(Tab[n,1],Tab[n,2]);
                       if Imprimante2 = ti_Autre
                          then
                            case n of
                              11:txtwrite(Code1);
                              12:txtwrite(Code2);
                              13:txtwrite(Code3);
                              14:txtwrite(Code4);
                              15:txtwrite(Code5);
                              16:txtwrite(Code6);
                            end;
                     end;
              17:if SauverOptions2 then txtwrite('') else txtwrite('.');
              18,19:txtattrib(Tab[n,3]);
            end;
          End;
          Function LECTURE_OPTION : word;
          (* LECTURE D'UNE OPTION A BASCULE. RETOURNE LE CODE QUI AURAIT ETE RENVOYE PAR txtvalidate2 *)
          Var NumeroLigne:word;
              Fin:boolean;
          Begin
            Fin:=false;
            repeat
              if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
              if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
              if txtkeypressed
                 then
                   begin
                     txtinput(Entree);
                     case ord(Entree) of
                       0:begin
                           txtinput(Entree);
                           case ord(Entree) of
                             15:begin Fin:=true; LECTURE_OPTION:=tv_TabLe; end;
                             59:begin   (* F1 : AIDE *)
                                  case Rubrique of
                                    1:NumeroLigne:=hlp_OptionSouris;
                                    2:NumeroLigne:=hlp_OptionAutoSave;
                                    4:NumeroLigne:=hlp_OptionScreenSaver;
                                    6..10:NumeroLigne:=hlp_OptionImprimante;
                                    17:NumeroLigne:=hlp_OptionsEnregistrer;
                                  end;
                                  AIDE(NumeroLigne);
                                end;
                             72:begin Fin:=true; LECTURE_OPTION:=tv_ArUp; end;
                             73:begin Fin:=true; LECTURE_OPTION:=tv_PgUp; end;
                             80:begin Fin:=true; LECTURE_OPTION:=tv_ArDn; end;
                             81:begin Fin:=true; LECTURE_OPTION:=tv_PgDn; end;
                             97:DEBOGAGE;   (* CTRL-F4 : BOITE DE DIALOGUE DE DEBOGAGE *)
                             117:begin Fin:=true; LECTURE_OPTION:=tv_CtrlEnd; end;
                             118:begin Fin:=true; LECTURE_OPTION:=tv_CtrlPgDn; end;
                             119:begin Fin:=true; LECTURE_OPTION:=tv_CtrlHome; end;
                             132:begin Fin:=true; LECTURE_OPTION:=tv_CtrlPgUp; end;
                             141:begin Fin:=true; LECTURE_OPTION:=tv_CtrlArUp; end;
                             145:begin Fin:=true; LECTURE_OPTION:=tv_CtrlArDn; end;
                           end;
                         end;
                       9:begin Fin:=true; LECTURE_OPTION:=tv_TabRi; end;
                       13,32:begin Fin:=true; LECTURE_OPTION:=tv_Enter; end;
                       27:begin Fin:=true; LECTURE_OPTION:=tv_Escape; end;
                     end;
                   end;
            until Fin;
          End;
          Function ENCODAGE_RUBRIQUE : word;
          (* ENCODAGE D'UNE RUBRIQUE. RETOURNE LE CODE RENVOYE PAR txtvalidate2 *)
          Var Chaine:string;
              Erreur:integer;
              n:byte;
              r:word;
          Begin
            txtback(Fond2); txtcolour(Brillant);
            case Rubrique of
              1:begin   (* DESACTIVER LA SOURIS ? *)
                  txtmove(Tab[1,1],Tab[1,2]); txtattrib(Tab[1,3]);
                  r:=LECTURE_OPTION; if r = tv_Enter then Souris2:=not Souris2;
                  AFFICHAGE_RUBRIQUE(1);
                end;
              2:begin   (* SAUVETAGE AUTOMATIQUE SUR DISQUE ? *)
                  txtmove(Tab[2,1],Tab[2,2]); txtattrib(Tab[2,3]);
                  r:=LECTURE_OPTION;
                  if r = tv_Enter then if DelaiSauvetage2 = 0 then DelaiSauvetage2:=15 else DelaiSauvetage2:=0;
                  AFFICHAGE_RUBRIQUE(2); AFFICHAGE_RUBRIQUE(3);
                end;
              3:begin   (* DELAI DU SAUVETAGE AUTOMATIQUE SUR DISQUE *)
                  str(DelaiSauvetage2,Chaine); txtcurssize(CurseurHaut,CurseurBas);
                  txtmove(Tab[3,1],Tab[3,2]); r:=txtvalidate2(Chaine,Chaine,2,OptionLecture,hlp_OptionAutoSave,[48..57]);
                  txtcursoff; if r and tv_Escape = 0 then val(Chaine,DelaiSauvetage2,Erreur);
                  AFFICHAGE_RUBRIQUE(2); AFFICHAGE_RUBRIQUE(3);
                end;
              4:begin   (* ECONOMISEUR D'ECRAN ? *)
                  txtmove(Tab[4,1],Tab[4,2]); txtattrib(Tab[4,3]);
                  r:=LECTURE_OPTION;
                  if r = tv_Enter then if DelaiEcran2 = 0 then DelaiEcran2:=3 else DelaiEcran2:=0;
                  AFFICHAGE_RUBRIQUE(4); AFFICHAGE_RUBRIQUE(5);
                end;
              5:begin   (* DELAI DE L'ECONOMISEUR D'ECRAN *)
                  str(DelaiEcran2,Chaine); txtcurssize(CurseurHaut,CurseurBas);
                  txtmove(Tab[5,1],Tab[5,2]); r:=txtvalidate2(Chaine,Chaine,2,OptionLecture,hlp_OptionScreenSaver,[48..57]);
                  txtcursoff; if r and tv_Escape = 0 then val(Chaine,DelaiEcran2,Erreur);
                  AFFICHAGE_RUBRIQUE(4); AFFICHAGE_RUBRIQUE(5);
                end;
              6..10:begin   (* TYPES D'IMPRIMANTE *)
                      txtmove(Tab[Rubrique,1],Tab[Rubrique,2]); txtattrib(Tab[Rubrique,3]);
                      r:=LECTURE_OPTION;
                      if r = tv_Enter
                         then
                           case Rubrique of
                             6:Imprimante2:=ti_HPDeskJet;
                             7:Imprimante2:=ti_ProPrinter;
                             8:Imprimante2:=ti_EpsonLX;
                             9:Imprimante2:=ti_Aucune;
                             10:Imprimante2:=ti_Autre;
                           end;
                      for n:=6 to 16 do AFFICHAGE_RUBRIQUE(n);
                    end;
              11:begin   (* CODE D'IMPRIMANTE "DEBUT COMPRESSE" *)
                   Chaine:=Code1; txtcurssize(CurseurHaut,CurseurBas);
                   txtmove(Tab[11,1],Tab[11,2]);
                   r:=txtvalidate2(Chaine,Chaine,35,OptionLecture,hlp_OptionCommandesImprimante,[32,48..57]);
                   txtcursoff; if r and tv_Escape = 0 then Code1:=Chaine;
                   AFFICHAGE_RUBRIQUE(11);
                 end;
              12:begin   (* CODE D'IMPRIMANTE "FIN COMPRESSE" *)
                   Chaine:=Code2; txtcurssize(CurseurHaut,CurseurBas);
                   txtmove(Tab[12,1],Tab[12,2]);
                   r:=txtvalidate2(Chaine,Chaine,35,OptionLecture,hlp_OptionCommandesImprimante,[32,48..57]);
                   txtcursoff; if r and tv_Escape = 0 then Code2:=Chaine;
                   AFFICHAGE_RUBRIQUE(12);
                 end;
              13:begin   (* CODE D'IMPRIMANTE "DEBUT GRAS" *)
                   Chaine:=Code3; txtcurssize(CurseurHaut,CurseurBas);
                   txtmove(Tab[13,1],Tab[13,2]);
                   r:=txtvalidate2(Chaine,Chaine,35,OptionLecture,hlp_OptionCommandesImprimante,[32,48..57]);
                   txtcursoff; if r and tv_Escape = 0 then Code3:=Chaine;
                   AFFICHAGE_RUBRIQUE(13);
                 end;
              14:begin   (* CODE D'IMPRIMANTE "FIN GRAS" *)
                   Chaine:=Code4; txtcurssize(CurseurHaut,CurseurBas);
                   txtmove(Tab[14,1],Tab[14,2]);
                   r:=txtvalidate2(Chaine,Chaine,35,OptionLecture,hlp_OptionCommandesImprimante,[32,48..57]);
                   txtcursoff; if r and tv_Escape = 0 then Code4:=Chaine;
                   AFFICHAGE_RUBRIQUE(14);
                 end;
              15:begin   (* CODE D'IMPRIMANTE "DEBUT SOULIGNE" *)
                   Chaine:=Code5; txtcurssize(CurseurHaut,CurseurBas);
                   txtmove(Tab[15,1],Tab[15,2]);
                   r:=txtvalidate2(Chaine,Chaine,35,OptionLecture,hlp_OptionCommandesImprimante,[32,48..57]);
                   txtcursoff; if r and tv_Escape = 0 then Code5:=Chaine;
                   AFFICHAGE_RUBRIQUE(15);
                 end;
              16:begin   (* CODE D'IMPRIMANTE "FIN SOULIGNE" *)
                   Chaine:=Code6; txtcurssize(CurseurHaut,CurseurBas);
                   txtmove(Tab[16,1],Tab[16,2]);
                   r:=txtvalidate2(Chaine,Chaine,35,OptionLecture,hlp_OptionCommandesImprimante,[32,48..57]);
                   txtcursoff; if r and tv_Escape = 0 then Code6:=Chaine;
                   AFFICHAGE_RUBRIQUE(16);
                 end;
              17:begin   (* ENREGISTRER LES OPTIONS EN FIN DE PROGRAMME ? *)
                   txtmove(Tab[17,1],Tab[17,2]); txtattrib(Tab[17,3]);
                   r:=LECTURE_OPTION; if r = tv_Enter then SauverOptions2:=not SauverOptions2;
                   AFFICHAGE_RUBRIQUE(17);
                 end;
            end;
            ENCODAGE_RUBRIQUE:=r;
          End;
Begin
  Souris2:=Souris; SauverOptions2:=SauverOptions;
  DelaiSauvetage2:=DelaiSauvetage; DelaiEcran2:=DelaiEcran; VitesseTimer2:=VitesseTimer;
  Imprimante2:=Imprimante;
  Code1:=CHAR_TO_ASCII(ci_CompressedON); Code2:=CHAR_TO_ASCII(ci_CompressedOFF); Code3:=CHAR_TO_ASCII(ci_BoldON);
  Code4:=CHAR_TO_ASCII(ci_BoldOFF); Code5:=CHAR_TO_ASCII(ci_UnderlineON); Code6:=CHAR_TO_ASCII(ci_UnderlineOFF);
  case ModeEcran of
    ModeMono:begin
               Fond1:=lightgrey; Normal1:=black; Fond2:=black; Brillant:=white;
               Fond3:=black; Normal3:=white; FondOmbre:=black; Ombre:=lightgrey;
             end;
    ModeCouleur:begin
                  Fond1:=blue; Normal1:=yellow; Fond2:=brown; Brillant:=white;
                  Fond3:=cyan; Normal3:=yellow; FondOmbre:=black; Ombre:=lightgrey;
                end;
  end;
  Tab[1,1]:=c+4; Tab[1,2]:=l+2; Tab[1,3]:=1;
  Tab[2,1]:=c+4; Tab[2,2]:=l+3; Tab[2,3]:=1;
  Tab[3,1]:=c+52; Tab[3,2]:=l+3; Tab[3,3]:=2;
  Tab[4,1]:=c+4; Tab[4,2]:=l+4; Tab[4,3]:=1;
  Tab[5,1]:=c+42; Tab[5,2]:=l+4; Tab[5,3]:=2;
  Tab[6,1]:=c+31; Tab[6,2]:=l+6; Tab[6,3]:=1;
  Tab[7,1]:=c+31; Tab[7,2]:=l+7; Tab[7,3]:=1;
  Tab[8,1]:=c+31; Tab[8,2]:=l+8; Tab[8,3]:=1;
  Tab[9,1]:=c+31; Tab[9,2]:=l+9; Tab[9,3]:=1;
  Tab[10,1]:=c+31; Tab[10,2]:=l+10; Tab[10,3]:=1;
  Tab[11,1]:=c+36; Tab[11,2]:=l+11; Tab[11,3]:=35;
  Tab[12,1]:=c+36; Tab[12,2]:=l+12; Tab[12,3]:=35;
  Tab[13,1]:=c+30; Tab[13,2]:=l+13; Tab[13,3]:=35;
  Tab[14,1]:=c+30; Tab[14,2]:=l+14; Tab[14,3]:=35;
  Tab[15,1]:=c+27; Tab[15,2]:=l+15; Tab[15,3]:=35;
  Tab[16,1]:=c+27; Tab[16,2]:=l+16; Tab[16,3]:=35;
  Tab[17,1]:=c+4; Tab[17,2]:=l+18; Tab[17,3]:=1;
  Tab[18,1]:=c+21; Tab[18,2]:=l+20; Tab[18,3]:=12;
  Tab[19,1]:=c+41; Tab[19,2]:=l+20; Tab[19,3]:=13;
  OptionLecture:=tv_ArUp or tv_ArDn or tv_PgUp or tv_PgDn or tv_CtrlHome or tv_CtrlPgUp or tv_CtrlEnd or
                 tv_CtrlPgDn or tv_TabLe or tv_TabRi;
  x:=windx; y:=windy; x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image);
  TITRE_HAUT_ECRAN(7);
  txtback(Fond1); txtcolour(Normal1);
  txtmove(c,l);    txtwrite(' ͻ ');
  txtmove(c,l+1);  txtwrite('                                                                         ');
  txtmove(c,l+2);  txtwrite('  <.> Dsactiver la souris                                               ');
  txtmove(c,l+3);  txtwrite('  <.> Sauvetage automatique sur disque toutes les <..> minutes           ');
  txtmove(c,l+4);  txtwrite('  <.> Mettre l''cran en veilleuse aprs <..> minutes d''inactivit        ');
  txtmove(c,l+5);  txtwrite('                                                                         ');
  txtmove(c,l+6);  txtwrite('      Imprimante installe : <.> HP DeskJet gnrique (5xx)              ');
  txtmove(c,l+7);  txtwrite('                             <.> IBM gnrique (ProPrinter)              ');
  txtmove(c,l+8);  txtwrite('                             <.> EPSON gnrique (LX/FX)                 ');
  txtmove(c,l+9);  txtwrite('                             <.> Aucune                                  ');
  txtmove(c,l+10); txtwrite('                             <.> Autre (voir codes ci-dessous)           ');
  txtmove(c,l+11); txtwrite('      Caractres compresss Oui : <...................................>  ');
  txtmove(c,l+12); txtwrite('                            Non : <...................................>  ');
  txtmove(c,l+13); txtwrite('      Caractres gras Oui : <...................................>        ');
  txtmove(c,l+14); txtwrite('                      Non : <...................................>        ');
  txtmove(c,l+15); txtwrite('      Soulignement Oui : <...................................>           ');
  txtmove(c,l+16); txtwrite('                   Non : <...................................>           ');
  txtmove(c,l+17); txtwrite('                                                                         ');
  txtmove(c,l+18); txtwrite('  <.> Enregistrer les options  la fin du programme                      ');
  txtmove(c,l+19); txtwrite('                                                                         ');
  txtmove(c,l+20); txtwrite('                   <     OK     >      <   Annuler   >                   ');
  txtmove(c,l+21); txtwrite('                                                                         ');
  txtmove(c,l+22); txtwrite(' ͼ ');
  txtcolour(Brillant); txtmove(35,1); txtwrite(' Options ');
  txtback(FondOmbre); txtcolour(Ombre);
  for Rubrique:=(l+1) to (l+22) do
    begin
      txtmove(c+75,Rubrique); txtattrib(2);
    end;
  for Rubrique:=1 to 19 do AFFICHAGE_RUBRIQUE(Rubrique);
  (* LECTURE DU CLAVIER *)
  txtflush; Ok:=false; Annuler:=false; Rubrique:=1; RUBRIQUE_ALLUMEE; txtsimulatekey(13,28);
  repeat
    if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
    if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   59:AIDE(hlp_OptionsPrgm);   (* F1 : AIDE *)
                   15,72:begin   (* FLECHE HAUT : RUBRIQUE PRECEDENTE *)
                           RUBRIQUE_ETEINTE; RUBRIQUE_PRECEDENTE; RUBRIQUE_ALLUMEE;
                         end;
                   73,119,132:begin   (* (CTRL-)PgUp / CTRL-HOME : RUBRIQUE 1 *)
                                RUBRIQUE_ETEINTE; Rubrique:=1; txtsimulatekey(13,28); RUBRIQUE_ALLUMEE;
                              end;
                   80:begin   (* FLECHE BAS : RUBRIQUE SUIVANTE *)
                        RUBRIQUE_ETEINTE; RUBRIQUE_SUIVANTE; RUBRIQUE_ALLUMEE;
                      end;
                   81,117,118:if Rubrique < 18   (* (CTRL-)PgDn / CTRL-END : BOUTON "OK" *)
                                 then
                                   begin
                                     RUBRIQUE_ETEINTE; Rubrique:=18; RUBRIQUE_ALLUMEE;
                                   end;
                   97:DEBOGAGE;   (* CTRL-F4 : BOITE DE DIALOGUE DE DEBOGAGE *)
                 end;
               end;
             9:begin   (* TAB DROITE : RUBRIQUE SUIVANTE *)
                 RUBRIQUE_ETEINTE; RUBRIQUE_SUIVANTE; RUBRIQUE_ALLUMEE;
               end;
             13:begin   (* ENTER : ENCODAGE D'UNE RUBRIQUE *)
                  RUBRIQUE_ETEINTE;
                  case Rubrique of
                    18:Ok:=true;   (* BOUTON "OK" *)
                    19:Annuler:=true;   (* BOUTON "ANNULER" *)
                  else
                    Resultat:=ENCODAGE_RUBRIQUE;
                    if (Resultat = tv_PgUp) or (Resultat = tv_CtrlPgUp) or (Resultat = tv_CtrlHome)
                       then
                         begin
                           Rubrique:=1; txtsimulatekey(13,28);
                         end
                       else
                         if (Resultat = tv_PgDn) or (Resultat = tv_CtrlPgDn) or (Resultat = tv_CtrlEnd)
                            then
                              Rubrique:=18   (* BOUTON "OK" *)
                            else
                              if (Resultat = tv_ArUp) or (Resultat = tv_TabLe)
                                 then
                                   RUBRIQUE_PRECEDENTE
                                 else
                                   if (Resultat = tv_ArDn) or (Resultat = tv_TabRi) or (Resultat = tv_Enter)
                                      then
                                        RUBRIQUE_SUIVANTE
                                      else
                                        if Resultat = tv_Escape
                                           then
                                             Rubrique:=19;
                  end;
                  RUBRIQUE_ALLUMEE;
                end;
             27:begin   (* ESCAPE : ALLER SUR LE BOUTON "ANNULER" *)
                  RUBRIQUE_ETEINTE; Rubrique:=19; RUBRIQUE_ALLUMEE;
                end;
           end;
         end;
  until (Ok) or (Annuler);
  if Ok
     then   (* MODIFICATION DES PARAMETRES DU PROGRAMME *)
       begin
         (* MESSAGE D'ATTENTE *)
         txtback(Fond3); txtcolour(Normal3);
         txtmove(22,11); txtwrite(' ͻ ');
         txtmove(22,12); txtwrite('    Veuillez patienter, svp...    ');
         txtmove(22,13); txtwrite(' ͼ ');
         txtback(FondOmbre); txtcolour(Ombre);
         txtmove(58,12); txtattrib(2); txtmove(58,13); txtattrib(2); txtmove(24,14); txtattrib(36);
         (* MODIFICATION DES PARAMETRES *)
         if Souris <> Souris2
            then   (* MODIFICATION DU STATUT DE LA SOURIS *)
              begin
                Souris:=Souris2;   (* LA VALEUR DE Souris PEUT CHANGER AVEC INITIALISATION_SOURIS ! *)
                if Souris2
                   then   (* ACTIVER LE DRIVER DE SOURIS *)
                     begin
                       if MouseParams.mp_Valid then Void:=txtloadmouse(BufferSouris);
                       INITIALISATION_SOURIS;
                     end
                   else   (* DESACTIVER LE DRIVER DE SOURIS *)
                     if MouseParams.mp_Valid
                        then   (* LE DRIVER EST ACTUELLEMENT ACTIVE *)
                          begin
                            Void:=txtloadmouse(BufferSouris); Void:=txtmousecursoff;
                          end;
              end;
         if (DelaiEcran <> DelaiEcran2) or (DelaiSauvetage <> DelaiSauvetage2)
            then   (* MODIFICATION DU STATUT DU TIMER *)
              if (DelaiEcran2 <> 0) or (DelaiSauvetage2 <> 0)
                 then   (* ACTIVER LE TIMER *)
                   begin
                     if VitesseTimer2 = 0
                        then   (* LE TEST DU TIMER N'A PAS ENCORE ETE EFFECTUE *)
                          if NUMERO_INTERRUPTION_LIBRE then VitesseTimer2:=VITESSE_TIMER;
                     if VitesseTimer2 <> 0
                        then
                          begin
                            TicsDelaiSauvetage:=DelaiSauvetage2 * 60 * VitesseTimer2;
                            TicsDelaiEcran:=DelaiEcran2 * 60 * VitesseTimer2;
                            CompteurTicsSauvetage:=0; CompteurTicsEcran:=0; DETOURNEMENT_INT08;
                          end;
                   end
                 else   (* DESACTIVER LE TIMER *)
                   RESTAURATION_INT08;
         (* CHARGEMENT DES NOUVELLES VALEURS DANS LES CONSTANTES GLOBALES *)
         DelaiSauvetage:=DelaiSauvetage2; DelaiEcran:=DelaiEcran2; VitesseTimer:=VitesseTimer2;
         Imprimante:=Imprimante2;
         ci_CompressedON:=ASCII_TO_CHAR(Code1); ci_CompressedOFF:=ASCII_TO_CHAR(Code2); ci_BoldON:=ASCII_TO_CHAR(Code3);
         ci_BoldOFF:=ASCII_TO_CHAR(Code4); ci_UnderlineON:=ASCII_TO_CHAR(Code5); ci_UnderlineOFF:=ASCII_TO_CHAR(Code6);
         SauverOptions:=SauverOptions2;
       end;
  txtload(Image); txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


END.
