
UNIT TTO_PLYR;

(* GESTION DES JOUEURS POUR LE PROGRAMME TTO VERSION 1.20.
   MODULES APPELES PAR L'UNITE TTO_GEST (GESTION D'UNE CATEGORIE) *)

INTERFACE

Uses TXT,        (* GESTION DE L'ECRAN EN MODE TEXTE *)
     TTO_DECL,   (* DECLARATION DES CONSTANTES, TYPES ET VARIABLES GLOBALES *)
     TTO_HARD,   (* GESTION DE LA SOURIS, ECONOMISEUR D'ECRAN *)
     TTO_COMN,   (* EXPLICATIONS AU BAS DE L'ECRAN, MESSAGES D'ERREUR OU D'AVERTISSEMENT *)
     TTO_FILE,   (* SAUVETAGE AUTOMATIQUE SUR DISQUE *)
     TTO_GENE,   (* PROCEDURE TXTVALIDATE2 *)
     TTO_HELP;   (* AIDE CONTEXTUELLE ET DEBOGAGE *)


Function MODIFICATION_PARAMETRES_JOUEUR (var Joueur : EnregJ) : byte;
   (* MODIFICATION DU NOM, DU PRENOM, DE L'AGE OU DU CLUB D'UN JOUEUR *)


IMPLEMENTATION

Function MODIFICATION_PARAMETRES_JOUEUR (var Joueur : EnregJ) : byte;
(* MODIFICATION DU NOM, DU PRENOM, DE L'AGE OU DU CLUB D'UN JOUEUR.
   VALEURS RETOURNEES : mp_Avorter SI ANNULER,
                        mp_Ok SI OK SANS MODIFICATION NOM OU PRENOM,
                        mp_OkModifie SI OK ET MODIFICATION NOM OU PRENOM. *)
Const c=10; l=9; lg=60; nbl=5;
Var x1,y1,x2,y2,x,y,FondCourant,CouleurCourante:word;
    Image:videosave;
    Fond1,Normal1,Fond2,Brillant,Fond3,Normal3,FondOmbre,Ombre:word;
    Ligne,Rubrique:byte;
    Chaine:string;
    OptionLecture1,OptionLecture2,Resultat:word;
    NomTemp,PrenomTemp:string[15]; ClubTemp:string[20]; AgeTemp:string[2];
    Entree:char;
    Ok,Avorter:boolean;
          Procedure ECRITURE_RUBRIQUE;
          (* ECRITURE DE LA VALEUR D'UNE RUBRIQUE *)
          Begin
            txtback(Fond3); txtcolour(Normal3);
            case Rubrique of
              1:begin txtmove(c+11,l+1); txtwrite('               '); txtmove(c+11,l+1); txtwrite(NomTemp); end;
              2:begin txtmove(c+40,l+1); txtwrite('               '); txtmove(c+40,l+1); txtwrite(PreNomTemp); end;
              3:begin txtmove(c+11,l+2); txtwrite('  '); txtmove(c+11,l+2); txtwrite(AgeTemp); end;
              4:begin txtmove(c+35,l+2); txtwrite('                    '); txtmove(c+35,l+2); txtwrite(ClubTemp); end;
            end;
          End;
          Procedure RUBRIQUE_ALLUMEE;
          (* MISE EN EVIDENCE DE LA RUBRIQUE COURANTE *)
          Begin
            txtback(Fond2); txtcolour(Brillant);
            case Rubrique of
              1:begin txtmove(c+11,l+1); txtattrib(15); end;
              2:begin txtmove(c+40,l+1); txtattrib(15); end;
              3:begin txtmove(c+11,l+2); txtattrib(2); end;
              4:begin txtmove(c+35,l+2); txtattrib(20); end;
              5:begin txtmove(c+14,l+3); txtattrib(10); end;
              6:begin txtmove(c+35,l+3); txtattrib(11); end;
            end;
          End;
          Procedure RUBRIQUE_ETEINTE;
          (* FIN DE LA MISE EN EVIDENCE DE LA RUBRIQUE COURANTE *)
          Begin
            txtback(Fond3); txtcolour(Normal3);
            case Rubrique of
              1:begin txtmove(c+11,l+1); txtattrib(15); end;
              2:begin txtmove(c+40,l+1); txtattrib(15); end;
              3:begin txtmove(c+11,l+2); txtattrib(2); end;
              4:begin txtmove(c+35,l+2); txtattrib(20); end;
              5:begin txtmove(c+14,l+3); txtattrib(10); end;
              6:begin txtmove(c+35,l+3); txtattrib(11); end;
            end;
          End;
          Procedure ENCODAGE_RUBRIQUE;
          (* ENCODAGE D'UNE DES RUBRIQUES ET SAUT A UNE AUTRE RUBRIQUE *)
          Var i:byte;
              Ok,Avorter:boolean;
          Begin
            txtflush; txtcurssize(CurseurHaut,CurseurBas); txtback(Fond2); txtcolour(Brillant);
            case Rubrique of
              1:Chaine:=NomTemp;
              2:Chaine:=PrenomTemp;
              3:Chaine:=AgeTemp;
              4:Chaine:=ClubTemp;
            end;
            Ok:=false; Avorter:=false;
            repeat
              case Rubrique of
                1:begin
                    txtmove(c+11,l+1);
                    Resultat:=txtvalidate2(Chaine,Chaine,15,OptionLecture2,hlp_InscriptionJoueur,[0..255]);
                  end;
                2:begin
                    txtmove(c+40,l+1);
                    Resultat:=txtvalidate2(Chaine,Chaine,15,OptionLecture1,hlp_InscriptionJoueur,[0..255]);
                    Chaine[1]:= upcase(Chaine[1]);
                    for i:=1 to (length(Chaine)-1) do if Chaine[i] = '-' then Chaine[i+1]:=upcase(Chaine[i+1]);
                  end;
                3:begin
                    txtmove(c+11,l+2);
                    Resultat:=txtvalidate2(Chaine,Chaine,2,OptionLecture1,hlp_InscriptionJoueur,[48..57]);
                  end;
                4:begin
                    txtmove(c+35,l+2);
                    Resultat:=txtvalidate2(Chaine,Chaine,20,OptionLecture1,hlp_InscriptionJoueur,[0..255]);
                    Chaine[1]:=upcase(Chaine[1]);
                  end;
              end;
              if (Resultat and tv_Escape = 0) and (length(Chaine) > 0) and (Chaine[1] <> ' ')
                 then
                   begin
                     case Rubrique of
                       1:NomTemp:=Chaine;
                       2:PrenomTemp:=Chaine;
                       3:AgeTemp:=Chaine;
                       4:ClubTemp:=Chaine;
                     end;
                     Ok:=true;
                   end
                 else
                   Avorter:=true;
            until (Ok) or (Avorter);
            txtcursoff; ECRITURE_RUBRIQUE;
            if (Resultat = tv_Enter) or (Resultat = tv_ArDn) or (Resultat = tv_TabRi)
               then
                 inc(Rubrique)
               else
                 if (Resultat = tv_PgDn) or (Resultat = tv_CtrlEnd) or (Resultat = tv_CtrlPgDn)
                    then
                      Rubrique:=5
                    else
                      if Resultat = tv_Escape
                         then
                           Rubrique:=6
                         else
                           if (Resultat = tv_ArUp) or (Resultat = tv_TabLe)
                              then
                                begin
                                  if Rubrique = 1 then Rubrique:=6 else dec(Rubrique);
                                end
                              else
                                if (Resultat = tv_PgUp) or (Resultat = tv_CtrlHome) or (Resultat = tv_CtrlPgUp)
                                   then
                                     Rubrique:=1;
          End;
Begin
  case ModeEcran of
    ModeMono:begin
               Fond1:=lightgrey; Normal1:=black; Fond2:=black; Brillant:=white;
               Fond3:=lightgrey; Normal3:=white; FondOmbre:=black; Ombre:=lightgrey;
             end;
    ModeCouleur:begin
                  Fond1:=blue; Normal1:=yellow; Fond2:=brown; Brillant:=white;
                  Fond3:=blue; Normal3:=white; FondOmbre:=black; Ombre:=lightgrey;
                end;
  end;
  x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; x:=windx; y:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image);
  txtback(Fond1); txtcolour(Normal1);
  txtmove(c,l);   txtwrite(' ͻ ');
  txtmove(c,l+1); txtwrite('   Nom : <               >   Prnom : <               >   ');
  txtmove(c,l+2); txtwrite('   Age : <  >             Club : <                    >   ');
  txtmove(c,l+3); txtwrite('            <          >         <           >            ');
  txtmove(c,l+4); txtwrite(' ͼ ');
  txtback(FondOmbre); txtcolour(Ombre);
  for Ligne:=1 to (nbl-1) do
    begin
      txtmove(c+lg,l+Ligne); txtattrib(2);
    end;
  txtmove(c+2,l+nbl); txtattrib(lg);
  txtback(Fond1); txtcolour(Brillant);
  txtmove(30,l); txtwrite(' Donnes du joueur ');
  txtback(Fond3); txtcolour(Normal3);
  txtmove(c+14,l+3); txtwrite('    OK    '); txtmove(c+35,l+3); txtwrite('  Annuler  ');
  with Joueur do
    begin
      NomTemp:=NomJoueur; PrenomTemp:=PrenomJoueur; AgeTemp:=Age; ClubTemp:=Club;
    end;
  for Rubrique:=1 to 4 do ECRITURE_RUBRIQUE;
  OptionLecture1:=tv_ArUp or tv_ArDn or tv_PgUp or tv_PgDn or tv_CtrlHome or tv_CtrlPgUp or tv_CtrlEnd or
                  tv_CtrlPgDn or tv_TabLe or tv_TabRi;
  OptionLecture2:=OptionLecture1 or tv_Upcase;
  txtflush; mouseeventparams.me_modified:=false; 
  Ok:=false; Avorter:=false; Rubrique:=1; RUBRIQUE_ALLUMEE; MESSAGE_BAS_ECRAN(ip_ModificationJoueur + 1);
  txtsimulatekey(13,28); if Souris then Void:=txtmousecurson;
  repeat
    if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
    if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   59:begin   (* F1 : AIDE *)
                        if Souris then Void:=txtmousecursoff;
                        AIDE(hlp_InscriptionJoueur);
                        if Souris then Void:=txtmousecurson;
                      end;
                   15,72,75:begin   (* TAB GAUCHE / FLECHE HAUT / FLECHE GAUCHE : RUBRIQUE PRECEDENTE *)
                              if Souris then Void:=txtmousecursoff;
                              RUBRIQUE_ETEINTE;
                              case Rubrique of
                                1:Rubrique:=6;
                                6:Rubrique:=5;
                              else
                                dec(Rubrique); txtsimulatekey(13,28);
                              end;
                              RUBRIQUE_ALLUMEE; MESSAGE_BAS_ECRAN(ip_ModificationJoueur + Rubrique);
                              if Souris then Void:=txtmousecurson;
                            end;
                   71,73,119,132:begin   (* (CTRL-)HOME / (CTRL-)PgUp : RUBRIQUE 1 *)
                                   if Rubrique <> 1
                                      then
                                        begin
                                          if Souris then Void:=txtmousecursoff;
                                          RUBRIQUE_ETEINTE; Rubrique:=1; txtsimulatekey(13,28); RUBRIQUE_ALLUMEE;
                                          MESSAGE_BAS_ECRAN(ip_ModificationJoueur + Rubrique);
                                          if Souris then Void:=txtmousecurson;
                                        end;
                                 end;
                   77,80:begin   (* FLECHE DROITE / FLECHE BAS : RUBRIQUE SUIVANTE *)
                           if Souris then Void:=txtmousecursoff;
                           RUBRIQUE_ETEINTE;
                           case Rubrique of
                             4,5:inc(Rubrique);
                             6:begin Rubrique:=1; txtsimulatekey(13,28);  end;
                           else
                             inc(Rubrique); txtsimulatekey(13,28);
                           end;
                           RUBRIQUE_ALLUMEE; MESSAGE_BAS_ECRAN(ip_ModificationJoueur + Rubrique);
                           if Souris then Void:=txtmousecurson;
                         end;
                   79,81,117,118:begin   (* (CTRL-)END / (CTRL-)PgDn : BOUTON "OK" *)
                                   if Rubrique < 5
                                      then
                                        begin
                                          if Souris then Void:=txtmousecursoff;
                                          RUBRIQUE_ETEINTE; Rubrique:=5; RUBRIQUE_ALLUMEE;
                                          MESSAGE_BAS_ECRAN(ip_ModificationJoueur + Rubrique);
                                          if Souris then Void:=txtmousecurson;
                                        end;
                                 end;
                   97:begin   (* CTRL-F4 : DEBOGAGE *)
                        if Souris then Void:=txtmousecursoff;
                        DEBOGAGE;
                        if Souris then Void:=txtmousecurson;
                      end;
                 end;
               end;
             9:begin   (* TAB DROITE : RUBRIQUE SUIVANTE *)
                 if Souris then Void:=txtmousecursoff;
                 RUBRIQUE_ETEINTE;
                 case Rubrique of
                   4,5:inc(Rubrique);
                   6:begin Rubrique:=1; txtsimulatekey(13,28);  end;
                 else
                   inc(Rubrique); txtsimulatekey(13,28);
                 end;
                 RUBRIQUE_ALLUMEE; MESSAGE_BAS_ECRAN(ip_ModificationJoueur + Rubrique);
                 if Souris then Void:=txtmousecurson;
               end;
             13:begin   (* ENTER : ENCODAGE RUBRIQUE OU "OK" OU "ANNULER" *)
                  case Rubrique of
                    1..4:begin   (* ENCODAGE RUBRIQUE *)
                           if Souris then Void:=txtmousecursoff;
                           RUBRIQUE_ETEINTE; ENCODAGE_RUBRIQUE; RUBRIQUE_ALLUMEE;
                           if Rubrique in [1..4] then txtsimulatekey(13,28);
                           MESSAGE_BAS_ECRAN(ip_ModificationJoueur + Rubrique);
                           if Souris then Void:=txtmousecurson;
                         end;
                    5:Ok:=(length(NomTemp) > 0);   (* BOUTON "OK" *)
                    6:Avorter:=true;   (* BOUTON "ANNULER" *)
                  end;
                end;
             27:begin   (* ESCAPE : BOUTON "ANNULER" *)
                  if Souris then Void:=txtmousecursoff;
                  RUBRIQUE_ETEINTE; Rubrique:=6; RUBRIQUE_ALLUMEE;
                  MESSAGE_BAS_ECRAN(ip_ModificationJoueur + 4);
                  if Souris then Void:=txtmousecurson;
                end;
           end;
         end;
    if mouseeventparams.me_modified
       then
         begin
           with mouseeventparams do
             begin
               if (me_y = (l+1)) and (me_x in [(c+11)..(c+25)])
                  then
                    begin   (* ENCODAGE DU NOM *)
                      Void:=txtmousecursoff;
                      RUBRIQUE_ETEINTE; Rubrique:=1; ENCODAGE_RUBRIQUE; RUBRIQUE_ALLUMEE;
                      if Rubrique in [1..4] then txtsimulatekey(13,28);
                      MESSAGE_BAS_ECRAN(ip_ModificationJoueur + Rubrique);
                      Void:=txtmousecurson;
                    end
                  else
                    if (me_y = (l+1)) and (me_x in [(c+40)..(c+54)])
                       then
                         begin   (* ENCODAGE DU PRENOM *)
                           Void:=txtmousecursoff;
                           RUBRIQUE_ETEINTE; Rubrique:=2; ENCODAGE_RUBRIQUE; RUBRIQUE_ALLUMEE;
                           if Rubrique in [1..4] then txtsimulatekey(13,28);
                           MESSAGE_BAS_ECRAN(ip_ModificationJoueur + Rubrique);
                           Void:=txtmousecurson;
                         end
                       else
                         if (me_y = (l+2)) and (me_x in [(c+11)..(c+12)])
                            then
                              begin   (* ENCODAGE DE L'AGE *)
                                Void:=txtmousecursoff;
                                RUBRIQUE_ETEINTE; Rubrique:=3; ENCODAGE_RUBRIQUE; RUBRIQUE_ALLUMEE;
                                if Rubrique in [1..4] then txtsimulatekey(13,28);
                                MESSAGE_BAS_ECRAN(ip_ModificationJoueur + Rubrique);
                                Void:=txtmousecurson;
                              end
                            else
                              if (me_y = (l+2)) and (me_x in [(c+35)..(c+54)])
                                 then
                                   begin   (* ENCODAGE DU CLUB *)
                                     Void:=txtmousecursoff;
                                     RUBRIQUE_ETEINTE; Rubrique:=4; ENCODAGE_RUBRIQUE; RUBRIQUE_ALLUMEE;
                                     if Rubrique in [1..4] then txtsimulatekey(13,28);
                                     MESSAGE_BAS_ECRAN(ip_ModificationJoueur + Rubrique);
                                     Void:=txtmousecurson;
                                   end
                                 else
                                   if (me_y = (l+3)) and (me_x in [(c+14)..(c+23)])
                                      then   (* BOUTON "OK" *)
                                        Ok:=(length(NomTemp) > 0)
                                      else
                                        if (me_y = (l+3)) and (me_x in [(c+35)..(c+45)])
                                           then   (* BOUTON "ANNULER" *)
                                             Avorter:=true;
               me_modified:=false;
             end;
         end;
  until (Ok) or (Avorter);
  if Souris then Void:=txtmousecursoff;
  if Avorter
     then
       MODIFICATION_PARAMETRES_JOUEUR:=mp_Avorter
     else
       with Joueur do
         begin
           if (NomJoueur = NomTemp) and (PrenomJoueur = PrenomTemp)
              then MODIFICATION_PARAMETRES_JOUEUR:=mp_Ok
              else MODIFICATION_PARAMETRES_JOUEUR:=mp_OkModifie;
           NomJoueur:=NomTemp; PrenomJoueur:=PrenomTemp; Age:=AgeTemp; Club:=ClubTemp;
         end;
  txtload(Image); txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


END.
