
UNIT TTO_POUL;

(* MODULES RELATIFS AUX POULES POUR LE PROGRAMME TTO VERSION 1.20 *)

INTERFACE

Uses TXT,        (* GESTION DE L'ECRAN EN MODE TEXTE *)
     TTO_DECL,   (* DECLARATION DES CONSTANTES, TYPES ET VARIABLES GLOBALES *)
     TTO_HARD,   (* GESTION DE LA SOURIS ET ECONOMISEUR D'ECRAN *)
     TTO_COMN,   (* EXPLICATIONS AU BAS DE L'ECRAN ET MESSAGES D'ERREUR OU D'AVERTISSEMENT *)
     TTO_LIST,   (* GESTION DES LISTES CHAINEES DE POINTEURS *)
     TTO_FILE,   (* SAUVETAGE AUTOMATIQUE SUR DISQUE *)
     TTO_GENE,   (* PROCEDURE TXTVALIDATE2 *)
     TTO_HELP;   (* AIDE CONTEXTUELLE ET DEBOGAGE *)


Function LECTURE_NOMBRE_POULES (Numero : byte) : word;
   (* LECTURE DU NOMBRE DE POULES A CREER  *)
Function REPARTITION_JOUEURS_DANS_POULES (Numero : byte; NbJoueurs : word; pTeteLJ, pQueueLJ : pListeJoueurs) : boolean;
   (* REPARTITION DES JOUEURS DANS LES DIFFERENTES POULES *)


IMPLEMENTATION

Function LECTURE_NOMBRE_POULES (Numero : byte) : word;
(* LECTURE DU NOMBRE DE POULES A CREER. RENVOIE 0 SI ANNULER *)
Const c=19; l=10; lg=42;
Var Fond1,Normal1,Fond2,Brillant,Fond3,Normal3,FondOmbre,Ombre:word;
    x,y,x1,y1,x2,y2,FondCourant,CouleurCourante:word;
    Image:videosave;
    Rubrique:byte;
    Fin:boolean;
    Entree:char;
    OptionLecture,Nombre:word;
          Procedure RUBRIQUE_ALLUMEE;
          (* MISE EN SURBRILLANCE DE LA RUBRIQUE COURANTE *)
          Begin
            txtback(Fond2); txtcolour(Brillant);
            case Rubrique of
              1:begin txtmove(c+32,l+1); txtattrib(5); end;
              2:begin txtmove(c+8,l+2); txtattrib(10); end;
              3:begin txtmove(c+23,l+2); txtattrib(11); end;
            end;
          End;
          Procedure RUBRIQUE_ETEINTE;
          (* FIN DE LA MISE EN SURBRILLANCE DE LA RUBRIQUE COURANTE *)
          Begin
            txtback(Fond3); txtcolour(Normal3);
            case Rubrique of
              1:begin txtmove(c+32,l+1); txtattrib(5); end;
              2:begin txtmove(c+8,l+2); txtattrib(10); end;
              3:begin txtmove(c+23,l+2); txtattrib(11); end;
            end;
          End;
          Procedure AFFICHAGE_NOMBRE;
          (* AFFICHAGE DU NOMBRE DE POULES *)
          Begin
            txtback(Fond3); txtcolour(Normal3);
            txtmove(c+32,l+1); txtwrite('     '); txtmove(c+32,l+1); txtnumwrite(Nombre,0);
          End;
          Procedure LECTURE_NOMBRE;
          (* LECTURE DU NOMBRE DE POULES *)
          Var Ok:boolean;
              Chaine:string;
              r,Valeur:word;
              Erreur:integer;
          Begin
            txtback(Fond2); txtcolour(Brillant);
            txtflush; txtcurssize(CurseurHaut,CurseurBas); Ok:=false;
            if Nombre < 2 then Chaine:='2' else str(Nombre,Chaine);
            repeat
              txtmove(c+32,l+1); r:=txtvalidate2(Chaine,Chaine,5,OptionLecture,hlp_DivisionPoules,[48..57]);
              if r = tv_Escape
                 then
                   Ok:=true
                 else
                   begin
                     val(Chaine,Valeur,Erreur);
                     if (Erreur = 0) and (Valeur > 1) then begin Ok:=true; Nombre:=Valeur; end;
                   end;
            until Ok;
            txtcursoff; AFFICHAGE_NOMBRE;
            if (r = tv_Escape) or (r = tv_ArUp) or (r = tv_TabLe) then Rubrique:=3 else Rubrique:=2;
          End;
          Procedure SELECTION_RUBRIQUE;
          (* REACTION A LA SELECTION D'UNE RUBRIQUE *)
          Begin
            if Souris then Void:=txtmousecursoff;
            case Rubrique of
              1:begin RUBRIQUE_ETEINTE; LECTURE_NOMBRE; RUBRIQUE_ALLUMEE; end;
              2:Fin:=true;
              3:begin Fin:=true; Nombre:=0; end;
            end;
            if Souris then Void:=txtmousecurson;
          End;
Begin
  case ModeEcran of
    ModeMono:begin
               Fond1:=lightgrey; Fond2:=black; Normal1:=black; Brillant:=white;
               Fond3:=lightgrey; Normal3:=white; FondOmbre:=black; Ombre:=lightgrey;
             end;
    ModeCouleur:begin
                  Fond1:=blue; Fond2:=brown; Normal1:=yellow; Brillant:=white;
                  Fond3:=blue; Normal3:=white; FondOmbre:=black; Ombre:=lightgrey;
                end;
  end;
  x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; x:=windx; y:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image);
  txtback(Fond1); txtcolour(Normal1);
  txtmove(c,l);   txtwrite(' ͻ ');
  txtmove(c,l+1); txtwrite('   Nombre de poules  crer : <     >   ');
  txtmove(c,l+2); txtwrite('      <    Ok    >   <  Annuler  >      ');
  txtmove(c,l+3); txtwrite(' ͼ ');
  txtcolour(Brillant); txtmove(c+11,l); txtwrite(' Division en poules ');
  txtback(FondOmbre); txtcolour(Ombre);
  for Rubrique:=1 to 3 do
    begin
      txtmove(c+lg,l+Rubrique); txtattrib(2);
    end;
  txtmove(c+2,l+4); txtattrib(lg);
  (* INITIALISATIONS *)
  Nombre:=Categories[Numero].NbPoules;
  OptionLecture:=tv_ArUp or tv_ArDn or tv_PgUp or tv_PgDn or tv_CtrlHome or tv_CtrlPgUp or tv_CtrlEnd or
                 tv_CtrlPgDn or tv_TabLe or tv_TabRi;
  (* LECTURE DU CLAVIER ET DE LA SOURIS *)
  txtflush; mouseeventparams.me_modified:=false; MESSAGE_BAS_ECRAN(ip_DivisionPoules + 1);
  Fin:=false; Rubrique:=1; RUBRIQUE_ALLUMEE; if Souris then Void:=txtmousecurson; txtsimulatekey(13,28);
  repeat
    if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
    if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   59:begin   (* F1 : AIDE *)
                        if Souris then Void:=txtmousecursoff;
                        AIDE(hlp_DivisionPoules);
                        if Souris then Void:=txtmousecurson;
                      end;
                   15,72:begin   (* TAB GAUCHE / FLECHE HAUT : RUBRIQUE PRECEDENTE *)
                           if Souris then Void:=txtmousecursoff;
                           RUBRIQUE_ETEINTE;
                           case Rubrique of
                             1:Rubrique:=3;
                             2:begin Rubrique:=1; txtsimulatekey(13,28); end;
                             3:Rubrique:=2;
                           end;
                           RUBRIQUE_ALLUMEE; MESSAGE_BAS_ECRAN(ip_DivisionPoules + Rubrique);
                           if Souris then Void:=txtmousecurson;
                         end;
                   73,119,132:begin   (* (CTRL-)PgUp / CTRL-HOME : RUBRIQUE 1 *)
                                if Rubrique <> 1
                                   then
                                     begin
                                       if Souris then Void:=txtmousecursoff;
                                       RUBRIQUE_ETEINTE; Rubrique:=1; txtsimulatekey(13,28); RUBRIQUE_ALLUMEE;
                                       MESSAGE_BAS_ECRAN(ip_DivisionPoules + Rubrique);
                                       if Souris then Void:=txtmousecurson;
                                     end;
                              end;
                   80:begin   (* FLECHE BAS : RUBRIQUE SUIVANTE *)
                        if Souris then Void:=txtmousecursoff;
                        RUBRIQUE_ETEINTE;
                        case Rubrique of
                          1,2:inc(Rubrique);
                          3:begin Rubrique:=1; txtsimulatekey(13,28); end;
                        end;
                        RUBRIQUE_ALLUMEE; MESSAGE_BAS_ECRAN(ip_DivisionPoules + Rubrique);
                        if Souris then Void:=txtmousecurson;
                      end;
                   81,117,118:begin   (* (CTRL-)PgDn / CTRL-END : RUBRIQUE 2 *)
                                if Rubrique = 1
                                   then
                                     begin
                                       if Souris then Void:=txtmousecursoff;
                                       RUBRIQUE_ETEINTE; Rubrique:=2; RUBRIQUE_ALLUMEE;
                                       MESSAGE_BAS_ECRAN(ip_DivisionPoules + Rubrique);
                                       if Souris then Void:=txtmousecurson;
                                     end;
                              end;
                   97:begin   (* CTR-F4 : DEBOGAGE *)
                        if Souris then Void:=txtmousecursoff;
                        DEBOGAGE;
                        if Souris then Void:=txtmousecurson;
                      end;
                 end;
               end;
             9:begin   (* TAB DROITE : RUBRIQUE SUIVANTE *)
                 if Souris then Void:=txtmousecursoff;
                 RUBRIQUE_ETEINTE;
                 case Rubrique of
                   1,2:inc(Rubrique);
                   3:begin Rubrique:=1; txtsimulatekey(13,28); end;
                 end;
                 RUBRIQUE_ALLUMEE; MESSAGE_BAS_ECRAN(ip_DivisionPoules + Rubrique);
                 if Souris then Void:=txtmousecurson;
               end;
             13:begin   (* ENTER : SELECTION D'UNE RUBRIQUE *)
                  if Souris then Void:=txtmousecursoff;
                  SELECTION_RUBRIQUE; MESSAGE_BAS_ECRAN(ip_DivisionPoules + Rubrique);
                  if Souris then Void:=txtmousecurson;
                end;
             27:begin   (* ESCAPE : SURBRILLER LE BOUTON "ANNULER" *)
                  if Rubrique <> 3
                     then
                       begin
                         if Souris then Void:=txtmousecursoff;
                         RUBRIQUE_ETEINTE; Rubrique:=3; RUBRIQUE_ALLUMEE;
                         MESSAGE_BAS_ECRAN(ip_DivisionPoules + 3);
                         if Souris then Void:=txtmousecurson;
                       end;
                end;
           end;
         end;
    if mouseeventparams.me_modified
       then
         with mouseeventparams do
           begin
             if (me_y = (l+1)) and (me_x in [(c+32)..(c+36)])
                then
                  begin
                    Rubrique:=1; SELECTION_RUBRIQUE;
                  end
                else
                  if (me_y = (l+2)) and (me_x in [(c+8)..(c+17)])
                     then
                       begin
                         Rubrique:=2; SELECTION_RUBRIQUE;
                       end
                     else
                       if (me_y = (l+2)) and (me_x in [(c+23)..(c+33)])
                          then
                            begin
                              Rubrique:=3; SELECTION_RUBRIQUE;
                            end;
             me_modified:=false;
           end;
  until Fin;
  if Souris then Void:=txtmousecursoff;
  LECTURE_NOMBRE_POULES:=Nombre;
  txtload(Image); txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


Procedure AFFICHAGE_CONTENU_POULE (Numero : byte; NumeroPoule : word);
(* AFFICHAGE DES JOUEURS DE LA POULE NumeroPoule DE LA CATEGORIE Numero.
   CETTE PROCEDURE EST UTILISEE PAR LES PROCEDURES MENU_POULE_JOUEUR ET REPARTITION_JOUEURS_DANS_POULES. *)
Const c=40; lg=39;
Var x,y,x1,y1,x2,y2,FondCourant,CouleurCourante:word;
    Fond,Normal,Brillant:word;
    n:byte;
    NbJ:word;
    Chaine:string[5];
    pJ:pJoueur;
Begin
  case ModeEcran of
    ModeMono:begin Fond:=lightgrey; Normal:=black; Brillant:=white; end;
    ModeCouleur:begin Fond:=magenta; Normal:=yellow; Brillant:=white; end;
  end;
  x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; x:=windx; y:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtback(Fond); txtcolour(Normal);
  txtwind(c+2,2,c+lg-3,22); txtclear; txtunwind;
  n:=2; pJ:=Categories[Numero].pTeteJoueurs; NbJ:=0;
  while (pJ <> nil) and (n <= 22) do
    begin
      if (pJ^.Poule = NumeroPoule) and (pJ^.EnLice)
         then
           begin
             txtmove(c+4,n); txtwrite(pJ^.NomJoueur); txtmove(c+20,n); txtwrite(pJ^.PrenomJoueur);
             inc(n); inc(NbJ);
           end;
      pJ:=pJ^.pSuiv;
    end;
  (* AFFICHAGE DU TITRE ET DU NOMBRE DE JOUEURS *)
  txtmove(c,1); txtwrite(' ͻ ');
  txtmove(c,23); txtwrite(' ͼ ');
  txtcolour(Brillant);
  str(NumeroPoule,Chaine); txtmove(c+((39-(25+length(Chaine))) div 2),1);
  txtwrite(' Contenu de la poule n '); txtnumwrite(NumeroPoule,0); txtwrite(' ');
  str(NbJ,Chaine); txtmove(c+((39-(22+length(Chaine))) div 2),23);
  txtwrite(' Nombre de joueurs : '); txtnumwrite(NbJ,0); txtwrite(' ');
  txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


Function MENU_POULE_JOUEUR (Numero : byte; Joueur : EnregJ) : word;
(* MENU D'ATTRIBUTION D'UN N DE POULE A UN JOUEUR DE LA CATEGORIE Numero.
   PERMET DE PARCOURIR LA LISTE DES JOUEURS DE LA POULE ACTUELLE.
   RETOURNE LE NOUVEAU N DE POULE SI OK OU 0 SI ANNULER. *)
Const c=0; l=7; lg=39;
Var x1,y1,x2,y2,x,y,FondCourant,CouleurCourante:word;
    Image:videosave;
    Fond1,Normal1,Fond2,Brillant,Fond3,Normal3,FondOmbre,Ombre:word;
    Rubrique:byte;
    OptionLecture,Valeur:word;
    PouleTemp:string[5];
    Erreur:integer;
    Entree:char;
    Fin:boolean;
          Procedure ECRITURE_RUBRIQUE;
          (* ECRITURE DE LA VALEUR D'UNE RUBRIQUE *)
          Begin
            txtback(Fond3); txtcolour(Normal3);
            case Rubrique of
              1:begin txtmove(c+14,l+1); txtwrite('               '); txtmove(c+14,l+1); txtwrite(Joueur.NomJoueur); end;
              2:begin txtmove(c+14,l+2); txtwrite('               '); txtmove(c+14,l+2); txtwrite(Joueur.PrenomJoueur); end;
              3:begin txtmove(c+14,l+3); txtwrite('  '); txtmove(c+14,l+3); txtwrite(Joueur.Age); end;
              4:begin txtmove(c+14,l+4); txtwrite('                    '); txtmove(c+14,l+4); txtwrite(Joueur.Club); end;
              5:begin txtmove(c+27,l+5); txtwrite('     '); txtmove(c+27,l+5);txtnumwrite(Categories[Numero].NbPoules,0); end;
              6:begin txtmove(c+28,l+7); txtwrite('     '); txtmove(c+28,l+7); txtwrite(PouleTemp); end;
            end;
          End;
          Procedure RUBRIQUE_ALLUMEE;
          (* MISE EN EVIDENCE DE LA RUBRIQUE COURANTE *)
          Begin
            txtback(Fond2); txtcolour(Brillant);
            case Rubrique of
              6:begin txtmove(c+28,l+7); txtattrib(5); end;
              7:begin txtmove(c+10,l+8); txtattrib(19); end;
              8:begin txtmove(c+6,l+9); txtattrib(10); end;
              9:begin txtmove(c+22,l+9); txtattrib(11); end;
            end;
          End;
          Procedure RUBRIQUE_ETEINTE;
          (* FIN DE LA MISE EN EVIDENCE DE LA RUBRIQUE COURANTE *)
          Begin
            txtback(Fond3); txtcolour(Normal3);
            case Rubrique of
              6:begin txtmove(c+28,l+7); txtattrib(5); end;
              7:begin txtmove(c+10,l+8); txtattrib(19); end;
              8:begin txtmove(c+6,l+9); txtattrib(10); end;
              9:begin txtmove(c+22,l+9); txtattrib(11); end;
            end;
          End;
          Procedure ENCODAGE_POULE;
          (* ENCODAGE DU N DE POULE SAUT A UNE AUTRE RUBRIQUE *)
          Var i:byte;
              Ok,Avorter:boolean;
              Valeur,Resultat:word;
              Chaine:string;
          Begin
            txtflush; txtcurssize(CurseurHaut,CurseurBas); txtback(Fond2); txtcolour(Brillant);
            Chaine:=PouleTemp; Ok:=false; Avorter:=false;
            repeat
              txtmove(c+28,l+7); Resultat:=txtvalidate2(Chaine,Chaine,5,OptionLecture,hlp_DivisionPoules+35,[48..57]);
              if (Resultat and tv_Escape = 0) and (length(Chaine) > 0)
                 then
                   begin
                     val(Chaine,Valeur,Erreur);
                     if (Erreur = 0) and (Valeur > 0) and (Valeur <= Categories[Numero].NbPoules)
                        then
                          begin
                            PouleTemp:=Chaine; Ok:=true;
                          end;
                   end
                 else
                   Avorter:=true;
            until (Ok) or (Avorter);
            txtcursoff; ECRITURE_RUBRIQUE;
            if (Resultat = tv_Enter) or (Resultat = tv_ArDn) or (Resultat = tv_TabRi)
               then
                 Rubrique:=7
               else
                 if (Resultat = tv_PgDn) or (Resultat = tv_CtrlEnd) or (Resultat = tv_CtrlPgDn)
                    then
                      Rubrique:=8
                    else
                      if (Resultat = tv_Escape) or (Resultat = tv_ArUp) or (Resultat = tv_TabLe)
                         then
                           Rubrique:=9;
          End;
Begin
  case ModeEcran of
    ModeMono:begin
               Fond1:=lightgrey; Normal1:=black; Fond2:=black; Brillant:=white;
               Fond3:=lightgrey; Normal3:=white; FondOmbre:=black; Ombre:=lightgrey;
             end;
    ModeCouleur:begin
                  Fond1:=magenta; Normal1:=yellow; Fond2:=green; Brillant:=white;
                  Fond3:=magenta; Normal3:=white; FondOmbre:=black; Ombre:=lightgrey;
                end;
  end;
  x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; x:=windx; y:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image);
  txtback(Fond1); txtcolour(Normal1);
  txtmove(c,l);    txtwrite(' ͻ ');
  txtmove(c,l+1);  txtwrite('   Nom    : <               >        ');
  txtmove(c,l+2);  txtwrite('   Prnom : <               >        ');
  txtmove(c,l+3);  txtwrite('   Age    : <  >                     ');
  txtmove(c,l+4);  txtwrite('   Club   : <                    >   ');
  txtmove(c,l+5);  txtwrite('   Nb poules catgorie : <     >     ');
  txtmove(c,l+6);  txtwrite(' Ķ ');
  txtmove(c,l+7);  txtwrite('    Nouveau n de poule : <     >    ');
  txtmove(c,l+8);  txtwrite('       <                     >       ');
  txtmove(c,l+9);  txtwrite('    <          >    <           >    ');
  txtmove(c,l+10); txtwrite(' ͼ ');
  txtback(FondOmbre); txtcolour(Ombre);
  for Rubrique:=1 to 10 do
    begin
      txtmove(c+lg,l+Rubrique); txtattrib(2);
    end;
  txtmove(c+2,l+11); txtattrib(lg);
  txtback(Fond1); txtcolour(Brillant);
  txtmove(c+5,l); txtwrite(' Attribution d''un n de poule ');
  txtback(Fond3); txtcolour(Normal3);
  txtmove(c+9,l+8); txtwrite(' Voir poule actuelle ');
  txtmove(c+6,l+9); txtwrite('    OK    '); txtmove(c+22,l+9); txtwrite('  Annuler  ');
  str(Joueur.Poule,PouleTemp);
  for Rubrique:=1 to 6 do ECRITURE_RUBRIQUE;
  OptionLecture:=tv_ArUp or tv_ArDn or tv_PgUp or tv_PgDn or tv_CtrlHome or tv_CtrlPgUp or tv_CtrlEnd or
                 tv_CtrlPgDn or tv_TabLe or tv_TabRi;
  txtflush; mouseeventparams.me_modified:=false; if Souris then Void:=txtmousecurson;
  Fin:=false; Rubrique:=6; RUBRIQUE_ALLUMEE; MESSAGE_BAS_ECRAN(ip_DivisionPoules + 4);
  txtsimulatekey(13,28);
  repeat
    if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
    if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   59:begin   (* F1 : AIDE *)
                        if Souris then Void:=txtmousecursoff;
                        AIDE(hlp_DivisionPoules + 35);
                        if Souris then Void:=txtmousecurson;
                      end;
                   15,72,75:begin   (* TAB GAUCHE / FLECHE HAUT / FLECHE GAUCHE : RUBRIQUE PRECEDENTE *)
                              if Souris then Void:=txtmousecursoff;
                              RUBRIQUE_ETEINTE;
                              case Rubrique of
                                6:Rubrique:=9;
                                7:begin Rubrique:=6; txtsimulatekey(13,28); end;
                              else
                                dec(Rubrique);
                              end;
                              RUBRIQUE_ALLUMEE; MESSAGE_BAS_ECRAN(ip_DivisionPoules + Rubrique - 2);
                              if Souris then Void:=txtmousecurson;
                            end;
                   71,73,119,132:begin   (* (CTRL-)HOME / (CTRL-)PgUp : RUBRIQUE 6 *)
                                   if Rubrique <> 6
                                      then
                                        begin
                                          if Souris then Void:=txtmousecursoff;
                                          RUBRIQUE_ETEINTE; Rubrique:=6; txtsimulatekey(13,28); RUBRIQUE_ALLUMEE;
                                          MESSAGE_BAS_ECRAN(ip_DivisionPoules + Rubrique - 2);
                                          if Souris then Void:=txtmousecurson;
                                        end;
                                 end;
                   77,80:begin   (* FLECHE DROITE / FLECHE BAS : RUBRIQUE SUIVANTE *)
                           if Souris then Void:=txtmousecursoff;
                           RUBRIQUE_ETEINTE;
                           case Rubrique of
                             9:begin Rubrique:=6; txtsimulatekey(13,28); end;
                           else
                             inc(Rubrique);
                           end;
                           RUBRIQUE_ALLUMEE; MESSAGE_BAS_ECRAN(ip_DivisionPoules + Rubrique - 2);
                           if Souris then Void:=txtmousecurson;
                         end;
                   79,81,117,118:begin   (* (CTRL-)END / (CTRL-)PgDn : BOUTON "OK" *)
                                   if Rubrique < 8
                                      then
                                        begin
                                          if Souris then Void:=txtmousecursoff;
                                          RUBRIQUE_ETEINTE; Rubrique:=8; RUBRIQUE_ALLUMEE;
                                          MESSAGE_BAS_ECRAN(ip_DivisionPoules + Rubrique - 2);
                                          if Souris then Void:=txtmousecurson;
                                        end;
                                 end;
                   97:begin   (* CTRL-F4 : DEBOGAGE *)
                        if Souris then Void:=txtmousecursoff;
                        DEBOGAGE;
                        if Souris then Void:=txtmousecurson;
                      end;
                 end;
               end;
             9:begin   (* TAB DROITE : RUBRIQUE SUIVANTE *)
                 if Souris then Void:=txtmousecursoff;
                 RUBRIQUE_ETEINTE;
                 case Rubrique of
                   9:begin Rubrique:=6; txtsimulatekey(13,28);  end;
                 else
                   inc(Rubrique);
                 end;
                 RUBRIQUE_ALLUMEE; MESSAGE_BAS_ECRAN(ip_DivisionPoules + Rubrique - 2);
                 if Souris then Void:=txtmousecurson;
               end;
             13:begin   (* ENTER : ENCODAGE RUBRIQUE OU "OK" OU "ANNULER" *)
                  case Rubrique of
                    6:begin   (* ENCODAGE N DE POULE *)
                        if Souris then Void:=txtmousecursoff;
                        RUBRIQUE_ETEINTE; ENCODAGE_POULE; RUBRIQUE_ALLUMEE;
                        MESSAGE_BAS_ECRAN(ip_DivisionPoules + Rubrique - 2);
                        if Souris then Void:=txtmousecurson;
                      end;
                    7:begin   (* AFFICHAGE CONTENU POULE ACTUELLE *)
                        if Souris then Void:=txtmousecursoff;
                        val(PouleTemp,Valeur,Erreur); AFFICHAGE_CONTENU_POULE(Numero,Valeur);
                        MESSAGE_BAS_ECRAN(ip_DivisionPoules + Rubrique - 2);
                        if Souris then Void:=txtmousecurson;
                      end;
                    8:begin   (* BOUTON "OK" *)
                        val(PouleTemp,Joueur.Poule,Erreur); Fin:=true;
                        MENU_POULE_JOUEUR:=Joueur.Poule;
                      end;
                    9:begin Fin:=true; MENU_POULE_JOUEUR:=0; end;   (* BOUTON "ANNULER" *)
                  end;
                end;
             27:begin   (* ESCAPE : BOUTON "ANNULER" *)
                  if Souris then Void:=txtmousecursoff;
                  RUBRIQUE_ETEINTE; Rubrique:=9; RUBRIQUE_ALLUMEE;
                  MESSAGE_BAS_ECRAN(ip_DivisionPoules + Rubrique - 2);
                  if Souris then Void:=txtmousecurson;
                end;
           end;
         end;
    if mouseeventparams.me_modified
       then
         begin
           with mouseeventparams do
             begin
               if (me_y = (l+7)) and (me_x in [(c+28)..(c+32)])
                  then
                    begin   (* ENCODAGE DU N DE POULE *)
                      Void:=txtmousecursoff;
                      RUBRIQUE_ETEINTE; Rubrique:=6; ENCODAGE_POULE; RUBRIQUE_ALLUMEE;
                      MESSAGE_BAS_ECRAN(ip_DivisionPoules + Rubrique - 2);
                      Void:=txtmousecurson;
                    end
                  else
                    if (me_y = (l+8)) and (me_x in [(c+8)..(c+26)])
                       then
                         begin   (* BOUTON "VOIR POULE ACTUELLE" *)
                           Void:=txtmousecursoff;
                           RUBRIQUE_ETEINTE; Rubrique:=7;
                           val(PouleTemp,Valeur,Erreur); AFFICHAGE_CONTENU_POULE(Numero,Valeur);
                           RUBRIQUE_ALLUMEE;
                           MESSAGE_BAS_ECRAN(ip_DivisionPoules + Rubrique - 2);
                           Void:=txtmousecurson;
                         end
                       else
                         if (me_y = (l+9)) and (me_x in [(c+6)..(c+15)])
                            then   (* BOUTON "OK" *)
                              begin
                                val(PouleTemp,Joueur.Poule,Erreur); Fin:=true;
                                MENU_POULE_JOUEUR:=Joueur.Poule;
                              end
                            else
                              if (me_y = (l+9)) and (me_x in [(c+22)..(c+32)])
                                 then   (* BOUTON "ANNULER" *)
                                   begin
                                     Fin:=true; MENU_POULE_JOUEUR:=0;
                                   end;
               me_modified:=false;
             end;
         end;
  until Fin;
  if Souris then Void:=txtmousecursoff;
  txtload(Image); txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


Function REPARTITION_JOUEURS_DANS_POULES (Numero : byte; NbJoueurs : word; pTeteLJ, pQueueLJ : pListeJoueurs) : boolean;
(* REPARTITION DES JOUEURS DE LA CATEGORIE Numero DANS LES DIFFERENTES POULES.
   LA LISTE DES JOUEURS EST POINTEE PAR pTeteLJ ET pQueueLJ. NbJoueurs EST LE NOMBRE DE JOUEURS DE LA LISTE.
   RETOURNE true SI LA REPARTITION EST MENEE A SON TERME, false SINON. *)
Const c1=0; lg1=33; c2=40; lg2=39; NbL=21; yHaut=2;
Var x1,y1,x2,y2,x,y,FondCourant,CouleurCourante:word;
    Image:videosave;
    Fond1,Normal1,Fond2,Brillant2,Fond3,Normal3,Brillant4:word;
    pLJ:pListeJoueurs;
    TableauPointeurs:array[1..NbL] of pListeJoueurs;
    JoueurHaut:word;
    Ligne:byte;
    Entree:char;
    Ok:boolean;
          Procedure LIGNE_ALLUMEE;
          (* MISE EN EVIDENCE DE LA LIGNE COURANTE DU CADRE DES JOUEURS *)
          Begin
            txtback(Fond2); txtcolour(Brillant2); txtmove(c1+3,Ligne); txtattrib(lg1);
          End;
          Procedure LIGNE_ETEINTE;
          (* FIN DE LA MISE EN EVIDENCE DE LA LIGNE COURANTE DU CADRE DES JOUEURS *)
          Begin
            txtback(Fond1); txtcolour(Normal1); txtmove(c1+3,Ligne); txtattrib(lg1);
          End;
          Procedure AFFICHAGE_JOUEUR (n:byte);
          (* AFFICHAGE DU JOUEUR CORRESPONDANT A TableauPointeurs[n] *)
          Begin
            txtback(Fond1); txtcolour(Normal1);
            txtmove(c1+4,n+1); txtwrite('                               ');
            with TableauPointeurs[n]^ do
              begin
                txtmove(c1+4,n+1); txtwrite(PointeurJoueur^.NomJoueur);
                txtmove(c1+20,n+1); txtwrite(PointeurJoueur^.PrenomJoueur);
              end;
          End;
          Procedure AFFICHAGE_PAGE;
          (* AFFICHAGE DES JOUEURS CORRESPONDANT A TableauPointeurs *)
          Var n:byte;
          Begin
            txtback(Fond1); txtcolour(Normal1);
            for n:=1 to NbL do
              if TableauPointeurs[n] = nil
                 then
                   begin
                     txtmove(c1+4,n+1); txtwrite('............... ...............');
                   end
                 else
                   AFFICHAGE_JOUEUR(n);
          End;
          Procedure PREMIER_JOUEUR;
          (* REMONTEE JUSQU'AU PREMIER JOUEUR *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pPrec <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if JoueurHaut > 1
                      then   (* SCROLLING *)
                        begin
                          i:=1; pLJ:=pTeteLJ;
                          while (i <= NbL) and (pLJ <> nil) do
                            begin
                              TableauPointeurs[i]:=pLJ; inc(i); if pLJ <> nil then pLJ:=pLJ^.pSuiv;
                            end;
                          JoueurHaut:=1; AFFICHAGE_PAGE;
                        end;
                   Ligne:=yHaut; LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure DERNIER_JOUEUR;
          (* DESCENTE JUSQU'AU DERNIER JOUEUR *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pSuiv <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if NbJoueurs > NbL
                      then   (* IL FAUDRA TESTER SI SCROLLING *)
                        begin
                          if JoueurHaut < (NbJoueurs - NbL + 1)
                             then   (* LE DERNIER JOUEUR N'EST PAS A L'ECRAN : SCROLLING *)
                               begin
                                 i:=NbL; pLJ:=pQueueLJ;
                                 while (i >= 1) and (pLJ <> nil) do
                                   begin
                                     TableauPointeurs[i]:=pLJ; dec(i); if pLJ <> nil then pLJ:=pLJ^.pPrec;
                                   end;
                                 Ligne:=yHaut + NbL - 1; JoueurHaut:=NbJoueurs - NbL + 1; AFFICHAGE_PAGE;
                               end
                             else   (* LE DERNIER JOUEUR EST A L'ECRAN *)
                               Ligne:=NbJoueurs - JoueurHaut + yHaut;
                        end
                      else   (* MOINS DE JOUEURS QUE DE LIGNES : DERNIER JOUEUR A L'ECRAN *)
                        Ligne:=NbJoueurs + yHaut - 1;
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure JOUEUR_PRECEDENT;
          (* REMONTEE AU JOUEUR PRECEDENT *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pPrec <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if Ligne = yHaut
                      then   (* SCROLLING *)
                        begin
                          for i:=NbL downto 2 do TableauPointeurs[i]:=TableauPointeurs[i-1];
                          TableauPointeurs[1]:=TableauPointeurs[1]^.pPrec; dec(JoueurHaut);
                          txtwind(c1+2,yHaut,c1+36,yHaut+NbL-1); txtinsdn(0); txtunwind; AFFICHAGE_JOUEUR(1);
                        end
                      else   (* PAS DE SCROLLING *)
                        dec(Ligne);
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure JOUEUR_SUIVANT;
          (* DESCENTE AU JOUEUR SUIVANT *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pSuiv <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if Ligne = (yHaut + NbL - 1)
                      then   (* SCROLLING *)
                        begin
                          for i:=1 to (NbL - 1) do TableauPointeurs[i]:=TableauPointeurs[i+1];
                          TableauPointeurs[NbL]:=TableauPointeurs[NbL]^.pSuiv; inc(JoueurHaut);
                          txtwind(c1+2,yHaut,c1+36,yHaut+NbL-1); txtdeldn(0); txtunwind; AFFICHAGE_JOUEUR(NbL);
                        end
                      else   (* PAS DE SCROLLING *)
                        inc(Ligne);
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure PAGE_PRECEDENTE;
          (* AFFICHAGE DE LA PAGE DE JOUEURS PRECEDENTE *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pPrec <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if JoueurHaut > (NbL - 1)
                      then   (* SCROLLING D'UNE PAGE ENTIERE *)
                        begin
                          pLJ:=TableauPointeurs[1]; TableauPointeurs[NbL]:=pLJ; pLJ:=pLJ^.pPrec;
                          for i:=(NbL - 1) downto 1 do
                            begin
                              TableauPointeurs[i]:=pLJ; pLJ:=pLJ^.pPrec;
                            end;
                          dec(JoueurHaut,NbL - 1); AFFICHAGE_PAGE;
                        end
                      else
                        if JoueurHaut > 1
                           then   (* PREMIERE PAGE *)
                             begin
                               i:=1; pLJ:=pTeteLJ;
                               while (i <= NbL) and (pLJ <> nil) do
                                 begin
                                   TableauPointeurs[i]:=pLJ; inc(i); if pLJ <> nil then pLJ:=pLJ^.pSuiv;
                                 end;
                               JoueurHaut:=1; AFFICHAGE_PAGE;
                             end
                           else   (* PAS DE SCROLLING *)
                             Ligne:=yHaut;
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure PAGE_SUIVANTE;
          (* AFFICHAGE DE LA PAGE DE JOUEURS SUIVANTE *)
          Var i:byte;
          Begin
            if TableauPointeurs[Ligne - yHaut + 1]^.pSuiv <> nil
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LIGNE_ETEINTE;
                   if NbJoueurs > (2 * (NbL - 1))
                      then   (* IL FAUDRA TESTER SI SCROLLING PAGE ENTIERE *)
                        begin
                          if JoueurHaut <= (NbJoueurs - 2 * (NbL - 1))
                             then   (* SCROLLING D'UNE PAGE ENTIERE *)
                               begin
                                 pLJ:=TableauPointeurs[NbL]; TableauPointeurs[1]:=pLJ; pLJ:=pLJ^.pSuiv;
                                 for i:=2 to NbL do
                                   begin
                                     TableauPointeurs[i]:=pLJ; pLJ:=pLJ^.pSuiv;
                                   end;
                                 inc(JoueurHaut,NbL - 1); AFFICHAGE_PAGE;
                               end
                             else
                               if JoueurHaut < (NbJoueurs - NbL + 1)
                                  then   (* AFFICHAGE DE LA DERNIERE PAGE *)
                                    begin
                                      i:=NbL; pLJ:=pQueueLJ;
                                      while (i >= 1) and (pLJ <> nil) do
                                        begin
                                          TableauPointeurs[i]:=pLJ; dec(i); if pLJ <> nil then pLJ:=pLJ^.pPrec;
                                        end;
                                      JoueurHaut:=NbJoueurs - NbL + 1; AFFICHAGE_PAGE;
                                    end
                                  else   (* DERNIERE PAGE DEJA AFFICHEE *)
                                    Ligne:=NbJoueurs - JoueurHaut + yHaut;
                        end
                      else
                        if NbJoueurs > NbL
                           then   (* IL FAUDRA TESTER SI SCROLLING *)
                             begin
                               if JoueurHaut < (NbJoueurs - NbL + 1)
                                  then   (* AFFICHAGE DE LA DERNIERE PAGE *)
                                    begin
                                      i:=NbL; pLJ:=pQueueLJ;
                                      while (i >= 1) and (pLJ <> nil) do
                                        begin
                                          TableauPointeurs[i]:=pLJ; dec(i); if pLJ <> nil then pLJ:=pLJ^.pPrec;
                                        end;
                                      JoueurHaut:=NbJoueurs - NbL + 1; AFFICHAGE_PAGE;
                                    end
                                  else   (* DERNIERE PAGE DEJA AFFICHEE *)
                                    Ligne:=NbJoueurs - JoueurHaut + yHaut;
                             end
                           else   (* MOINS DE JOUEURS QUE DE LIGNES : L'UNIQUE ET DERNIERE PAGE EST DEJA AFFICHEE *)
                             Ligne:=NbJoueurs + yHaut - 1;
                   LIGNE_ALLUMEE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Procedure SELECTION_JOUEUR;
          (* REACTION AU CHOIX D'UN JOUEUR : APPEL DE MENU_POULE_JOUEUR.
             EN RETOUR DE CE MENU, RECOIT LE N DE POULE CHOISI POUR LE JOUEUR OU 0 SI ANNULER. *)
          Var NumeroPoule:word;
              n:byte;
              p:pListeJoueurs;
          Begin
            if Souris then Void:=txtmousecursoff;
            LIGNE_ETEINTE;
            with TableauPointeurs[Ligne-1]^ do NumeroPoule:=MENU_POULE_JOUEUR(Numero,PointeurJoueur^);
            if NumeroPoule <> 0
               then
                 begin
                   (* ATTRIBUTION DU NOUVEAU N DE POULE AU JOUEUR *)
                   with TableauPointeurs[Ligne-1]^ do PointeurJoueur^.Poule:=NumeroPoule;
                   (* SUPPRESSION DU JOUEUR DANS LA LISTE *)
                   SUPPRESSION_JOUEUR_LISTE(TableauPointeurs[Ligne-1],pTeteLJ,pQueueLJ); dec(NbJoueurs);
                   (* TEST SI FIN OU SI AFFICHAGE POUR LA SUITE *)
                   if NbJoueurs = 0
                      then   (* FIN DE LA REPARTITION EN POULES *)
                        begin
                          Ok:=true; REPARTITION_JOUEURS_DANS_POULES:=true;
                        end
                      else   (* AFFICHAGE DES JOUEURS *)
                        begin
                          for n:=1 to 21 do TableauPointeurs[n]:=nil;
                          n:=1; p:=pTeteLJ;
                          while (n <= 21) and (p <> nil) do
                            begin
                              TableauPointeurs[n]:=p; inc(n); if p <> nil then p:=p^.pSuiv;
                            end;
                          JoueurHaut:=1;
                          if Souris then Void:=txtmousecursoff;
                          LIGNE_ETEINTE; AFFICHAGE_PAGE; Ligne:=2; LIGNE_ALLUMEE;
                          if Souris then Void:=txtmousecurson;
                        end;
                   (* AFFICHAGE DU CONTENU DE LA DERNIERE POULE VISIONNEE *)
                   AFFICHAGE_CONTENU_POULE(Numero,NumeroPoule);
                 end;
            LIGNE_ALLUMEE;
            if Souris then Void:=txtmousecurson;
          End;
Begin
  case ModeEcran of
    ModeMono:begin
               Fond1:=lightgrey; Normal1:=black; Fond2:=black; Brillant2:=white;
               Fond3:=lightgrey; Normal3:=black; Brillant4:=white;
             end;
    ModeCouleur:begin
                  Fond1:=blue; Normal1:=yellow; Fond2:=brown; Brillant2:=white;
                  Fond3:=magenta; Normal3:=yellow; Brillant4:=white;
                end;
  end;
  x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; x:=windx; y:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image);
  TITRE_HAUT_ECRAN(ip_DivisionPoules + 1);
  (* INITIALISATION DU TABLEAU DE POINTEURS DES JOUEURS *)
  for Ligne:=1 to NbL do TableauPointeurs[Ligne]:=nil;
  Ligne:=1; pLJ:=pTeteLJ;
  while (Ligne <= NbL) and (pLJ <> nil) do
    begin
      TableauPointeurs[Ligne]:=pLJ; inc(Ligne); if pLJ <> nil then pLJ:=pLJ^.pSuiv;
    end;
  JoueurHaut:=1;
  (* CADRE JOUEURS *)
  txtback(Fond1); txtcolour(Normal1);
  txtmove(c1,1); txtwrite(' ͻ ');
  for Ligne:=2 to 22 do
    begin
      txtmove(c1,Ligne); txtwrite('                                     ');
    end;
  txtmove(c1,23); txtwrite(' ͼ ');
  txtcolour(Brillant2);
  txtmove(c1+37,2); txtwrite(''); txtmove(c1+37,3); txtwrite(#30); txtmove(c1+37,4); txtwrite(#24);
  txtmove(c1+37,22); txtwrite(''); txtmove(c1+37,21); txtwrite(#31); txtmove(c1+37,20); txtwrite(#25);
  txtmove(c1+10,1); txtwrite(' Joueurs  rpartir ');
  (* CADRE CONTENU DE LA POULE *)
  txtback(Fond3); txtcolour(Normal3);
  txtmove(c2,1); txtwrite(' ͻ ');
  for Ligne:=2 to 22 do
    begin
      txtmove(c2,Ligne); txtwrite('                                     ');
    end;
  txtmove(c2,23); txtwrite(' ͼ ');
  AFFICHAGE_CONTENU_POULE(Numero,1);
  (* REPARTITION EN POULES *)
  MESSAGE_BAS_ECRAN(ip_DivisionPoules); AFFICHAGE_PAGE;
  txtflush; mouseeventparams.me_modified:=false;
  Ok:=false; Ligne:=yHaut; LIGNE_ALLUMEE; if Souris then Void:=txtmousecurson;
  repeat
    if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
    if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   59:begin   (* F1 : AIDE *)
                        if Souris then Void:=txtmousecursoff;
                        AIDE(hlp_DivisionPoules + 19);
                        if Souris then Void:=txtmousecurson;
                      end;
                   71,119,132:PREMIER_JOUEUR;   (* CTRL-PgUp / (CTRL-)HOME : JOUEUR 1 *)
                   72:JOUEUR_PRECEDENT;         (* FLECHE HAUT : JOUEUR PRECEDENT *)
                   73:PAGE_PRECEDENTE;          (* PgUp : PAGE PRECEDENTE *)
                   80:JOUEUR_SUIVANT;           (* FLECHE BAS : JOUEUR SUIVANT *)
                   81:PAGE_SUIVANTE;            (* PgDn : PAGE SUIVANTE *)
                   79,117,118:DERNIER_JOUEUR;   (* CTRL-PgDn / (CTRL-)END : DERNIER JOUEUR *)
                   97:begin   (* CTRL-F4 : DEBOGAGE *)
                        if Souris then Void:=txtmousecursoff;
                        DEBOGAGE;
                        if Souris then Void:=txtmousecurson;
                      end;
                 end;
               end;
             13:SELECTION_JOUEUR;   (* ENTER : SELECTION D'UN JOUEUR *)
             27:begin   (* ESCAPE : ANNULER *)
                  if MESSAGE_AVERTISSEMENT(ip_DivisionPoules + 2)
                     then
                       begin
                         Ok:=true; REPARTITION_JOUEURS_DANS_POULES:=false;
                       end;
                end;
           end;
         end;
    if mouseeventparams.me_modified
       then
         with mouseeventparams do
           begin
             if (me_x in [(c1+2)..(c1+36)]) and (me_y in [2..22])
                then   (* SELECTION D'UN JOUEUR *)
                  begin
                    if TableauPointeurs[me_y - 1] <> nil
                       then
                         begin
                           Ligne:=me_y; SELECTION_JOUEUR;
                         end;
                  end
                else
                  if me_x = (c1+37)
                     then
                       case me_y of
                         2:PREMIER_JOUEUR;
                         3:PAGE_PRECEDENTE;
                         4:JOUEUR_PRECEDENT;
                         20:JOUEUR_SUIVANT;
                         21:PAGE_SUIVANTE;
                         22:DERNIER_JOUEUR;
                       end;
             me_modified:=false;
           end;
  until Ok;
  if Souris then Void:=txtmousecursoff;
  txtload(Image); txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


END.
