
UNIT TTO_PRNT;

(* GESTION DES IMPRESSIONS POUR LE PROGRAMME TTO VERSION 1.20 *)

INTERFACE

Uses DOS,        (* APPEL DES INTERRUPTIONS POUR GERER L'IMPRIMANTE *)
     TXT,        (* GESTION DE L'ECRAN EN MODE TEXTE *)
     TTO_DECL,   (* DECLARATION DES CONSTANTES, TYPES ET VARIABLES GLOBALES *)
     TTO_HARD,   (* GESTION BAS NIVEAU DE LA SOURIS *)
     TTO_COMN,   (* EXPLICATIONS AU BAS DE L'ECRAN ET MESSAGES D'ERREUR *)
     TTO_LIST,   (* EXTRACTION DE LISTE CHAINEE DE JOUEURS *)
     TTO_FILE,   (* GESTION DES FICHIERS D'IMPRESSION *)
     TTO_HELP;   (* AIDE CONTEXTUELLE ET DEBOGAGE *)


Function INITIALISATION_FICHIER_IMPRESSION (Numero : byte) : boolean;
   (* INITIALISATION D'UN FICHIER D'IMPRESSION *)
Function MISE_A_JOUR_FICHIER_IMPRESSION (Numero : byte; pTeteListe : pListeJoueurs) : boolean;
   (* MISE A JOUR D'UN FICHIER D'IMPRESSION *)
Procedure AFFICHAGE_TEXTE_IMPRESSION (Numero : byte);
   (* AFFICHAGE DU CONTENU DU FICHIER D'IMPRESSION D'UNE CATEGORIE *)


IMPLEMENTATION

Function INITIALISATION_FICHIER_IMPRESSION (Numero : byte) : boolean;
(* LORS DE LA CREATION D'UNE CATEGORIE OU DE LA MODIFICATION DE LA SITUATION
   DE DEPART, REINITIALISATION DU FICHIER D'IMPRESSION DE LA CATEGORIE Numero.
   LE FICHIER NE CONTIENT QUE LE NOM DU PROGRAMME, LA DATE ET LE NOM DE LA CATEGORIE.
   RETOURNE true SI OK OU false SI ERREUR. *)
Const c=12; l=11; lg=56;
Var x,y,x1,y1,x2,y2,FondCourant,CouleurCourante:word;
    Image:videosave;
    Fond1,Normal1,Brillant,FondOmbre,Ombre:word;
    Annee,Mois,Jour,JourSemaine:word;
    Chaine:string[4];
    Ok:boolean;
Begin
  case ModeEcran of
    ModeMono:begin Fond1:=lightgrey; Normal1:=black; Brillant:=white; FondOmbre:=black; Ombre:=lightgrey; end;
    ModeCouleur:begin Fond1:=green; Normal1:=yellow; Brillant:=white; FondOmbre:=black; Ombre:=lightgrey; end;
  end;
  (* CADRE *)
  x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; x:=windx; y:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image);
  txtback(Fond1); txtcolour(Normal1);
  txtmove(c,l);   txtwrite(' ͻ ');
  txtmove(c,l+1); txtwrite('  Initialisation du fichier d''impression en cours...  ');
  txtmove(c,l+2); txtwrite(' ͼ ');
  txtcolour(Brillant); txtmove(29,l); txtwrite(' Fichier d''impression ');
  txtback(FondOmbre); txtcolour(Ombre);
  txtmove(c+lg,l+1); txtattrib(2); txtmove(c+lg,l+2); txtattrib(2);
  txtmove(c+2,l+3); txtattrib(lg);
  (* INITIALISATION DU FICHIER *)
  str(Numero,Chaine); if length(Chaine) = 1 then insert('0',Chaine,1);
  NomFichierTraite:='CAT' + Chaine + '.PRN'; assign(FichierPrint,NomFichierTraite);
  Ok:=CREATION_FICHIER(tf_Print);
  if Ok
     then
       begin
         BufferPrint:='TTO version 1.20 - LPJJl Software, Belgium, 1995-1996.';
         Ok:=ECRITURE_FICHIER(tf_Print);
       end;
  if Ok
     then
       begin
         getDate(Annee,Mois,Jour,JourSemaine);
         str(Jour,BufferPrint); if Jour < 10 then insert('0',BufferPrint,1);
         str(Mois,Chaine); if Mois < 10 then insert('0',Chaine,1); BufferPrint:=BufferPrint + '-' + Chaine;
         str(Annee,Chaine); BufferPrint:=BufferPrint + '-' + Chaine + '.';
         Ok:=ECRITURE_FICHIER(tf_Print);
       end;
  if Ok
     then
       begin
         BufferPrint:='--- Catgorie : ' + Categories[Numero].NomCategorie + '.';
         Ok:=ECRITURE_FICHIER(tf_Print);
       end;
  if Ok then Ok:=FERMETURE_FICHIER(tf_Print);
  INITIALISATION_FICHIER_IMPRESSION:=Ok;
  txtunwind; txtload(Image); txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


Function MISE_A_JOUR_FICHIER_IMPRESSION (Numero : byte; pTeteListe : pListeJoueurs) : boolean;
(* MISE A JOUR DU FICHIER D'IMPRESSION DE LA CATEGORIE Numero.
   pTeteListe POINTE SUR LE CLASSEMENT DES JOUEURS (POUR ELIMINATOIRES).
   RETOURNE true SI L'OPERATION S'EST BIEN DEROULEE, false SINON. *)
Const c=12; l=11; lg=56;
      Separation:string[73]='-------------------------------------------------------------------------';
Var x,y,x1,y1,x2,y2,FondCourant,CouleurCourante:word;
    Image:videosave;
    Fond1,Normal1,Fond2,Brillant,FondOmbre,Ombre:word;
    Chaine:string[18];
    pTeteLJ,pQueueLJ,pLJ:pListeJoueurs;
    NbJoueurs:word;
    pJ:pJoueur;
    pM:pMatch;
    i:word;
    Ok,Stop:boolean;
          Function IMPRESSION_JOUEUR (Pointeur:pJoueur) : boolean;
          (* IMPRESSION DES DONNEES DU JOUEUR POINTE PAR Pointeur *)
          Var n:byte;
          Begin
            with Pointeur^ do
              begin
                BufferPrint:=NomJoueur + ' ' + PrenomJoueur;
                if length(BufferPrint) < 31
                   then
                     begin
                       for n:=(length(BufferPrint) + 1) to 31 do BufferPrint[n]:=' ';
                       BufferPrint[0]:=char(31);
                     end;
                if length(Age) <> 0
                   then
                     begin
                       Chaine:=Age; insert(' - ',Chaine,1); if length(Age) = 1 then insert(' ',Chaine,4);
                       Chaine:=Chaine + ' ans'; BufferPrint:=BufferPrint + Chaine;
                     end;
                if length(Club) <> 0
                   then
                     begin
                       if length(Age) = 0 then BufferPrint:=BufferPrint + '         ';
                       BufferPrint:=BufferPrint + ' - Club : ' + Club;
                     end;
                IMPRESSION_JOUEUR:=ECRITURE_FICHIER(tf_Print);
              end;
          End;
          Function IMPRESSION_SCORE (Pointeur:pListeJoueurs) : boolean;
          (* IMPRESSION DES SCORES DU JOUEUR POINTE PAR Pointeur (CLASSEMENT) *)
          Var n:byte;
                    Function ADAPTER_LONGUEUR_CHAINE (ChaineSource:string) : string;
                    (* CENTRAGE DU CONTENU DE ChaineSource SUR 8 CARACTERES *)
                    Var ChaineDest:string;
                    Begin
                      ChaineDest:='        ';
                      insert(ChaineSource,ChaineDest,(8 - length(ChaineSource)) div 2 + 1);
                      ChaineDest[0]:=char(8);
                      ADAPTER_LONGUEUR_CHAINE:=ChaineDest;
                    End;
          Begin
            with Pointeur^ do
              begin
                (* NOM ET PRENOM DU JOUEUR *)
                BufferPrint:=PointeurJoueur^.NomJoueur + ' ' + PointeurJoueur^.PrenomJoueur;
                if length(BufferPrint) < 31
                   then
                     begin
                       for n:=(length(BufferPrint) + 1) to 31 do BufferPrint[n]:=' ';
                       BufferPrint[0]:=char(31);
                     end;
                (* N DE POULE (SI CATEGORIE DIVISEE) *)
                if Categories[Numero].NbPoules > 0
                   then
                     begin
                       str(PointeurJoueur^.Poule,Chaine);
                       BufferPrint:=BufferPrint + ' ' + ADAPTER_LONGUEUR_CHAINE(Chaine);
                     end;
                (* POINTS - SETS - SCORE *)
                str(PointeurJoueur^.Points,Chaine); BufferPrint:=BufferPrint + '' + ADAPTER_LONGUEUR_CHAINE(Chaine);
                str(PointeurJoueur^.Sets,Chaine); BufferPrint:=BufferPrint + '' + ADAPTER_LONGUEUR_CHAINE(Chaine);
                str(PointeurJoueur^.Score,Chaine); BufferPrint:=BufferPrint + '' + ADAPTER_LONGUEUR_CHAINE(Chaine);
                IMPRESSION_SCORE:=ECRITURE_FICHIER(tf_Print);
              end;
          End;
Begin
  case ModeEcran of
    ModeMono:begin
               Fond1:=lightgrey; Normal1:=black; Fond2:=black; Brillant:=white; FondOmbre:=black; Ombre:=lightgrey;
             end;
    ModeCouleur:begin
                  Fond1:=green; Normal1:=yellow; Fond2:=magenta; Brillant:=white; FondOmbre:=black; Ombre:=lightgrey;
                end;
  end;
  x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; x:=windx; y:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image);
  (* CADRE *)
  txtback(Fond1); txtcolour(Normal1);
  txtmove(c,l);   txtwrite(' ͻ ');
  txtmove(c,l+1); txtwrite('    Mise  jour du fichier d''impression en cours...   ');
  txtmove(c,l+2); txtwrite(' ͼ ');
  txtcolour(Brillant); txtmove(29,l); txtwrite(' Fichier d''impression ');
  txtback(FondOmbre); txtcolour(Ombre);
  for i:=1 to 2 do begin txtmove(c+lg,l+i); txtattrib(2); end;
  txtmove(c+2,l+3); txtattrib(lg);
  (* MISE A JOUR DU FICHIER *)
  str(Numero,Chaine); if length(Chaine) = 1 then insert('0',Chaine,1);
  NomFichierTraite:='CAT' + Chaine + '.PRN'; assign(FichierPrint,NomFichierTraite);
  Ok:=AJOUT_FICHIER(tf_Print);
  if Ok then begin BufferPrint:=''; Ok:=ECRITURE_FICHIER(tf_Print); end;
  if Ok then begin BufferPrint:=Separation; Ok:=ECRITURE_FICHIER(tf_Print); end;
  if Ok
     then
       begin
         (* DEBUT DE PAGE : NOM DE LA CATEGORIE ET SITUATION COURANTE *)
         case Categories[Numero].Situation of
           1:Chaine:='FINALE';
           1..64:begin
                   str(Categories[Numero].Situation,Chaine); insert('1/',Chaine,1);
                   Chaine:=Chaine + ' FINALE';
                 end;
           255:Chaine:='ELIMINATOIRES';
         end;
         BufferPrint:='--- Situation : ' + Chaine + '.';
         Ok:=ECRITURE_FICHIER(tf_Print);
       end;
  if Ok then begin BufferPrint:=Separation; Ok:=ECRITURE_FICHIER(tf_Print); end;
  if Ok then begin BufferPrint:=''; Ok:=ECRITURE_FICHIER(tf_Print); end;
  (* NOMS DES JOUEURS EN LICE *)
  if Ok then begin BufferPrint:='--- Joueurs en lice :'; Ok:=ECRITURE_FICHIER(tf_Print); end;
  if Ok
     then
       begin
         if (Categories[Numero].Situation = 255) and (Categories[Numero].NbPoules > 0)
            then   (* CATEGORIE DIVISEE EN POULES *)
              begin
                i:=1;
                while (i <= Categories[Numero].NbPoules) and (Ok) do
                  begin
                    str(i,Chaine); BufferPrint:='- Poule n ' + Chaine + ' :';
                    Ok:=ECRITURE_FICHIER(tf_Print);
                    if Ok
                       then
                         begin
                           NbJoueurs:=EXTRACTION_LISTE_JOUEURS(list_PouleNormal,i,Numero,pTeteLJ,pQueueLJ);
                           if NbJoueurs > 0
                              then
                                begin
                                  pLJ:=pTeteLJ;
                                  while (pLJ <> nil) and (Ok) do
                                    begin
                                      Ok:=IMPRESSION_JOUEUR(pLJ^.PointeurJoueur);
                                      pLJ:=pLJ^.pSuiv;
                                    end;
                                end;
                           if pTeteLJ <> nil then SUPPRESSION_LISTE_JOUEURS(pTeteLJ);
                         end;
                    inc(i);
                  end;
              end
            else   (* PAS DE DIVISION EN POULES *)
              begin
                pJ:=Categories[Numero].pTeteJoueurs;
                while (pJ <> nil) and (Ok) do
                  begin
                    if pJ^.EnLice then Ok:=IMPRESSION_JOUEUR(pJ);
                    pJ:=pJ^.pSuiv;
                  end;
              end;
       end;
  if Ok then begin BufferPrint:=''; Ok:=ECRITURE_FICHIER(tf_Print); end;
  (* RESULTATS DES MATCHES *)
  if Ok then begin BufferPrint:='--- Rsultats des matches :'; Ok:=ECRITURE_FICHIER(tf_Print); end;
  if Ok
     then
       begin
         pM:=Categories[Numero].pTeteMatches;
         while (pM <> nil) and (Ok) do with pM^ do
           begin
             Chaine:=pJoueur1^.NomJoueur;
             if length(pJoueur1^.PrenomJoueur) > 0
                then
                  begin
                    Chaine:=Chaine + ' ' + pJoueur1^.PrenomJoueur[1] + '.';
                  end;
             if length(Chaine) < 18
                then
                  begin
                    for i:=(length(Chaine) + 1) to 18 do Chaine[i]:=' ';
                    Chaine[0]:=char(18);
                  end;
             BufferPrint:=Chaine;
             Chaine:=pJoueur2^.NomJoueur;
             if length(pJoueur2^.PrenomJoueur) > 0
                then
                  begin
                    Chaine:=Chaine + ' ' + pJoueur2^.PrenomJoueur[1] + '.';
                  end;
             if length(Chaine) < 18
                then
                  begin
                    for i:=(length(Chaine) + 1) to 18 do Chaine[i]:=' ';
                    Chaine[0]:=char(18);
                  end;
             BufferPrint:=BufferPrint + ' - ' + Chaine + ' : ';
             i:=1; Stop:=false;
             while (i <= 5) and (not Stop) do
               begin
                 if Resultats[i,1] <> Resultats[i,2]
                    then
                      begin
                        if i > 1 then BufferPrint:=BufferPrint + '';
                        str(Resultats[i,1],Chaine); if length(Chaine) = 1 then insert(' ',Chaine,1);
                        BufferPrint:=BufferPrint + Chaine;
                        str(Resultats[i,2],Chaine); if length(Chaine) = 1 then Chaine:=Chaine + ' ';
                        BufferPrint:=BufferPrint + '-' + Chaine;
                        inc(i);
                      end
                    else
                      Stop:=true;
               end;
             Ok:=ECRITURE_FICHIER(tf_Print); pM:=pM^.pSuiv;
           end;
       end;
  (* AFFICHAGE DU CLASSEMENT (SI ELIMINATOIRES) *)
  if Ok and (Categories[Numero].Situation = 255)
     then
       begin
         BufferPrint:=''; Ok:=ECRITURE_FICHIER(tf_Print);
         if Ok then begin BufferPrint:='--- Classement des joueurs :'; Ok:=ECRITURE_FICHIER(tf_Print); end;
         if Ok
            then
              begin
                if Categories[Numero].NbPoules = 0
                   then BufferPrint:='                                 Points    Sets    Score'
                   else BufferPrint:='                                  Poule    Points    Sets    Score';
                Ok:=ECRITURE_FICHIER(tf_Print);
              end;
         if Ok
            then
              begin
                pLJ:=pTeteListe;
                while (pLJ <> nil) and (Ok) do
                  begin
                    Ok:=IMPRESSION_SCORE(pLJ);
                    pLJ:=pLJ^.pSuiv;
                  end;
              end;
       end;
  Void:=FERMETURE_FICHIER(tf_Print); if Ok then Ok:=Void;
  MISE_A_JOUR_FICHIER_IMPRESSION:=Ok;
  txtunwind; txtload(Image); txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


Function ECRITURE_CARACTERE_IMPRIMANTE (Caractere : char) : boolean;
(* ECRITURE DE Caractere SUR L'IMPRIMANTE LPT1.
   RETOURNE true SI OK OU false SI ERREUR. *)
Var Statut,Erreur:byte;
    Ok,Avorter:boolean;
Begin
  Ok:=false; Avorter:=false;
  with Registres do
    repeat
      ah:=$00;
      al:=byte(Caractere);
      dx:=$0000;   (* LPT1 *)
      intr($17,Registres);
      Statut:=ah;
      Erreur:=0;
      if Statut and si_ACK <> 0 then Erreur:=si_ACK else
      if Statut and si_Transmission <> 0 then Erreur:=si_Transmission else
      if Statut and si_Paper <> 0 then Erreur:=si_Paper;
      if Erreur <> 0 then Avorter:=not MESSAGE_ERREUR(2000 + Erreur) else Ok:=true;
    until (Ok) or (Avorter);
  ECRITURE_CARACTERE_IMPRIMANTE:=Ok;
End;


Function IMPRIMER (Chaine : string) : boolean;
(* IMPRESSION D'UNE CHAINE DE CARACTERES SUR L'IMPRIMANTE LPT1.
   RETOURNE true SI OK OU false SI ERREUR. *)
Var Indice:byte;
    Stop:boolean;
Begin
  Indice:=1; Stop:=false;
  while (Indice <= length(Chaine)) and (not Stop) do
    begin
      Stop:=not ECRITURE_CARACTERE_IMPRIMANTE(Chaine[Indice]); inc(Indice);
    end;
  IMPRIMER:=not Stop;
End;


Function INITIALISATION_IMPRIMANTE : boolean;
(* INITIALISATION DE L'IMPRIMANTE.
   RETOURNE true SI OK OU false SI ERREUR. *)
Begin
  case Imprimante of
    ti_HPDeskJet:begin
                   ci_CompresseOUI:=ci_HP_CompressedON; ci_CompresseNON:=ci_HP_CompressedOFF;
                   ci_GrasOUI:=ci_HP_BoldON; ci_GrasNON:=ci_HP_BoldOFF;
                   ci_SouligneOUI:=ci_HP_UnderlineON; ci_SouligneNON:=ci_HP_UnderlineOFF;
                 end;
    ti_Proprinter:begin
                    ci_CompresseOUI:=ci_IBM_CompressedON; ci_CompresseNON:=ci_IBM_CompressedOFF;
                    ci_GrasOUI:=ci_IBM_BoldON; ci_GrasNON:=ci_IBM_BoldOFF;
                    ci_SouligneOUI:=ci_IBM_UnderlineON; ci_SouligneNON:=ci_IBM_UnderlineOFF;
                  end;
    ti_EpsonLX:begin
                 ci_CompresseOUI:=ci_Epson_CompressedON; ci_CompresseNON:=ci_Epson_CompressedOFF;
                 ci_GrasOUI:=ci_Epson_BoldON; ci_GrasNON:=ci_Epson_BoldOFF;
                 ci_SouligneOUI:=ci_Epson_UnderlineON; ci_SouligneNON:=ci_Epson_UnderlineOFF;
               end;
    ti_Autre:begin
               ci_CompresseOUI:=ci_CompressedON; ci_CompresseNON:=ci_CompressedOFF;
               ci_GrasOUI:=ci_BoldON; ci_GrasNON:=ci_BoldOFF;
               ci_SouligneOUI:=ci_UnderlineON; ci_SouligneNON:=ci_UnderlineOFF;
             end;
  end;
  INITIALISATION_IMPRIMANTE:=IMPRIMER(ci_CompresseNON + ci_GrasNON + ci_SouligneNON);
End;


Procedure IMPRESSION;
(* IMPRESSION DES RESULTATS DE LA CATEGORIE COURANTE.
   LE FICHIER CAT??.PRN EST DEJA OUVERT (PROCEDURE APPELEE PAR AFFICHAGE_TEXTE_IMPRESSION). *)
Const c=12; l=11; lg=56;
Var x,y,x1,y1,x2,y2,FondCourant,CouleurCourante:word;
    Image:videosave;
    Fond1,Normal1,Brillant,FondOmbre,Ombre:word;
    Entree:char;
    Chaine:string;
    Ok,Page1:boolean;
Begin
  case ModeEcran of
    ModeMono:begin Fond1:=lightgrey; Normal1:=black; Brillant:=white; FondOmbre:=black; Ombre:=lightgrey; end;
    ModeCouleur:begin Fond1:=green; Normal1:=yellow; Brillant:=white; FondOmbre:=black; Ombre:=lightgrey; end;
  end;
  (* CADRE *)
  x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; x:=windx; y:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image);
  txtback(Fond1); txtcolour(Normal1);
  txtmove(c,l);   txtwrite(' ͻ ');
  txtmove(c,l+1); txtwrite('         Impression des rsultats en cours...         ');
  txtmove(c,l+2); txtwrite(' ͼ ');
  txtcolour(Brillant); txtmove(34,l); txtwrite(' Impression ');
  txtback(FondOmbre); txtcolour(Ombre);
  txtmove(c+lg,l+1); txtattrib(2); txtmove(c+lg,l+2); txtattrib(2);
  txtmove(c+2,l+3); txtattrib(lg);
  MESSAGE_BAS_ECRAN(ip_Impressions + 3);
  (* IMPRESSION *)
  if OUVERTURE_FICHIER(tf_Print) and INITIALISATION_IMPRIMANTE   (* RESET DU FICHIER ET DE L'IMPRIMANTE *)
     then
       begin
         Ok:=true; Page1:=true;
         while (not eof(FichierPrint)) and (Ok) do
           begin
             if txtkeypressed
                then   (* TOUCHE DU CLAVIER FRAPPEE *)
                  begin
                    txtinput(Entree);
                    case ord(Entree) of
                      0:txtinput(Entree);
                      27:Ok:=false;   (* ESCAPE : INTERROMPT L'OPERATION *)
                    end;
                  end;
             if (Ok) and (LECTURE_FICHIER(tf_Print))
                then
                  begin
                    if copy(BufferPrint,1,3) = 'TTO'
                       then   (* HAUT DE PAGE *)
                         begin
                           Chaine:=ci_CompresseNON + ci_GrasOUI + ci_SouligneOUI +
                                   BufferPrint + ci_CR + ci_LF + ci_SouligneNON + ci_GrasNON;
                           if not Page1 then insert(ci_FF,Chaine,1); Page1:=false;
                         end
                       else
                         if copy(BufferPrint,1,3) = '---'
                            then   (* SOUS-TITRE *)
                              Chaine:=ci_GrasOUI + BufferPrint + ci_CR + ci_LF + ci_GrasNON
                            else
                              if copy(BufferPrint,1,3) = '- P'
                                 then   (* N DE POULE *)
                                   Chaine:=ci_CompresseOUI + BufferPrint + ci_CR + ci_LF + ci_CompresseNON
                                 else   (* LIGNE NORMALE *)
                                   Chaine:=BufferPrint + ci_CR + ci_LF;
                    Ok:=IMPRIMER(Chaine);
                  end
                else
                  Ok:=false;
           end;
         Void:=ECRITURE_CARACTERE_IMPRIMANTE(ci_FF[1]);   (* EJECTION DE LA DERNIERE PAGE *)
       end;
  (* RESTAURATION DE L'ECRAN INITIAL *)
  txtunwind; txtload(Image); txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


Procedure AFFICHAGE_TEXTE_IMPRESSION (Numero : byte);
(* AFFICHAGE DU CONTENU DU FICHIER D'IMPRESSION DE LA CATEGORIE Numero.
   LE TABLEAU Texte DOIT DEJA ETRE INITIALISE. *)
Var x,y,x1,y1,x2,y2,FondCourant,CouleurCourante:word;
    Image:videosave;
    Fond1,Normal1,Brillant:word;
    Ligne:byte;
    ChaineNumero:string[2];
    LigneHaut:word;
    Entree:char;
    Fin:boolean;
          Function AFFICHAGE_LIGNE (nEcran:byte;nTexte:word) : boolean;
          (* AFFICHAGE DE LA LIGNE nTexte A LA LIGNE nEcran. RETOURNE false SI ERREUR. *)
          Begin
            if Souris then Void:=txtmousecursoff;
            if DEPLACEMENT_FICHIER(tf_Print,Texte[nTexte]) and LECTURE_FICHIER(tf_Print)
               then
                 begin
                   txtmove(3,nEcran); txtwrite('                                                                         ');
                   txtmove(3,nEcran); txtwrite(BufferPrint); AFFICHAGE_LIGNE:=true;
                 end
               else
                 AFFICHAGE_LIGNE:=false;
            if Souris then Void:=txtmousecurson;
          End;
          Function AFFICHAGE_PAGE : boolean;
          (* AFFICHAGE D'UNE PAGE. RETOURNE false SI ERREUR. *)
          Var i:byte;
              j:word;
              Ok:boolean;
          Begin
            i:=2; j:=LigneHaut; Ok:=true;
            while (i <= 22) and (j <= NbLignesTexte) and (Ok) do
              begin
                Ok:=AFFICHAGE_LIGNE(i,j); inc(i); inc(j);
              end;
            AFFICHAGE_PAGE:=Ok;
          End;
          Function PREMIERE_PAGE : boolean;
          (* REMONTEE JUSQU'A LA PREMIERE PAGE. RETOURNE false SI ERREUR. *)
          Begin
            PREMIERE_PAGE:=true;
            if LigneHaut > 1
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LigneHaut:=1; PREMIERE_PAGE:=AFFICHAGE_PAGE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Function DERNIERE_PAGE : boolean;
          (* DESCENTE JUSQU'A LA DERNIERE PAGE. RETOURNE false SI ERREUR. *)
          Begin
            DERNIERE_PAGE:=true;
            if (NbLignesTexte > 21) and (LigneHaut < (NbLignesTexte - 20))
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   LigneHaut:=NbLignesTexte - 20; DERNIERE_PAGE:=AFFICHAGE_PAGE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Function LIGNE_PRECEDENTE : boolean;
          (* REMONTEE JUSQU'A LA LIGNE PRECEDENTE. RETOURNE false SI ERREUR. *)
          Begin
            LIGNE_PRECEDENTE:=true;
            if LigneHaut > 1
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   txtwind(2,2,76,22); txtinsdn(0); txtunwind;
                   dec(LigneHaut); LIGNE_PRECEDENTE:=AFFICHAGE_LIGNE(2,LigneHaut);
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Function LIGNE_SUIVANTE : boolean;
          (* DESCENTE JUSQU'A LA LIGNE SUIVANTE. RETOURNE false SI ERREUR. *)
          Begin
            LIGNE_SUIVANTE:=true;
            if (NbLignesTexte > 21) and (LigneHaut < (NbLignesTexte - 20))
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   txtwind(2,2,76,22); txtdeldn(0); txtunwind;
                   inc(LigneHaut); LIGNE_SUIVANTE:=AFFICHAGE_LIGNE(22,LigneHaut + 20);
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Function PAGE_PRECEDENTE : boolean;
          (* REMONTEE A LA PAGE PRECEDENTE. RETOURNE false SI ERREUR. *)
          Begin
            PAGE_PRECEDENTE:=true;
            if LigneHaut > 1
               then
                 begin
                   if Souris then Void:=txtmousecursoff;
                   if LigneHaut > 21
                      then dec(LigneHaut,20)  (* REMONTEE D'UNE PAGE ENTIERE *)
                      else LigneHaut:=1;  (* AFFICHAGE DE LA PREMIERE PAGE *)
                   PAGE_PRECEDENTE:=AFFICHAGE_PAGE;
                   if Souris then Void:=txtmousecurson;
                 end;
          End;
          Function PAGE_SUIVANTE : boolean;
          (* DESCENTE A LA PAGE SUIVANTE. RETOURNE false SI ERREUR. *)
          Begin
            PAGE_SUIVANTE:=true;
            if NbLignesTexte > 40
               then   (* POSSIBILITE DE SCROLLING D'UNE PAGE ENTIERE *)
                 begin
                   if LigneHaut < (NbLignesTexte - 40)
                      then   (* SCROLLING D'UNE PAGE ENTIERE *)
                        begin
                          if Souris then Void:=txtmousecursoff;
                          inc(LigneHaut,20);
                          PAGE_SUIVANTE:=AFFICHAGE_PAGE;
                          if Souris then Void:=txtmousecurson;
                        end
                      else
                        if LigneHaut < (NbLignesTexte - 20)
                           then   (* AFFICHAGE DE LA DERNIERE PAGE *)
                             begin
                               if Souris then Void:=txtmousecursoff;
                               LigneHaut:=NbLignesTexte - 20;
                               PAGE_SUIVANTE:=AFFICHAGE_PAGE;
                               if Souris then Void:=txtmousecurson;
                             end;
                 end
               else   (* PAS DE SCROLLING D'UNE PAGE ENTIERE *)
                 if (NblignesTexte > 21) and (LigneHaut < (NbLignesTexte - 20))
                    then   (* AFFICHAGE DE LA DERNIERE PAGE *)
                      begin
                        if Souris then Void:=txtmousecursoff;
                        LigneHaut:=NbLignesTexte - 20;
                        PAGE_SUIVANTE:=AFFICHAGE_PAGE;
                        if Souris then Void:=txtmousecurson;
                      end;
          End;
Begin
  case ModeEcran of
    ModeMono:begin Fond1:=lightgrey; Normal1:=black; Brillant:=white; end;
    ModeCouleur:begin Fond1:=lightgrey; Normal1:=black; Brillant:=white; end;
  end;
  x:=windx; y:=windy; x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtunwind; txtsave(Image);
  TITRE_HAUT_ECRAN(9);
  (* CADRE *)
  txtback(Fond1); txtcolour(Normal1);
  txtmove(0,1); txtwrite(' ͻ ');
  for Ligne:=2 to 22 do
    begin
      txtmove(0,Ligne); txtwrite('                                                                             ');
    end;
  txtmove(0,23); txtwrite(' ͼ ');
  txtcolour(Brillant); txtmove(24,1); txtwrite(' Visualisation avant impression ');
  (* BOUTONS DE LA SOURIS *)
  txtmove(77,2); txtwrite(''); txtmove(77,3); txtwrite(#30); txtmove(77,4); txtwrite(#24);
  txtmove(77,22); txtwrite(''); txtmove(77,21); txtwrite(#31); txtmove(77,20); txtwrite(#25);
  txtcolour(Normal1);
  (* OUVERTURE DU FICHIER A IMPRIMER *)
  str(Numero,ChaineNumero); if length(ChaineNumero) = 1 then insert('0',ChaineNumero,1);
  NomFichierTraite:='CAT' + ChaineNumero + '.PRN'; assign(FichierPrint,NomFichierTraite);
  txtflush; mouseeventparams.me_modified:=false; MESSAGE_BAS_ECRAN(ip_Impressions + 2);
  LigneHaut:=1;
  if OUVERTURE_FICHIER(tf_Print) and AFFICHAGE_PAGE
     then
       begin
         Fin:=false; Ligne:=2; if Souris then Void:=txtmousecurson;
         (* LECTURE DU CLAVIER ET DE LA SOURIS *)
         repeat
           if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
           if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
           if txtkeypressed
              then   (* ACTION CLAVIER DETECTEE *)
                begin
                  txtinput(Entree);
                  case ord(Entree) of
                    0:begin
                        txtinput(Entree);
                        case ord(Entree) of
                          23:begin   (* ALT-I : IMPRIMER *)
                               if Souris then Void:=txtmousecursoff;
                               if Imprimante = ti_Aucune
                                  then Void:=MESSAGE_AVERTISSEMENT(ip_Impressions)
                                  else if MESSAGE_AVERTISSEMENT(ip_Impressions + 2) then IMPRESSION;
                               if Souris then Void:=txtmousecurson;
                             end;
                          59:begin   (* F1 : AIDE *)
                               if Souris then Void:=txtmousecursoff;
                               AIDE(hlp_ImpressionResultats);
                               if Souris then Void:=txtmousecurson;
                             end;
                          71,119,132:Fin:=not PREMIERE_PAGE;   (* (CTRL-)HOME / CTRL-PgUp : PREMIERE PAGE *)
                          72:Fin:=not LIGNE_PRECEDENTE;        (* FLECHE HAUT : LIGNE PRECEDENTE *)
                          73:Fin:=not PAGE_PRECEDENTE;         (* PgUp : PAGE PRECEDENTE *)
                          79,117,118:Fin:=not DERNIERE_PAGE;   (* (CTRL-)END / CTRL-PgDn : DERNIERE PAGE *)
                          80:Fin:=not LIGNE_SUIVANTE;          (* FLECHE BAS : LIGNE SUIVANTE *)
                          81:Fin:=not PAGE_SUIVANTE;           (* PgDn : PAGE SUIVANTE *)
                          97:begin   (* CTRL-F4 : DEBOGAGE *)
                               if Souris then Void:=txtmousecursoff;
                               DEBOGAGE;
                               if Souris then Void:=txtmousecurson;
                             end;
                        end;
                      end;
                    27:Fin:=true;   (* ESCAPE : QUITTER *)
                    73,105:begin   (* "I","i" : IMPRIMER *)
                             if Souris then Void:=txtmousecursoff;
                             if Imprimante = ti_Aucune
                                then Void:=MESSAGE_AVERTISSEMENT(ip_Impressions)
                                else if MESSAGE_AVERTISSEMENT(ip_Impressions + 2) then IMPRESSION;
                             if Souris then Void:=txtmousecurson;
                           end;
                  end;
                end;
           if mouseeventparams.me_modified
              then   (* ACTION SOURIS DETECTEE *)
                with mouseeventparams do
                  begin
                    if me_x = 77
                       then
                         case me_y of
                           2:Fin:=not PREMIERE_PAGE;
                           3:Fin:=not PAGE_PRECEDENTE;
                           4:Fin:=not LIGNE_PRECEDENTE;
                           20:Fin:=not LIGNE_SUIVANTE;
                           21:Fin:=not PAGE_SUIVANTE;
                           22:Fin:=not DERNIERE_PAGE;
                         end;
                    me_modified:=false;
                  end;
         until Fin;
         if Souris then Void:=txtmousecursoff;
         (* FERMETURE DU FICHIER *)
         Void:=FERMETURE_FICHIER(tf_Print);
       end;
  (* RESTAURATION DE L'ECRAN ORIGINAL *)
  txtload(Image);
  txtwind(x1,y1,x2,y2); txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y);
End;


END.
