
UNIT TTO_GENE;

(* MODULES DE DEBUT ET DE FIN DU PROGRAMME TTO VERSION 1.20.
   MODULES DE L'UNITE TXT 3.00 (EN CHANTIER). *)

INTERFACE

Uses DOS,        (* APPEL ET DETOURNEMENT DES INTERRUPTIONS *)
     TXT,        (* GESTION DE L'ECRAN EN MODE TEXTE (VERSION 2.00) *)
     TTO_DECL,   (* DECLARATION DE CONSTANTES, TYPES ET VARIABLES GLOBALES *)
     TTO_HARD,   (* GESTION BAS NIVEAU DE LA SOURIS, RECONNAISSANCE DU HARDWARE *)
     TTO_FILE,   (* GESTION DU FICHIER TTO.INI, SAUVETAGE AUTOMATIQUE SUR DISQUE *)
     TTO_HELP;   (* AIDE CONTEXTUELLE ET DEBOGAGE *)


Function TXTVALIDATE2 (Source : string; var Dest : string; lChaine : byte; Option, LigneAide : word; Filtre : ByteSet) : word;
   (* LECTURE/MODIFICATION D'UNE CHAINE AU CLAVIER *)
Procedure TXTAVOIDBREAK2;
   (* EMPECHE QU'UN CTRL-C OU UN CTRL-BREAK INTERROMPE LE PROGRAMME EN COURS *)
Procedure TXTALLOWBREAK2;
   (* RESTAURATION DE LA FONCTIONNALITE DES CTRL-C ET CTRL-BREAK *)

Procedure INITIALISATION_PROGRAMME;
   (* INITIALISATION DES VARIABLES GLOBALES DU PROGRAMME ET DE L'UNITE TXT *)
Procedure INITIALISATION_SOURIS;
   (* DETECTION, SAUVETAGE DRIVER ET CHARGEMENT GESTIONNAIRE EVENEMENTS SOURIS *)
Procedure SORTIE_PROGRAMME;
   (* RESTAURATION DE L'ENVIRONNEMENT EN FIN DE PROGRAMME *)
Procedure INTRODUCTION;
   (* ECRAN D'INTRODUCTION PENDANT LA DETECTION DE LA SOURIS *)


IMPLEMENTATION

Function TXTVALIDATE2 (Source : string; var Dest : string; lChaine : byte; Option, LigneAide : word; Filtre : ByteSet) : word;
(* MODIFICATION D'UNE CHAINE EXISTANTE D'UNE LONGUEUR MAXIMALE lChaine.
   LA LECTURE EST THEORIQUEMENT LIMITEE A UNE SEULE LIGNE D'ECRAN (SINON : COMPORTEMENT ALEATOIRE); CETTE
   LIMITATION N'EST PAS TESTEE PAR LA FONCTION : L'UTILISATEUR DOIT PRENDRE SES PRECAUTIONS !
   SI LA 1ERE TOUCHE EST UN CARACTERE, LA CHAINE EST EFFACEE.
   Option EST UNE OPERATION "OR" ENTRE LES OPTIONS SUIVANTES :
   - tv_ArUp      = 1000 0000 0000 0000b = 8000h = FLECHE HAUT;
   - tv_ArDn      = 0100 0000 0000 0000b = 4000h = FLECHE BAS;
   - tv_PgUp      = 0010 0000 0000 0000b = 2000h = PAGE HAUT;
   - tv_PgDn      = 0001 0000 0000 0000b = 1000h = PAGE BAS;
   - tv_TabRi     = 0000 1000 0000 0000b = 0800h = TAB DROITE;
   - tv_TabLe     = 0000 0100 0000 0000b = 0400h = TAB GAUCHE;
   - tv_CtrlEnter = 0000 0010 0000 0000b = 0200h = CTRL-ENTER;
   - tv_CtrlArUp  = 0000 0001 0000 0000b = 0100h = CTRL-FLECHE HAUT;
   - tv_CtrlArDn  = 0000 0000 1000 0000b = 0080h = CTRL-FLECHE BAS;
   - tv_CtrlPgUp  = 0000 0000 0100 0000b = 0040h = CTRL-PAGE HAUT;
   - tv_CtrlPgDn  = 0000 0000 0010 0000b = 0020h = CTRL-PAGE BAS;
   - tv_CtrlHome  = 0000 0000 0001 0000b = 0010h = CTRL-HOME;
   - tv_CtrlEnd   = 0000 0000 0000 1000b = 0008h = CTRL-END;
   - tv_Escape    = 0000 0000 0000 0100b = 0004h = ESCAPE;
   - tv_UpCase    = 0000 0000 0000 0001b = 0001h = CONVERSION EN MAJUSCULES.
   Filtre CONTIENT LES CODES ASCII DES CARACTERES PERMIS.
   L'AIDE EST DISPONIBLE EN PRESSANT F1 (LigneAide INDIQUE LE BRANCHEMENT DANS LE FICHIER D'AIDE).
   CTRL-F4 APPELLE LA BOITE DE DIALOGUE DE DEBOGAGE.
   L'ECONOMISEUR D'ECRAN ET LE SAUVETAGE AUTOMATIQUE PEUVENT EVENTUELLEMENT SE DECLENCHER.
   VALEUR RETOURNEE PAR LA FONCTION : LA TOUCHE AYANT PROVOQUE LA FIN DE LA LECTURE (VOIR Option). *)
Var Buffer:string;
    Entree:char;
    x,xMin,xMax,x1,y1,x2,y2,CurseurHaut,CurseurBas:word;
    Indice,lBuffer:byte;
    Fin,PremiereTouche:boolean;
          Procedure SUPPRESSION_BLANCS;
          (* SUPPRESSION DES BLANCS A LA FIN DE Buffer AVANT DE QUITTER *)
          Begin
            Indice:=lChaine; while (Buffer[Indice] = ' ') and (Indice > 0)  do dec(Indice); Buffer[0]:=char(Indice);
          End;
Begin
  (* INITIALISATIONS *)
  x:=windx; x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; txtgetcurssize(CurseurHaut,CurseurBas);
  Buffer:=Source;
  if length(Buffer) > lchaine then lBuffer:=lChaine else lBuffer:=length(Buffer);
  xMin:=windx; xMax:=xMin + lChaine - 1;
  if length(Buffer) < lChaine then for Indice:=(length(Buffer) + 1) to lChaine do Buffer[Indice]:=' ';
  Buffer[0]:=char(lChaine);
  Indice:=1; PremiereTouche:=true;   (* IL N'Y A PAS ENCORE EU DE TOUCHE PRESSEE *)
  txtwrite(Buffer); txtmove(x,windy);
  (* LECTURES DU CLAVIER *)
  Fin:=false;
  repeat
    if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
    if (DelaiSauvetage <> 0) and (SauverSituation) then Void:=SAUVETAGE_SITUATION(ss_Automatique);
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   15:begin   (* TAB GAUCHE *)
                        if (Option and tv_TabLe) <> 0
                           then
                             begin
                               SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_TabLe;
                             end;
                      end;
                   59:begin   (* F1 : AIDE *)
                        txtcursoff;
                        if LigneAide <> 0 then AIDE(LigneAide);
                        txtcurssize(CurseurHaut,CurseurBas);
                      end;
                   71:begin   (* HOME : CURSEUR EN DEBUT DE CHAINE  *)
                        if Indice > 1
                           then
                             begin
                               Indice:=1; x:=xMin; txtmove(x,windy); PremiereTouche:=false;
                             end;
                      end;
                   72:begin   (* FLECHE HAUT *)
                        if (Option and tv_ArUp) <> 0
                           then
                             begin
                               SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_ArUp;
                             end;
                      end;
                   73:begin   (* PAGE HAUT *)
                        if (Option and tv_PgUp) <> 0
                           then
                             begin
                               SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_PgUp;
                             end;
                      end;
                   75:begin   (* FLECHE GAUCHE : CURSEUR SUR LE CARACTERE PRECEDENT *)
                        if Indice > 1
                           then
                             begin
                               dec(Indice); dec(x); txtmove(x,windy); PremiereTouche:=false;
                             end;
                      end;
                   77:begin   (* FLECHE DROITE : CURSEUR SUR LE CARACTERE SUIVANT *)
                        if Indice < lChaine
                           then
                             begin
                               inc(Indice); inc(x); txtmove(x,windy); PremiereTouche:=false;
                             end;
                      end;
                   79:begin   (* END : CURSEUR EN FIN DE CHAINE  *)
                        Indice:=lChaine; x:=xMax;
                        while (Buffer[Indice] = ' ') and (Indice > 0) do
                          begin
                            dec(Indice); dec(x);
                          end;
                        if Indice < lChaine
                           then
                             begin
                               inc(Indice); inc(x);
                             end;
                        txtmove(x,windy);
                        PremiereTouche:=false;
                      end;
                   80:begin   (* FLECHE BAS *)
                        if (Option and tv_ArDn) <> 0
                           then
                             begin
                               SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_ArDn;
                             end;
                      end;
                   81:begin   (* PAGE BAS *)
                        if (Option and tv_PgDn) <> 0
                           then
                             begin
                               SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_PgDn;
                             end;
                      end;
                   83:begin   (* DELETE : SUPPRESSION DU CARACTERE COURANT *)
                        delete(Buffer,Indice,1); insert(' ',Buffer,lChaine); dec(lBuffer);
                        txtcursoff;
                        txtmove(xMin,windy); txtwrite(Buffer); txtmove(x,windy);
                        txtcurssize(CurseurHaut,CurseurBas);
                        PremiereTouche:=false;
                      end;
                   97:begin   (* CTRL-F4 : BOITE DE DIALOGUE DE DEBOGAGE *)
                        txtcursoff; DEBOGAGE; txtcurssize(CurseurHaut,CurseurBas);
                      end;
                   117:begin   (* CTRL-END *)
                         if (Option and tv_CtrlEnd) <> 0
                            then
                              begin
                                SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_CtrlEnd;
                              end;
                       end;
                   118:begin   (* CTRL-PAGE BAS *)
                         if (Option and tv_CtrlPgDn) <> 0
                            then
                              begin
                                SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_CtrlPgDn;
                              end;
                       end;
                   119:begin   (* CTRL-HOME *)
                         if (Option and tv_CtrlHome) <> 0
                            then
                              begin
                                SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_CtrlHome;
                              end;
                       end;
                   132:begin   (* CTRL-PAGE HAUT *)
                         if (Option and tv_CtrlPgUp) <> 0
                            then
                              begin
                                SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_CtrlPgUp;
                              end;
                       end;
                   141:begin   (* CTRL-FLECHE HAUT *)
                         if (Option and tv_CtrlArUp) <> 0
                            then
                              begin
                                SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_CtrlArUp;
                              end;
                       end;
                   145:begin   (* CTRL-FLECHE BAS *)
                         if (Option and tv_CtrlArDn) <> 0
                            then
                              begin
                                SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_CtrlArDn;
                              end;
                       end;
                 end;
               end;
             8:begin   (* BACK SPACE : SUPPRESSION DU CARACTERE PRECEDENT *)
                 if Indice > 1
                    then
                      begin
                        delete(Buffer,Indice-1,1); insert(' ',Buffer,lChaine); dec(lBuffer);
                        txtcursoff;
                        txtmove(xMin,windy); txtwrite(Buffer); dec(Indice); dec(x); txtmove(x,windy);
                        txtcurssize(CurseurHaut,CurseurBas);
                        PremiereTouche:=false;
                      end;
               end;
             9:begin   (* TAB DROITE *)
                 if (Option and tv_TabRi) <> 0
                    then
                      begin
                        SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_TabRi;
                      end;
               end;
             10:begin   (* CTRL-ENTER *)
                  if (Option and tv_CtrlEnter) <> 0
                     then
                       begin
                         SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_CtrlEnter;
                       end;
                end;
             13:begin   (* ENTER : VALIDATION DE LA CHAINE LUE *)
                  SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_Enter;
                end;
             27:begin   (* ESCAPE : ANNULATION DE L'OPERATION *)
                  Dest:=Source; Fin:=true; TXTVALIDATE2:=tv_Escape;
                end;
           else   (* AUTRES CARACTERES *)
             if ord(Entree) in Filtre
                then
                  begin
                    if PremiereTouche
                       then   (* MISE A BLANC DE LA CHAINE *)
                         begin
                           for Indice:=1 to lChaine do Buffer[Indice]:=' '; Buffer[0]:=char(lChaine);
                           Indice:=1; PremiereTouche:=false;
                         end;
                    if (Option and tv_Upcase) <> 0
                       then    (* CONVERSION AUTOMATIQUE EN MAJUSCULES *)
                         case Entree of
                           '','','':Entree:='A';
                           '','','','':Entree:='E';
                           '','','':Entree:='I';
                           '','','':Entree:='O';
                           '','','':Entree:='U';
                           '':Entree:='';
                           '':Entree:='';
                           '':Entree:='';
                           '':Entree:='';
                           '':Entree:='';
                           '':Entree:='Y';
                           '':Entree:='C';
                           '':Entree:='';
                         else
                           Entree:=upcase(Entree);
                         end;
                    if Indice = lChaine
                       then
                         begin
                           Buffer[Indice]:=Entree; txtwrite(Entree); txtmove(x,windy);
                         end
                       else
                         begin
                           delete(Buffer,lChaine,1); insert(Entree,Buffer,Indice);
                           if lBuffer < lChaine then inc(lBuffer);
                           txtcursoff;
                           txtmove(xMin,windy); txtwrite(Buffer); inc(Indice); inc(x); txtmove(x,windy);
                           txtcurssize(CurseurHaut,CurseurBas);
                         end;
                  end;
           end;
         end;
  until Fin;
End;


Procedure NEWINT09; interrupt;
(* DETOURNEMENT DE L'INT 09H POUR INTERCEPTER CTRL-C.
   REMET EGALEMENT LA VARIABLE GLOBALE CompteurTicsEcran A ZERO *)
Begin
  if (port[$60] = 46) and (mem[$0040:$0017] and $04 = $04)
     then   (* ENVOI DE "FIN D'INTERRUPTION" AU CONTROLEUR D'INTERRUPTIONS *)
       port[$20]:=$20
     else   (* APPEL DE L'ANCIENNE INT 09H *)
       intr(Int09,Registres);
  CompteurTicsEcran:=0;   (* DELAI DE L'ECONOMISEUR D'ECRAN REMIS A ZERO A CHAQUE TOUCHE PRESSEE *)
End;


Procedure NEWINT1B; interrupt;
(* DETOURNEMENT DE L'INT 1BH POUR DESACTIVER LA GESTION DU CTRL-BREAK *)
Begin
  (* LA NOUVELLE INTERRUPTION NE FAIT RIEN *)
End;


Procedure TXTAVOIDBREAK2;
(* EMPECHE QU'UN CTRL-C OU UN CTRL-BREAK INTERROMPE LE PROGRAMME EN COURS *)
Begin
  (* DESACTIVATION DU CTRL-BREAK *)
  getintvec($1B,OldInt1B); setintvec($1B,@ NEWINT1B);
  (* DESCATIVATION DU CTRL-C *)
  Int09:=255; repeat getintvec(Int09,OldInt09); if OldInt09 <> nil then dec(Int09); until (Int09 = 0) or (OldInt09 = nil);
  if Int09 > 0
     then
       begin
         getintvec($09,OldInt09); setintvec(Int09,OldInt09); setintvec($09,@ NEWINT09);
       end
     else
       OldInt09:=nil;
End;


Procedure TXTALLOWBREAK2;
(* RESTAURATION DE LA FONCTIONNALITE DES CTRL-C ET CTRL-BREAK *)
Begin
  (* RESTAURATION DU CTRL-BREAK *)
  setintvec($1B,OldInt1B);
  (* RESTAURATION DU CTRL-C *)
  if Int09 <> 0
     then
       begin
         setintvec($09,OldInt09); setintvec(Int09,nil); Int09:=0; OldInt09:=nil;
       end;
End;


{$F+}
Function ERREUR_HEAP (Taille:word) : integer;
(* EMPECHE UNE ERREUR FATALE SI ERREUR ALLOCATION MEMOIRE *)
(* CONSERVEE VERSION 1.20 *)
Begin
  ERREUR_HEAP:=1;   (* new ET getmem RENVOIENT nil SI ERREUR D'ALLOCATION *)
End;
{$F-}


Function PARAMETRES_PROGRAMME : word;
(* INTERPRETATION DES PARAMETRES PASSES AU PROGRAMME.
   RETOURNE LA COMBINAISON or DES CODES SUIVANTS :
   - pp_Mono : LANCER LE PROGRAMME EN MODE MONOCHROME (/mono);
   - pp_Gris : LANCER LE PROGRAMME EN MODE NIVEAUX DE GRIS (/gris);
   - pp_Couleur : LANCER LE PROGRAMME EN MODE COULEUR (/couleur). *)
Var p:string;
    NbParametres,i,j:byte;
    CodeSortie:word;
Begin
  NbParametres:=paramcount; CodeSortie:=0;
  if NbParametres > 0
     then
       for i:=1 to NbParametres do
         begin
           p:=paramstr(i); for j:=1 to length(p) do p[j]:=upcase(p[j]);
           if (p = '/MONO') or (p = 'MONO')
              then
                CodeSortie:=CodeSortie or pp_Mono
              else
                if (p = '/GRIS') or (p = 'GRIS')
                   then
                     CodeSortie:=CodeSortie or pp_Gris
                   else
                     if (p = '/COULEUR') or (p = 'COULEUR') or (p = '/COLOR') or (p = 'COLOR')
                        then
                          CodeSortie:=CodeSortie or pp_Couleur;
         end;
  PARAMETRES_PROGRAMME:=CodeSortie;
End;


Procedure CARACTERES_PERSONNELS;
(* DEFINITION DE CARACTERES PERSONNELS (BOUTONS SOURIS). *)
Type NewCharEGA = array[1..14] of byte;
     NewCharVGA = array[1..16] of byte;
Const fnt_CtrlPgUpEGA : NewCharEGA = ($00,$00,$7E,$18,$3C,$7E,$18,$18,$18,$18,$18,$18,$00,$00);
      fnt_CtrlPgUpVGA : NewCharVGA = ($00,$00,$00,$7E,$18,$3C,$7E,$18,$18,$18,$18,$18,$18,$00,$00,$00);
      fnt_PgUpEGA : NewCharEGA = ($00,$00,$18,$3C,$7E,$18,$18,$7E,$18,$7E,$18,$18,$00,$00);
      fnt_PgUpVGA : NewCharVGA = ($00,$00,$00,$18,$3C,$7E,$18,$18,$7E,$18,$7E,$18,$18,$00,$00,$00);
      fnt_ArUpEGA : NewCharEGA = ($00,$00,$18,$3C,$7E,$18,$18,$18,$18,$18,$18,$18,$00,$00);
      fnt_ArUpVGA : NewCharVGA = ($00,$00,$00,$18,$3C,$7E,$18,$18,$18,$18,$18,$18,$18,$00,$00,$00);
      fnt_CtrlPgDnEGA : NewCharEGA = ($00,$00,$18,$18,$18,$18,$18,$18,$7E,$3C,$18,$7E,$00,$00);
      fnt_CtrlPgDnVGA : NewCharVGA = ($00,$00,$00,$18,$18,$18,$18,$18,$18,$7E,$3C,$18,$7E,$00,$00,$00);
      fnt_PgDnEGA : NewCharEGA = ($00,$00,$18,$18,$7E,$18,$7E,$18,$18,$7E,$3C,$18,$00,$00);
      fnt_PgDnVGA : NewCharVGA = ($00,$00,$00,$18,$18,$7E,$18,$7E,$18,$18,$7E,$3C,$18,$00,$00,$00);
      fnt_ArDnEGA : NewCharEGA = ($00,$00,$18,$18,$18,$18,$18,$18,$18,$7E,$3C,$18,$00,$00);
      fnt_ArDnVGA : NewCharVGA = ($00,$00,$00,$18,$18,$18,$18,$18,$18,$18,$7E,$3C,$18,$00,$00,$00);
Var Fonte:fontarray;
Begin
  case Carte of
    vc_Ega:begin
             move(fnt_CtrlPgUpEGA,Fonte,14); txtuserfont(Fonte,223,1,14);
             move(fnt_PgUpEGA,Fonte,14); txtuserfont(Fonte,30,1,14);
             move(fnt_CtrlPgDnEGA,Fonte,14); txtuserfont(Fonte,220,1,14);
             move(fnt_PgDnEGA,Fonte,14); txtuserfont(Fonte,31,1,14);
             move(fnt_ArUpEGA,Fonte,14); txtuserfont(Fonte,24,1,14);
             move(fnt_ArDnEGA,Fonte,14); txtuserfont(Fonte,25,1,14);
           end;
    vc_Mcga,vc_Vga,vc_SvgaVesa:begin
                                 move(fnt_CtrlPgUpVGA,Fonte,16); txtuserfont(Fonte,223,1,16);
                                 move(fnt_PgUpVGA,Fonte,16); txtuserfont(Fonte,30,1,16);
                                 move(fnt_CtrlPgDnVGA,Fonte,16); txtuserfont(Fonte,220,1,16);
                                 move(fnt_PgDnVGA,Fonte,16); txtuserfont(Fonte,31,1,16);
                                 move(fnt_ArUpVGA,Fonte,16); txtuserfont(Fonte,24,1,16);
                                 move(fnt_ArDnVGA,Fonte,16); txtuserfont(Fonte,25,1,16);
                               end;
  end;
End;


Procedure INITIALISATION_PROGRAMME;
(* INITIALISATION DES VARIABLES GLOBALES DU PROGRAMME ET DE L'UNITE TXT.
   CHARGEMENT DU TYPE D'ORDINATEUR, DE CARTE VIDEO ET DE MONITEUR POUR LA
   BOITE DE DIALOGUE DE DEBOGAGE.
   REMARQUE : LE MODE NIVEAUX DE GRIS DEVIENT MODE MONOCHROME PUR. *)
Var ResultatInit:byte;
    Carte2,Moniteur2:byte;
    i:byte;
Begin
  txtavoidbreak2;
  txtinit(ResultatInit);
  Void:=txtgetcomputertype(TypeOrdinateur);
  case TypeOrdinateur of
    ct_PC:dbg_TypeOrdinateur:='PC';
    ct_PCBiosXT:dbg_TypeOrdinateur:='PC avec BIOS XT';
    ct_PCConv:dbg_TypeOrdinateur:='PC convertible';
    ct_PCJr:dbg_TypeOrdinateur:='PC Junior';
    ct_XT:dbg_TypeOrdinateur:='PC/XT';
    ct_XT286:dbg_TypeOrdinateur:='PC/XT avec Proc 80286';
    ct_AT:dbg_TypeOrdinateur:='PC/AT';
    ct_Ps2Mod25:dbg_TypeOrdinateur:='PS/2 modle 25';
    ct_Ps2Mod30:dbg_TypeOrdinateur:='PS/2 modle 30';
    ct_Ps2Mod50:dbg_TypeOrdinateur:='PS/2 modle 50';
    ct_Ps2Mod60:dbg_TypeOrdinateur:='PS/2 modle 60';
    ct_Ps2Mod80:dbg_TypeOrdinateur:='PS/2 modle 80';
    ct_AT_Ps2_XT286:dbg_TypeOrdinateur:='PC/AT ou PS/2 ou PC/XT avec Proc 286';
    ct_Ps2:dbg_TypeOrdinateur:='PS/2';
    ct_Error:dbg_TypeOrdinateur:='(Erreur de dtection)';
  else
    dbg_TypeOrdinateur:='(Type inconnu)';
  end;
  if txtgetvideosystems(Carte,Moniteur,Carte2,Moniteur2)
     then
       begin
         case Carte of
           vc_Unknown:dbg_Carte:='(Type inconnu)';
           vc_MDA:dbg_Carte:='MDA';
           vc_CGA:dbg_Carte:='CGA';
           vc_Hercules:dbg_Carte:='Hercules';
           vc_EGA:dbg_Carte:='EGA';
           vc_MCGA:dbg_Carte:='MCGA';
           vc_VGA:dbg_Carte:='VGA';
           vc_SVGAVesa:dbg_Carte:='SVGA compatible VESA';
         else
           dbg_Carte:='(Erreur de dtection)';
         end;
         case Moniteur of
           vm_Unknown:dbg_Moniteur:='(Type inconnu)';
           vm_Mono:dbg_Moniteur:='Monochrome';
           vm_Colour:dbg_Moniteur:='Couleur';
           vm_MonoAnalog:dbg_Moniteur:='Monochrome analogique';
           vm_ColourAnalog:dbg_Moniteur:='Couleur analogique';
           vm_EGAHiRes:dbg_Moniteur:='EGA haute rsolution';
         else
           dbg_Moniteur:='(Erreur de dtection)';
         end;
         if Carte in [vc_Mda,vc_Hercules]
            then
              ModeEcran:=ModeMono
            else
              if Moniteur in [vm_Mono,vm_MonoAnalog] then ModeEcran:=ModeMono {ModeGris} else ModeEcran:=ModeCouleur;
       end
     else
       ModeEcran:=ModeMono;   (* PAR DEFAUT, MODE MONOCHROME *)
  (* LECTURE DES PARAMETRES DE LA LIGNE DE COMMANDE *)
  ParametresProgramme:=PARAMETRES_PROGRAMME;
  if (ParametresProgramme and pp_Mono) <> 0
     then
       ModeEcran:=ModeMono
     else
       if (ParametresProgramme and pp_Gris) <> 0
          then
            ModeEcran:=ModeMono {ModeGris}
          else
            if (ParametresProgramme and pp_Couleur) <> 0
               then
                 ModeEcran:=ModeCouleur;
  if ModeEcran = ModeMono then txtmode(7) else txtmode(3);
  txtgetcurssize(CurseurHaut,CurseurBas); txtcursoff;
  (* GESTION D'ERREURS DU TAS *)
  heaperror:=@ ERREUR_HEAP;
  (* VARIABLES GLOBALES *)
  for i:=1 to 20 do
    begin
      with Categories[i] do
        begin
          NomCategorie:='';
          Situation:=0;
          NbPoules:=0; NbJoueurs:=0; NbJoueursRestants:=0; NbMatches:=0; NbMatchesRestants:=0;
          pTeteJoueurs:=nil; pQueueJoueurs:=nil; pTeteMatches:=nil; pQueueMatches:=nil;
        end;
    end;
End;


Procedure INITIALISATION_SOURIS;
(* DETECTION, SAUVETAGE DRIVER ET CHARGEMENT GESTIONNAIRE EVENEMENTS SOURIS.
   CHARGEMENT DU TYPE DE SOURIS ET DE LA VERSION POUR LA BOITE DE DIALOGUE DE
   DEBOGAGE. *)
Var StatutSouris:integer;
    MasqueAnd,MasqueXor:word;
    Chaine:string;
Begin
  Souris:=true;
  (* DETECTION *)
  if txtdetectmouse
     then
       begin
         (* SAUVETAGE DES PARAMETRES DU DRIVER ET INITIALISATION *)
         TailleBufferSouris:=txtmousesavebuffersize;
         getmem(BufferSouris,TailleBufferSouris);
         if BufferSouris <> nil
            then
              begin
                if (txtsavemouse(BufferSouris)) and (txtinitmouse(StatutSouris))
                   then
                     begin
                       (* CHARGEMENT DU GESTIONNAIRE D'EVENEMENTS *)
                       if txtinstallmouseeventhandler(me_Normal,@ EVENTHND,me_LButtonDown or me_MouseMove)
                          then
                            begin
                              (* DEFINITION DU CURSEUR SOURIS *)
                              Void:=txtmousecursormasks(mc_Keep,0,mc_Invert,0,MasqueAnd,MasqueXor);
                              if not txtmousecursor(mc_Log,MasqueAnd,MasqueXor) then Souris:=false;
                            end
                          else
                            Souris:=false;
                     end
                   else
                     Souris:=false;
              end
            else
              Souris:=false;
       end
     else
       Souris:=false;
  with mouseparams do
    if mp_valid
       then
         begin
           case mp_mousetype of
             1:dbg_TypeSouris:='Bus';
             2:dbg_TypeSouris:='Serial';
             3:dbg_TypeSouris:='InPort';
             4:dbg_TypeSouris:='PS/2';
             5:dbg_TypeSouris:='HP';
           else
             dbg_TypeSouris:='(Erreur de dtection)';
           end;
           str(mp_VersionHi,dbg_VersionSouris); str(mp_VersionLo,Chaine);
           dbg_VersionSouris:=dbg_VersionSouris + '.' + Chaine;
         end;
End;


Procedure INITIALISATION_TIMER;
(* TEST DE LA VITESSE DU TIMER, DETOURNEMENT DE L'INT 08H ET INITIALISATION DES
   COMPTEURS DE L'ECONOMISEUR D'ECRAN ET DU SAUVETAGE AUTOMATIQUE *)
Begin
  if NUMERO_INTERRUPTION_LIBRE
     then
       begin
         VitesseTimer:=VITESSE_TIMER;   (* NOMBRE DE TICS PAR SECONDE *)
         if VitesseTimer > 0
            then
              begin
                TicsDelaiSauvetage:=DelaiSauvetage * 60 * VitesseTimer;
                TicsDelaiEcran:=DelaiEcran * 60 * VitesseTimer;
                CompteurTicsSauvetage:=0; CompteurTicsEcran:=0; DETOURNEMENT_INT08;
              end;
       end
     else
       begin
         DelaiSauvetage:=0; DelaiEcran:=0; VitesseTimer:=0;
       end;
End;


Procedure SORTIE_PROGRAMME;
(* RESTAURATION DE L'ENVIRONNEMENT EN FIN DE PROGRAMME *)
Begin
  if (DelaiSauvetage <> 0) or (DelaiEcran <> 0) then RESTAURATION_INT08;
  if Souris then Void:=txtloadmouse(BufferSouris);
  release(heaporg);
  txtallowbreak2;
  if SauverOptions then ECRITURE_FICHIER_INI;
  txtrestoremode;
  writeln('LPJJl vous salue bien bas...');
  writeln('');
  txtcurssize(CurseurHaut,CurseurBas);
End;


Procedure INTRODUCTION;
(* ECRAN D'INTRODUCTION PENDANT LA DETECTION DE LA SOURIS ET LE TEST DE VITESSE DU TIMER.
   SE TERMINE PAR L'ATTENTE D'UNE TOUCHE AU CLAVIER : - SI F1, ALORS AIDE;
                                                      - SI CTRL-F4, ALORS BOITE DE DIALOGUE DE DEBOGAGE. *)
Const l=7;
Var Fond,Brillant,Blanc,Normal:word;
    n:byte;
    Entree:char;
    Ok:boolean;
Begin
  case ModeEcran of
    ModeMono:begin Fond:=black; Normal:=lightgrey; Brillant:=white; Blanc:=white; end;
    ModeCouleur:begin Fond:=cyan; Normal:=black; Brillant:=yellow; Blanc:=white; end;
  end;
  txtback(Fond); txtcolour(Brillant);
  txtmove(0,0); txtwrite(' ͻ ');
  for n:=1 to 23 do
    begin
      txtmove(0,n); txtwrite('                                                                             ');
    end;
  txtmove(0,24); txtwrite(' ͼ ');
  txtmove(16,l);   txtwrite('     ');
  txtmove(16,l+1); txtwrite('                               ');
  txtmove(16,l+2); txtwrite('                                    ');
  txtmove(16,l+3); txtwrite('                                       ');
  txtmove(16,l+4); txtwrite('                                     ');
  txtmove(16,l+5); txtwrite('                                 ');
  txtmove(16,l+6); txtwrite('                                   ');
  txtmove(16,l+7); txtwrite('                     ');
  txtcolour(Normal);
  txtmove(26,l+11); txtwrite('Initialisations en cours...');
  LECTURE_FICHIER_INI;
  if Souris then INITIALISATION_SOURIS;
  if (DelaiSauvetage <> 0) or (DelaiEcran <> 0) then INITIALISATION_TIMER;
  txtcolour(Blanc);
  txtmove(26,l+9); txtwrite('Tennis Tournament Organizer');
  txtmove(34,l+10); txtwrite('Version 1.20');
  txtcolour(Normal);
  txtmove(25,l+11); txtwrite('LPJJl Software, Belgium, 1996');
  txtmove(53,24); txtwrite(' Pressez une touche... ');
  txtflush; Ok:=false;
  repeat
    if (DelaiEcran <> 0) and (EconomiserEcran) then ECONOMISEUR_ECRAN;
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   59:AIDE(hlp_Debut);    (* F1 : AIDE *)
                   97:DEBOGAGE;   (* CTRL-F4 : BOITE DE DIALOGUE DE DEBOGAGE *)
                 else
                   Ok:=true;
                 end;
               end;
           else
             Ok:=true;
           end;
         end;
  until Ok;
  CARACTERES_PERSONNELS;
End;


END.
